//-----------------------------------------------------------------------------
// 
// 		cwCu		`揈vO( Direct3D11 )
// 
//  	Ver 3.13d
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "../DxCompileConfig.h"

#ifndef DX_NON_DIRECT3D11

// CN[h ---------------------------------------------------------------
#include "DxGraphicsD3D11.h"
#include "DxGraphicsWin.h"
#include "DxMaskD3D11.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "../DxSystem.h"
#include "../DxLog.h"
#include "../DxModel.h"
#include "../DxMovie.h"
#include "../DxMask.h"
#include "../DxBaseFunc.h"
#include "../DxGraphics.h"
#include "../DxGraphicsFilter.h"
#include "../DxInput.h"
#include "../DxASyncLoad.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

#define DX_D3D11_DRAWPREP_NOTEX( FLAG )													\
	Graphics_D3D11_DrawSetting_SetTexture( NULL, NULL ) ;								\
	if( GSYS.ChangeSettingFlag ||														\
		GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag != FALSE ||						\
		GD3D11.Device.DrawSetting.DrawPrepParamFlag  != FLAG )							\
		Graphics_D3D11_DrawPreparation( FLAG ) ;												


// Graphics_D3D11_DrawPreparation ĂԒ^
#define DX_D3D11_DRAWPREP_TEX( ORIG, TEX, TEXSRV, FLAG )								\
	FLAG |= DX_D3D11_DRAWPREP_TEXTURE ;													\
	if( (ORIG)->FormatDesc.AlphaChFlag   ) FLAG |= DX_D3D11_DRAWPREP_TEXALPHACH ;		\
	if( (ORIG)->FormatDesc.AlphaTestFlag ) FLAG |= DX_D3D11_DRAWPREP_TEXALPHATEST ;		\
	Graphics_D3D11_DrawSetting_SetTexture( (TEX), (TEXSRV) ) ;							\
	if( GSYS.ChangeSettingFlag ||														\
		GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag != FALSE ||						\
		GD3D11.Device.DrawSetting.DrawPrepParamFlag  != FLAG )							\
		Graphics_D3D11_DrawPreparation( FLAG ) ;


#define GETVERTEX_QUAD( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 0 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 6 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 0 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_BILLBOARD( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 1 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 6 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 1 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_TRIANGLE( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 0 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 3 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 0 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_TRIANGLE3D( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 1 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 3 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 1 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_LINEBOX( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 0 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 24 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 0 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_LINETRIANGLE( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 0 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 6 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 0 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_LINETRIANGLE3D( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 1 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 6 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 1 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_LINE( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex == 1 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 2 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 0 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;


#define GETVERTEX_LINE3D( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 1 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 2 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 1 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;


#define GETVERTEX_POINT( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 0 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_POINTLIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 1 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 0 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_POINTLIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;

#define GETVERTEX_POINT3D( p )		\
	MV1DRAWPACKDRAWMODEL		\
	if(\
		  GD3D11.Device.DrawInfo.Use3DVertex != 1 ||\
		  GD3D11.Device.DrawInfo.PrimitiveType != D_D3D11_PRIMITIVE_TOPOLOGY_POINTLIST ||\
		  GD3D11.Device.DrawInfo.VertexNum + 1 >= D3D11_VertexBuffer_MaxVertexNum[ D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ]\
	  )\
	{\
		Graphics_D3D11_RenderVertex( 1 ) ;\
		GD3D11.Device.DrawInfo.PrimitiveType = D_D3D11_PRIMITIVE_TOPOLOGY_POINTLIST ;\
	}\
	*( ( void ** )&p ) = ( void * )GD3D11.Device.DrawInfo.VertexBufferNextAddr ;



#define ADD4VERTEX_POINT		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_2D ) ;	\
		GD3D11.Device.DrawInfo.VertexNum ++ ;

#define ADD4VERTEX_POINT3D		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_3D ) ;	\
		GD3D11.Device.DrawInfo.VertexNum ++ ;
/*
#define ADD4VERTEX_LINEBOX			\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_2D ) * 8 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 8 ;
*/
#define ADD4VERTEX_LINEBOX			\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_2D ) * 24 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 24 ;

#define ADD4VERTEX_LINETRIANGLE		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_2D ) * 6 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 6 ;

#define ADD4VERTEX_LINETRIANGLE3D		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_3D ) * 6 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 6 ;

#define ADD4VERTEX_LINE			\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_2D ) * 2 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 2 ;

#define ADD4VERTEX_LINE3D		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_3D ) * 2 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 2 ;

#define ADD4VERTEX_NOTEX		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_2D ) * 6 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 6 ;

#define ADD4VERTEX_TEX			\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_2D ) * 6 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 6 ;

#define ADD4VERTEX_BLENDTEX		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_BLENDTEX_2D ) * 6 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 6 ;

#define ADD3VERTEX_NOTEX		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_2D ) * 3 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 3 ;

#define ADD3VERTEX_NOTEX3D		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_NOTEX_3D ) * 3 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 3 ;

#define ADD4VERTEX_BILLBOARD		\
		GD3D11.Device.DrawInfo.VertexBufferNextAddr += sizeof( VERTEX_3D ) * 6 ;	\
		GD3D11.Device.DrawInfo.VertexNum += 6 ;


#define D3D11_COMMONBUFFER_ADDSIZE			(16 * 1024)

// \̐錾 -----------------------------------------------------------------

// W`p̕GȏsȂ_VF[_[̏
typedef struct tagGRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO
{
	const char *				ShaderFileName ;						// gp钸_VF[_[t@C
	int							VertexDataSize ;						// _f[^̃oCg
	D_D3D11_INPUT_ELEMENT_DESC	InputElementDesc[ 11 ] ;				// ͒_f[^`
} GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO ;

// f[^` -----------------------------------------------------------------

// _obt@Ɋi[ł钸_̍ő吔̃e[u
static const int D3D11_VertexBuffer_MaxVertexNum[ D3D11_VERTEX_INPUTLAYOUT_NUM ] =
{
	D3D11_VERTEXBUFFER_SIZE / sizeof( VERTEX_NOTEX_2D    ),
	D3D11_VERTEXBUFFER_SIZE / sizeof( VERTEX_2D          ),
	D3D11_VERTEXBUFFER_SIZE / sizeof( VERTEX_BLENDTEX_2D ),
	D3D11_VERTEXBUFFER_SIZE / sizeof( VERTEX_NOTEX_3D    ),
	D3D11_VERTEXBUFFER_SIZE / sizeof( VERTEX_3D          ),
	D3D11_VERTEXBUFFER_SIZE / sizeof( VERTEX3D           ),
	D3D11_VERTEXBUFFER_SIZE / sizeof( VERTEX3DSHADER     ),
} ;

// e_f[^̃TCỸe[u
static const int D3D11_VertexSize[ D3D11_VERTEX_INPUTLAYOUT_NUM ] =
{
	sizeof( VERTEX_NOTEX_2D    ),
	sizeof( VERTEX_2D          ),
	sizeof( VERTEX_BLENDTEX_2D ),
	sizeof( VERTEX_NOTEX_3D    ),
	sizeof( VERTEX_3D          ),
	sizeof( VERTEX3D           ),
	sizeof( VERTEX3DSHADER     ),
} ;

// Rc_ǂƒ_^Cv̑gݍ킹ɑΉ钸_f[^^Cv[ 0:Qc_  1:Rc_ ][ _^Cv ]
static const DWORD D3D11_VertexTypeToInputLayout[ 2 ][ VERTEXTYPE_NUM ] =
{
	{
		D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D,
		D3D11_VERTEX_INPUTLAYOUT_2D,
		D3D11_VERTEX_INPUTLAYOUT_BLENDTEX_2D,
	},

	{
		D3D11_VERTEX_INPUTLAYOUT_NOTEX_3D,
		D3D11_VERTEX_INPUTLAYOUT_3D
	},
} ;

// Pʍs
static MATRIX D3D11_GlobalIdentMatrix =
{
	1.0f, 0.0f, 0.0f, 0.0f,
	0.0f, 1.0f, 0.0f, 0.0f,
	0.0f, 0.0f, 1.0f, 0.0f,
	0.0f, 0.0f, 0.0f, 1.0f
} ;

// W`p̕GȏsȂ_VF[_[̏
static GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO g_BaseSimpleVertexShaderInfo[ D3D11_VERTEX_INPUTLAYOUT_NUM ] =
{
	// D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D( VERTEX_NOTEX_2D )
	{
		"Base_VERTEX_NOTEX_2D.vso",
		sizeof( VERTEX_NOTEX_2D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// D3D11_VERTEX_INPUTLAYOUT_2D( VERTEX2D or VERTEX_2D )
	{
		"Base_VERTEX2D.vso",
		sizeof( VERTEX2D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 20, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// D3D11_VERTEX_INPUTLAYOUT_BLENDTEX_2D( VERTEX_BLENDTEX_2D or VERTEX2DSHADER )
	{
		"Base_VERTEX_BLENDTEX_2D.vso",		
		sizeof( VERTEX_BLENDTEX_2D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        1, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 20, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 24, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32_FLOAT,       0, 32, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// D3D11_VERTEX_INPUTLAYOUT_NOTEX_3D( VERTEX_NOTEX_3D )
	{
		"Base_VERTEX_NOTEX_3D.vso",
		sizeof( VERTEX_NOTEX_3D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// D3D11_VERTEX_INPUTLAYOUT_3D( VERTEX_3D )
	{
		"Base_VERTEX_3D.vso",
		sizeof( VERTEX_3D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// D3D11_VERTEX_INPUTLAYOUT_3D_LIGHT( VERTEX3D )
	{
		"Base_VERTEX3D.vso",
		sizeof( VERTEX3D ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 24, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        1, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 28, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 32, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32_FLOAT,       0, 40, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},

	// D3D11_VERTEX_INPUTLAYOUT_SHADER_3D( VERTEX3DSHADER )
	{
		"Base_VERTEX3DSHADER.vso",
		sizeof( VERTEX3DSHADER ),
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 0,  D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "POSITION",     1, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 28, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TANGENT",      0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 40, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "BINORMAL",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 52, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 64, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "COLOR",        1, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 68, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT,       0, 72, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32_FLOAT,       0, 80, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     2, D_DXGI_FORMAT_R32G32_FLOAT,       0, 88, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ NULL },
		},
	},
} ;

// Direct3D11 gOtBbNX̍\
GRAPHICS_HARDDATA_DIRECT3D11 GraphicsHardDataDirect3D11 ;

// VF[_[oCiz
extern BYTE DxShaderCodeBin_Model_D3D11[] ;
extern BYTE DxShaderCodeBin_Filter_D3D11[] ;
extern BYTE DxShaderCodeBin_Base_D3D11[] ;
extern BYTE DxShaderCodeBin_Base3D_D3D11[] ;
extern BYTE DxShaderCodeBin_RgbaMix_D3D11[] ;

// ֐錾 -------------------------------------------------------------------

static void Graphics_D3D11_ObjectArray_Release( void **pObject, int Num ) ;							// IuWFNgz

// D3D11Device Xe[^X֌W
static int Graphics_D3D11_DeviceState_SetupSamplerState( void ) ;									// ݂̐ݒɊÂ ID3D11SamplerState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateSamplerState( void ) ;								// ID3D11SamplerState 

static int Graphics_D3D11_DeviceState_SetupRasterizerState( void ) ;								// ݂̐ݒɊÂ ID3D11RasterizerState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateRasterizerState( void ) ;							// ID3D11RasterizerState 

static int Graphics_D3D11_DeviceState_SetupDepthStencilState( void ) ;								// ݂̐ݒɊÂ ID3D11DepthStencilState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateDepthStencilState( void ) ;							// ID3D11DepthStencilState 

static int Graphics_D3D11_DeviceState_SetupBlendState( void ) ;										// ݂̐ݒɊÂ ID3D11BlendState ZbgAbv
static int Graphics_D3D11_DeviceState_TerminateBlendState( void ) ;									// ID3D11BlendState 

static int Graphics_D3D11_DeviceState_SetNormalTextureAddressTransformMatrix_ConstBuffer( void ) ;	// W`p̃eNX`Wϊs萔obt@ɃZbg
static int Graphics_D3D11_DeviceState_UpdateConstantFogParam( void ) ;								// tHO̐FȊO̒萔XV
static void Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam( void ) ;						// ArGgCgƃG~bVuJ[|킹p[^XV
static void Graphics_D3D11_DeviceState_SetRenderTarget_SizeCheck( void ) ;							// SĂ̕`Ώۂ̃TCYvĂ烌_O^[QbgɃZbg


// Direct3D11 ɐݒ肷ˉesXV
static void Graphics_Hardware_D3D11_RefreshProjectionMatrix( void ) ;

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_MipMapBlt(
	      IMAGEDATA_ORIG	*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	      int				UseSysMemSurface,
	      D_ID3D11Texture2D	*UseTex,
	      int				TexWidth,
	      int				TexHeight,
	const BASEIMAGE			*RgbBaseImage,
	const BASEIMAGE			*AlphaBaseImage,
	const COLORDATA			*DestColor,
	      int				RedIsAlphaFlag,
	      int				UseTransColorConvAlpha,
	      int				ASyncThread
) ;

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
	      IMAGEDATA_ORIG	*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	      int				UseSysMemSurface,
	      D_ID3D11Texture2D	*UseTex,
	      int				TexWidth,
	      int				TexHeight,
	      int				TexUseWidth,
	      int				TexUseHeight,
	const BASEIMAGE			*RgbBaseImage,
	const BASEIMAGE			*AlphaBaseImage,
	const COLORDATA			*DestColor,
	      int				RedIsAlphaFlag,
	      int				UseTransColorConvAlpha,
	      int				ASyncThread
) ;

__inline	static DWORD GetDiffuseColor( void )															// ݂̃fBt[YJ[𓾂
			{
				return  ( GSYS.DrawSetting.DrawBright.Red   << 16 ) |
						( GSYS.DrawSetting.DrawBright.Green << 8  ) |
						( GSYS.DrawSetting.DrawBright.Blue        ) |
						( ( ( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND || GSYS.DrawSetting.UseNoBlendModeParam ) ? GSYS.DrawSetting.BlendParam : 255 ) << 24 ) ;
			}

// vO -----------------------------------------------------------------

// Direct3D11 gpOtBbNX̏s( 0: -1:s )
extern	int		Graphics_D3D11_Initialize( void )
{
	// Direct3D11.DLL ̓ǂݍ
	if( Direct3D11_LoadDLL() < 0 )
	{
		return -1 ;
	}

	// D3D11Device 쐬
	if( Graphics_D3D11_Device_Create() != 0 )
	{
		return -1 ;
	}

	// [xobt@̍쐬݂
	if( Graphics_D3D11_CreateDepthBuffer() != 0 )
	{
		return -1 ;
	}

	// VF[_[̍쐬
	if( Graphics_D3D11_Shader_Initialize() != 0 )
	{
		return -1 ;
	}

	// 萔̏
	if( Graphics_D3D11_Constant_Initialize() != 0 )
	{
		return -1 ;
	}

	// ̓CAEg̍쐬
	if( Graphics_D3D11_InputLayout_Base_Create() != 0 )
	{
		return -1 ;
	}

	// W`p_obt@̍쐬
	if( Graphics_D3D11_NormalDrawVertexBuffer_Create() != 0 )
	{
		return -1 ;
	}

#ifndef DX_NON_MODEL
	// {[eNX`̍쐬
//	CreateRGBtoVMaxRGBVolumeTexture() ;
#endif // DX_NON_MODEL

	// tXN[[h̏ꍇ̓TuobNobt@̃ZbgAbvs
	if( GetWindowModeFlag() == FALSE )
	{
		if( Graphics_D3D11_SetupSubBackBuffer() != 0 )
		{
			return -1 ;
		}
	}

	// P]̏
	if( Graphics_D3D11_StretchRect_Initialize() != 0 )
	{
		return -1 ;
	}

	GSYS.Setting.ValidHardware = TRUE ;

	// I
	return 0 ;
}

// Direct3D11 gpOtBbNX̌ns
extern int Graphics_D3D11_Terminate( void )
{
#ifndef DX_NON_MODEL
	// f̒_obt@
	MV1TerminateVertexBufferAll() ;
#endif // DX_NON_MODEL

	// P]̌n
	Graphics_D3D11_StretchRect_Terminate() ;

	// Tv[Xe[g̉
	Graphics_D3D11_DeviceState_TerminateSamplerState() ;

	// X^CU[Xe[g̉
	Graphics_D3D11_DeviceState_TerminateRasterizerState() ;

	// [xXeVXe[g̉
	Graphics_D3D11_DeviceState_TerminateDepthStencilState() ;

	// uhXe[g̉
	Graphics_D3D11_DeviceState_TerminateBlendState() ;

	// ėp`p_obt@ƃCfbNXobt@̉
	Graphics_D3D11_CommonVertexBuffer_Terminate() ;
	Graphics_D3D11_CommonIndexBuffer_Terminate() ;

	// W`p̒_obt@̉
	Graphics_D3D11_NormalDrawVertexBuffer_Terminate() ;

	// ̓CAEǧn
	Graphics_D3D11_InputLayout_Base_Terminate() ;
#ifndef DX_NON_MODEL
	Graphics_D3D11_InputLayout_Model_Terminate() ;
#endif // DX_NON_MODEL

	// VF[_[̉
	Graphics_D3D11_Shader_Terminate() ;

	// 萔̌n
	Graphics_D3D11_Constant_Terminate() ;

	// Zobt@ ̉
	if( GD3D11.Device.Screen.DepthBufferDSV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferDSV ) ;
		GD3D11.Device.Screen.DepthBufferDSV = NULL ;
	}
	if( GD3D11.Device.Screen.DepthBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferTexture2D ) ;
		GD3D11.Device.Screen.DepthBufferTexture2D = NULL ;
	}

	// TuobNobt@̉
	if( GD3D11.Device.Screen.SubBackBufferSRV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.SubBackBufferSRV ) ;
		GD3D11.Device.Screen.SubBackBufferSRV = NULL ;
	}
	if( GD3D11.Device.Screen.SubBackBufferRTV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.SubBackBufferRTV ) ;
		GD3D11.Device.Screen.SubBackBufferRTV = NULL ;
	}
	if( GD3D11.Device.Screen.SubBackBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.SubBackBufferTexture2D ) ;
		GD3D11.Device.Screen.SubBackBufferTexture2D = NULL ;
	}

	// obNobt@̉
	if( GD3D11.Device.Screen.BackBufferRTV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.BackBufferRTV ) ;
		GD3D11.Device.Screen.BackBufferRTV = NULL ;
	}
	if( GD3D11.Device.Screen.BackBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.BackBufferTexture2D ) ;
		GD3D11.Device.Screen.BackBufferTexture2D = NULL ;
	}

#ifndef DX_NON_MODEL
	// {[eNX`̉
	if( GD3D11.RGBtoVMaxRGBVolumeTexture )
	{
		Direct3D11_ObjectRelease( GD3D11.RGBtoVMaxRGBVolumeTexture ) ;
		GD3D11.RGBtoVMaxRGBVolumeTexture = NULL ;
	}
#endif // DX_NON_MODEL

	// D3D11Device ̉
	D3D11Device_Release() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = FALSE ;

	// d3d11.dll ̉
	Direct3D11_FreeDLL() ;

	// fBXvC[hpɊmۂ̉
	if( GSYS.Screen.DisplayMode )
	{
		HeapFree( GetProcessHeap(), 0, GSYS.Screen.DisplayMode ) ;
		GSYS.Screen.DisplayMode = NULL ;
	}

	// I
	return 0 ;
}
























// VF[_[R[h֌W

// VF[_[R[hpbP[WVF[_[R[hoCĩAhXƃTCY擾
static void Graphics_D3D11_ShaderCodePackage_GetInfo( WORD **pSize, BYTE **pCode, GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *DestInfo, int Num )
{
	WORD *Size ;
	BYTE *Code ;
	int i ;

	Size = *pSize ;
	Code = *pCode ;
	for( i = 0 ; i < Num ; i ++, Size ++, DestInfo ++ )
	{
		if( *Size != 0 )
		{
			DestInfo->Binary = ( void * )Code ;
			DestInfo->Size   = *Size ;
			Code            += *Size ;
		}
	}

	*pSize = Size ;
	*pCode = Code ;
}

// Direct3D11 ̕W`p̃VF[_[R[h̏s
extern int Graphics_D3D11_ShaderCode_Base_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE *SCBASE = &GraphicsHardDataDirect3D11.ShaderCode.Base ;
	int   Size = 0 ;
	BYTE  *ShaderAddr = NULL ;
	WORD  *SizeBuf    = NULL ;

	// łɏĂ牽Ȃ
	if( SCBASE->BaseShaderInitializeFlag == TRUE )
	{
		return TRUE ;
	}

	// CgCfbNXXg̍\z
	{
		int l0, l1, l2, l3, l4, l5, ind ;

		ind = 0 ;
		for( l0 = 0 ; l0 < 4 ; l0 ++ )
		{
			for( l1 = 0 ; l1 <= l0 ; l1 ++ )
			{
				for( l2 = 0 ; l2 <= l1 ; l2 ++ )
				{
					for( l3 = 0 ; l3 <= l2 ; l3 ++ )
					{
						for( l4 = 0 ; l4 <= l3 ; l4 ++ )
						{
							for( l5 = 0 ; l5 <= l4 ; l5 ++ )
							{
								SCBASE->LightIndexList84[ l0 ][ l1 ][ l2 ][ l3 ][ l4 ][ l5 ] = ( short )ind ;
								ind ++ ;
							}
						}
					}
				}
			}
		}

		ind = 0 ;
		for( l0 = 0 ; l0 < 4 ; l0 ++ )
		{
			for( l1 = 0 ; l1 <= l0 ; l1 ++ )
			{
				for( l2 = 0 ; l2 <= l1 ; l2 ++ )
				{
					SCBASE->LightIndexList20[ l0 ][ l1 ][ l2 ] = ( short )ind ;
					ind ++ ;
				}
			}
		}

		ind = 0 ;
		for( l0 = 0 ; l0 < 3 ; l0 ++ )
		{
			for( l1 = 0 ; l1 <= l0 ; l1 ++ )
			{
				for( l2 = 0 ; l2 <= l1 ; l2 ++ )
				{
					SCBASE->LightIndexList10[ l0 ][ l1 ][ l2 ] = ( short )ind ;
					ind ++ ;
				}
			}
		}
	}

#ifndef DX_NON_FILTER
	SCBASE->FilterShaderBinDxaImage = NULL ;
	SCBASE->RGBAMixS_ShaderPackImage = NULL ;
#endif // DX_NON_FILTER

	SCBASE->Base2DShaderPackageImage = NULL ;

	// W`pVF[_[IuWFNgt@Ccw`kf[^𓀂
	{
		Size = DXA_Decode( DxShaderCodeBin_Base_D3D11, NULL ) ;
		SCBASE->Base2DShaderPackageImage = DXALLOC( Size ) ;
		if( SCBASE->Base2DShaderPackageImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Base_D3D11, SCBASE->Base2DShaderPackageImage ) ;
	}

	// AhXXg̃Zbg
	SizeBuf    = ( WORD * )SCBASE->Base2DShaderPackageImage ;
	ShaderAddr = ( BYTE * )SCBASE->Base2DShaderPackageImage +
		sizeof( WORD ) * (
			sizeof( SCBASE->BaseSimple_VS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->BaseNoneTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->BaseUseTex_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->MaskEffect_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->StretchRect_VS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE->StretchRect_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->BaseSimple_VS_Code,   sizeof( SCBASE->BaseSimple_VS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->BaseNoneTex_PS_Code,  sizeof( SCBASE->BaseNoneTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->BaseUseTex_PS_Code,   sizeof( SCBASE->BaseUseTex_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&SCBASE->MaskEffect_PS_Code,  sizeof( SCBASE->MaskEffect_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&SCBASE->StretchRect_VS_Code, sizeof( SCBASE->StretchRect_VS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&SCBASE->StretchRect_PS_Code, sizeof( SCBASE->StretchRect_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;

#ifndef DX_NON_FILTER

	// RGBAMixVF[_[pbNkt@CWJ
	{
		Size = DXA_Decode( DxShaderCodeBin_RgbaMix_D3D11, NULL ) ;
		SCBASE->RGBAMixS_ShaderPackImage = DXALLOC( Size ) ;
		if( SCBASE->RGBAMixS_ShaderPackImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_RgbaMix_D3D11, SCBASE->RGBAMixS_ShaderPackImage ) ;

		// AhXXg̃Zbg
		SizeBuf    = ( WORD  * )SCBASE->RGBAMixS_ShaderPackImage ;
		ShaderAddr = ( BYTE  * )SCBASE->RGBAMixS_ShaderPackImage +
			sizeof( WORD ) * (
				sizeof( SCBASE->RGBAMixS_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE->RGBAMixS_PS_Code,  sizeof( SCBASE->RGBAMixS_PS_Code )  / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	}

	// tB^[VF[_[IuWFNgt@Ccw`kf[^𓀂
	{
		Size = DXA_Decode( DxShaderCodeBin_Filter_D3D11, NULL ) ;
		SCBASE->FilterShaderBinDxaImage = DXALLOC( Size ) ;
		if( SCBASE->FilterShaderBinDxaImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Filter_D3D11, SCBASE->FilterShaderBinDxaImage ) ;

		// cw`t@CI[v
		DXA_Initialize( &SCBASE->FilterShaderBinDxa ) ;
		if( DXA_OpenArchiveFromMem( &SCBASE->FilterShaderBinDxa, SCBASE->FilterShaderBinDxaImage, Size, FALSE, FALSE ) != 0 )
		{
			goto ERR ;
		}
	}

#endif // DX_NON_FILTER

	SCBASE->BaseShaderInitializeFlag = TRUE ;

	// I
	return TRUE ;

ERR :
	if( SCBASE->Base2DShaderPackageImage != NULL )
	{
		DXFREE( SCBASE->Base2DShaderPackageImage ) ;
		SCBASE->Base2DShaderPackageImage = NULL ;
	}

#ifndef DX_NON_FILTER
	if( SCBASE->FilterShaderBinDxaImage != NULL )
	{
		DXFREE( SCBASE->FilterShaderBinDxaImage ) ;
		SCBASE->FilterShaderBinDxaImage = NULL ;
	}

	if( SCBASE->RGBAMixS_ShaderPackImage != NULL )
	{
		DXFREE( SCBASE->RGBAMixS_ShaderPackImage ) ;
		SCBASE->RGBAMixS_ShaderPackImage = NULL ;
	}
#endif // DX_NON_FILTER

	return FALSE ;
}

// Direct3D11 ̕W`p̃VF[_[R[ȟns
extern int Graphics_D3D11_ShaderCode_Base_Terminate( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE *SCBASE = &GraphicsHardDataDirect3D11.ShaderCode.Base ;

	// łɌnĂ牽Ȃ
	if( SCBASE->BaseShaderInitializeFlag == FALSE )
	{
		return TRUE ;
	}

	// 𓀂VF[_[i[Ẳ
	if( SCBASE->Base2DShaderPackageImage != NULL )
	{
		DXFREE( SCBASE->Base2DShaderPackageImage ) ;
		SCBASE->Base2DShaderPackageImage = NULL ;
	}

#ifndef DX_NON_FILTER

	// tB^[VF[_[pcw`̌n
	DXA_Terminate( &SCBASE->FilterShaderBinDxa ) ;

	if( SCBASE->RGBAMixS_ShaderPackImage )
	{
		DXFREE( SCBASE->RGBAMixS_ShaderPackImage ) ;
		SCBASE->RGBAMixS_ShaderPackImage = NULL ;
	}
	if( SCBASE->FilterShaderBinDxaImage )
	{
		DXFREE( SCBASE->FilterShaderBinDxaImage ) ;
		SCBASE->FilterShaderBinDxaImage = NULL ;
	}

#endif // DX_NON_FILTER

	// tO|
	SCBASE->BaseShaderInitializeFlag = FALSE ;

	// I
	return TRUE ;
}

// Direct3D11 ̕WRc`p̃VF[_[R[h̏s
extern int Graphics_D3D11_ShaderCode_Base3D_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D *SCBASE3D = &GraphicsHardDataDirect3D11.ShaderCode.Base3D ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ DX_HANDLETYPE_GRAPH ] ;
	int   Size = 0 ;
	BYTE  *ShaderAddr = NULL ;
	WORD  *SizeBuf    = NULL ;

	// łɏĂ牽Ȃ
	if( SCBASE3D->Base3DShaderInitializeFlag == TRUE )
	{
		return TRUE ;
	}

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	// NeBJZNV擾ŉ߂ďmF
	if( SCBASE3D->Base3DShaderInitializeFlag == TRUE )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		return TRUE ;
	}

	SCBASE3D->Base3DShaderPackageImage = NULL ;

	// kf[^̉
	{
		Size = DXA_Decode( DxShaderCodeBin_Base3D_D3D11, NULL ) ;
		SCBASE3D->Base3DShaderPackageImage = DXCALLOC( Size ) ;
		if( SCBASE3D->Base3DShaderPackageImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Base3D_D3D11, SCBASE3D->Base3DShaderPackageImage ) ;
	}

	// AhXXg̃Zbg
	SizeBuf    = ( WORD * )SCBASE3D->Base3DShaderPackageImage ;
	ShaderAddr = ( BYTE * )SCBASE3D->Base3DShaderPackageImage +
		sizeof( WORD ) * (
			sizeof( SCBASE3D->Base3D_PixelLighting_VS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_PixelLighting_Normal_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_ShadowMap_VS_Code             ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_NoLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_VertexLighting_VS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_ShadowMap_Normal_PS_Code      ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_NoLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCBASE3D->Base3D_VertexLighting_Normal_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_PixelLighting_VS_Code,         sizeof( SCBASE3D->Base3D_PixelLighting_VS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_PixelLighting_Normal_PS_Code,  sizeof( SCBASE3D->Base3D_PixelLighting_Normal_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_ShadowMap_VS_Code,             sizeof( SCBASE3D->Base3D_ShadowMap_VS_Code             ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_NoLighting_VS_Code,            sizeof( SCBASE3D->Base3D_NoLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_VertexLighting_VS_Code,        sizeof( SCBASE3D->Base3D_VertexLighting_VS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_ShadowMap_Normal_PS_Code,      sizeof( SCBASE3D->Base3D_ShadowMap_Normal_PS_Code      ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_NoLighting_Normal_PS_Code,     sizeof( SCBASE3D->Base3D_NoLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCBASE3D->Base3D_VertexLighting_Normal_PS_Code, sizeof( SCBASE3D->Base3D_VertexLighting_Normal_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;

	SCBASE3D->Base3DShaderInitializeFlag = TRUE ;

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// I
	return TRUE ;

ERR :
	if( SCBASE3D->Base3DShaderPackageImage != NULL )
	{
		DXFREE( SCBASE3D->Base3DShaderPackageImage ) ;
		SCBASE3D->Base3DShaderPackageImage = NULL ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	return FALSE ;
}


// Direct3D11 ̕WRc`p̃VF[_[R[ȟns
extern int Graphics_D3D11_ShaderCode_Base3D_Terminate( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D *SCBASE3D = &GraphicsHardDataDirect3D11.ShaderCode.Base3D ;

	// łɌnĂ牽Ȃ
	if( SCBASE3D->Base3DShaderInitializeFlag == FALSE )
	{
		return TRUE ;
	}

	if( SCBASE3D->Base3DShaderPackageImage )
	{
		DXFREE( SCBASE3D->Base3DShaderPackageImage ) ;
		SCBASE3D->Base3DShaderPackageImage = NULL ;
	}

	// tO|
	SCBASE3D->Base3DShaderInitializeFlag = FALSE ;

	// I
	return TRUE ;
}


#ifndef DX_NON_MODEL

// Direct3D11 ̃f`p̃VF[_[R[h̏s
extern	int		Graphics_D3D11_ShaderCode_Model_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL *SCMODEL = &GraphicsHardDataDirect3D11.ShaderCode.Model ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ DX_HANDLETYPE_GRAPH ] ;
	int   Size = 0 ;
	BYTE  *ShaderAddr = NULL ;
	WORD  *SizeBuf    = NULL ;

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	// łɏĂ牽Ȃ
	if( SCMODEL->ModelShaderInitializeFlag == TRUE )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		return TRUE ;
	}

	SCMODEL->ModelShaderPackImage = NULL ;

	// kf[^̉
	{
		Size = DXA_Decode( DxShaderCodeBin_Model_D3D11, NULL ) ;
		SCMODEL->ModelShaderPackImage = DXCALLOC( Size ) ;
		if( SCMODEL->ModelShaderPackImage == NULL )
		{
			goto ERR ;
		}

		DXA_Decode( DxShaderCodeBin_Model_D3D11, SCMODEL->ModelShaderPackImage ) ;
	}

	// AhXXg̃Zbg
	SizeBuf    = ( WORD * )SCMODEL->ModelShaderPackImage ;
	ShaderAddr = ( BYTE * )SCMODEL->ModelShaderPackImage +
		sizeof( WORD ) * (
			sizeof( SCMODEL->MV1_PixelLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_PixelLighting_ToonType1_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_PixelLighting_ToonType2_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_PixelLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ToonOutLine_ShadowMap_VS_Code    ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ToonOutLine_VS_Code              ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ShadowMap_VS_Code                ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_NoLighting_VS_Code               ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_VertexLighting_VS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ShadowMap_Toon_PS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_ShadowMap_Normal_PS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_NoLighting_Toon_PS_Code          ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_NoLighting_Normal_PS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_VertexLighting_ToonType1_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_VertexLighting_ToonType2_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) +
			sizeof( SCMODEL->MV1_VertexLighting_Normal_PS_Code    ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_PixelLighting_VS_Code,            sizeof( SCMODEL->MV1_PixelLighting_VS_Code            ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_PixelLighting_ToonType1_PS_Code,  sizeof( SCMODEL->MV1_PixelLighting_ToonType1_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_PixelLighting_ToonType2_PS_Code,  sizeof( SCMODEL->MV1_PixelLighting_ToonType2_PS_Code  ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_PixelLighting_Normal_PS_Code,     sizeof( SCMODEL->MV1_PixelLighting_Normal_PS_Code     ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ToonOutLine_ShadowMap_VS_Code,    sizeof( SCMODEL->MV1_ToonOutLine_ShadowMap_VS_Code    ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ToonOutLine_VS_Code,              sizeof( SCMODEL->MV1_ToonOutLine_VS_Code              ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ShadowMap_VS_Code,                sizeof( SCMODEL->MV1_ShadowMap_VS_Code                ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_NoLighting_VS_Code,               sizeof( SCMODEL->MV1_NoLighting_VS_Code               ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_VertexLighting_VS_Code,           sizeof( SCMODEL->MV1_VertexLighting_VS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ShadowMap_Toon_PS_Code,           sizeof( SCMODEL->MV1_ShadowMap_Toon_PS_Code           ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_ShadowMap_Normal_PS_Code,         sizeof( SCMODEL->MV1_ShadowMap_Normal_PS_Code         ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_NoLighting_Toon_PS_Code,          sizeof( SCMODEL->MV1_NoLighting_Toon_PS_Code          ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_NoLighting_Normal_PS_Code,        sizeof( SCMODEL->MV1_NoLighting_Normal_PS_Code        ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_VertexLighting_ToonType1_PS_Code, sizeof( SCMODEL->MV1_VertexLighting_ToonType1_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_VertexLighting_ToonType2_PS_Code, sizeof( SCMODEL->MV1_VertexLighting_ToonType2_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
	Graphics_D3D11_ShaderCodePackage_GetInfo( &SizeBuf, &ShaderAddr, ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )SCMODEL->MV1_VertexLighting_Normal_PS_Code,    sizeof( SCMODEL->MV1_VertexLighting_Normal_PS_Code    ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;

	SCMODEL->ModelShaderInitializeFlag = TRUE ;

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// I
	return TRUE ;

ERR :
	if( SCMODEL->ModelShaderPackImage != NULL )
	{
		DXFREE( SCMODEL->ModelShaderPackImage ) ;
		SCMODEL->ModelShaderPackImage = NULL ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	return FALSE ;
}

// Direct3D11 ̃f`p̃VF[_[R[ȟns
extern	int		Graphics_D3D11_ShaderCode_Model_Terminate( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_MODEL *SCMODEL = &GraphicsHardDataDirect3D11.ShaderCode.Model ;

	// łɌnĂ牽Ȃ
	if( SCMODEL->ModelShaderInitializeFlag == FALSE )
	{
		return TRUE ;
	}

	if( SCMODEL->ModelShaderPackImage )
	{
		DXFREE( SCMODEL->ModelShaderPackImage ) ;
		SCMODEL->ModelShaderPackImage = NULL ;
	}

	// tO|
	SCMODEL->ModelShaderInitializeFlag = FALSE ;

	// I
	return TRUE ;
}

#endif // DX_NON_MODEL



// VF[_[R[h璸_VF[_[쐬
extern int Graphics_D3D11_VertexShader_Create( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *Code, D_ID3D11VertexShader **pDestShader, int Num )
{
	int i ;

	for( i = 0; i < Num; i++, Code++, pDestShader++ )
	{
		if( D3D11Device_CreateVertexShader( ( BYTE * )Code->Binary, ( SIZE_T )Code->Size, NULL, pDestShader ) != S_OK )
		{
			return -1 + i ;
		}
	}

	return 0 ;
}

// VF[_[R[hsNZVF[_[쐬
extern int Graphics_D3D11_PixelShader_Create( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *Code, D_ID3D11PixelShader **pDestShader, int Num )
{
	int i ;

	for( i = 0; i < Num; i++, Code++, pDestShader++ )
	{
		if( D3D11Device_CreatePixelShader( ( BYTE * )Code->Binary, ( SIZE_T )Code->Size, NULL, pDestShader ) != S_OK )
		{
			return -1 + i ;
		}
	}

	return 0 ;
}

// IuWFNgz
static void Graphics_D3D11_ObjectArray_Release( void **pObject, int Num )
{
	int i ;

	for( i = 0 ; i < Num ; i++, pObject++ )
	{
		if( *pObject )
		{
			Direct3D11_ObjectRelease( *pObject ) ;
			*pObject = NULL ;
		}
	}
}

// Direct3D11 ̃VF[_[̏s
extern int Graphics_D3D11_Shader_Initialize( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE      *ShaderCode = &GraphicsHardDataDirect3D11.ShaderCode ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER          *Shader     = &GraphicsHardDataDirect3D11.Device.Shader ;
	int Result ;

	// ɍ쐬ĂƂ̂߂ɍ폜s
	//TerminateDirect3D11Shader() ;
	Graphics_D3D11_Shader_Terminate() ;

//	return 0 ;

	// Direct3D11 ̏ꍇ̓VF[_[͕Kgpł
	GSYS.HardInfo.UseShader = TRUE ;

	// W`pVF[_[R[hWJĂȂꍇ͓WJ
	if( Graphics_D3D11_ShaderCode_Base_Initialize() == FALSE )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "VF[_[R[hWJ郁̈̊mۂɎs܂\n" ) ) ) ;
		GSYS.HardInfo.UseShader = FALSE ;
		goto ERR ;
	}

	// {Iȕ`揈ɎgpVF[_[쐬
	{
		// W`p̕GȏsȂ_VF[_[̍쐬
		Result = Graphics_D3D11_VertexShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )ShaderCode->Base.BaseSimple_VS_Code, ( D_ID3D11VertexShader ** )Shader->Base.BaseSimple_VS, sizeof( ShaderCode->Base.BaseSimple_VS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "W`p̕GȏsȂ_VF[_[IuWFNg No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}

		// Œ@\pCvC݊̃sNZVF[_[( eNX`Ȃ )̍쐬
		Result = Graphics_D3D11_PixelShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )ShaderCode->Base.BaseNoneTex_PS_Code, ( D_ID3D11PixelShader ** )Shader->Base.BaseNoneTex_PS, sizeof( ShaderCode->Base.BaseNoneTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "Œ@\pCvC݊̃sNZVF[_[IuWFNg( eNX`Ȃ ) No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}

		// Œ@\pCvC݊̃sNZVF[_[( eNX` )̍쐬
		Result = Graphics_D3D11_PixelShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )ShaderCode->Base.BaseUseTex_PS_Code, ( D_ID3D11PixelShader ** )Shader->Base.BaseUseTex_PS, sizeof( ShaderCode->Base.BaseUseTex_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "Œ@\pCvC݊̃sNZVF[_[IuWFNg( eNX` ) No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}

		// }XNpsNZVF[_[̍쐬
		Result = Graphics_D3D11_PixelShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&ShaderCode->Base.MaskEffect_PS_Code, ( D_ID3D11PixelShader ** )&Shader->Base.MaskEffect_PS, sizeof( ShaderCode->Base.MaskEffect_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "}XNp̃sNZVF[_[IuWFNg No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}

		// P]pVF[_[̍쐬
		Result = Graphics_D3D11_VertexShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&ShaderCode->Base.StretchRect_VS_Code, ( D_ID3D11VertexShader ** )&Shader->Base.StretchRect_VS, sizeof( ShaderCode->Base.StretchRect_VS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "P]p̒_VF[_[IuWFNg No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}
		Result = Graphics_D3D11_PixelShader_Create( ( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO * )&ShaderCode->Base.StretchRect_PS_Code, ( D_ID3D11PixelShader ** )&Shader->Base.StretchRect_PS, sizeof( ShaderCode->Base.StretchRect_PS_Code ) / sizeof( GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO ) ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "P]p̃sNZVF[_[IuWFNg No.%d ̍쐬Ɏs܂\n" ), -( Result + 1 ) ) ) ;
			GSYS.HardInfo.UseShader = FALSE ;
			goto ERR ;
		}
	}

	// I
	return 0 ;

ERR :

	// G[I
	return -1 ;
}


// Direct3D11 ̃VF[_[̌n
extern int Graphics_D3D11_Shader_Terminate( void )
{
	GRAPHICS_HARDDATA_DIRECT3D11_DEVICE *Device = &GraphicsHardDataDirect3D11.Device ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER *Shader = &Device->Shader ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	Graphics_D3D11_DeviceState_ResetVertexShader() ;
	Graphics_D3D11_DeviceState_ResetPixelShader() ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )Shader->Base.BaseSimple_VS,   sizeof( Shader->Base.BaseSimple_VS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )Shader->Base.BaseNoneTex_PS,  sizeof( Shader->Base.BaseNoneTex_PS ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )Shader->Base.BaseUseTex_PS,   sizeof( Shader->Base.BaseUseTex_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base.MaskEffect_PS,  sizeof( Shader->Base.MaskEffect_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base.StretchRect_VS, sizeof( Shader->Base.StretchRect_VS ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base.StretchRect_PS, sizeof( Shader->Base.StretchRect_PS ) / sizeof( void * ) ) ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_PixelLighting_VS,         sizeof( Shader->Base3D.Base3D_PixelLighting_VS         ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_PixelLighting_Normal_PS,  sizeof( Shader->Base3D.Base3D_PixelLighting_Normal_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_ShadowMap_VS,             sizeof( Shader->Base3D.Base3D_ShadowMap_VS             ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_NoLighting_VS,            sizeof( Shader->Base3D.Base3D_NoLighting_VS            ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_VertexLighting_VS,        sizeof( Shader->Base3D.Base3D_VertexLighting_VS        ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_ShadowMap_Normal_PS,      sizeof( Shader->Base3D.Base3D_ShadowMap_Normal_PS      ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_NoLighting_Normal_PS,     sizeof( Shader->Base3D.Base3D_NoLighting_Normal_PS     ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Base3D.Base3D_VertexLighting_Normal_PS, sizeof( Shader->Base3D.Base3D_VertexLighting_Normal_PS ) / sizeof( void * ) ) ;

#ifndef DX_NON_MODEL

	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_PixelLighting_VS,            sizeof( Shader->Model.MV1_PixelLighting_VS            ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_PixelLighting_ToonType1_PS,  sizeof( Shader->Model.MV1_PixelLighting_ToonType1_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_PixelLighting_ToonType2_PS,  sizeof( Shader->Model.MV1_PixelLighting_ToonType2_PS  ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_PixelLighting_Normal_PS,     sizeof( Shader->Model.MV1_PixelLighting_Normal_PS     ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ToonOutLine_ShadowMap_VS,    sizeof( Shader->Model.MV1_ToonOutLine_ShadowMap_VS    ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ToonOutLine_VS,              sizeof( Shader->Model.MV1_ToonOutLine_VS              ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ShadowMap_VS,                sizeof( Shader->Model.MV1_ShadowMap_VS                ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_NoLighting_VS,               sizeof( Shader->Model.MV1_NoLighting_VS               ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_VertexLighting_VS,           sizeof( Shader->Model.MV1_VertexLighting_VS           ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ShadowMap_Toon_PS,           sizeof( Shader->Model.MV1_ShadowMap_Toon_PS           ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_ShadowMap_Normal_PS,         sizeof( Shader->Model.MV1_ShadowMap_Normal_PS         ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_NoLighting_Toon_PS,          sizeof( Shader->Model.MV1_NoLighting_Toon_PS          ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_NoLighting_Normal_PS,        sizeof( Shader->Model.MV1_NoLighting_Normal_PS        ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_VertexLighting_ToonType1_PS, sizeof( Shader->Model.MV1_VertexLighting_ToonType1_PS ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_VertexLighting_ToonType2_PS, sizeof( Shader->Model.MV1_VertexLighting_ToonType2_PS ) / sizeof( void * ) ) ;
	Graphics_D3D11_ObjectArray_Release( ( void ** )&Shader->Model.MV1_VertexLighting_Normal_PS,    sizeof( Shader->Model.MV1_VertexLighting_Normal_PS    ) / sizeof( void * ) ) ;

#endif // DX_NON_MODEL

	// I
	return 0 ;
}

// RcW`̎w̒_p̕`pVF[_[ZbgAbv
extern int Graphics_D3D11_Shader_Normal3DDraw_Setup( void )
{
	GRAPHICS_HARDWARE_DIRECT3D11_SHADER_BASE3D		*SB3D  = &GD3D11.Device.Shader.Base3D ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_BASE3D	*SCB3D = &GD3D11.ShaderCode.Base3D ;
	int												ValidPL ;
	D_ID3D11VertexShader							**VS_PL       = NULL ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO	*VSAddress_PL = NULL ;
	D_ID3D11PixelShader								**PS_PL       = NULL ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO	*PSAddress_PL = NULL ;
	D_ID3D11VertexShader							**VS          = NULL ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO	*VSAddress    = NULL ;
	D_ID3D11PixelShader								**PS          = NULL ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO	*PSAddress    = NULL ;
	int												ShadowMap ;
	int												FogType ;
	int												LightIndex84 ;
	int												LightIndex20 ;
	int												LightIndex10 ;
	int												AlphaTestMode ;
	int												BumpMap ;

	if( GD3D11.ShaderCode.Base3D.Base3DShaderInitializeFlag == FALSE &&
		Graphics_D3D11_ShaderCode_Base3D_Initialize() == FALSE )
	{
		return FALSE ;
	}

	ShadowMap     = GSYS.DrawSetting.UseShadowMapNum != 0 ? 1 : 0 ;
	FogType       = GD3D11.Device.State.FogEnable ? GD3D11.Device.State.FogMode : DX_FOGMODE_NONE ;
	AlphaTestMode = GD3D11.Device.State.AlphaTestModeShaderIndex ;
	BumpMap       = 0 ;

	if( GSYS.DrawSetting.ShadowMapDraw )
	{
		// VhE}bvւ̕`

		VS           =  &SB3D->Base3D_ShadowMap_VS     [ BumpMap ] ;
		VSAddress    = &SCB3D->Base3D_ShadowMap_VS_Code[ BumpMap ] ;

		PS           =  &SB3D->Base3D_ShadowMap_Normal_PS     [ AlphaTestMode ] ;
		PSAddress    = &SCB3D->Base3D_ShadowMap_Normal_PS_Code[ AlphaTestMode ] ;
	}
	else
	if( GD3D11.Device.State.Lighting )
	{
		// CeBO`

		int LightMode[ DX_PIXELLIGHTING_LIGHT_NUM ] ;
		int i ;

		for( i = 0 ; i < DX_PIXELLIGHTING_LIGHT_NUM ; i ++ )
		{
			LightMode[ i ] = GD3D11.Device.State.LightEnableFlag[ i ] ? GD3D11.Device.State.LightParam[ i ].LightType : 0 ;
		}

		LightIndex84 = GD3D11.ShaderCode.Base.LightIndexList84[ LightMode[ 0 ] ][ LightMode[ 1 ] ][ LightMode[ 2 ] ][ LightMode[ 3 ] ][ LightMode[ 4 ] ][ LightMode[ 5 ] ] ;
		LightIndex20 = GD3D11.ShaderCode.Base.LightIndexList20[ LightMode[ 0 ] ][ LightMode[ 1 ] ][ LightMode[ 2 ] ] ;
		LightIndex10 = GD3D11.ShaderCode.Base.LightIndexList10
				[ LightMode[ 0 ] == DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ? 2 : ( LightMode[ 0 ] ? 1 : 0 ) ]
				[ LightMode[ 1 ] == DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ? 2 : ( LightMode[ 1 ] ? 1 : 0 ) ]
				[ LightMode[ 2 ] == DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ? 2 : ( LightMode[ 2 ] ? 1 : 0 ) ] ;

		VS_PL        =  &SB3D->Base3D_PixelLighting_VS     [ ShadowMap ][ FogType ] ;
		VSAddress_PL = &SCB3D->Base3D_PixelLighting_VS_Code[ ShadowMap ][ FogType ] ;

		PS_PL        =  &SB3D->Base3D_PixelLighting_Normal_PS     [ ShadowMap ][ LightIndex84 ][ AlphaTestMode ] ;
		PSAddress_PL = &SCB3D->Base3D_PixelLighting_Normal_PS_Code[ ShadowMap ][ LightIndex84 ][ AlphaTestMode ] ;

		VS           =  &SB3D->Base3D_VertexLighting_VS     [ ShadowMap ][ FogType ][ LightIndex20 ] ;
		VSAddress    = &SCB3D->Base3D_VertexLighting_VS_Code[ ShadowMap ][ FogType ][ LightIndex20 ] ;

		PS           =  &SB3D->Base3D_VertexLighting_Normal_PS     [ ShadowMap ][ LightIndex10 ][ AlphaTestMode ] ;
		PSAddress    = &SCB3D->Base3D_VertexLighting_Normal_PS_Code[ ShadowMap ][ LightIndex10 ][ AlphaTestMode ] ;
	}
	else
	{
		// CeBOȂ`

		VS           =  &SB3D->Base3D_NoLighting_VS     [ FogType ] ;
		VSAddress    = &SCB3D->Base3D_NoLighting_VS_Code[ FogType ] ;

		PS           =  &SB3D->Base3D_NoLighting_Normal_PS     [ AlphaTestMode ] ;
		PSAddress    = &SCB3D->Base3D_NoLighting_Normal_PS_Code[ AlphaTestMode ] ;
	}

	ValidPL = 
		VSAddress_PL != NULL && VSAddress_PL->Binary != NULL &&
		PSAddress_PL != NULL && PSAddress_PL->Binary != NULL ;

	if( ( GSYS.Light.EnableNum > DX_VERTEXLIGHTING_LIGHT_NUM || GD3D11.UsePixelLightingShader ) && ValidPL )
	{
		// VF[_[邩ǂ𒲂ׂ
		if( *VS_PL == NULL )
		{
			// VF[_[̍쐬݂
			if( Graphics_D3D11_VertexShader_Create( VSAddress_PL, VS_PL, 1 ) != 0 )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "Graphics_D3D11_Shader_Normal3DDraw_Setup Œ_VF[_[̍쐬Ɏs܂\n" ) ) ) ;
				return FALSE ;
			}
		}

		// o[ebNXVF[_[̃ZbgAbv
		Graphics_D3D11_DeviceState_SetVertexShader( *VS_PL, FALSE ) ;


		// VF[_[邩ǂ𒲂ׂ
		if( *PS_PL == NULL )
		{
			// VF[_[̍쐬݂
			if( Graphics_D3D11_PixelShader_Create( PSAddress_PL, PS_PL, 1 ) != 0 )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "Graphics_D3D11_Shader_Normal3DDraw_Setup ŃsNZVF[_[̍쐬Ɏs܂\n" ) ) ) ;
				return FALSE ;
			}
		}

		// sNZVF[_[̃ZbgAbv
		Graphics_D3D11_DeviceState_SetPixelShader( *PS_PL, FALSE ) ;
	}
	else
	{
		// VF[_[邩ǂ𒲂ׂ
		if( *VS == NULL )
		{
			// VF[_[̍쐬݂
			if( Graphics_D3D11_VertexShader_Create( VSAddress, VS, 1 ) != 0 )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "Graphics_D3D11_Shader_Normal3DDraw_Setup Œ_VF[_[̍쐬Ɏs܂\n" ) ) ) ;
				return FALSE ;
			}
		}

		// o[ebNXVF[_[̃ZbgAbv
		Graphics_D3D11_DeviceState_SetVertexShader( *VS, FALSE ) ;


		// VF[_[邩ǂ𒲂ׂ
		if( *PS == NULL )
		{
			// VF[_[̍쐬݂
			if( Graphics_D3D11_PixelShader_Create( PSAddress, PS, 1 ) != 0 )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "Graphics_D3D11_Shader_Normal3DDraw_Setup ŃsNZVF[_[̍쐬Ɏs܂\n" ) ) ) ;
				return FALSE ;
			}
		}

		// sNZVF[_[̃ZbgAbv
		Graphics_D3D11_DeviceState_SetPixelShader( *PS ) ;
	}


	// I
	return TRUE ;
}

// At@eXg̔r[hsNZVF[_[̃At@eXg[h( DIRECT3D11_PS_ALPHATEST_CMP_GREATER  )擾
extern int Graphics_D3D11_Shader_GetAlphaTestModeIndex( int AlphaTestEnable, int AlphaTestMode /* DX_CMP_NEVER  */ )
{
	if( AlphaTestEnable == FALSE )
	{
		return DIRECT3D11_PS_ALPHATEST_CMP_GREATER ;
	}

	switch( AlphaTestMode )
	{
	default:
		return DIRECT3D11_PS_ALPHATEST_CMP_OTHER ;

	case DX_CMP_GREATER :		// DrawAlpha >  TestParam
		return DIRECT3D11_PS_ALPHATEST_CMP_GREATER ;
	}
}

























// Direct3D11 ̉ʊ֌W

// ScreenCopy  GetDrawScreen 邽߂Ɏgpe|obt@̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_SetupSubBackBuffer( void )
{
	HRESULT                           hr ;
	D_D3D11_TEXTURE2D_DESC            Texture2DDesc ;
	D_D3D11_RENDER_TARGET_VIEW_DESC   RTVDesc ;
	D_D3D11_SHADER_RESOURCE_VIEW_DESC SRVDesc ;
	float                             ColorRGBA[ 4 ] ;

	// ɃTuobNobt@쐬Ăꍇ͉Ȃ
	if( GD3D11.Device.Screen.SubBackBufferTexture2D != NULL ) return 0 ;

	// foCX̏ꍇ͉I
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `foĂ
	DRAWSTOCKINFO

	// TuobNobt@̃TCYZbg
	GD3D11.Device.Screen.SubBackBufferTextureSizeX = GSYS.Screen.MainScreenSizeX ;
	GD3D11.Device.Screen.SubBackBufferTextureSizeY = GSYS.Screen.MainScreenSizeY ;

	// TuobNobt@peNX`̍쐬
	_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) );
	Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
	Texture2DDesc.Format             = DIRECT3D11_BACKBUFFER_FORMAT ;
	Texture2DDesc.BindFlags          = D_D3D11_BIND_RENDER_TARGET | D_D3D11_BIND_SHADER_RESOURCE ;
	Texture2DDesc.Width              = GD3D11.Device.Screen.SubBackBufferTextureSizeX ;
	Texture2DDesc.Height             = GD3D11.Device.Screen.SubBackBufferTextureSizeY ;
	Texture2DDesc.CPUAccessFlags     = 0 ;
	Texture2DDesc.MipLevels          = 1 ;
	Texture2DDesc.ArraySize          = 1 ;
	Texture2DDesc.SampleDesc.Count   = GRAWIN.Setting.FSAAMultiSampleCount == 0 ? 1 : GRAWIN.Setting.FSAAMultiSampleCount ;
	Texture2DDesc.SampleDesc.Quality = GRAWIN.Setting.FSAAMultiSampleQuality ;
	hr = D3D11Device_CreateTexture2D( &Texture2DDesc, NULL, &GD3D11.Device.Screen.SubBackBufferTexture2D ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "TuobNobt@peNX`̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
			Texture2DDesc.Format, GD3D11.Device.Screen.SubBackBufferTextureSizeX, GD3D11.Device.Screen.SubBackBufferTextureSizeY )) ;
		return -1 ;
	}

	// TuobNobt@p_[^[Qbgr[쐬
	_MEMSET( &RTVDesc, 0, sizeof( RTVDesc ) );
	RTVDesc.Format        = DIRECT3D11_BACKBUFFER_FORMAT ;
	RTVDesc.ViewDimension = D_D3D11_RTV_DIMENSION_TEXTURE2D ;
	hr = D3D11Device_CreateRenderTargetView( GD3D11.Device.Screen.SubBackBufferTexture2D, &RTVDesc, &GD3D11.Device.Screen.SubBackBufferRTV ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "TuobNobt@p_[^[Qbgr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
			Texture2DDesc.Format, GD3D11.Device.Screen.SubBackBufferTextureSizeX, GD3D11.Device.Screen.SubBackBufferTextureSizeY )) ;
		return -1 ;
	}

	// TuobNobt@p̃VF[_\[Xr[쐬
	_MEMSET( &SRVDesc, 0, sizeof( SRVDesc ) );
	SRVDesc.Format              = DIRECT3D11_BACKBUFFER_FORMAT ;
	SRVDesc.ViewDimension       = D_D3D11_SRV_DIMENSION_TEXTURE2D ;
	SRVDesc.Texture2D.MipLevels = 1 ;
	hr = D3D11Device_CreateShaderResourceView( GD3D11.Device.Screen.SubBackBufferTexture2D, &SRVDesc, &GD3D11.Device.Screen.SubBackBufferSRV ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "TuobNobt@pVF[_[\[Xr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
			Texture2DDesc.Format, GD3D11.Device.Screen.SubBackBufferTextureSizeX, GD3D11.Device.Screen.SubBackBufferTextureSizeY )) ;
		return -1 ;
	}

	// {obNobt@̓e]
	// }`TvΉɂ͕`揈ɂKv
	D3D11DeviceContext_CopyResource( GD3D11.Device.Screen.SubBackBufferTexture2D, GD3D11.Device.Screen.BackBufferTexture2D ) ;

	// {obNobt@̓e
	ColorRGBA[ 0 ] = 0.0f ;
	ColorRGBA[ 1 ] = 0.0f ;
	ColorRGBA[ 2 ] = 0.0f ;
	ColorRGBA[ 3 ] = 0.0f ;
	D3D11DeviceContext_ClearRenderTargetView( GD3D11.Device.Screen.BackBufferRTV, ColorRGBA ) ;

	// _O^[Qbg̕ύX
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;
	Graphics_D3D11_DeviceState_SetRenderTarget( GD3D11.Device.Screen.SubBackBufferTexture2D, GD3D11.Device.Screen.SubBackBufferRTV ) ;
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;

	// I
	return 0 ;
}

// [xobt@IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_CreateDepthBuffer( void )
{
	HRESULT hr ;
	int w, h ;
	int depth ;
	int index ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// ɍ쐬ς݂̏ꍇ͈x폜
	if( GD3D11.Device.Screen.DepthBufferTexture2D )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferTexture2D ) ;
		GD3D11.Device.Screen.DepthBufferTexture2D = NULL ;
	}
	if( GD3D11.Device.Screen.DepthBufferDSV )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DepthBufferDSV ) ;
		GD3D11.Device.Screen.DepthBufferDSV = NULL ;
	}

	DXST_ERRORLOG_ADD( _T( "[xobt@쐬܂.... " ) ) ;

	// [xobt@̃TCY
	if( GD3D11.Setting.UserDepthBufferSizeSet == FALSE ||
		GD3D11.Device.Screen.DepthBufferSizeX == 0 ||
		GD3D11.Device.Screen.DepthBufferSizeY == 0 )
	{
		for( w = 1 ; w < GSYS.Screen.MainScreenSizeX ; w <<= 1 ){}
		for( h = 1 ; h < GSYS.Screen.MainScreenSizeY ; h <<= 1 ){}
		GD3D11.Device.Screen.DepthBufferSizeX = w ;
		GD3D11.Device.Screen.DepthBufferSizeY = h ;
	}
	else
	{
		w = GD3D11.Device.Screen.DepthBufferSizeX ;
		h = GD3D11.Device.Screen.DepthBufferSizeY ;
	}

	// [xobt@̃rbg[x
	if( GD3D11.Setting.UserDepthBufferBitDepthSet == FALSE ||
		GD3D11.Device.Screen.DepthBufferBitDepth == 0  )
	{
		depth = DEFAULT_ZBUFFER_BITDEPTH ;
		GD3D11.Device.Screen.DepthBufferBitDepth = DEFAULT_ZBUFFER_BITDEPTH ;
	}
	else
	{
		depth = GD3D11.Device.Screen.DepthBufferBitDepth ;
	}
	switch( depth )
	{
	default :
	case 16 : index = ZBUFFER_FORMAT_16BIT ; break ;
	case 24 : index = ZBUFFER_FORMAT_24BIT ; break ;
	case 32 : index = ZBUFFER_FORMAT_32BIT ; break ;
	}

	// [xobt@eNX`̍쐬
	{
		D_D3D11_TEXTURE2D_DESC Texture2DDesc ;

		_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) ) ;
		Texture2DDesc.Width              = GSYS.Screen.MainScreenSizeX ;
		Texture2DDesc.Height             = GSYS.Screen.MainScreenSizeY ;
		Texture2DDesc.MipLevels          = 1 ;
		Texture2DDesc.ArraySize          = 1 ;
//		Texture2DDesc.Format             = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ index ] ;
		Texture2DDesc.Format             = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ index ] ;
		Texture2DDesc.SampleDesc.Count   = GRAWIN.Setting.FSAAMultiSampleCount ;
		Texture2DDesc.SampleDesc.Quality = GRAWIN.Setting.FSAAMultiSampleQuality ;
		Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
		Texture2DDesc.BindFlags          = D_D3D11_BIND_DEPTH_STENCIL /* | D_D3D11_BIND_SHADER_RESOURCE */ ;
		Texture2DDesc.CPUAccessFlags     = 0 ;
		Texture2DDesc.MiscFlags          = 0 ;

		// 쐬
		hr = D3D11Device_CreateTexture2D( &Texture2DDesc, NULL, &GD3D11.Device.Screen.DepthBufferTexture2D ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "[xobt@p Texture2D ̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// [xXeVr[̍쐬
	{
		D_D3D11_DEPTH_STENCIL_VIEW_DESC DepthStencilViewDesc ;

		_MEMSET( &DepthStencilViewDesc, 0, sizeof( DepthStencilViewDesc ) ) ;
		DepthStencilViewDesc.Format = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ index ] ;
		if ( GRAWIN.Setting.FSAAMultiSampleCount <= 1 )
		{
			DepthStencilViewDesc.ViewDimension      = D_D3D11_DSV_DIMENSION_TEXTURE2D;
			DepthStencilViewDesc.Texture2D.MipSlice = 0;
		}
		else
		{
			DepthStencilViewDesc.ViewDimension		= D_D3D11_DSV_DIMENSION_TEXTURE2DMS;
		}

		hr = D3D11Device_CreateDepthStencilView( GD3D11.Device.Screen.DepthBufferTexture2D, &DepthStencilViewDesc, &GD3D11.Device.Screen.DepthBufferDSV ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "[xobt@p DepthStencilView ̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// foCXɃZbg
	Graphics_D3D11_DeviceState_SetDepthStencil( GD3D11.Device.Screen.DepthBufferTexture2D, GD3D11.Device.Screen.DepthBufferDSV ) ;

	// NA
	D3D11DeviceContext_ClearDepthStencilView( GD3D11.Device.Screen.DepthBufferDSV, D_D3D11_CLEAR_DEPTH, 1.0f, 0 ) ;

	DXST_ERRORLOG_ADD( _T( "\n" ) ) ;

	// I
	return 0 ;
}























// Direct3D11 ̉摜֌W

// D_DXGI_FORMAT ̃tH[}bgɍ킹J[tH[}bg擾
extern COLORDATA *Graphics_D3D11_GetD3DFormatColorData( D_DXGI_FORMAT Format )
{
	static int InitializeFlag = FALSE ;
	static COLORDATA R8G8B8A8_ColorData ;
	static COLORDATA A16B16G16R16I_ColorData ;
	static COLORDATA A16B16G16R16F_ColorData ;
	static COLORDATA A32B32G32R32F_ColorData ;
	static COLORDATA ONE_I8_ColorData ;
	static COLORDATA ONE_I16_ColorData ;
	static COLORDATA ONE_F16_ColorData ;
	static COLORDATA ONE_F32_ColorData ;
	static COLORDATA TWO_I8_ColorData ;
	static COLORDATA TWO_I16_ColorData ;
	static COLORDATA TWO_F16_ColorData ;
	static COLORDATA TWO_F32_ColorData ;

	if( InitializeFlag == FALSE )
	{
		InitializeFlag = TRUE ;
		NS_CreateColorData( &R8G8B8A8_ColorData,       32, 0x000000ff, 0x0000ff00, 0x00ff0000, 0xff000000 ) ;
		NS_CreateColorData( &A16B16G16R16I_ColorData,   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, FALSE ) ;
		NS_CreateColorData( &A16B16G16R16F_ColorData,   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16,  TRUE ) ;
		NS_CreateColorData( &A32B32G32R32F_ColorData,   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 32,  TRUE ) ;
		NS_CreateColorData( &ONE_I8_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1,  8, FALSE ) ;
		NS_CreateColorData( &ONE_I16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, FALSE ) ;
		NS_CreateColorData( &ONE_F16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16,  TRUE ) ;
		NS_CreateColorData( &ONE_F32_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 32,  TRUE ) ;
		NS_CreateColorData( &TWO_I8_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2,  8, FALSE ) ;
		NS_CreateColorData( &TWO_I16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, FALSE ) ;
		NS_CreateColorData( &TWO_F16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16,  TRUE ) ;
		NS_CreateColorData( &TWO_F32_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 32,  TRUE ) ;
	}

	switch( Format )
	{
	case D_DXGI_FORMAT_R8G8B8A8_UNORM :     return &R8G8B8A8_ColorData ;
	case D_DXGI_FORMAT_R16G16B16A16_UNORM : return &A16B16G16R16I_ColorData ;
	case D_DXGI_FORMAT_R16G16B16A16_FLOAT : return &A16B16G16R16F_ColorData ;
	case D_DXGI_FORMAT_R32G32B32A32_FLOAT : return &A32B32G32R32F_ColorData ;
	case D_DXGI_FORMAT_R8_UNORM :           return &ONE_I8_ColorData ;
	case D_DXGI_FORMAT_R16_UNORM :          return &ONE_I16_ColorData ;
	case D_DXGI_FORMAT_R16_FLOAT :          return &ONE_F16_ColorData ;
	case D_DXGI_FORMAT_R32_FLOAT :          return &ONE_F32_ColorData ;
	case D_DXGI_FORMAT_R8G8_UNORM :         return &TWO_I8_ColorData ;
	case D_DXGI_FORMAT_R16G16_UNORM :       return &TWO_I16_ColorData ;
	case D_DXGI_FORMAT_R16G16_FLOAT :       return &TWO_F16_ColorData ;
	case D_DXGI_FORMAT_R32G32_FLOAT :       return &TWO_F32_ColorData ;
	}
	return NULL ;
}

// {C[W̃tH[}bg DX_BASEIMAGE_FORMAT_NORMAL ɕϊKv邩ǂ`FbN
// ( RequiredRgbBaseImageConvFlag  RequiredAlphaBaseImageConvFlag ɓl  TRUE:ϊKv  FALSE:ϊKv͖ )
extern	int		Graphics_D3D11_CheckRequiredNormalImageConv_BaseImageFormat_PF(
	IMAGEDATA_ORIG *Orig,
	int             RgbBaseImageFormat,
	int            *RequiredRgbBaseImageConvFlag,
	int             AlphaBaseImageFormat,
	int            *RequiredAlphaBaseImageConvFlag
)
{
	int RgbConvFlag   = FALSE ;
	int AlphaConvFlag = FALSE ;

	if( Orig->FormatDesc.TextureFlag )
	{
		if( ( RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT1 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC1_UNORM ) ||
			( RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT2 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC2_UNORM ) ||
			( RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT3 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC3_UNORM ) ||
			( RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT4 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC4_UNORM ) ||
			( RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT5 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC5_UNORM ) )
		{
			RgbConvFlag = TRUE ;
		}

		if( AlphaBaseImageFormat >= 0 )
		{
			if( ( AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT1 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC1_UNORM ) ||
				( AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT2 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC2_UNORM ) ||
				( AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT3 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC3_UNORM ) ||
				( AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT4 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC4_UNORM ) ||
				( AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT5 && GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_DXGI_FORMAT_BC5_UNORM ) )
			{
				AlphaConvFlag = TRUE ;
			}
		}
	}
	else
	{
		if( RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT1 ||
			RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT2 ||
			RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT3 ||
			RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT4 ||
			RgbBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT5 )
		{
			RgbConvFlag = TRUE ;
		}

		if( AlphaBaseImageFormat >= 0 )
		{
			if( AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT1 ||
				AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT2 ||
				AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT3 ||
				AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT4 ||
				AlphaBaseImageFormat == DX_BASEIMAGE_FORMAT_DXT5 )
			{
				AlphaConvFlag = TRUE ;
			}
		}
	}

	if( RequiredRgbBaseImageConvFlag != NULL )
	{
		*RequiredRgbBaseImageConvFlag = RgbConvFlag ;
	}

	if( RequiredAlphaBaseImageConvFlag != NULL )
	{
		*RequiredAlphaBaseImageConvFlag = AlphaConvFlag ;
	}

	// I
	return 0 ;
}

// P]̏s
extern int Graphics_D3D11_StretchRect_Initialize( void )
{
	HRESULT hr ;
	int i ;

	// uhXe[g̍쐬
	if( GD3D11.Device.Shader.Base.StretchRect_BlendState[ 0 ] == NULL )
	{
		D_D3D11_BLEND_DESC BlendDesc ;
		static D_D3D11_RENDER_TARGET_BLEND_DESC RenderTargetBlendDesc_NoBlend = 
		{
			FALSE,
			D_D3D11_BLEND_ONE,
			D_D3D11_BLEND_ZERO,
			D_D3D11_BLEND_OP_ADD,
			D_D3D11_BLEND_ONE,
			D_D3D11_BLEND_ZERO,
			D_D3D11_BLEND_OP_ADD,
			D_D3D11_COLOR_WRITE_ENABLE_ALL
		} ;

		static D_D3D11_RENDER_TARGET_BLEND_DESC RenderTargetBlendDesc_AlphaBlend = 
		{
			TRUE,
			D_D3D11_BLEND_SRC_ALPHA,
			D_D3D11_BLEND_INV_SRC_ALPHA,
			D_D3D11_BLEND_OP_ADD,
			D_D3D11_BLEND_SRC_ALPHA,
			D_D3D11_BLEND_INV_SRC_ALPHA,
			D_D3D11_BLEND_OP_ADD,
			D_D3D11_COLOR_WRITE_ENABLE_ALL
		} ;

		BlendDesc.AlphaToCoverageEnable  = FALSE ;
		BlendDesc.IndependentBlendEnable = FALSE ;
		for( i = 0; i < 8; i++ )
		{
			BlendDesc.RenderTarget[ i ] = RenderTargetBlendDesc_NoBlend ;
		}

		hr = D3D11Device_CreateBlendState( &BlendDesc, &GD3D11.Device.Shader.Base.StretchRect_BlendState[ 0 ] ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "P]p ID3D11BlendState ̍쐬Ɏs܂\n" ) ) ) ;
			return -1 ;
		}

		BlendDesc.RenderTarget[ 0 ] = RenderTargetBlendDesc_AlphaBlend ;
		hr = D3D11Device_CreateBlendState( &BlendDesc, &GD3D11.Device.Shader.Base.StretchRect_BlendState[ 1 ] ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "PAt@uh]p ID3D11BlendState ̍쐬Ɏs܂\n" ) ) ) ;
			return -1 ;
		}
	}

	// Tv[Xe[g̍쐬
	{
		static D_D3D11_SAMPLER_DESC SamplerDesc =
		{
			D_D3D11_FILTER_MIN_MAG_MIP_POINT,
			D_D3D11_TEXTURE_ADDRESS_CLAMP,
			D_D3D11_TEXTURE_ADDRESS_CLAMP,
			D_D3D11_TEXTURE_ADDRESS_CLAMP,
			0.0f,
			16,
			D_D3D11_COMPARISON_ALWAYS,
			{ 0.0f, 0.0f, 0.0f, 0.0f },
			-D_D3D11_FLOAT32_MAX,
			 D_D3D11_FLOAT32_MAX
		} ;

		if( GD3D11.Device.Shader.Base.StretchRect_SamplerState[ 0 ] == NULL )
		{
			SamplerDesc.Filter = D_D3D11_FILTER_MIN_MAG_MIP_POINT ;
			hr = D3D11Device_CreateSamplerState( &SamplerDesc, &GD3D11.Device.Shader.Base.StretchRect_SamplerState[ 0 ] ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ŋߓ_TvOP]p ID3D11SamplerState ̍쐬Ɏs܂\n" ) ) ) ;
				return -1 ;
			}
		}

		if( GD3D11.Device.Shader.Base.StretchRect_SamplerState[ 1 ] == NULL )
		{
			SamplerDesc.Filter = D_D3D11_FILTER_MIN_MAG_MIP_LINEAR ;
			hr = D3D11Device_CreateSamplerState( &SamplerDesc, &GD3D11.Device.Shader.Base.StretchRect_SamplerState[ 1 ] ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "oCjAԒP]p ID3D11SamplerState ̍쐬Ɏs܂\n" ) ) ) ;
				return -1 ;
			}
		}
	}

	// X^CU[Xe[g̍쐬
	if( GD3D11.Device.Shader.Base.StretchRect_RasterizerState == NULL )
	{
		static D_D3D11_RASTERIZER_DESC RasterizerDesc =
		{
			D_D3D11_FILL_SOLID,
			D_D3D11_CULL_NONE,
			0,
			0,
			0.0f,
			0.0f,
			FALSE,
			FALSE,
			FALSE,
			FALSE
		} ;

		hr = D3D11Device_CreateRasterizerState( &RasterizerDesc, &GD3D11.Device.Shader.Base.StretchRect_RasterizerState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "P]p ID3D11RasterizerState ̍쐬Ɏs܂\n" ) ) ) ;
			return -1 ;
		}
	}

	// [xXeVXe[g̍쐬
	if( GD3D11.Device.Shader.Base.StretchRect_DepthStencilState == NULL )
	{
		static D_D3D11_DEPTH_STENCIL_DESC DepthStencilDesc =
		{
			FALSE,
			D_D3D11_DEPTH_WRITE_MASK_ZERO,
			D_D3D11_COMPARISON_ALWAYS,
			FALSE,
			D_D3D11_DEFAULT_STENCIL_READ_MASK,
			D_D3D11_DEFAULT_STENCIL_WRITE_MASK,
			{
				D_D3D11_STENCIL_OP_KEEP,
				D_D3D11_STENCIL_OP_KEEP,
				D_D3D11_STENCIL_OP_KEEP,
				D_D3D11_COMPARISON_ALWAYS
			},
			{
				D_D3D11_STENCIL_OP_KEEP,
				D_D3D11_STENCIL_OP_KEEP,
				D_D3D11_STENCIL_OP_KEEP,
				D_D3D11_COMPARISON_ALWAYS
			}
		} ;

		// 悭gݒ̐[xXeVXe[gł͂Ȃꍇ͂Ő[xXeVXe[g쐬
		hr = D3D11Device_CreateDepthStencilState( &DepthStencilDesc, &GD3D11.Device.Shader.Base.StretchRect_DepthStencilState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "P]p ID3D11DepthStencilState ̍쐬Ɏs܂\n" ) ) ) ;
			return -1 ;
		}
	}

	// I
	return 0 ;
}

// P]̌ns
extern int Graphics_D3D11_StretchRect_Terminate( void )
{
	int i ;

	for( i = 0 ; i < 2 ; i ++ )
	{
		if( GD3D11.Device.Shader.Base.StretchRect_SamplerState[ i ] != NULL )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.Shader.Base.StretchRect_SamplerState[ i ] ) ;
			GD3D11.Device.Shader.Base.StretchRect_SamplerState[ i ] = NULL ;
		}
	}

	if( GD3D11.Device.Shader.Base.StretchRect_RasterizerState != NULL )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Shader.Base.StretchRect_RasterizerState ) ;
		GD3D11.Device.Shader.Base.StretchRect_RasterizerState = NULL ;
	}

	if( GD3D11.Device.Shader.Base.StretchRect_DepthStencilState != NULL )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.Shader.Base.StretchRect_DepthStencilState ) ;
		GD3D11.Device.Shader.Base.StretchRect_DepthStencilState = NULL ;
	}

	for( i = 0 ; i < 2 ; i ++ )
	{
		if( GD3D11.Device.Shader.Base.StretchRect_BlendState[ i ] != NULL )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.Shader.Base.StretchRect_BlendState[ i ] ) ;
			GD3D11.Device.Shader.Base.StretchRect_BlendState[ i ] = NULL ;
		}
	}

	// I
	return 0 ;
}

// _[^[QbgeNX`ɃeNX`̒P]s
extern int		Graphics_D3D11_StretchRect(
	D_ID3D11Texture2D *SrcTexture,  D_ID3D11ShaderResourceView *SrcTextureSRV,  const RECT *SrcRect,
	D_ID3D11Texture2D *DestTexture, D_ID3D11RenderTargetView   *DestTextureRTV, const RECT *DestRect,
	D_D3D11_FILTER_TYPE FilterType,
	int AlphaBlend,
	D_ID3D11VertexShader *VertexShader,
	D_ID3D11PixelShader  *PixelShader,
	D_ID3D11Texture2D *BlendTexture, D_ID3D11ShaderResourceView  *BlendTextureSRV, const RECT *BlendRect
)
{
	float                  VertexData[ 4 ][ 6 ] ;
	D_D3D11_TEXTURE2D_DESC SrcDesc ;
	D_D3D11_TEXTURE2D_DESC DestDesc ;
	D_D3D11_TEXTURE2D_DESC BlendDesc ;
	D_D3D11_VIEWPORT       Viewport ;
	RECTF                  SrcRectF ;
	RECTF                  DestRectF ;
	RECTF                  BlendRectF ;
	D_D3D11_BOX            DestBox ;
	UINT                   Offsets = 0 ;
	UINT                   VertexStride = sizeof( VertexData[ 0 ] ) ;
	static FLOAT BlendFactor[ 4 ] = { 0.0f } ;

	DRAWSTOCKINFO

	// eNX`擾
	SrcTexture->GetDesc(  &SrcDesc  ) ;
	DestTexture->GetDesc( &DestDesc ) ;
	if( BlendTexture != NULL )
	{
		BlendTexture->GetDesc( &BlendDesc ) ;
	}

	// _f[^
	DestRectF.left   =     ( float )DestRect->left   / DestDesc.Width  * 2.0f - 1.0f   ;
	DestRectF.top    = - ( ( float )DestRect->top    / DestDesc.Height * 2.0f - 1.0f ) ;
	DestRectF.right  =     ( float )DestRect->right  / DestDesc.Width  * 2.0f - 1.0f   ;
	DestRectF.bottom = - ( ( float )DestRect->bottom / DestDesc.Height * 2.0f - 1.0f ) ;

	SrcRectF.left    = ( float )SrcRect->left    / SrcDesc.Width ;
	SrcRectF.top     = ( float )SrcRect->top     / SrcDesc.Height ;
	SrcRectF.right   = ( float )SrcRect->right   / SrcDesc.Width ;
	SrcRectF.bottom  = ( float )SrcRect->bottom  / SrcDesc.Height ;

	if( BlendTexture != NULL )
	{
		BlendRectF.left    = ( float )BlendRect->left    / BlendDesc.Width ;
		BlendRectF.top     = ( float )BlendRect->top     / BlendDesc.Height ;
		BlendRectF.right   = ( float )BlendRect->right   / BlendDesc.Width ;
		BlendRectF.bottom  = ( float )BlendRect->bottom  / BlendDesc.Height ;
	}

	VertexData[ 0 ][ 0 ] = DestRectF.left ;
	VertexData[ 0 ][ 1 ] = DestRectF.top ;
	VertexData[ 0 ][ 2 ] = SrcRectF.left ;
	VertexData[ 0 ][ 3 ] = SrcRectF.top ;

	VertexData[ 1 ][ 0 ] = DestRectF.right ;
	VertexData[ 1 ][ 1 ] = DestRectF.top ;
	VertexData[ 1 ][ 2 ] = SrcRectF.right ;
	VertexData[ 1 ][ 3 ] = SrcRectF.top ;

	VertexData[ 2 ][ 0 ] = DestRectF.left ;
	VertexData[ 2 ][ 1 ] = DestRectF.bottom ;
	VertexData[ 2 ][ 2 ] = SrcRectF.left ;
	VertexData[ 2 ][ 3 ] = SrcRectF.bottom ;

	VertexData[ 3 ][ 0 ] = DestRectF.right ;
	VertexData[ 3 ][ 1 ] = DestRectF.bottom ;
	VertexData[ 3 ][ 2 ] = SrcRectF.right ;
	VertexData[ 3 ][ 3 ] = SrcRectF.bottom ;

	if( BlendTexture != NULL )
	{
		VertexData[ 0 ][ 4 ] = BlendRectF.left ;
		VertexData[ 0 ][ 5 ] = BlendRectF.top ;

		VertexData[ 1 ][ 4 ] = BlendRectF.right ;
		VertexData[ 1 ][ 5 ] = BlendRectF.top ;

		VertexData[ 2 ][ 4 ] = BlendRectF.left ;
		VertexData[ 2 ][ 5 ] = BlendRectF.bottom ;

		VertexData[ 3 ][ 4 ] = BlendRectF.right ;
		VertexData[ 3 ][ 5 ] = BlendRectF.bottom ;
	}
	else
	{
		VertexData[ 0 ][ 4 ] = 0.0f ;
		VertexData[ 0 ][ 5 ] = 0.0f ;

		VertexData[ 1 ][ 4 ] = 0.0f ;
		VertexData[ 1 ][ 5 ] = 0.0f ;

		VertexData[ 2 ][ 4 ] = 0.0f ;
		VertexData[ 2 ][ 5 ] = 0.0f ;

		VertexData[ 3 ][ 4 ] = 0.0f ;
		VertexData[ 3 ][ 5 ] = 0.0f ;
	}

	DestBox.left   = 0 ;
	DestBox.top    = 0 ;
	DestBox.front  = 0 ;
	DestBox.right  = sizeof( VertexData ) ;
	DestBox.bottom = 1 ;
	DestBox.back   = 1 ;

	Graphics_D3D11_CommonVertexBuffer_Setup( sizeof( VertexData ) ) ;
	D3D11DeviceContext_UpdateSubresource_ASync( GD3D11.Device.DrawInfo.CommonVertexBuffer, 0, &DestBox, VertexData, 0, 0 ) ;

	// _O^[Qbg̃Zbg
	D3D11DeviceContext_OMSetRenderTargets( 1, &DestTextureRTV, NULL ) ;

	// VF[_[\[Xr[Zbg
	D3D11DeviceContext_PSSetShaderResources( 0, 1, &SrcTextureSRV ) ;
	if( BlendTextureSRV != NULL )
	{
		D3D11DeviceContext_PSSetShaderResources( 1, 1, &BlendTextureSRV ) ;
	}

	// r[|[g̃Zbg
	Viewport.TopLeftX = 0.0f ;
	Viewport.TopLeftY = 0.0f ;
	Viewport.Width    = ( float )DestDesc.Width ;
	Viewport.Height   = ( float )DestDesc.Height ;
	Viewport.MinDepth = 0.0f ;
	Viewport.MaxDepth = 1.0f ;
	D3D11DeviceContext_RSSetViewports( 1, &Viewport ) ;

	// Tv[Xe[gZbg
	D3D11DeviceContext_PSSetSamplers( 0, 1, &GD3D11.Device.Shader.Base.StretchRect_SamplerState[ FilterType == D_D3D11_FILTER_TYPE_POINT ? 0 : 1 ] ) ;
	if( BlendTexture != NULL )
	{
		D3D11DeviceContext_PSSetSamplers( 1, 1, &GD3D11.Device.Shader.Base.StretchRect_SamplerState[ FilterType == D_D3D11_FILTER_TYPE_POINT ? 0 : 1 ] ) ;
	}

	// X^CU[Xe[gZbg
	D3D11DeviceContext_RSSetState( GD3D11.Device.Shader.Base.StretchRect_RasterizerState ) ;

	// [xXeVXe[gZbg
	D3D11DeviceContext_OMSetDepthStencilState( GD3D11.Device.Shader.Base.StretchRect_DepthStencilState, 0 ) ;

	// uhXe[gZbg
	D3D11DeviceContext_OMSetBlendState( GD3D11.Device.Shader.Base.StretchRect_BlendState[ AlphaBlend ? 1 : 0 ], BlendFactor, 0xffffffff ) ;

	// v~eBu^CvZbg
	D3D11DeviceContext_IASetPrimitiveTopology( D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP ) ;

	// ̓CAEgZbg
	D3D11DeviceContext_IASetInputLayout( GD3D11.Device.InputLayout.BaseStretchRectInputLayout ) ;

	// sNZVF[_[Zbg
	D3D11DeviceContext_PSSetShader( PixelShader  != NULL ? PixelShader  : GD3D11.Device.Shader.Base.StretchRect_PS, NULL, 0 ) ;

	// _VF[_[Zbg
	D3D11DeviceContext_VSSetShader( VertexShader != NULL ? VertexShader : GD3D11.Device.Shader.Base.StretchRect_VS, NULL, 0 ) ;

	// _obt@Zbg
	D3D11DeviceContext_IASetVertexBuffers( 0, 1, &GD3D11.Device.DrawInfo.CommonVertexBuffer, &VertexStride, &Offsets ) ;


	// `
	D3D11DeviceContext_Draw( 4, 0 ) ;


	// _obt@ݒ𕜋A
	D3D11DeviceContext_IASetVertexBuffers( 0, 1, &GD3D11.Device.State.SetVertexBuffer, ( UINT * )&GD3D11.Device.State.SetVertexBufferStride, &Offsets ) ;

	// Zbg钸_VF[_[𕜋A
	D3D11DeviceContext_VSSetShader( GD3D11.Device.State.SetVertexShader, NULL, 0 ) ;

	// ZbgsNZVF[_[𕜋A
	D3D11DeviceContext_PSSetShader( GD3D11.Device.State.SetPixelShader, NULL, 0 ) ;

	// ̓CAEgݒ𕜋A
	D3D11DeviceContext_IASetInputLayout( GD3D11.Device.State.SetVertexInputLayout ) ;

	// v~eBu^Cvݒ̕A
	D3D11DeviceContext_IASetPrimitiveTopology( GD3D11.Device.State.PrimitiveTopology ) ;

	// ZbguhXe[gA
	D3D11DeviceContext_OMSetBlendState( GD3D11.Device.State.BlendState, BlendFactor, 0xffffffff ) ;

	// Zbg[xXeVXe[g𕜋A
	D3D11DeviceContext_OMSetDepthStencilState( GD3D11.Device.State.DepthStencilState, 0 ) ;

	// Zbg郉X^CU[Xe[g𕜋A
	D3D11DeviceContext_RSSetState( GD3D11.Device.State.RasterizerState ) ;

	// ZbgTv[Xe[g𕜋A
	D3D11DeviceContext_PSSetSamplers( 0, 1, &GD3D11.Device.State.SamplerState[ 0 ] ) ;
	if( BlendTexture != NULL )
	{
		D3D11DeviceContext_PSSetSamplers( 1, 1, &GD3D11.Device.State.SamplerState[ 1 ] ) ;
	}

	// Zbg郌_O^[Qbg̕A
	Graphics_D3D11_DeviceState_SetRenderTarget_SizeCheck() ;

	// r[|[gݒ̕A
	D3D11DeviceContext_RSSetViewports( 1, &GD3D11.Device.State.Viewport ) ;

	// ZbgVF[_[\[Xr[𕜋A
	D3D11DeviceContext_PSSetShaderResources( 0, 1, &GD3D11.Device.State.PSSetShaderResourceView[ 0 ] ) ;
	if( BlendTextureSRV != NULL )
	{
		D3D11DeviceContext_PSSetShaderResources( 1, 1, &GD3D11.Device.State.PSSetShaderResourceView[ 1 ] ) ;
	}

	return 0 ;
}














































// D3D11Device ̏֌W

// D3D11Device IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_Device_Create( void )
{
	const TCHAR *String = NULL ;

	// ɍ쐬ς݂̏ꍇ͈x폜
	D3D11Device_Release() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = FALSE ;

	// foCX̍쐬
	if( D3D11_CreateDeviceAndSwapChain() < 0 )
	{
		return -1 ;
	}

	// Zuh\ǂZbg
	GSYS.HardInfo.ValidSubBlend = TRUE ;

	// eNX`̃TCYQ̂łKv邩ǂ擾
	GSYS.HardInfo.TextureSizePow2 = FALSE ;

	// eNX``łKv邩ǂ擾
	GSYS.HardInfo.TextureSquareOnly = FALSE ;

	// tŃeNX`̃TCYQ̂łȂĂvǂ擾
	GSYS.HardInfo.TextureSizeNonPow2Conditional = TRUE ;

	// xɎgp邱Ƃ̏oő咸_擾
	GSYS.HardInfo.MaxVertexIndex = 0xffff ;

	switch( GD3D11.Setting.FeatureLevel )
	{
	case D_D3D_FEATURE_LEVEL_11_0 :
	case D_D3D_FEATURE_LEVEL_11_1 :
		// Ƀ_Oł^[Qbg̐ۑ
		GSYS.HardInfo.RenderTargetNum = 8 ;

		// eNX`̍ő啝ƍő卂ۑ
		GSYS.HardInfo.MaxTextureWidth  = 16384 ;
		GSYS.HardInfo.MaxTextureHeight = GSYS.HardInfo.MaxTextureWidth ;

		// xɕ`łőv~eBu擾
		GSYS.HardInfo.MaxPrimitiveCount = 0x7fffffff ;
		break ;

	case D_D3D_FEATURE_LEVEL_10_0 :
	case D_D3D_FEATURE_LEVEL_10_1 :
		// Ƀ_Oł^[Qbg̐ۑ
		GSYS.HardInfo.RenderTargetNum = 8 ;

		// eNX`̍ő啝ƍő卂ۑ
		GSYS.HardInfo.MaxTextureWidth  = 8192 ;
		GSYS.HardInfo.MaxTextureHeight = GSYS.HardInfo.MaxTextureWidth ;

		// xɕ`łőv~eBu擾
		GSYS.HardInfo.MaxPrimitiveCount = 0x7fffffff ;
		break ;

	case D_D3D_FEATURE_LEVEL_9_1 :
	case D_D3D_FEATURE_LEVEL_9_2 :
	case D_D3D_FEATURE_LEVEL_9_3 :
		// Ƀ_Oł^[Qbg̐ۑ
		GSYS.HardInfo.RenderTargetNum = GD3D11.Setting.FeatureLevel == D_D3D_FEATURE_LEVEL_9_3 ? 4 : 1 ;

		// eNX`̍ő啝ƍő卂ۑ
		GSYS.HardInfo.MaxTextureWidth  = GD3D11.Setting.FeatureLevel == D_D3D_FEATURE_LEVEL_9_3 ? 4096 : 2048 ;
		GSYS.HardInfo.MaxTextureHeight = GSYS.HardInfo.MaxTextureWidth ;

		// xɕ`łőv~eBu擾
		GSYS.HardInfo.MaxPrimitiveCount = GD3D11.Setting.FeatureLevel == D_D3D_FEATURE_LEVEL_9_1 ? 65535 : 1048575 ;
		break ;
	}

	// TCY̏قőTCYƂ
	GSYS.HardInfo.MaxTextureSize = GSYS.HardInfo.MaxTextureWidth < GSYS.HardInfo.MaxTextureHeight ? GSYS.HardInfo.MaxTextureWidth : GSYS.HardInfo.MaxTextureHeight ;

	// _[^[Qbg̐𒲐
	if( GSYS.HardInfo.RenderTargetNum > DX_RENDERTARGET_COUNT )
	{
		GSYS.HardInfo.RenderTargetNum = DX_RENDERTARGET_COUNT ;
	}

	// Graphics_D3D11_DrawPreparation sׂtO𗧂Ă
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// hCoo
	{
		D_DXGI_ADAPTER_DESC AdapterDesc ;

		_MEMSET( &AdapterDesc, 0, sizeof( AdapterDesc ) ) ;
		DXGIAdapter_GetDesc( &AdapterDesc ) ;
		DXST_ERRORLOGFMT_ADDW(( L"Description:%s", AdapterDesc.Description )) ;
	}

	// etH[}bg𒲂ׂ
	{
		UINT FormatSupport ;

		// ʂ̃tH[}bg̎擾
		GD3D11.Device.Caps.ScreenFormat = DIRECT3D11_BACKBUFFER_FORMAT ;
		String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "ʂ̃tH[}bg %s ł" ), String )) ;

		// 16rbg[xobt@tH[}bg̐ݒ
		GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_16BIT ]    = DIRECT3D11_DEPTHBUFFER_TEXTURE2D_FORMAT ;
		GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_16BIT ] = DIRECT3D11_DEPTHBUFFER_DEPTHSTENCIL_FORMAT ;
		String = _T( "DXGI_FORMAT_D16_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "16bit Zobt@tH[}bg %s ł" ), String )) ;

		// 24rbg[xobt@tH[}bg̑I
		if( /*D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R24G8_TYPELESS, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 &&*/
			D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_D24_UNORM_S8_UINT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_DEPTH_STENCIL ) != 0 )
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_24BIT ]    = D_DXGI_FORMAT_R24G8_TYPELESS ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_24BIT ] = D_DXGI_FORMAT_D24_UNORM_S8_UINT ;
			String = _T( "DXGI_FORMAT_D24_UNORM_S8_UINT" ) ;
		}
		else
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_24BIT ]    = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_16BIT ] ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_24BIT ] = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_16BIT ] ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "24bit Zobt@tH[}bg %s ł" ), String )) ;

		// 32rbg[xobt@tH[}bg̐ݒ
		if( /*D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32_TYPELESS, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 &&*/
			D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_D32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_DEPTH_STENCIL ) != 0 )
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_32BIT ]    = D_DXGI_FORMAT_R32_TYPELESS ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_32BIT ] = D_DXGI_FORMAT_D32_FLOAT ;
			String = _T( "DXGI_FORMAT_D32_FLOAT" ) ;
		}
		else
		{
			GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_32BIT ]    = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ZBUFFER_FORMAT_24BIT ] ;
			GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_32BIT ] = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ZBUFFER_FORMAT_24BIT ] ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "32bit Zobt@tH[}bg %s ł" ), String )) ;


		// J[tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) != S_OK ||
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) == 0 )
		{
			DXST_ERRORLOG_ADD( _T( "gpłJ[tH[}bg܂ł\n" ) ) ;
			return -1 ;
		}
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB16           ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB32           ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB16     ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32     ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "J[tH[}bg %s ł" ), String )) ;

		// BC1tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC1_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ] = D_DXGI_FORMAT_BC1_UNORM ;
			String = _T( " DXGI_FORMAT_BC1_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abPeNX`tH[}bg%s" ), String )) ;

		// BC2tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC2_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ] = D_DXGI_FORMAT_BC2_UNORM ;
			String = _T( " DXGI_FORMAT_BC2_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abQeNX`tH[}bg%s" ), String )) ;

		// BC3tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC3_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ] = D_DXGI_FORMAT_BC3_UNORM ;
			String = _T( " DXGI_FORMAT_BC3_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abReNX`tH[}bg%s" ), String )) ;

		// BC4tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC4_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ] = D_DXGI_FORMAT_BC4_UNORM ;
			String = _T( " DXGI_FORMAT_BC4_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abSeNX`tH[}bg%s" ), String )) ;

		// BC5tH[}bg̃`FbN
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_BC5_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ] = D_DXGI_FORMAT_BC5_UNORM ;
			String = _T( " DXGI_FORMAT_BC5_UNORM ł" ) ;
		}
		else
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ] = GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "abTeNX`tH[}bg%s" ), String )) ;

		// `\J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) != S_OK ||
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) == 0 ||
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) == 0 )
		{
			DXST_ERRORLOG_ADD( _T( "gpł`\J[tH[}bg܂ł\n" ) ) ;
			return -1 ;
		}
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16       ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32       ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
		String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "`pJ[tH[}bg %s ł" ), String )) ;

		// `\ ARGB16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] = D_DXGI_FORMAT_R16G16B16A16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ ARGB_16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ ARGB_32rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l8rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_R8_UNORM ;
			String = _T( "DXGI_FORMAT_R8_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_R8G8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l8rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l8rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_R16_UNORM ;
			String = _T( "DXGI_FORMAT_R16_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_R16G16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_R16G16B16A16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l_16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R16G16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l_32rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R32G32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l8rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_DXGI_FORMAT_R8G8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R8G8B8A8_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_DXGI_FORMAT_R8G8B8A8_UNORM ;
			String = _T( "DXGI_FORMAT_R8G8B8A8_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l8rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l8rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_DXGI_FORMAT_R16G16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16_UNORM" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_UNORM, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_DXGI_FORMAT_R16G16B16A16_UNORM ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_UNORM" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l_16rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_R16G16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l_32rbg^J[tH[}bg̑I
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_R32G32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R32G32B32A32_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_R32G32B32A32_FLOAT ;
			String = _T( "DXGI_FORMAT_R32G32B32A32_FLOAT" ) ;
		}
		else
		if( D3D11Device_CheckFormatSupport( D_DXGI_FORMAT_R16G16B16A16_FLOAT, &FormatSupport ) == S_OK &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_TEXTURE2D     ) != 0 &&
			( FormatSupport & D_D3D11_FORMAT_SUPPORT_RENDER_TARGET ) != 0 )
		{
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_R16G16B16A16_FLOAT ;
			String = _T( "DXGI_FORMAT_R16G16B16A16_FLOAT" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_DXGI_FORMAT_UNKNOWN ;
		}

		if( GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] != D_DXGI_FORMAT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// }XNJ[obt@ptH[}bg̑I
		GD3D11.Device.Caps.MaskColorFormat = GSYS.Screen.MainScreenColorBitDepth == 32 ? GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] : GD3D11.Device.Caps.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] ;

		// }XNAt@tH[}bg̑I
		GD3D11.Device.Caps.MaskAlphaFormat = D_DXGI_FORMAT_R8_UNORM ;
	}

	// o
	{
		switch( GD3D11.Setting.FeatureLevel )
		{
		case D_D3D_FEATURE_LEVEL_9_1 :
			String = _T( "D3D_FEATURE_LEVEL_9_1" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_9_2 :
			String = _T( "D3D_FEATURE_LEVEL_9_2" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_9_3 :
			String = _T( "D3D_FEATURE_LEVEL_9_3" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_10_0 :
			String = _T( "D3D_FEATURE_LEVEL_10_0" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_10_1 :
			String = _T( "D3D_FEATURE_LEVEL_10_1" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_11_0 :
			String = _T( "D3D_FEATURE_LEVEL_11_0" ) ;
			break ;

		case D_D3D_FEATURE_LEVEL_11_1 :
			String = _T( "D3D_FEATURE_LEVEL_11_1" ) ;
			break ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "ΉĂ@\x:%s" ), String )) ;
//		DXST_ERRORLOGFMT_ADD(( _T( "ΉĂő咸_CfbNX:%d" ),     GSYS.HardInfo.MaxVertexIndex )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "Ƀ_Ołobt@̐:%d" ), GSYS.HardInfo.RenderTargetNum )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "őeNX`TCY@:%d :%d" ), GSYS.HardInfo.MaxTextureWidth, GSYS.HardInfo.MaxTextureHeight )) ;
	}

	// I
	return 0 ;
}

// Direct3DDevice11 ֌W̏
extern	int		Graphics_D3D11_Device_Initialize( void )
{
	int i ;

#ifndef DX_NON_FILTER
	GraphFilter_Initialize() ;
#endif // DX_NON_FILTER

	// `Xe[^X̃Zbg
	{
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;

		// X^CY֌W̏lZbg
		GD3D11.Device.State.RasterizerDesc.FillMode              = D_D3D11_FILL_SOLID ;
		GD3D11.Device.State.RasterizerDesc.CullMode              = D_D3D11_CULL_NONE ;
		GD3D11.Device.State.RasterizerDesc.FrontCounterClockwise = 0 ;
		GD3D11.Device.State.RasterizerDesc.DepthBias             = 0 ;
		GD3D11.Device.State.RasterizerDesc.DepthBiasClamp        = 0.0f ;
		GD3D11.Device.State.RasterizerDesc.SlopeScaledDepthBias  = 0.0f ;
		GD3D11.Device.State.RasterizerDesc.DepthClipEnable       = TRUE ;
		GD3D11.Device.State.RasterizerDesc.ScissorEnable         = FALSE ;
		GD3D11.Device.State.RasterizerDesc.MultisampleEnable     = FALSE ;
		GD3D11.Device.State.RasterizerDesc.AntialiasedLineEnable = FALSE ;

		// [xXeV֌W̏lZbg
		GD3D11.Device.State.DepthStencilDesc.DepthEnable					= FALSE ;
		GD3D11.Device.State.DepthStencilDesc.DepthWriteMask					= D_D3D11_DEPTH_WRITE_MASK_ZERO ;
		GD3D11.Device.State.DepthStencilDesc.DepthFunc						= D_D3D11_COMPARISON_LESS_EQUAL ;
		GD3D11.Device.State.DepthStencilDesc.StencilEnable					= FALSE ;
		GD3D11.Device.State.DepthStencilDesc.StencilReadMask				= D_D3D11_DEFAULT_STENCIL_READ_MASK ;
		GD3D11.Device.State.DepthStencilDesc.StencilWriteMask				= D_D3D11_DEFAULT_STENCIL_WRITE_MASK ;
		GD3D11.Device.State.DepthStencilDesc.FrontFace.StencilFailOp		= D_D3D11_STENCIL_OP_KEEP ;
		GD3D11.Device.State.DepthStencilDesc.FrontFace.StencilDepthFailOp	= D_D3D11_STENCIL_OP_KEEP ;
		GD3D11.Device.State.DepthStencilDesc.FrontFace.StencilPassOp		= D_D3D11_STENCIL_OP_KEEP ;
		GD3D11.Device.State.DepthStencilDesc.FrontFace.StencilFunc			= D_D3D11_COMPARISON_ALWAYS ;
		GD3D11.Device.State.DepthStencilDesc.BackFace.StencilFailOp			= D_D3D11_STENCIL_OP_KEEP ;
		GD3D11.Device.State.DepthStencilDesc.BackFace.StencilDepthFailOp	= D_D3D11_STENCIL_OP_KEEP ;
		GD3D11.Device.State.DepthStencilDesc.BackFace.StencilPassOp			= D_D3D11_STENCIL_OP_KEEP ;
		GD3D11.Device.State.DepthStencilDesc.BackFace.StencilFunc			= D_D3D11_COMPARISON_ALWAYS ;

		// uhXe[g֌W̏lZbg
		GD3D11.Device.State.BlendDesc.AlphaToCoverageEnable		= FALSE ;
		GD3D11.Device.State.BlendDesc.IndependentBlendEnable	= FALSE ;
		for( i = 0 ; i < 8 ; i ++ )
		{
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].BlendEnable				= FALSE ;
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].SrcBlend				= D_D3D11_BLEND_ONE ;
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].DestBlend				= D_D3D11_BLEND_ZERO ;
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].BlendOp					= D_D3D11_BLEND_OP_ADD ;
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].SrcBlendAlpha			= D_D3D11_BLEND_ONE ;
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].DestBlendAlpha			= D_D3D11_BLEND_ZERO ;
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].BlendOpAlpha			= D_D3D11_BLEND_OP_ADD ;
			GD3D11.Device.State.BlendDesc.RenderTarget[ i ].RenderTargetWriteMask	= D_D3D11_COLOR_WRITE_ENABLE_ALL ;
		}

		// Tv[Xe[g֌W̏lZbg
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			GD3D11.Device.State.SamplerDesc[ i ].Filter				= D_D3D11_FILTER_MIN_MAG_MIP_POINT ;
			GD3D11.Device.State.SamplerDesc[ i ].AddressU			= D_D3D11_TEXTURE_ADDRESS_CLAMP ;
			GD3D11.Device.State.SamplerDesc[ i ].AddressV			= D_D3D11_TEXTURE_ADDRESS_CLAMP ;
			GD3D11.Device.State.SamplerDesc[ i ].AddressW			= D_D3D11_TEXTURE_ADDRESS_CLAMP ;
			GD3D11.Device.State.SamplerDesc[ i ].MipLODBias			= 0.0f ;
			GD3D11.Device.State.SamplerDesc[ i ].MaxAnisotropy		= 16 ;
			GD3D11.Device.State.SamplerDesc[ i ].ComparisonFunc		= D_D3D11_COMPARISON_ALWAYS ;
			GD3D11.Device.State.SamplerDesc[ i ].BorderColor[ 0 ]	= 0.0f ;
			GD3D11.Device.State.SamplerDesc[ i ].BorderColor[ 1 ]	= 0.0f ;
			GD3D11.Device.State.SamplerDesc[ i ].BorderColor[ 2 ]	= 0.0f ;
			GD3D11.Device.State.SamplerDesc[ i ].BorderColor[ 3 ]	= 0.0f ;
			GD3D11.Device.State.SamplerDesc[ i ].MinLOD				= -D_D3D11_FLOAT32_MAX ;
			GD3D11.Device.State.SamplerDesc[ i ].MaxLOD				=  D_D3D11_FLOAT32_MAX ;
		}

		// eNX`AhX[hݒ
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			if( GSYS.DrawSetting.TexAddressModeU[ i ] == 0 )
			{
				GSYS.DrawSetting.TexAddressModeU[ i ] = D_D3D11_TEXTURE_ADDRESS_CLAMP ;
			}

			if( GSYS.DrawSetting.TexAddressModeV[ i ] == 0 )
			{
				GSYS.DrawSetting.TexAddressModeV[ i ] = D_D3D11_TEXTURE_ADDRESS_CLAMP ;
			}

			if( GSYS.DrawSetting.TexAddressModeW[ i ] == 0 )
			{
				GSYS.DrawSetting.TexAddressModeW[ i ] = D_D3D11_TEXTURE_ADDRESS_CLAMP ;
			}
		}

		// `惂[hZbg
		Graphics_D3D11_DeviceState_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// őٕZbg
		Graphics_D3D11_DeviceState_SetMaxAnisotropy( 16 ) ;

		// eNX`Wϊsgp邩ǂ̐ݒZbg
		Graphics_D3D11_DeviceState_SetTextureAddressTransformMatrix(
			FALSE,
			&D3D11_GlobalIdentMatrix ) ;

		// CeBOnm
		Graphics_D3D11_DeviceState_SetLighting( TRUE ) ;

		// }eÃp[^ݒ
		{
			MATERIALPARAM Material ;
			Material.Diffuse.r  = 0.8f ;
			Material.Diffuse.g  = 0.8f ;
			Material.Diffuse.b  = 0.8f ;
			Material.Diffuse.a  = 1.0f ;
			Material.Specular.r = 0.8f ;
			Material.Specular.g = 0.8f ;
			Material.Specular.b = 0.8f ;
			Material.Specular.a = 0.0f ;
			Material.Emissive.r = 0.0f ;
			Material.Emissive.g = 0.0f ;
			Material.Emissive.b = 0.0f ;
			Material.Emissive.a = 0.0f ;
			Material.Ambient.r  = 0.0f ;
			Material.Ambient.g  = 0.0f ;
			Material.Ambient.b  = 0.0f ;
			Material.Ambient.a  = 0.0f ;
			Material.Power      = 20.0f ;
			Graphics_D3D11_DeviceState_SetMaterial( &Material ) ;
		}

		// _̃J[l}eÃfBt[YJ[XyLJ[ƂĎgp邩ǂ̐ݒ
		Graphics_D3D11_DeviceState_SetUseVertexDiffuseColor( TRUE ) ;
		Graphics_D3D11_DeviceState_SetUseVertexSpecularColor( TRUE ) ;

		// XyLgp邩ǂ
		Graphics_D3D11_DeviceState_SetSpecularEnable( TRUE ) ;

		// tHO֌W̐ݒ
		Graphics_D3D11_DeviceState_SetFogEnable( FALSE ) ;
		Graphics_D3D11_DeviceState_SetFogColor( 0 ) ;
		Graphics_D3D11_DeviceState_SetFogVertexMode( DX_FOGMODE_NONE ) ;
		Graphics_D3D11_DeviceState_SetFogStartEnd( 0.0f, 1.0f ) ;
		Graphics_D3D11_DeviceState_SetFogDensity( 1.0f ) ;

		// O[oArGgJ[Zbg
		{
			COLOR_F GAmbColor = { 0.0f } ;

			Graphics_D3D11_DeviceState_SetAmbient( &GAmbColor ) ;
		}

		// r[|[gݒ
		{
			D_D3D11_VIEWPORT Viewport ;

			GD3D11.Device.State.Viewport.TopLeftX	= 0 ;
			GD3D11.Device.State.Viewport.TopLeftY	= 0 ;
			GD3D11.Device.State.Viewport.Width		= ( FLOAT )GSYS.Screen.MainScreenSizeX ;
			GD3D11.Device.State.Viewport.Height		= ( FLOAT )GSYS.Screen.MainScreenSizeY ;
			GD3D11.Device.State.Viewport.MinDepth	= 0.0f ;
			GD3D11.Device.State.Viewport.MaxDepth	= 1.0f ;
			Graphics_D3D11_DeviceState_SetViewport( &Viewport ) ;
		}

		// `摜̐F𖳎邩ǂZbg
		Graphics_D3D11_DrawSetting_SetIgnoreDrawGraphColor( FALSE ) ;

		// `ݒ
		Graphics_D3D11_DeviceState_SetRenderTarget( GD3D11.Device.Screen.BackBufferTexture2D, GD3D11.Device.Screen.BackBufferRTV ) ;

		// uh[hݒ
		Graphics_D3D11_DeviceState_SetBlendMode( DX_BLENDMODE_NOBLEND ) ;

		// At@eXgݒ
		Graphics_D3D11_DrawSetting_SetDrawAlphaTest( -1, 0 ) ;

		// uheNX`֌W
		Graphics_D3D11_DrawSetting_SetBlendTexture( NULL, NULL ) ;
		GD3D11.Device.DrawSetting.BlendGraphBorderParam	= -1 ;
		GD3D11.Device.DrawSetting.BlendGraphType		= 0 ;

		// `eNX`֌W
		Graphics_D3D11_DrawSetting_SetTexture( NULL, NULL ) ;
		GD3D11.Device.DrawSetting.AlphaChannelValidFlag	= FALSE ;
		GD3D11.Device.DrawSetting.AlphaTestValidFlag	= FALSE ;

		GD3D11.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;
	}

	// foCXݒtbV
	Graphics_D3D11_DeviceState_RefreshRenderState() ;

	// tO
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag	= TRUE ;
	GD3D11.Device.DrawSetting.ChangeBlendParamFlag	= TRUE ;
	GD3D11.Device.DrawSetting.ChangeTextureFlag		= FALSE ;

	// `
	GD3D11.Device.DrawInfo.DiffuseColor				= 0xffffffff ;
	GD3D11.Device.DrawInfo.BlendMaxNotDrawFlag		= FALSE ;
	GD3D11.Device.DrawInfo.BeginSceneFlag			= FALSE ;
	GD3D11.Device.DrawInfo.VertexNum				= 0 ;
	GD3D11.Device.DrawInfo.Use3DVertex				= 0 ;
	GD3D11.Device.DrawInfo.VertexType				= VERTEXTYPE_TEX ;
	GD3D11.Device.DrawInfo.VertexBufferNextAddr		= GD3D11.Device.DrawInfo.VertexBufferTemp ;

	// I
	return 0 ;
}

// ꎞI Direct3DDevice11 jۂɁAjȌԂo߂̊֐
extern	int		Graphics_D3D11_Device_ReInitialize( void )
{
	int i ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// tO𗧂Ă
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;

	// K Graphics_D3D9_DrawPreparation stO𗧂Ă
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// 폜OƓo
	{
		// `eNX`֌W
		Graphics_D3D11_DrawSetting_SetTexture( NULL, NULL ) ;
		GD3D11.Device.DrawSetting.AlphaChannelValidFlag	= FALSE ;
		GD3D11.Device.DrawSetting.AlphaTestValidFlag	= FALSE ;

		// `撸_Zbg
		GD3D11.Device.DrawInfo.VertexNum = 0 ;

		// `uh[h̐ݒ
		Graphics_D3D11_DrawSetting_SetDrawBlendMode( GD3D11.Device.DrawSetting.BlendMode, GD3D11.Device.DrawSetting.AlphaTestValidFlag, GD3D11.Device.DrawSetting.AlphaChannelValidFlag ) ;

		// `摜̐F𖳎邩ǂZbg
		Graphics_D3D11_DrawSetting_SetIgnoreDrawGraphColor( GD3D11.Device.DrawSetting.IgnoreGraphColorFlag ) ;

		// ٕtB^O̐ݒZbg
		Graphics_D3D11_DeviceState_SetMaxAnisotropy( GD3D11.Device.State.MaxAnisotropy ) ;

		// UVAhbVO[h̐ݒZbg
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			Graphics_D3D11_DeviceState_SetTextureAddressUVW(
				GD3D11.Device.State.SamplerDesc[ i ].AddressU,
				GD3D11.Device.State.SamplerDesc[ i ].AddressV,
				GD3D11.Device.State.SamplerDesc[ i ].AddressW,
				i ) ;
		}

		// eNX`Wϊsgp邩ǂ̐ݒZbg
		Graphics_D3D11_DeviceState_SetTextureAddressTransformMatrix(
			GD3D11.Device.State.TextureAddressTransformMatrixUse,
			&GD3D11.Device.State.TextureAddressTransformMatrix ) ;

		// tHO̐ݒZbg
		Graphics_D3D11_DeviceState_SetFogEnable(     GD3D11.Device.State.FogEnable ) ;
		Graphics_D3D11_DeviceState_SetFogVertexMode( GD3D11.Device.State.FogMode ) ;
		Graphics_D3D11_DeviceState_SetFogColor(      GD3D11.Device.State.FogColor ) ;
		Graphics_D3D11_DeviceState_SetFogStartEnd(   GD3D11.Device.State.FogStart, GD3D11.Device.State.FogEnd ) ;
		Graphics_D3D11_DeviceState_SetFogDensity(    GD3D11.Device.State.FogDensity ) ;

		// s̍Đݒ
		NS_SetTransformToWorldD(                              &GSYS.DrawSetting.WorldMatrix ) ;
		NS_SetTransformToViewD(                               &GSYS.DrawSetting.ViewMatrix ) ;
		Graphics_DrawSetting_SetTransformToProjection_Direct( &GSYS.DrawSetting.ProjectionMatrix ) ;
		NS_SetTransformToViewportD(                           &GSYS.DrawSetting.ViewportMatrix ) ;

		// Cg̍Đݒ
		Graphics_D3D11_DeviceState_SetAmbient( &GD3D11.Device.State.GlobalAmbientLightColor ) ;
		Graphics_D3D11_DeviceState_SetLighting( GD3D11.Device.State.Lighting ) ;
		for( i = 0 ; i < DX_D3D11_COMMON_CONST_LIGHT_NUM ; i ++ )
		{
			if( GD3D11.Device.State.LightParam[ i ].LightType == 0 )
			{
				continue ;
			}

			Graphics_D3D11_DeviceState_SetLightState( i, &GD3D11.Device.State.LightParam[ i ] ) ;
			Graphics_D3D11_DeviceState_SetLightEnable( i, GD3D11.Device.State.LightEnableFlag[ i ] ) ;
		}
	}

	// tO|
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;

	// LȊO̐ݒtbV
	Graphics_D3D11_DeviceState_RefreshRenderState() ;

	// I
	return 0 ;
}



































// D3D11Device Xe[^X֌W

// `ݒtbV
extern	void	Graphics_D3D11_DeviceState_RefreshRenderState( void )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 ) return ;

	// tO𗧂Ă
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = TRUE ;

	// Graphics_D3D11_DrawPreparation sׂtO𗧂Ă
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// ݒ̃tbV
	Graphics_D3D11_DeviceState_SetFogEnable             ( GD3D11.Device.State.FogEnable           ) ;
	Graphics_D3D11_DeviceState_SetViewport              ( &GD3D11.Device.State.Viewport           ) ;
//	Graphics_D3D11_DeviceState_SetScissorRect           ( &GD3D11.Device.State.ScissorRect        ) ;
	Graphics_D3D11_DrawSetting_SetTexture               ( GD3D11.Device.DrawSetting.RenderTexture, GD3D11.Device.DrawSetting.RenderTextureSRV ) ;
	Graphics_D3D11_DeviceState_SetBaseState             (                                        ) ;
	Graphics_D3D11_DeviceState_SetDrawMode              ( GD3D11.Device.State.DrawMode            ) ;
//	Graphics_D3D11_DrawSetting_SetDrawBlendMode         ( GD3D11.Device.DrawSetting.BlendMode, GD3D11.Device.DrawSetting.AlphaChannelValidFlag  ) ;
	Graphics_D3D11_DeviceState_NormalDrawSetup          (                                        ) ;
	Graphics_D3D11_DeviceState_SetDepthEnable           ( GD3D11.Device.State.DepthStencilDesc.DepthEnable ) ;
	Graphics_D3D11_DeviceState_SetDepthWriteEnable      ( GD3D11.Device.State.DepthStencilDesc.DepthWriteMask == D_D3D11_DEPTH_WRITE_MASK_ALL ? TRUE : FALSE ) ;
	Graphics_D3D11_DeviceState_SetDepthFunc             ( GD3D11.Device.State.DepthStencilDesc.DepthFunc ) ;
	Graphics_D3D11_DeviceState_SetDepthBias             ( GD3D11.Device.State.RasterizerDesc.DepthBias ) ;
	Graphics_D3D11_DeviceState_SetFillMode              ( GD3D11.Device.State.RasterizerDesc.FillMode  ) ;
	Graphics_D3D11_DeviceState_SetCullMode              ( GD3D11.Device.State.RasterizerDesc.CullMode == D_D3D11_CULL_FRONT ? 2 : ( GD3D11.Device.State.RasterizerDesc.CullMode == D_D3D11_CULL_BACK ? 1 : 0 ) ) ;
//	Graphics_D3D11_DeviceState_SetShadeMode             ( GD3D11.Device.State.ShadeMode           ) ;
	Graphics_D3D11_DeviceState_SetMaterial              ( &GD3D11.Device.State.Material           ) ;
	Graphics_D3D11_DeviceState_SetSpecularEnable        ( GD3D11.Device.State.UseSpecular         ) ;
	Graphics_D3D11_DeviceState_SetUseVertexDiffuseColor ( GD3D11.Device.State.MaterialUseVertexDiffuseColor ) ;
	Graphics_D3D11_DeviceState_SetUseVertexSpecularColor( GD3D11.Device.State.MaterialUseVertexSpecularColor ) ;

	// 萔obt@tbV
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix->ChangeFlag = TRUE ;
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix->ChangeFlag = TRUE ;
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix ) ;

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->ChangeFlag = TRUE ;
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap->ChangeFlag = TRUE ;
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap ) ;

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter->ChangeFlag = TRUE ;
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter ) ;

	// 萔obt@Zbg
	Graphics_D3D11_ConstantBuffer_VSSet( DX_D3D11_VS_CONSTANTBUFFER_COMMON,      1, &GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
	Graphics_D3D11_ConstantBuffer_VSSet( DX_D3D11_VS_CONSTANTBUFFER_BASE,        1, &GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;
	Graphics_D3D11_ConstantBuffer_VSSet( DX_D3D11_VS_CONSTANTBUFFER_OTHERMATRIX, 1, &GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;
	Graphics_D3D11_ConstantBuffer_VSSet( DX_D3D11_VS_CONSTANTBUFFER_MATRIX,      1, &GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix ) ;

	Graphics_D3D11_ConstantBuffer_PSSet( DX_D3D11_PS_CONSTANTBUFFER_COMMON,      1, &GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
	Graphics_D3D11_ConstantBuffer_PSSet( DX_D3D11_PS_CONSTANTBUFFER_BASE,        1, &GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;
	Graphics_D3D11_ConstantBuffer_PSSet( DX_D3D11_PS_CONSTANTBUFFER_SHADOWMAP,   1, &GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap ) ;
	Graphics_D3D11_ConstantBuffer_PSSet( DX_D3D11_PS_CONSTANTBUFFER_FILTER,      1, &GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter ) ;

	// tO|
	GD3D11.Device.DrawSetting.CancelSettingEqualCheck = FALSE ;
}

// Direct3DDevice11 ̊{ݒs
extern int Graphics_D3D11_DeviceState_SetBaseState( void )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// o
	DRAWSTOCKINFO

	// Tv[ݒăZbgAbv
	Graphics_D3D11_DeviceState_SetupSamplerState() ;

	// X^CUXe[găZbgAbv
	Graphics_D3D11_DeviceState_SetupRasterizerState() ;

	// [xXeVXe[găZbgAbv
	Graphics_D3D11_DeviceState_SetupDepthStencilState() ;

	// uhXe[găZbgAbv
	Graphics_D3D11_DeviceState_SetupBlendState() ;

	// I
	return 0 ;
}

// Tv[̃eNX`tB^O[hݒ肷
extern int Graphics_D3D11_DeviceState_SetSampleFilterMode( D_D3D11_FILTER Filter, int Sampler )
{
	int						i ;
	D_D3D11_SAMPLER_DESC	*SamplerDesc ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( Sampler < 0 )
	{
		if( Filter == D_D3D11_FILTER_MIN_MAG_MIP_LINEAR ||
			Filter == D_D3D11_FILTER_MIN_MAG_MIP_POINT ||
			Filter == D_D3D11_FILTER_ANISOTROPIC )
		{
			GD3D11.Device.State.DrawMode = -1 ;
		}

		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( SamplerDesc->Filter != Filter )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		DRAWSTOCKINFO

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( SamplerDesc->Filter == Filter &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->Filter = Filter ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return 0 ;
		}

		GD3D11.Device.State.DrawMode = -1 ;

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( SamplerDesc->Filter == Filter &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		DRAWSTOCKINFO

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->Filter = Filter ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// [xobt@̗L̃Zbg
extern int Graphics_D3D11_DeviceState_SetDepthEnable( BOOL DepthEnable )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// [h牽I
	if( GD3D11.Device.State.DepthStencilDesc.DepthEnable == DepthEnable &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	DRAWSTOCKINFO

	GD3D11.Device.State.ChangeDepthStencilDesc = TRUE ;

	GD3D11.Device.State.DepthStencilDesc.DepthEnable = DepthEnable ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupDepthStencilState() ;
}

// [xobt@݂̗̏LZbg
extern int Graphics_D3D11_DeviceState_SetDepthWriteEnable( int Flag )
{
	D_D3D11_DEPTH_WRITE_MASK DepthWriteMask ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	DepthWriteMask = Flag == FALSE ? D_D3D11_DEPTH_WRITE_MASK_ZERO : D_D3D11_DEPTH_WRITE_MASK_ALL ;

	// [h牽I
	if( GD3D11.Device.State.DepthStencilDesc.DepthWriteMask == DepthWriteMask &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	DRAWSTOCKINFO

	GD3D11.Device.State.ChangeDepthStencilDesc = TRUE ;

	GD3D11.Device.State.DepthStencilDesc.DepthWriteMask = DepthWriteMask ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupDepthStencilState() ;
}

// [xl̔r^CvZbg
extern int Graphics_D3D11_DeviceState_SetDepthFunc( D_D3D11_COMPARISON_FUNC DepthFunc )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// [h牽I
	if( GD3D11.Device.State.DepthStencilDesc.DepthFunc == DepthFunc &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	DRAWSTOCKINFO

	GD3D11.Device.State.ChangeDepthStencilDesc = TRUE ;

	GD3D11.Device.State.DepthStencilDesc.DepthFunc = DepthFunc ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupDepthStencilState() ;
}

// [xl̃oCAXZbg
extern int Graphics_D3D11_DeviceState_SetDepthBias( int DepthBias )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// [h牽I
	if( GD3D11.Device.State.RasterizerDesc.DepthBias == DepthBias &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	DRAWSTOCKINFO

	GD3D11.Device.State.ChangeRasterizerDesc = TRUE ;

	GD3D11.Device.State.RasterizerDesc.DepthBias = DepthBias ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupRasterizerState() ;
}

// tB[hZbg
extern int Graphics_D3D11_DeviceState_SetFillMode( D_D3D11_FILL_MODE FillMode )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// [h牽I
	if( GD3D11.Device.State.RasterizerDesc.FillMode == FillMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	DRAWSTOCKINFO

	GD3D11.Device.State.ChangeRasterizerDesc = TRUE ;

	GD3D11.Device.State.RasterizerDesc.FillMode = FillMode ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupRasterizerState() ;
}

// [hϊpsZbg
extern int Graphics_D3D11_DeviceState_SetWorldMatrix( const MATRIX *Matrix )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// 萔f[^ɔf
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 0 ] = Matrix->m[ 0 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 1 ] = Matrix->m[ 1 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 2 ] = Matrix->m[ 2 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 0 ][ 3 ] = Matrix->m[ 3 ][ 0 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 0 ] = Matrix->m[ 0 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 1 ] = Matrix->m[ 1 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 2 ] = Matrix->m[ 2 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 1 ][ 3 ] = Matrix->m[ 3 ][ 1 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 0 ] = Matrix->m[ 0 ][ 2 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 1 ] = Matrix->m[ 1 ][ 2 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 2 ] = Matrix->m[ 2 ][ 2 ] ;
	ConstantVSBase->LocalWorldMatrix[ 2 ][ 3 ] = Matrix->m[ 3 ][ 2 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// r[ϊpsZbg
extern int Graphics_D3D11_DeviceState_SetViewMatrix( const MATRIX *Matrix )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// Cg̈ʒuE̍ČvZ
	{
		DX_D3D11_CONST_BUFFER_COMMON  *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON  * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;
		DX_D3D11_CONST_LIGHT          *ConstantLight ;
		int                           i ;
		VECTOR                        Direction ;
		VECTOR                        Position ;

		ConstantLight = ConstantCommon->Light ;
		for( i = 0 ; i < DX_D3D11_COMMON_CONST_LIGHT_NUM ; i ++, ConstantLight ++ )
		{
			VectorTransformSR( &Direction, &GD3D11.Device.State.LightParam[ i ].Direction, Matrix ) ;
			VectorTransform(   &Position,  &GD3D11.Device.State.LightParam[ i ].Position,  Matrix ) ;
			ConstantLight->Position[ 0 ]  = Position.x ;
			ConstantLight->Position[ 1 ]  = Position.y ;
			ConstantLight->Position[ 2 ]  = Position.z ;
			ConstantLight->Direction[ 0 ] = Direction.x ;
			ConstantLight->Direction[ 1 ] = Direction.y ;
			ConstantLight->Direction[ 2 ] = Direction.z ;
		}

		GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

		// 萔obt@XV
		Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
	}

	// 萔f[^ɔf
	ConstantVSBase->ViewMatrix[ 0 ][ 0 ] = Matrix->m[ 0 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 0 ][ 1 ] = Matrix->m[ 1 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 0 ][ 2 ] = Matrix->m[ 2 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 0 ][ 3 ] = Matrix->m[ 3 ][ 0 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 0 ] = Matrix->m[ 0 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 1 ] = Matrix->m[ 1 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 2 ] = Matrix->m[ 2 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 1 ][ 3 ] = Matrix->m[ 3 ][ 1 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 0 ] = Matrix->m[ 0 ][ 2 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 1 ] = Matrix->m[ 1 ][ 2 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 2 ] = Matrix->m[ 2 ][ 2 ] ;
	ConstantVSBase->ViewMatrix[ 2 ][ 3 ] = Matrix->m[ 3 ][ 2 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// eϊpsZbg
extern int Graphics_D3D11_DeviceState_SetProjectionMatrix( const MATRIX *Matrix )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// 萔f[^ɔf
	ConstantVSBase->ProjectionMatrix[ 0 ][ 0 ] = Matrix->m[ 0 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 0 ][ 1 ] = Matrix->m[ 1 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 0 ][ 2 ] = Matrix->m[ 2 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 0 ][ 3 ] = Matrix->m[ 3 ][ 0 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 0 ] = Matrix->m[ 0 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 1 ] = Matrix->m[ 1 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 2 ] = Matrix->m[ 2 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 1 ][ 3 ] = Matrix->m[ 3 ][ 1 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 0 ] = Matrix->m[ 0 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 1 ] = Matrix->m[ 1 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 2 ] = Matrix->m[ 2 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 2 ][ 3 ] = Matrix->m[ 3 ][ 2 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 0 ] = Matrix->m[ 0 ][ 3 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 1 ] = Matrix->m[ 1 ][ 3 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 2 ] = Matrix->m[ 2 ][ 3 ] ;
	ConstantVSBase->ProjectionMatrix[ 3 ][ 3 ] = Matrix->m[ 3 ][ 3 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// A`r[|[gsZbg
extern int Graphics_D3D11_DeviceState_SetAntiViewportMatrix( const MATRIX *Matrix )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// 萔f[^ɔf
	ConstantVSBase->AntiViewportMatrix[ 0 ][ 0 ] = Matrix->m[ 0 ][ 0 ] ;
	ConstantVSBase->AntiViewportMatrix[ 0 ][ 1 ] = Matrix->m[ 1 ][ 0 ] ;
	ConstantVSBase->AntiViewportMatrix[ 0 ][ 2 ] = Matrix->m[ 2 ][ 0 ] ;
	ConstantVSBase->AntiViewportMatrix[ 0 ][ 3 ] = Matrix->m[ 3 ][ 0 ] ;
	ConstantVSBase->AntiViewportMatrix[ 1 ][ 0 ] = Matrix->m[ 0 ][ 1 ] ;
	ConstantVSBase->AntiViewportMatrix[ 1 ][ 1 ] = Matrix->m[ 1 ][ 1 ] ;
	ConstantVSBase->AntiViewportMatrix[ 1 ][ 2 ] = Matrix->m[ 2 ][ 1 ] ;
	ConstantVSBase->AntiViewportMatrix[ 1 ][ 3 ] = Matrix->m[ 3 ][ 1 ] ;
	ConstantVSBase->AntiViewportMatrix[ 2 ][ 0 ] = Matrix->m[ 0 ][ 2 ] ;
	ConstantVSBase->AntiViewportMatrix[ 2 ][ 1 ] = Matrix->m[ 1 ][ 2 ] ;
	ConstantVSBase->AntiViewportMatrix[ 2 ][ 2 ] = Matrix->m[ 2 ][ 2 ] ;
	ConstantVSBase->AntiViewportMatrix[ 2 ][ 3 ] = Matrix->m[ 3 ][ 2 ] ;
	ConstantVSBase->AntiViewportMatrix[ 3 ][ 0 ] = Matrix->m[ 0 ][ 3 ] ;
	ConstantVSBase->AntiViewportMatrix[ 3 ][ 1 ] = Matrix->m[ 1 ][ 3 ] ;
	ConstantVSBase->AntiViewportMatrix[ 3 ][ 2 ] = Matrix->m[ 2 ][ 3 ] ;
	ConstantVSBase->AntiViewportMatrix[ 3 ][ 3 ] = Matrix->m[ 3 ][ 3 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// ArGgCgƃG~bVuJ[|킹p[^XV
extern void Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam( void )
{
	DX_D3D11_CONST_BUFFER_COMMON  *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON  * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;
	DX_D3D11_CONST_LIGHT          *ConstantLight ;
	int                           i ;

	// LȃCg̃ArGgJ[ƃ}eÃArGgJ[ẐVF[_[ɃZbg
	ConstantLight = ConstantCommon->Light ;
	for( i = 0 ; i <= GD3D11.Device.State.LightEnableMaxIndex ; i ++, ConstantLight ++ )
	{
		if( GD3D11.Device.State.LightEnableFlag[ i ] == FALSE )
		{
			continue ;
		}

		// 萔obt@ɔf
		ConstantLight->Ambient[ 0 ] = GD3D11.Device.State.LightParam[ i ].Ambient.r * GD3D11.Device.State.Material.Ambient.r ;
		ConstantLight->Ambient[ 1 ] = GD3D11.Device.State.LightParam[ i ].Ambient.g * GD3D11.Device.State.Material.Ambient.g ;
		ConstantLight->Ambient[ 2 ] = GD3D11.Device.State.LightParam[ i ].Ambient.b * GD3D11.Device.State.Material.Ambient.b ;
		ConstantLight->Ambient[ 3 ] = GD3D11.Device.State.LightParam[ i ].Ambient.a * GD3D11.Device.State.Material.Ambient.a ;
	}

	// O[oArGgCgJ[ƃ}eAArGgJ[ẐƃG~bVuJ[Ẑ쐬
	ConstantCommon->Material.Ambient_Emissive[ 0 ] = GD3D11.Device.State.GlobalAmbientLightColor.r * GD3D11.Device.State.Material.Ambient.r + GD3D11.Device.State.Material.Emissive.r ;
	ConstantCommon->Material.Ambient_Emissive[ 1 ] = GD3D11.Device.State.GlobalAmbientLightColor.g * GD3D11.Device.State.Material.Ambient.g + GD3D11.Device.State.Material.Emissive.g ;
	ConstantCommon->Material.Ambient_Emissive[ 2 ] = GD3D11.Device.State.GlobalAmbientLightColor.b * GD3D11.Device.State.Material.Ambient.b + GD3D11.Device.State.Material.Emissive.b ;
	ConstantCommon->Material.Ambient_Emissive[ 3 ] = GD3D11.Device.State.GlobalAmbientLightColor.a * GD3D11.Device.State.Material.Ambient.a + GD3D11.Device.State.Material.Emissive.a ;

	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;		
}



// Cg̃Zbg
extern int Graphics_D3D11_DeviceState_SetLightState( int LightNumber, LIGHTPARAM *Light )
{
	DX_D3D11_CONST_BUFFER_COMMON  *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON  * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;
	DX_D3D11_CONST_LIGHT          *ConstantLight ;
	VECTOR                        Direction ;
	VECTOR                        Position ;
	float                         ThetaSin ;
	float                         ThetaCos ;
	float                         PhiSin ;
	float                         PhiCos ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( LightNumber < 0 || LightNumber >= DX_D3D11_COMMON_CONST_LIGHT_NUM )
	{
		return -1 ;
	}

	if( _MEMCMP( &GD3D11.Device.State.LightParam[ LightNumber ], Light, sizeof( LIGHTPARAM ) ) == 0 &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// p[^̕ۑ
	GD3D11.Device.State.LightParam[ LightNumber ] = *Light ;

	// 萔f[^ɔf
	ConstantLight = &ConstantCommon->Light[ LightNumber ] ;

	_SINCOS( Light->Theta / 2.0f, &ThetaSin, &ThetaCos ) ;
	_SINCOS( Light->Phi   / 2.0f, &PhiSin,   &PhiCos ) ;

	ConstantLight->Type           = Light->LightType ;
	VectorTransformSR( &Direction, &Light->Direction, &GSYS.DrawSetting.ViewMatrixF ) ;
	VectorTransform(   &Position,  &Light->Position,  &GSYS.DrawSetting.ViewMatrixF ) ;
	ConstantLight->Position[ 0 ]  = Position.x ;
	ConstantLight->Position[ 1 ]  = Position.y ;
	ConstantLight->Position[ 2 ]  = Position.z ;
	ConstantLight->RangePow2      = Light->Range * Light->Range ;
	ConstantLight->Direction[ 0 ] = Direction.x ;
	ConstantLight->Direction[ 1 ] = Direction.y ;
	ConstantLight->Direction[ 2 ] = Direction.z ;
	ConstantLight->FallOff        = Light->Falloff ;
	ConstantLight->Diffuse[ 0 ]   = Light->Diffuse.r ;
	ConstantLight->Diffuse[ 1 ]   = Light->Diffuse.g ;
	ConstantLight->Diffuse[ 2 ]   = Light->Diffuse.b ;
	ConstantLight->SpotParam0     = PhiCos ;
	ConstantLight->Specular[ 0 ]  = Light->Specular.r ;
	ConstantLight->Specular[ 1 ]  = Light->Specular.g ;
	ConstantLight->Specular[ 2 ]  = Light->Specular.b ;
	ConstantLight->SpotParam1     = 1.0f / ( ThetaCos - PhiCos ) ;
	ConstantLight->Ambient[ 0 ]   = Light->Ambient.r ;
	ConstantLight->Ambient[ 1 ]   = Light->Ambient.g ;
	ConstantLight->Ambient[ 2 ]   = Light->Ambient.b ;
	ConstantLight->Ambient[ 3 ]   = Light->Ambient.a ;
	ConstantLight->Attenuation0   = Light->Attenuation0 ;
	ConstantLight->Attenuation1   = Light->Attenuation1 ;
	ConstantLight->Attenuation2   = Light->Attenuation2 ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	// I
	return 0 ;
}

// Cg̗LAύX
extern int Graphics_D3D11_DeviceState_SetLightEnable( int LightNumber, int EnableState )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( LightNumber < 0 || LightNumber >= DX_D3D11_COMMON_CONST_LIGHT_NUM )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.LightEnableFlag[ LightNumber ] == EnableState &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.LightEnableFlag[ LightNumber ] = EnableState ;

	// LȃCg̍őCfbNXXV
	if( EnableState == TRUE )
	{
		if( GD3D11.Device.State.LightEnableMaxIndex < LightNumber )
			GD3D11.Device.State.LightEnableMaxIndex = LightNumber ;
	}
	else
	{
		if( GD3D11.Device.State.LightEnableMaxIndex == LightNumber )
		{
			int i ;

			for( i = LightNumber ; i > 0 && GD3D11.Device.State.LightEnableFlag[ i ] == FALSE ; i -- ){}
			GD3D11.Device.State.LightEnableMaxIndex = i ;
		}
	}

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// }eÃZbg
extern int Graphics_D3D11_DeviceState_SetMaterial( MATERIALPARAM *Material )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( _MEMCMP( Material, &GD3D11.Device.State.Material, sizeof( MATERIALPARAM ) ) == 0 &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.Material = *Material ;

	// 萔f[^ɔf
	ConstantCommon->Material.Diffuse[ 0 ]  = Material->Diffuse.r ;
	ConstantCommon->Material.Diffuse[ 1 ]  = Material->Diffuse.g ;
	ConstantCommon->Material.Diffuse[ 2 ]  = Material->Diffuse.b ;
	ConstantCommon->Material.Diffuse[ 3 ]  = Material->Diffuse.a ;
	ConstantCommon->Material.Specular[ 0 ] = Material->Specular.r ;
	ConstantCommon->Material.Specular[ 1 ] = Material->Specular.g ;
	ConstantCommon->Material.Specular[ 2 ] = Material->Specular.b ;
	ConstantCommon->Material.Specular[ 3 ] = Material->Specular.a ;
	ConstantCommon->Material.Power         = Material->Power ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// XyLgp邩ǂZbg
extern int Graphics_D3D11_DeviceState_SetSpecularEnable( int UseFlag )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// ̃p[^Ɠꍇ͉Ȃ
	if( GD3D11.Device.State.UseSpecular == UseFlag &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.UseSpecular = UseFlag ;

	// 萔f[^ɔf
	ConstantVSBase->MulSpecularColor = UseFlag ? 1.0f : 0.0f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern int Graphics_D3D11_DeviceState_SetUseVertexDiffuseColor( int UseFlag )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( UseFlag == GD3D11.Device.State.MaterialUseVertexDiffuseColor &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// 萔f[^ɔf
	ConstantVSBase->DiffuseSource = UseFlag ? 1.0f : 0.0f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	GD3D11.Device.State.MaterialUseVertexDiffuseColor = UseFlag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern int Graphics_D3D11_DeviceState_SetUseVertexSpecularColor( int UseFlag )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( UseFlag == GD3D11.Device.State.MaterialUseVertexSpecularColor &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// 萔f[^ɔf
	ConstantVSBase->SpecularSource = UseFlag ? 1.0f : 0.0f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	GD3D11.Device.State.MaterialUseVertexSpecularColor = UseFlag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// JO̗LZbg 
extern int Graphics_D3D11_DeviceState_SetCullMode( int State )
{
	D_D3D11_CULL_MODE D3DCullMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	switch( State )
	{
	case 0 :
	default :
		D3DCullMode = D_D3D11_CULL_NONE ;
		break ;

	case 1 :
		D3DCullMode = D_D3D11_CULL_BACK ;
		break ;

	case 2 :
		D3DCullMode = D_D3D11_CULL_FRONT ;
		break ;
	}

	// [h牽I
	if( GD3D11.Device.State.RasterizerDesc.CullMode == D3DCullMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}
	
	DRAWSTOCKINFO

	GD3D11.Device.State.ChangeRasterizerDesc = TRUE ;

	GD3D11.Device.State.RasterizerDesc.CullMode = D3DCullMode ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupRasterizerState() ;
}

// ArGgJ[̃Zbg
extern int Graphics_D3D11_DeviceState_SetAmbient( COLOR_F *Color )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( _MEMCMP( Color, &GD3D11.Device.State.GlobalAmbientLightColor, sizeof( COLOR_F ) ) == 0 &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.GlobalAmbientLightColor = *Color ;

	// ArGgJ[ƃG~bVuJ[|킹XV
	Graphics_D3D11_DeviceState_RefreshAmbientAndEmissiveParam() ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// O̃tB^[^Cv D_D3D11_FILTER 擾
static D_D3D11_FILTER Graphics_D3D11_DeviceState_GetFilter( int MinFilter /* DX_DRAWMODE_NEAREST  */, int MagFilter, int MipFilter )
{
	if( MagFilter == DX_DRAWMODE_ANISOTROPIC ||
		MinFilter == DX_DRAWMODE_ANISOTROPIC ||
		MipFilter == DX_DRAWMODE_ANISOTROPIC )
	{
		return D_D3D11_FILTER_ANISOTROPIC ;
	}
	else
	{
		// 0:Point  1:Linear
		static D_D3D11_FILTER FilterTable[ 2 /* Min */ ][ 2 /* Mag */ ][ 2 /* Mip */ ] =
		{
			{
				{
					D_D3D11_FILTER_MIN_MAG_MIP_POINT,
					D_D3D11_FILTER_MIN_MAG_POINT_MIP_LINEAR
				},

				{
					D_D3D11_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT,
					D_D3D11_FILTER_MIN_POINT_MAG_MIP_LINEAR,
				},
			},

			{
				{
					D_D3D11_FILTER_MIN_LINEAR_MAG_MIP_POINT,
					D_D3D11_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR
				},

				{
					D_D3D11_FILTER_MIN_MAG_LINEAR_MIP_POINT,
					D_D3D11_FILTER_MIN_MAG_MIP_LINEAR,
				},
			},
		} ;

		return FilterTable[ MinFilter != DX_DRAWMODE_NEAREST ? 1 : 0 ][ MagFilter != DX_DRAWMODE_NEAREST ? 1 : 0 ][ MipFilter != DX_DRAWMODE_NEAREST ? 1 : 0 ] ;
	}
}

// ݂̐ݒɊÂ ID3D11SamplerState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupSamplerState( void )
{
	int                     i ;
	int                     SetLength ;
	D_D3D11_SAMPLER_DESC	*SamplerDesc ;
	D_ID3D11SamplerState	*NewSamplerState ;
	D_ID3D11SamplerState	**DefaultSamplerState ;
	HRESULT                 hr ;
	static int				DefaultFilterIndexTableInitialize = FALSE ;
	static int				DefaultFilterIndexTable[ 0xff ] ;

	// D_D3D11_FILTER CfbNX擾邽߂̃e[uĂȂꍇ͏
	if( DefaultFilterIndexTableInitialize == FALSE )
	{
		DefaultFilterIndexTableInitialize = TRUE ;

		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_MIP_POINT                          ] = 0 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_POINT_MIP_LINEAR                   ] = 1 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT             ] = 2 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_POINT_MAG_MIP_LINEAR                   ] = 3 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_LINEAR_MAG_MIP_POINT                   ] = 4 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR            ] = 5 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_LINEAR_MIP_POINT                   ] = 6 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_MIN_MAG_MIP_LINEAR                         ] = 7 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_ANISOTROPIC                                ] = 8 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_MIP_POINT               ] = 9 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_POINT_MIP_LINEAR        ] = 10 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT  ] = 11 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_POINT_MAG_MIP_LINEAR        ] = 12 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_MIP_POINT        ] = 13 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR ] = 14 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_LINEAR_MIP_POINT        ] = 15 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_MIN_MAG_MIP_LINEAR              ] = 16 ;
		DefaultFilterIndexTable[ D_D3D11_FILTER_COMPARISON_ANISOTROPIC                     ] = 17 ;
	}

	// ݒɕύXꍇ͉ɏI
	if( GD3D11.Device.State.ChangeSamplerDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// ύXǂ̃tO|
	GD3D11.Device.State.ChangeSamplerDesc = FALSE ;

	// Tv[Xbg̐JԂ
	SamplerDesc = GD3D11.Device.State.SamplerDesc ;
	SetLength     = 0 ;
	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
	{
		// ݒlɕύXAKĐݒstO|Ă玟̃[v
		if( GD3D11.Device.State.ChangeSamplerDescSlot[ i ] == FALSE &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			// ύXݒ̐Oł͂Ȃꍇ̓Tv[Xe[gfoCXReLXgɐݒ肷
			if( SetLength > 0 )
			{
				D3D11DeviceContext_PSSetSamplers( i - SetLength, SetLength, &GD3D11.Device.State.SamplerState[ i - SetLength ] ) ;
				SetLength = 0 ;
			}
			continue ;
		}

		// ύXǂ̃tO|
		GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = FALSE ;

		// ݐݒ肳ĂTv[ꍇ͉
		if( GD3D11.Device.State.SamplerState[ i ] != NULL )
		{
			// ݂̐ݒύXۂɃTv[Xe[g[XwɂȂĂ烊[X
			if( GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] )
			{
				Direct3D11_ObjectRelease( GD3D11.Device.State.SamplerState[ i ] ) ;
			}

			GD3D11.Device.State.SamplerState[ i ] = NULL ;
		}

		// ݒύXۂɃTv[Xe[g[X邩ǂ̃tO|
		GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] = FALSE ;

		// 悭gݒ̃Tv[Xe[gǂ𔻒肷
		if(	SamplerDesc->MipLODBias       != 0.0f ||
			( SamplerDesc->MaxAnisotropy  != 16 && SamplerDesc->MaxAnisotropy != 1 ) ||
			SamplerDesc->ComparisonFunc   != D_D3D11_COMPARISON_ALWAYS ||
			SamplerDesc->BorderColor[ 0 ] != 0.0f ||
			SamplerDesc->BorderColor[ 1 ] != 0.0f ||
			SamplerDesc->BorderColor[ 2 ] != 0.0f ||
			SamplerDesc->BorderColor[ 3 ] != 0.0f ||
			SamplerDesc->MinLOD           != -D_D3D11_FLOAT32_MAX ||
			SamplerDesc->MaxLOD           !=  D_D3D11_FLOAT32_MAX )
		{
			// 悭gݒ̃Tv[Xe[gł͂Ȃꍇ͂ŃTv[Xe[g쐬
			hr = D3D11Device_CreateSamplerState( SamplerDesc, &NewSamplerState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11SamplerState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
				return -1 ;
			}

			// 쐬Tv[Xe[gݒ
			GD3D11.Device.State.SamplerState[ i ] = NewSamplerState ;

			// ̃Tv[Xe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
			GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] = TRUE ;
		}
		else
		{
			// 悭gݒ̃Tv[Xe[g̏ꍇ

			// ŵ悭gݒ̃Tv[Xe[g܂쐬ĂȂ쐬
			DefaultSamplerState = &GD3D11.Device.State.DefaultSamplerStateArray[ DefaultFilterIndexTable[ SamplerDesc->Filter ] ][ SamplerDesc->AddressU ][ SamplerDesc->AddressV ][ SamplerDesc->AddressW ][ SamplerDesc->MaxAnisotropy == 1 ? 0 : 1 ] ;
			if( *DefaultSamplerState == NULL )
			{
				hr = D3D11Device_CreateSamplerState( SamplerDesc, &NewSamplerState ) ;
				if( hr != S_OK )
				{
					DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11SamplerState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
					return -1 ;
				}
				*DefaultSamplerState = NewSamplerState ;
			}

			// 悭gݒ̃Tv[Xe[gݒ
			GD3D11.Device.State.SamplerState[ i ] = *DefaultSamplerState ;
		}

		// ύXݒ̐CNg
		SetLength ++ ;
	}

	// ύXݒ̐Oł͂Ȃꍇ̓Tv[Xe[gfoCXReLXgɐݒ肷
	if( SetLength > 0 )
	{
		D3D11DeviceContext_PSSetSamplers( i - SetLength, SetLength, &GD3D11.Device.State.SamplerState[ i - SetLength ] ) ;
		SetLength = 0 ;
	}

	// I
	return 0 ;
}

// ID3D11SamplerState 
static int Graphics_D3D11_DeviceState_TerminateSamplerState( void )
{
	int i ;

	GD3D11.Device.State.ChangeSamplerDesc = FALSE ;

	_MEMSET( GD3D11.Device.State.ChangeSamplerDescSlot, 0, sizeof( GD3D11.Device.State.ChangeSamplerDescSlot ) ) ;
	_MEMSET( GD3D11.Device.State.SamplerDesc, 0, sizeof( GD3D11.Device.State.SamplerDesc ) ) ;

	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
	{
		if( GD3D11.Device.State.SamplerState[ i ] == NULL )
		{
			continue ;
		}

		if( GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.SamplerState[ i ] ) ;
			GD3D11.Device.State.ChangeSamplerStateReleaseFlag[ i ] = FALSE ;
		}
		GD3D11.Device.State.SamplerState[ i ] = NULL ;
	}

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultSamplerStateArray, sizeof( GD3D11.Device.State.DefaultSamplerStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

// ݂̐ݒɊÂ ID3D11RasterizerState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupRasterizerState( void )
{
	D_D3D11_RASTERIZER_DESC *RasterizerDesc ;
	D_ID3D11RasterizerState *NewRasterizerState ;
	D_ID3D11RasterizerState **DefaultRasterizerState ;
	HRESULT                  hr ;

	// ݒɕύXAKĐݒstO|Ă牽I
	if( GD3D11.Device.State.ChangeRasterizerDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// ݒɕύXǂ̃tO|
	GD3D11.Device.State.ChangeRasterizerDesc = FALSE ;

	// ݐݒ肳Ă郉X^CU[Xe[gꍇ͉
	if( GD3D11.Device.State.RasterizerState != NULL )
	{
		// ݂̐ݒύXۂɃX^CU[Xe[g[XwɂȂĂ烊[X
		if( GD3D11.Device.State.ChangeRasterizerStateReleaseFlag )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.RasterizerState ) ;
		}

		GD3D11.Device.State.RasterizerState = NULL ;
	}

	// ݒύXۂɃX^CU[Xe[g[X邩ǂ̃tO|
	GD3D11.Device.State.ChangeRasterizerStateReleaseFlag = FALSE ;

	// 悭gݒ̃X^CU[Xe[gǂ𔻒肷
	RasterizerDesc = &GD3D11.Device.State.RasterizerDesc ;
	if( RasterizerDesc->FrontCounterClockwise != FALSE ||
		RasterizerDesc->DepthBias             != 0 ||
		RasterizerDesc->DepthBiasClamp        != 0.0f ||
		RasterizerDesc->SlopeScaledDepthBias  != 0.0f ||
		RasterizerDesc->ScissorEnable         != FALSE ||
		RasterizerDesc->AntialiasedLineEnable != FALSE )
	{
		// 悭gݒ̃X^CU[Xe[gł͂Ȃꍇ͂ŃX^CU[Xe[g쐬
		hr = D3D11Device_CreateRasterizerState( RasterizerDesc, &NewRasterizerState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11RasterizerState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
			return -1 ;
		}

		// 쐬X^CU[Xe[gݒ
		GD3D11.Device.State.RasterizerState = NewRasterizerState ;

		// ̃X^CU[Xe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
		GD3D11.Device.State.ChangeRasterizerStateReleaseFlag = TRUE ;
	}
	else
	{
		// 悭gݒ̃X^CU[Xe[g̏ꍇ

		// ŵ悭gݒ̃X^CU[Xe[g܂쐬ĂȂ쐬
		DefaultRasterizerState = &GD3D11.Device.State.DefaultRasterizerStateArray[ RasterizerDesc->CullMode ][ RasterizerDesc->FillMode ][ RasterizerDesc->DepthClipEnable ][ RasterizerDesc->MultisampleEnable ] ;
		if( *DefaultRasterizerState == NULL )
		{
			hr = D3D11Device_CreateRasterizerState( RasterizerDesc, &NewRasterizerState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11RasterizerState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
				return -1 ;
			}
			*DefaultRasterizerState = NewRasterizerState ;
		}

		// 悭gݒ̃X^CU[Xe[gݒ
		GD3D11.Device.State.RasterizerState = *DefaultRasterizerState ;
	}

	// X^CU[Xe[gfoCXReLXgɐݒ肷
	D3D11DeviceContext_RSSetState( GD3D11.Device.State.RasterizerState ) ;

	// I
	return 0 ;
}

// ID3D11RasterizerState 
static int Graphics_D3D11_DeviceState_TerminateRasterizerState( void )
{
	GD3D11.Device.State.ChangeRasterizerDesc = FALSE ;

	_MEMSET( &GD3D11.Device.State.RasterizerDesc, 0, sizeof( GD3D11.Device.State.RasterizerDesc ) ) ;

	if( GD3D11.Device.State.ChangeRasterizerStateReleaseFlag )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.State.RasterizerState ) ;
		GD3D11.Device.State.ChangeRasterizerStateReleaseFlag = FALSE ;
	}
	GD3D11.Device.State.RasterizerState = NULL ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultRasterizerStateArray, sizeof( GD3D11.Device.State.DefaultRasterizerStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

// ݂̐ݒɊÂ ID3D11DepthStencilState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupDepthStencilState( void )
{
	D_D3D11_DEPTH_STENCIL_DESC *DepthStencilDesc ;
	D_ID3D11DepthStencilState  *NewDepthStencilState ;
	D_ID3D11DepthStencilState  **DefaultDepthStencilState ;
	HRESULT                     hr ;

	// ݒɕύXAKĐݒstO|Ă牽I
	if( GD3D11.Device.State.ChangeDepthStencilDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// ݒɕύXǂ̃tO|
	GD3D11.Device.State.ChangeDepthStencilDesc = FALSE ;

	// ݐݒ肳Ă[xXeVXe[gꍇ͉
	if( GD3D11.Device.State.DepthStencilState != NULL )
	{
		// ݂̐ݒύXۂɐ[xXeVXe[g[XwɂȂĂ烊[X
		if( GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.DepthStencilState ) ;
		}

		GD3D11.Device.State.DepthStencilState = NULL ;
	}

	// ݒύXۂɐ[xXeVXe[g[X邩ǂ̃tO|
	GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag = FALSE ;

	// 悭gݒ̐[xXeVXe[gǂ𔻒肷
	DepthStencilDesc = &GD3D11.Device.State.DepthStencilDesc ;
	if( DepthStencilDesc->StencilEnable					!= FALSE ||
		DepthStencilDesc->StencilReadMask				!= D_D3D11_DEFAULT_STENCIL_READ_MASK ||
		DepthStencilDesc->StencilWriteMask				!= D_D3D11_DEFAULT_STENCIL_WRITE_MASK ||
		DepthStencilDesc->FrontFace.StencilFailOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->FrontFace.StencilDepthFailOp	!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->FrontFace.StencilPassOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->FrontFace.StencilFunc			!= D_D3D11_COMPARISON_ALWAYS ||
		DepthStencilDesc->BackFace.StencilFailOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->BackFace.StencilDepthFailOp	!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->BackFace.StencilPassOp		!= D_D3D11_STENCIL_OP_KEEP ||
		DepthStencilDesc->BackFace.StencilFunc			!= D_D3D11_COMPARISON_ALWAYS )
	{
		// 悭gݒ̐[xXeVXe[gł͂Ȃꍇ͂Ő[xXeVXe[g쐬
		hr = D3D11Device_CreateDepthStencilState( DepthStencilDesc, &NewDepthStencilState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11DepthStencilState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
			return -1 ;
		}

		// 쐬[xXeVXe[gݒ
		GD3D11.Device.State.DepthStencilState = NewDepthStencilState ;

		// ̐[xXeVXe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
		GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag = TRUE ;
	}
	else
	{
		// 悭gݒ̐[xXeVXe[g̏ꍇ

		// ŵ悭gݒ̐[xXeVXe[g܂쐬ĂȂ쐬
		DefaultDepthStencilState = &GD3D11.Device.State.DefaultDepthStencilStateArray[ DepthStencilDesc->DepthEnable ][ DepthStencilDesc->DepthWriteMask == D_D3D11_DEPTH_WRITE_MASK_ALL ? 1 : 0 ][ DepthStencilDesc->DepthFunc ] ;
		if( *DefaultDepthStencilState == NULL )
		{
			hr = D3D11Device_CreateDepthStencilState( DepthStencilDesc, &NewDepthStencilState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11DepthStencilState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
				return -1 ;
			}
			*DefaultDepthStencilState = NewDepthStencilState ;
		}

		// 悭gݒ̐[xXeVXe[gݒ
		GD3D11.Device.State.DepthStencilState = *DefaultDepthStencilState ;
	}

	// [xXeVXe[gfoCXReLXgɐݒ肷
	D3D11DeviceContext_OMSetDepthStencilState( GD3D11.Device.State.DepthStencilState, 0 ) ;

	// I
	return 0 ;
}

// ID3D11DepthStencilState 
static int Graphics_D3D11_DeviceState_TerminateDepthStencilState( void )
{
	GD3D11.Device.State.ChangeDepthStencilDesc = FALSE ;

	_MEMSET( &GD3D11.Device.State.DepthStencilDesc, 0, sizeof( GD3D11.Device.State.DepthStencilDesc ) ) ;

	if( GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.State.DepthStencilState ) ;
		GD3D11.Device.State.ChangeDepthStencilStateReleaseFlag = FALSE ;
	}
	GD3D11.Device.State.DepthStencilState = NULL ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultDepthStencilStateArray, sizeof( GD3D11.Device.State.DefaultDepthStencilStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

#define RENDER_BLEND_TYPE_NORMAL			(0)			// 0:ʏ`
#define RENDER_BLEND_TYPE_MUL				(1)			// 1:Z`
#define RENDER_BLEND_TYPE_INVERSE			(2)			// 2:RGB]
#define RENDER_BLEND_TYPE_X4				(3)			// 3:`Px4{
#define RENDER_BLEND_TYPE_PMA_NORMAL		(4)			// 4:Zς݃uh[h̒ʏ`
#define RENDER_BLEND_TYPE_PMA_INVERSE		(5)			// 5:Zς݃uh[hRGB]
#define RENDER_BLEND_TYPE_PMA_X4			(6)			// 6:Zς݃uh[h̕`Px4{
#define RENDER_BLEND_TYPE_NUM				(7)
typedef struct tagDX_DIRECT3D11_RENDER_BLEND_INFO
{
	int									RenderBlendType ;
	D_D3D11_RENDER_TARGET_BLEND_DESC	RenderTargetBlendDesc ;
} DX_DIRECT3D11_RENDER_BLEND_INFO ;
static DX_DIRECT3D11_RENDER_BLEND_INFO g_DefaultBlendDescArray[ DX_BLENDMODE_NUM ] =
{
	{ RENDER_BLEND_TYPE_NORMAL,			{ FALSE, D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_NOBLEND			m[uh
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_ALPHA			uh
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_ADD				Zuh
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_INV_DEST_COLOR,	D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_INV_DEST_COLOR,	D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_SUB				Zuh
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_ZERO,			D_D3D11_BLEND_SRC_COLOR,		D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_SRC_COLOR,		D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_MUL				Zuh
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_SUB2			pZuhP
	{ RENDER_BLEND_TYPE_NORMAL,			{ FALSE, D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_XOR				XORuh(Ή)
	{ RENDER_BLEND_TYPE_NORMAL,			{ FALSE, D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// 
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_ZERO,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_DESTCOLOR		J[͍XVȂ
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_INV_DEST_COLOR,	D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_INV_DEST_COLOR,	D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_INVDESTCOLOR	`̐F̔]l|
	{ RENDER_BLEND_TYPE_INVERSE,		{ TRUE,  D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_INVSRC			`挳̐F𔽓]
	{ RENDER_BLEND_TYPE_MUL,			{ TRUE,  D_D3D11_BLEND_ZERO,			D_D3D11_BLEND_SRC_COLOR,		D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_SRC_COLOR,		D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_MULA			At@`lltZuh
	{ RENDER_BLEND_TYPE_X4,				{ TRUE,  D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_ALPHA_X4		uh̕`摤̋PxőS{ɂł郂[h
	{ RENDER_BLEND_TYPE_X4,				{ TRUE,  D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_ADD_X4			Zuh̕`摤̋PxőS{ɂł郂[h
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ZERO,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_SRCCOLOR		`挳̃J[ł̂܂ܕ`悳
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_HALF_ADD		Zuh
	{ RENDER_BLEND_TYPE_NORMAL,			{ TRUE,  D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_REV_SUBTRACT,	D_D3D11_BLEND_SRC_ALPHA,		D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_REV_SUBTRACT,	D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_SUB1			o̓uhgp\ȏꍇ̌Zuh

	{ RENDER_BLEND_TYPE_PMA_NORMAL,		{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_PMA_ALPHA		Zς݃uh[h̃uh
	{ RENDER_BLEND_TYPE_PMA_NORMAL,		{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_PMA_ADD			Zς݃uh[h̉Zuh
	{ RENDER_BLEND_TYPE_PMA_NORMAL,		{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_REV_SUBTRACT,	D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_REV_SUBTRACT,	D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_PMA_SUB			Zς݃uh[ȟZuh
	{ RENDER_BLEND_TYPE_PMA_INVERSE,	{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_PMA_INVSRC		Zς݃uh[h̕`挳̐F𔽓]
	{ RENDER_BLEND_TYPE_PMA_X4,			{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_INV_SRC_ALPHA,	D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_PMA_ALPHA_X4	Zς݃uh[h̃uh̕`摤̋PxőS{ɂł郂[h
	{ RENDER_BLEND_TYPE_PMA_X4,			{ TRUE,  D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_BLEND_ONE,				D_D3D11_BLEND_ONE,				D_D3D11_BLEND_OP_ADD,			D_D3D11_COLOR_WRITE_ENABLE_ALL } },	// DX_BLENDMODE_PMA_ADD_X4		Zς݃uh[h̉Zuh̕`摤̋PxőS{ɂł郂[h
} ;

// ݂̐ݒɊÂ ID3D11BlendState ZbgAbv
static int Graphics_D3D11_DeviceState_SetupBlendState( void )
{
	D_ID3D11BlendState *NewBlendState ;
	D_ID3D11BlendState **DefaultBlendState ;
	HRESULT            hr ;

	// ݒɕύXAKĐݒstO|Ă牽I
	if( GD3D11.Device.State.ChangeBlendDesc == FALSE &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// ݒɕύXǂ̃tO|
	GD3D11.Device.State.ChangeBlendDesc = FALSE ;

	// ݐݒ肳ĂuhXe[gꍇ͉
	if( GD3D11.Device.State.BlendState != NULL )
	{
		// ݂̐ݒύXۂɃuhXe[g[XwɂȂĂ烊[X
		if( GD3D11.Device.State.ChangeBlendStateReleaseFlag )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.State.BlendState ) ;
		}

		GD3D11.Device.State.BlendState = NULL ;
	}

	// ݒύXۂɃuhXe[g[X邩ǂ̃tO|
	GD3D11.Device.State.ChangeBlendStateReleaseFlag = FALSE ;

	// 悭gݒ̃uhXe[gǂ𔻒肷
	if( GD3D11.Device.State.BlendMode == -1 )
	{
		// 悭gݒ̃uhXe[gł͂Ȃꍇ͂ŃuhXe[g쐬
		hr = D3D11Device_CreateBlendState( &GD3D11.Device.State.BlendDesc, &NewBlendState ) ;
		if( hr != S_OK )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11BlendState ̍쐬Ɏs܂@ӏP\n" ) ) ) ;
			return -1 ;
		}

		// 쐬uhXe[gݒ
		GD3D11.Device.State.BlendState = NewBlendState ;

		// ̃uhXe[g͈ꎞIȂ̂Ȃ̂ŁAIɃ[X悤ɂ
		GD3D11.Device.State.ChangeBlendStateReleaseFlag = TRUE ;
	}
	else
	{
		// 悭gݒ̃uhXe[g̏ꍇ

		// ŵ悭gݒ̃uhXe[g܂쐬ĂȂ쐬
		DefaultBlendState = &GD3D11.Device.State.DefaultBlendStateArray[ GD3D11.Device.State.BlendMode ] ;
		if( *DefaultBlendState == NULL )
		{
			D_D3D11_BLEND_DESC TempBlendDesc ;
			int i ;

			TempBlendDesc.AlphaToCoverageEnable  = FALSE ;
			TempBlendDesc.IndependentBlendEnable = FALSE ;
			for( i = 0; i < DX_RENDERTARGET_COUNT; i++ )
			{
				TempBlendDesc.RenderTarget[ i ] = g_DefaultBlendDescArray[ GD3D11.Device.State.BlendMode ].RenderTargetBlendDesc ;
			}

			hr = D3D11Device_CreateBlendState( &TempBlendDesc, &NewBlendState ) ;
			if( hr != S_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "ID3D11BlendState ̍쐬Ɏs܂@ӏQ\n" ) ) ) ;
				return -1 ;
			}
			*DefaultBlendState = NewBlendState ;
		}

		// 悭gݒ̃uhXe[gݒ
		GD3D11.Device.State.BlendState = *DefaultBlendState ;
	}

	// uhXe[gfoCXReLXgɐݒ肷
	static FLOAT BlendFactor[ 4 ] = { 0.0f } ;
	D3D11DeviceContext_OMSetBlendState( GD3D11.Device.State.BlendState, BlendFactor, 0xffffffff ) ;

	// I
	return 0 ;
}

// ID3D11BlendState 
static int Graphics_D3D11_DeviceState_TerminateBlendState( void )
{
	GD3D11.Device.State.ChangeBlendDesc = FALSE ;

	_MEMSET( &GD3D11.Device.State.BlendDesc, 0, sizeof( GD3D11.Device.State.BlendDesc ) ) ;

	if( GD3D11.Device.State.ChangeBlendStateReleaseFlag )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.State.BlendState ) ;
		GD3D11.Device.State.ChangeBlendStateReleaseFlag = FALSE ;
	}
	GD3D11.Device.State.BlendState = NULL ;

	Graphics_D3D11_ObjectArray_Release( ( void ** )GD3D11.Device.State.DefaultBlendStateArray, sizeof( GD3D11.Device.State.DefaultBlendStateArray ) / sizeof( void * ) ) ;

	// I
	return 0 ;
}

// eNX`[̃AhbVO[hZbg
extern int  Graphics_D3D11_DeviceState_SetTextureAddress( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler < 0 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressU ||
					D3D11AddressMode != SamplerDesc->AddressV ||
					D3D11AddressMode != SamplerDesc->AddressW )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		DRAWSTOCKINFO

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressU &&
				D3D11AddressMode == SamplerDesc->AddressV &&
				D3D11AddressMode == SamplerDesc->AddressW &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressU = D3D11AddressMode ;
			SamplerDesc->AddressV = D3D11AddressMode ;
			SamplerDesc->AddressW = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressU &&
			D3D11AddressMode == SamplerDesc->AddressV &&
			D3D11AddressMode == SamplerDesc->AddressW &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		DRAWSTOCKINFO

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressU = D3D11AddressMode ;
		SamplerDesc->AddressV = D3D11AddressMode ;
		SamplerDesc->AddressW = D3D11AddressMode ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressU( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler == -1 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressU )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		DRAWSTOCKINFO

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressU &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressU = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressU &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		DRAWSTOCKINFO

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressU = D3D11AddressMode ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressV( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler == -1 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressV )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		DRAWSTOCKINFO

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressV &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressV = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressV &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		DRAWSTOCKINFO

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressV = D3D11AddressMode ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressW( int AddressMode, int Sampler )
{
	int								i ;
	D_D3D11_SAMPLER_DESC			*SamplerDesc ;
	D_D3D11_TEXTURE_ADDRESS_MODE	D3D11AddressMode ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	D3D11AddressMode = ( D_D3D11_TEXTURE_ADDRESS_MODE )AddressMode ;

	if( Sampler == -1 )
	{
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( D3D11AddressMode != SamplerDesc->AddressW )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		DRAWSTOCKINFO

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( D3D11AddressMode == SamplerDesc->AddressW &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->AddressW = D3D11AddressMode ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return -1 ;
		}

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( D3D11AddressMode == SamplerDesc->AddressW &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		DRAWSTOCKINFO

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->AddressW = D3D11AddressMode ;

	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// eNX`[̃AhbVO[hZbg
extern int Graphics_D3D11_DeviceState_SetTextureAddressUVW( int AddressModeU, int AddressModeV, int AddressModeW, int Sampler )
{
	if( Graphics_D3D11_DeviceState_SetTextureAddressU( AddressModeU, Sampler ) < 0 )
	{
		return -1 ;
	}

	if( Graphics_D3D11_DeviceState_SetTextureAddressV( AddressModeV, Sampler ) < 0 )
	{
		return -1 ;
	}

	if( Graphics_D3D11_DeviceState_SetTextureAddressW( AddressModeW, Sampler ) < 0 )
	{
		return -1 ;
	}

	return 0 ;
}

// W`p̃eNX`Wϊs萔obt@ɃZbg
static int Graphics_D3D11_DeviceState_SetNormalTextureAddressTransformMatrix_ConstBuffer( void )
{
	DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX *ConstOtherMatrix = ( DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix->SysmemBuffer ;

	// 萔f[^ɔf
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 0 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 0 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 1 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 1 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 2 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 2 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 0 ][ 3 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 3 ][ 0 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 0 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 0 ][ 1 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 1 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 1 ][ 1 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 2 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 2 ][ 1 ] ;
	ConstOtherMatrix->TextureMatrix[ 0 ][ 1 ][ 3 ] = GD3D11.Device.State.TextureAddressTransformMatrix.m[ 3 ][ 1 ] ;
	GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;

	// W`p̃eNX`p[^ݒ肳Ă邩ǂtO𗧂Ă
	GD3D11.Device.Shader.Constant.SetNormalTextureAddressTransformMatrix = TRUE ;

	// I
	return 0 ;
}

// eNX`WϊsZbg
extern int  Graphics_D3D11_DeviceState_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.TextureAddressTransformMatrixUse == FALSE &&
		Use == FALSE && 
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// eNX`Wϊsgp邩ǂۑ
	GD3D11.Device.State.TextureAddressTransformMatrixUse = Use ;

	// eNX`WϊsZbg
	if( Use == TRUE )
	{
		GD3D11.Device.State.TextureAddressTransformMatrix = *Matrix ;
	}
	else
	{
		CreateIdentityMatrix( &GD3D11.Device.State.TextureAddressTransformMatrix ) ;
	}

	// 萔obt@ɔf
	Graphics_D3D11_DeviceState_SetNormalTextureAddressTransformMatrix_ConstBuffer() ;

	return 0 ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern int  Graphics_D3D11_DeviceState_SetFogEnable( int Flag )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( Flag == GD3D11.Device.State.FogEnable &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.FogEnable = Flag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHO[hݒ肷
extern int  Graphics_D3D11_DeviceState_SetFogVertexMode( int Mode /* DX_FOGMODE_NONE  */ )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( Mode == GD3D11.Device.State.FogMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.FogMode = Mode ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHOJ[ύX
extern int  Graphics_D3D11_DeviceState_SetFogColor( DWORD Color )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( Color == GD3D11.Device.State.FogColor &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// 萔f[^ɔf
	ConstantCommon->Fog.Color[ 0 ] = ( ( Color >> 16 ) & 0xff ) / 255.0f ;
	ConstantCommon->Fog.Color[ 1 ] = ( ( Color >>  8 ) & 0xff ) / 255.0f ;
	ConstantCommon->Fog.Color[ 2 ] = ( ( Color >>  0 ) & 0xff ) / 255.0f ;
	ConstantCommon->Fog.Color[ 3 ] = 1.0f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	GD3D11.Device.State.FogColor = Color ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHO̐FȊO̒萔XV
static int Graphics_D3D11_DeviceState_UpdateConstantFogParam( void )
{
	DX_D3D11_CONST_BUFFER_COMMON *ConstantCommon = ( DX_D3D11_CONST_BUFFER_COMMON * )GD3D11.Device.Shader.Constant.ConstBuffer_Common->SysmemBuffer ;

	// 萔f[^ɔf
	ConstantCommon->Fog.LinearAdd = GD3D11.Device.State.FogEnd / ( GD3D11.Device.State.FogEnd - GD3D11.Device.State.FogStart ) ;
	ConstantCommon->Fog.LinearDiv = -1.0f / ( GD3D11.Device.State.FogEnd - GD3D11.Device.State.FogStart ) ;
	ConstantCommon->Fog.Density   = GD3D11.Device.State.FogDensity ;
	ConstantCommon->Fog.E         = 2.71828183f ;
	GD3D11.Device.Shader.Constant.ConstBuffer_Common->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;

	// I
	return 0 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern int  Graphics_D3D11_DeviceState_SetFogStartEnd( float Start, float End )
{
	int UpdateFlag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	DRAWSTOCKINFO

	UpdateFlag = FALSE ;

	if( Start != GD3D11.Device.State.FogStart ||
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == TRUE )
	{
		GD3D11.Device.State.FogStart = Start ;
		UpdateFlag = TRUE ;
	}

	if( End != GD3D11.Device.State.FogEnd ||
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == TRUE )
	{
		GD3D11.Device.State.FogEnd = End ;
		UpdateFlag = TRUE ;
	}

	if( UpdateFlag )
	{
		// 萔XV
		Graphics_D3D11_DeviceState_UpdateConstantFogParam() ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern int  Graphics_D3D11_DeviceState_SetFogDensity( float Density )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( Density == GD3D11.Device.State.FogDensity &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.FogDensity = Density ;

	// 萔XV
	Graphics_D3D11_DeviceState_UpdateConstantFogParam() ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// CeBO̗LtOZbg
extern int  Graphics_D3D11_DeviceState_SetLighting( int UseFlag )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( UseFlag == GD3D11.Device.State.Lighting &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.Lighting = UseFlag ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// őٕZbg
extern	int		Graphics_D3D11_DeviceState_SetMaxAnisotropy( int MaxAnisotropy, int Sampler )
{
	int						i ;
	D_D3D11_SAMPLER_DESC	*SamplerDesc ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// l̕␳
	if( MaxAnisotropy < 1 )
	{
		MaxAnisotropy = 1 ;
	}

	if( Sampler < 0 )
	{
		if( GD3D11.Device.State.MaxAnisotropy == MaxAnisotropy &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		GD3D11.Device.State.MaxAnisotropy = MaxAnisotropy ;

		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			SamplerDesc = GD3D11.Device.State.SamplerDesc ;
			for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
			{
				if( SamplerDesc->MaxAnisotropy != MaxAnisotropy )
				{
					break ;
				}
			}
			if( i == USE_TEXTURESTAGE_NUM )
			{
				return 0 ;
			}
		}

		DRAWSTOCKINFO

		SamplerDesc = GD3D11.Device.State.SamplerDesc ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, SamplerDesc ++ )
		{
			if( SamplerDesc->MaxAnisotropy == MaxAnisotropy &&
				GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
			{
				continue ;
			}

			GD3D11.Device.State.ChangeSamplerDescSlot[ i ] = TRUE ;
			GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

			SamplerDesc->MaxAnisotropy = MaxAnisotropy ;
		}
	}
	else
	{
		if( Sampler < 0 || Sampler >= USE_TEXTURESTAGE_NUM )
		{
			return 0 ;
		}

		GD3D11.Device.State.MaxAnisotropy = -1 ;

		SamplerDesc = &GD3D11.Device.State.SamplerDesc[ Sampler ] ;
		if( SamplerDesc->MaxAnisotropy == MaxAnisotropy &&
			GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			return 0 ;
		}

		DRAWSTOCKINFO

		GD3D11.Device.State.ChangeSamplerDescSlot[ Sampler ] = TRUE ;
		GD3D11.Device.State.ChangeSamplerDesc = TRUE ;

		SamplerDesc->MaxAnisotropy = MaxAnisotropy ;
	}

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupSamplerState() ;
}

// r[|[gZbg
extern	int		Graphics_D3D11_DeviceState_SetViewport( D_D3D11_VIEWPORT *Viewport )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( Viewport->TopLeftX == GD3D11.Device.State.Viewport.TopLeftX &&
		Viewport->TopLeftY == GD3D11.Device.State.Viewport.TopLeftY &&
		Viewport->Width    == GD3D11.Device.State.Viewport.Width    &&
		Viewport->Height   == GD3D11.Device.State.Viewport.Height   &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// o
	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		DRAWSTOCKINFO
	}

	// `IĂ
	Graphics_D3D11_RenderEnd() ;

	// r[|[g̃ZbeBO
	D3D11DeviceContext_RSSetViewports( 1, Viewport ) ;

	// r[|[g̏̕ۑ
	GD3D11.Device.State.Viewport = *Viewport ;

	// I
	return 0 ;
}

// r[|[gZbg( ȈՔ )
extern	int		Graphics_D3D11_DeviceState_SetViewportEasy( float x1, float y1, float x2, float y2 )
{
	D_D3D11_VIEWPORT Viewport ;

	Viewport.TopLeftX = x1 ;
	Viewport.TopLeftY = y1 ;
	Viewport.Width    = x2 - x1 ;
	Viewport.Height   = y2 - y1 ;
	Viewport.MinDepth = 0.0f ;
	Viewport.MaxDepth = 1.0f ;

	return Graphics_D3D11_DeviceState_SetViewport( &Viewport ) ;
}

// `惂[h̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetDrawMode( int DrawMode )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.DrawMode == DrawMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		DRAWSTOCKINFO
	}

	// _OݒύX
	switch( DrawMode )
	{
	case DX_DRAWMODE_BILINEAR :
		// oCjA`
		Graphics_D3D11_DeviceState_SetSampleFilterMode( D_D3D11_FILTER_MIN_MAG_MIP_LINEAR, -1 ) ;
		break ;

	case DX_DRAWMODE_NEAREST :
		// AXglCo[
		Graphics_D3D11_DeviceState_SetSampleFilterMode( D_D3D11_FILTER_MIN_MAG_MIP_POINT, -1 ) ;
		break ;

	case DX_DRAWMODE_ANISOTROPIC :
		// ٕtB^O
		Graphics_D3D11_DeviceState_SetSampleFilterMode( D_D3D11_FILTER_ANISOTROPIC, -1 ) ;
		break ;

	default : return -1 ;
	}

	GD3D11.Device.State.DrawMode                 = DrawMode ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// At@eXgŎgpr[hݒ肷
extern	int		Graphics_D3D11_DeviceState_SetAlphaTestCmpMode( int AlphaTestCmpMode /* DX_CMP_NEVER Ȃ */ )
{
	DX_D3D11_PS_CONST_BUFFER_BASE *ConstantPSBase = ( DX_D3D11_PS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.AlphaTestCmpMode == AlphaTestCmpMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// lۑ
	GD3D11.Device.State.AlphaTestCmpMode = AlphaTestCmpMode ;

	// 萔f[^ɔf
	ConstantPSBase->AlphaTestCmpMode = AlphaTestCmpMode ;

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->ChangeFlag = TRUE ;
	
	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;

	// I
	return 0 ;
}

// At@eXgŎgpQƒlݒ肷
extern	int		Graphics_D3D11_DeviceState_SetAlphaTestRef( int AlphaTestRef )
{
	DX_D3D11_PS_CONST_BUFFER_BASE *ConstantPSBase = ( DX_D3D11_PS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.AlphaTestRef == AlphaTestRef &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// lۑ
	GD3D11.Device.State.AlphaTestRef = AlphaTestRef ;

	// 萔f[^ɔf
	ConstantPSBase->AlphaTestRef = AlphaTestRef / 255.0f ;

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->ChangeFlag = TRUE ;
	
	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;

	// I
	return 0 ;
}

// J[ɃAt@lZ邩ǂݒ肷
extern	int		Graphics_D3D11_DeviceState_SetMulAlphaColor( int UseMulAlphaColor )
{
	DX_D3D11_PS_CONST_BUFFER_BASE *ConstantPSBase = ( DX_D3D11_PS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	DRAWSTOCKINFO

	// 萔f[^ɔf
	ConstantPSBase->MulAlphaColor = UseMulAlphaColor ? 1.0f : 0.0f ;

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->ChangeFlag = TRUE ;
	
	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;

	// I
	return 0 ;
}

// foCXŎgpv~eBu^Cvݒ肷
extern	int		Graphics_D3D11_DeviceState_SetPrimitiveTopology( D_D3D11_PRIMITIVE_TOPOLOGY PrimitiveTopology )
{
	DX_D3D11_PS_CONST_BUFFER_BASE *ConstantPSBase = ( DX_D3D11_PS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.PrimitiveTopology == PrimitiveTopology &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// lۑ
	GD3D11.Device.State.PrimitiveTopology = PrimitiveTopology ;

	// v~eBu^CvZbg
	D3D11DeviceContext_IASetPrimitiveTopology( GD3D11.Device.State.PrimitiveTopology ) ;

	// I
	return 0 ;
}

// Factor Color ݒ肷
extern	int		Graphics_D3D11_DeviceState_SetFactorColor( const DX_D3D11_SHADER_FLOAT4 *FactorColor )
{
	DX_D3D11_PS_CONST_BUFFER_BASE *ConstantPSBase = ( DX_D3D11_PS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( ConstantPSBase->FactorColor[ 0 ] == (*FactorColor)[ 0 ] &&
		ConstantPSBase->FactorColor[ 1 ] == (*FactorColor)[ 1 ] &&
		ConstantPSBase->FactorColor[ 2 ] == (*FactorColor)[ 2 ] &&
		ConstantPSBase->FactorColor[ 3 ] == (*FactorColor)[ 3 ] &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// 萔f[^ɔf
	ConstantPSBase->FactorColor[ 0 ] = (*FactorColor)[ 0 ] ;
	ConstantPSBase->FactorColor[ 1 ] = (*FactorColor)[ 1 ] ;
	ConstantPSBase->FactorColor[ 2 ] = (*FactorColor)[ 2 ] ;
	ConstantPSBase->FactorColor[ 3 ] = (*FactorColor)[ 3 ] ;

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base->ChangeFlag = TRUE ;
	
	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;

	// I
	return 0 ;
}

// gD[_O̗֊s̑ݒ肷
extern int Graphics_D3D11_DeviceState_SetToonOutLineSize( float Size )
{
	DX_D3D11_VS_CONST_BUFFER_BASE *ConstantVSBase = ( DX_D3D11_VS_CONST_BUFFER_BASE * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->SysmemBuffer ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( ConstantVSBase->ToonOutLineSize[ 0 ] == Size &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	// 萔f[^ɔf
	ConstantVSBase->ToonOutLineSize[ 0 ] = Size ;
	ConstantVSBase->ToonOutLineSize[ 1 ] = Size ;
	ConstantVSBase->ToonOutLineSize[ 2 ] = Size ;
	ConstantVSBase->ToonOutLineSize[ 3 ] = Size ;

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base->ChangeFlag = TRUE ;
	
	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;

	// I
	return 0 ;
}

// `uh[h̃Zbg
extern	int		Graphics_D3D11_DeviceState_SetBlendMode( int BlendMode )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.BlendMode == BlendMode &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	DRAWSTOCKINFO

	GD3D11.Device.State.BlendMode = BlendMode ;
	GD3D11.Device.State.ChangeBlendDesc = TRUE ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	return Graphics_D3D11_DeviceState_SetupBlendState() ;
}

// SĂ̕`Ώۂ̃TCYvĂ烌_O^[QbgɃZbg
static	void	Graphics_D3D11_DeviceState_SetRenderTarget_SizeCheck( void )
{
	int i, Base ;

	for( Base = 0; Base < DX_RENDERTARGET_COUNT ; Base ++ )
	{
		if( GD3D11.Device.State.TargetTexture2D[ Base ] != NULL )
		{
			break ;
		}
	}

	for( i = Base + 1 ; i < DX_RENDERTARGET_COUNT ; i ++ )
	{
		if( GD3D11.Device.State.TargetTexture2D[ i ] != NULL &&
			( GD3D11.Device.State.TargetTexture2DDesc[ i ].Width  != GD3D11.Device.State.TargetTexture2DDesc[ Base ].Width  ||
			  GD3D11.Device.State.TargetTexture2DDesc[ i ].Height != GD3D11.Device.State.TargetTexture2DDesc[ Base ].Height ) )
		{
			return ;
		}
	}

	if( GD3D11.Device.State.TargetDepthTexture2D != NULL &&
		( GD3D11.Device.State.TargetDepthTexture2DDesc.Width  != GD3D11.Device.State.TargetTexture2DDesc[ Base ].Width  ||
		  GD3D11.Device.State.TargetDepthTexture2DDesc.Height != GD3D11.Device.State.TargetTexture2DDesc[ Base ].Height ) )
	{
		return ;
	}

	D3D11DeviceContext_OMSetRenderTargets( DX_RENDERTARGET_COUNT, GD3D11.Device.State.TargetRTV, GD3D11.Device.State.TargetDepthDSV ) ;
}

// `Ώۂ̕ύX
extern	int		Graphics_D3D11_DeviceState_SetRenderTarget( D_ID3D11Texture2D *RenderTargetTexture, D_ID3D11RenderTargetView *RenderTargetView, int TargetIndex )
{
	D_D3D11_TEXTURE2D_DESC      Texture2DDesc ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( TargetIndex < 0 || TargetIndex >= DX_RENDERTARGET_COUNT )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.TargetTexture2D[ TargetIndex ] == RenderTargetTexture &&
		GD3D11.Device.State.TargetRTV[ TargetIndex ]       == RenderTargetView &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck  == FALSE )
	{
		return 0 ;
	}

	// _o
	DRAWSTOCKINFO

	// _O^[Qbg̕ۑ
	GD3D11.Device.State.TargetTexture2D[ TargetIndex ] = RenderTargetTexture ;
	GD3D11.Device.State.TargetRTV[ TargetIndex ]       = RenderTargetView ;
	if( RenderTargetTexture != NULL )
	{
		RenderTargetTexture->GetDesc( &GD3D11.Device.State.TargetTexture2DDesc[ TargetIndex ] ) ;
	}
	else
	{
		_MEMSET( &GD3D11.Device.State.TargetTexture2DDesc[ TargetIndex ], 0, sizeof( D_D3D11_TEXTURE2D_DESC ) ) ;
	}

	// _O^[Qbg̕ύX
	Graphics_D3D11_DeviceState_SetRenderTarget_SizeCheck() ;

	// r[|[g̐ݒlXV
	if( TargetIndex == 0 )
	{
		D3D11Texture2D_GetDesc( RenderTargetTexture, &Texture2DDesc ) ; 
		Graphics_D3D11_DeviceState_SetViewportEasy( 0.0f, 0.0f, ( float )Texture2DDesc.Width, ( float )Texture2DDesc.Height ) ;
	}

	// I
	return  0 ;
}

// `Ώۂ̐[xobt@ύX
extern	int		Graphics_D3D11_DeviceState_SetDepthStencil( D_ID3D11Texture2D *DepthStencilTexture, D_ID3D11DepthStencilView *DepthStencilView )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.TargetDepthTexture2D == DepthStencilTexture &&
		GD3D11.Device.State.TargetDepthDSV       == DepthStencilView &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck  == FALSE )
	{
		return 0 ;
	}

	// _o
	DRAWSTOCKINFO

	// gp[xobt@̕ۑ
	GD3D11.Device.State.TargetDepthTexture2D = DepthStencilTexture ;
	GD3D11.Device.State.TargetDepthDSV       = DepthStencilView ;
	if( DepthStencilTexture != NULL )
	{
		DepthStencilTexture->GetDesc( &GD3D11.Device.State.TargetDepthTexture2DDesc ) ;
	}
	else
	{
		_MEMSET( &GD3D11.Device.State.TargetDepthTexture2DDesc, 0, sizeof( D_D3D11_TEXTURE2D_DESC ) ) ;
	}

	// _O^[Qbg̕ύX
	Graphics_D3D11_DeviceState_SetRenderTarget_SizeCheck() ;

	// I
	return  0 ;
}

// gp̓CAEgύX
extern	int		Graphics_D3D11_DeviceState_SetInputLayout( D_ID3D11InputLayout *InputLayout )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.State.SetVertexInputLayout == InputLayout &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( InputLayout != NULL )
	{
		D3D11DeviceContext_IASetInputLayout( InputLayout ) ;
	}
	GD3D11.Device.State.SetVertexInputLayout = InputLayout ;

	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// w̒_VF[_[foCXɃZbg
extern int Graphics_D3D11_DeviceState_SetVertexShaderToHandle( int ShaderHandle )
{
	SHADERHANDLEDATA *VertexShader ;

	// nh`FbN
	if( SHADERCHK( ShaderHandle, VertexShader ) )
	{
		return -1 ;
	}
	if( VertexShader->IsVertexShader == FALSE )
	{
		return -1 ;
	}

	// VF[_[̃Zbg
	Graphics_D3D11_DeviceState_SetVertexShader( VertexShader->PF->D3D11.VertexShader ) ;

	// I
	return 0 ;
}

// gp钸_VF[_[ύX
extern	int		Graphics_D3D11_DeviceState_SetVertexShader( D_ID3D11VertexShader *VertexShader, int NormalVertexShader )
{
	if( GD3D11.Device.State.SetVertexShader == VertexShader &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	D3D11DeviceContext_VSSetShader( VertexShader, NULL, 0 ) ;
	GD3D11.Device.State.SetVertexShader          = VertexShader ;
	GD3D11.Device.State.SetNormalVertexShader    = NormalVertexShader ;
	if( NormalVertexShader == FALSE )
	{
		GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;
	}

	// I
	return 0 ;
}

// _VF[_[̎gp~߂
extern	int		Graphics_D3D11_DeviceState_ResetVertexShader( int SetNormalVertexShaderCancel )
{
	if( GD3D11.Device.State.SetNormalVertexShader &&
		SetNormalVertexShaderCancel &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
		GD3D11.Device.State.SetVertexShader == NULL &&
		GD3D11.Device.State.SetVertexInputLayout == NULL )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck ||
		GD3D11.Device.State.SetVertexShader != NULL )
	{
		D3D11DeviceContext_VSSetShader( NULL, NULL, 0 ) ;
		GD3D11.Device.State.SetVertexShader = NULL ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck ||
		GD3D11.Device.State.SetVertexInputLayout != NULL )
	{
		D3D11DeviceContext_IASetInputLayout( NULL ) ;
		GD3D11.Device.State.SetVertexInputLayout = NULL ;
	}

	GD3D11.Device.State.SetNormalVertexShader    = FALSE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// _VF[_[Ŏgp萔obt@[ݒ肷
extern	int		Graphics_D3D11_DeviceState_SetVertexShaderConstantBuffers( UINT StartSlot, UINT NumBuffers, D_ID3D11Buffer * const *pConstantBuffers )
{
	UINT i ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( StartSlot < 0 || StartSlot + NumBuffers > D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		for( i = 0 ; i < NumBuffers ; i ++ )
		{
			if( GD3D11.Device.State.SetVertexShaderConstantBuffer[ i + StartSlot ] != pConstantBuffers[ i ] )
			{
				break ;
			}
		}
		if( i == NumBuffers )
		{
			return 0 ;
		}
	}

	D3D11DeviceContext_VSSetConstantBuffers( StartSlot, NumBuffers, pConstantBuffers ) ;

	for( i = 0 ; i < NumBuffers ; i ++ )
	{
		GD3D11.Device.State.SetVertexShaderConstantBuffer[ i + StartSlot ] = pConstantBuffers[ i ] ;
	}

	// I
	return 0 ;
}


// w̃sNZVF[_[foCXɃZbg
extern int Graphics_D3D11_DeviceState_SetPixelShaderToHandle( int ShaderHandle )
{
	SHADERHANDLEDATA *PixelShader ;

	// nh`FbN
	if( SHADERCHK( ShaderHandle, PixelShader ) )
	{
		return -1 ;
	}
	if( PixelShader->IsVertexShader != FALSE )
	{
		return -1 ;
	}

	// VF[_[̃Zbg
	Graphics_D3D11_DeviceState_SetPixelShader( PixelShader->PF->D3D11.PixelShader ) ;

	// I
	return 0 ;
}

// gpsNZVF[_[ύX
extern	int		Graphics_D3D11_DeviceState_SetPixelShader( D_ID3D11PixelShader *PixelShader, int NormalPixelShader )
{
	if( GD3D11.Device.State.SetPixelShader == PixelShader &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	D3D11DeviceContext_PSSetShader( PixelShader, NULL, 0 ) ;
	GD3D11.Device.State.SetPixelShader       = PixelShader ;
	GD3D11.Device.State.SetNormalPixelShader = NormalPixelShader ;
	if( NormalPixelShader == FALSE )
	{
		GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;
	}

	// I
	return 0 ;
}

// sNZVF[_[̎gp~߂
extern	int		Graphics_D3D11_DeviceState_ResetPixelShader( int SetNormalPixelShaderCancel )
{
	if( GD3D11.Device.State.SetNormalPixelShader &&
		SetNormalPixelShaderCancel &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
		GD3D11.Device.State.SetPixelShader == NULL )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck ||
		GD3D11.Device.State.SetPixelShader != NULL )
	{
		D3D11DeviceContext_PSSetShader( NULL, NULL, 0 ) ;
		GD3D11.Device.State.SetPixelShader = NULL ;
	}

	GD3D11.Device.State.SetNormalPixelShader     = FALSE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// sNZVF[_[Ŏgp萔obt@[ݒ肷
extern	int		Graphics_D3D11_DeviceState_SetPixelShaderConstantBuffers( UINT StartSlot, UINT NumBuffers, D_ID3D11Buffer * const *pConstantBuffers )
{
	UINT i ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( StartSlot < 0 || StartSlot + NumBuffers > D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		for( i = 0 ; i < NumBuffers ; i ++ )
		{
			if( GD3D11.Device.State.SetPixelShaderConstantBuffer[ i + StartSlot ] != pConstantBuffers[ i ] )
			{
				break ;
			}
		}
		if( i == NumBuffers )
		{
			return 0 ;
		}
	}

	D3D11DeviceContext_PSSetConstantBuffers( StartSlot, NumBuffers, pConstantBuffers ) ;

	for( i = 0 ; i < NumBuffers ; i ++ )
	{
		GD3D11.Device.State.SetPixelShaderConstantBuffer[ i + StartSlot ] = pConstantBuffers[ i ] ;
	}

	// I
	return 0 ;
}

// gp钸_obt@ύX
extern	int		Graphics_D3D11_DeviceState_SetVertexBuffer( D_ID3D11Buffer *VertexBuffer, int VertexStride )
{
	UINT Offsets ;

	if( GD3D11.Device.State.SetVertexBuffer       == VertexBuffer &&
		GD3D11.Device.State.SetVertexBufferStride == VertexStride &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( VertexBuffer != NULL )
	{
		Offsets = 0 ;
		D3D11DeviceContext_IASetVertexBuffers( 0, 1, &VertexBuffer, ( UINT* )&VertexStride, &Offsets ) ;
	}
	GD3D11.Device.State.SetVertexBuffer       = VertexBuffer ;
	GD3D11.Device.State.SetVertexBufferStride = VertexStride ;

	// I
	return 0 ;
}

// gpCfbNXobt@ύX
extern	int		Graphics_D3D11_DeviceState_SetIndexBuffer( D_ID3D11Buffer *IndexBuffer, D_DXGI_FORMAT Format )
{
	if( GD3D11.Device.State.SetIndexBuffer == IndexBuffer &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( IndexBuffer != NULL )
	{
		D3D11DeviceContext_IASetIndexBuffer( IndexBuffer, Format, 0 ) ;
	}
	GD3D11.Device.State.SetIndexBuffer       = IndexBuffer ;
	GD3D11.Device.State.SetIndexBufferFormat = Format ;

	// I
	return 0 ;
}

// sNZVF[_[ŎgpVF[_[\[Xr[ύX
extern int Graphics_D3D11_DeviceState_SetPSShaderResouceView( int StartSlot, int Num, D_ID3D11ShaderResourceView * const *ppShaderResourceViews )
{
	int i ;
	int Change ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	Change = FALSE ;
	for( i = 0; i < Num; i++ )
	{
		if( GD3D11.Device.State.PSSetShaderResourceView[ StartSlot + i ] != ppShaderResourceViews[ i ] )
		{
			Change = TRUE ;
			GD3D11.Device.State.PSSetShaderResourceView[ StartSlot + i ] = ppShaderResourceViews[ i ] ;
		}
	}
	if( Change == FALSE && GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	D3D11DeviceContext_PSSetShaderResources( StartSlot, Num, ppShaderResourceViews ) ;

	// I
	return 0 ;
}

// W`̏s
extern	int		Graphics_D3D11_DeviceState_NormalDrawSetup( void )
{
	int							IgnoreTextureAlpha ;
	int							NextBlendMode ;
	int							UseFloatFactorColor = FALSE ;
	DX_D3D11_SHADER_FLOAT4		FloatFactorColor ;
	int							AlphaTestRef = 0 ;
	int							AlphaTestCmpMode = 0 ;
	D_ID3D11ShaderResourceView	*ShaderResourceView[ 16 ] ;
	int							ShaderResourceViewNum = 0 ;
	D_ID3D11PixelShader			*UsePixelShader = NULL ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// eNX`ύXꂽAtO|
	GD3D11.Device.DrawSetting.ChangeTextureFlag = FALSE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// p[^ύXꂽAtO|
	GD3D11.Device.DrawSetting.ChangeBlendParamFlag = FALSE ;

	// uh[ȟ
	{
		NextBlendMode = GD3D11.Device.DrawSetting.BlendMode ;
		switch( GD3D11.Device.DrawSetting.BlendMode )
		{
		case DX_BLENDMODE_SUB :
			// Zuh̏ꍇ14Ԗڂ̃uh[hgp
			NextBlendMode = DX_BLENDMODE_SUB1 ;
			break ;

		case DX_BLENDMODE_NOBLEND :
			// `Ƀlꍇ DX_BLENDMODE_NOBLEND łuh[h DX_BLENDMODE_SRCCOLOR ɂ
			if( GSYS.DrawSetting.AlphaChDrawMode )
			{
				NextBlendMode = DX_BLENDMODE_SRCCOLOR ;
			}

			// `挳摜Ƀ`lꍇuh摜̗LȂǏ DX_BLENDMODE_ALPHA gp
			if( GD3D11.Device.DrawSetting.RenderTexture != NULL )
			{
				if( GD3D11.Device.DrawSetting.BlendTexture != NULL )
				{
					switch( GD3D11.Device.DrawSetting.BlendGraphType )
					{
					case DX_BLENDGRAPHTYPE_NORMAL :
					case DX_BLENDGRAPHTYPE_ALPHA :
						if( GD3D11.Device.DrawSetting.AlphaTestValidFlag    == TRUE ||
							GD3D11.Device.DrawSetting.AlphaChannelValidFlag == TRUE )
						{
							NextBlendMode = DX_BLENDMODE_ALPHA ;
						}
						break ;

					case DX_BLENDGRAPHTYPE_WIPE :
						NextBlendMode = DX_BLENDMODE_ALPHA ;
						break ;
					}
				}
				else
				{
					if( GD3D11.Device.DrawSetting.AlphaChannelValidFlag == TRUE )
					{
						NextBlendMode = DX_BLENDMODE_ALPHA ;
					}
				}
			}
			break ;
		}
	}
	
	// JgeNX`ꍇƂꍇŕ
	if( GD3D11.Device.DrawSetting.RenderTexture == NULL )
	{
		// JgeNX`ꍇ͐┠̕`ƔfAeNX`Xe[W͖ɂ

		// Ƃ肠`揈s
		GD3D11.Device.DrawInfo.BlendMaxNotDrawFlag = FALSE ;

		// At@eXgp[^Lȏꍇ͂D悷
		if( GD3D11.Device.DrawSetting.AlphaTestMode != -1 )
		{
			GD3D11.Device.State.AlphaTestEnable = TRUE ;
			AlphaTestCmpMode = GD3D11.Device.DrawSetting.AlphaTestMode ;
			AlphaTestRef     = GD3D11.Device.DrawSetting.AlphaTestParam ;
		}
		else
		{
			GD3D11.Device.State.AlphaTestEnable = FALSE ;
		}

		// gpsNZVF[_[̎擾
		GD3D11.Device.State.AlphaTestModeShaderIndex = Graphics_D3D11_Shader_GetAlphaTestModeIndex( GD3D11.Device.State.AlphaTestEnable, AlphaTestCmpMode ) ;
		UsePixelShader = GD3D11.Device.Shader.Base.BaseNoneTex_PS[ g_DefaultBlendDescArray[ NextBlendMode ].RenderBlendType ][ GD3D11.Device.State.AlphaTestModeShaderIndex ] ;

		// _^CṽZbg
		GD3D11.Device.DrawInfo.VertexType = VERTEXTYPE_NOTEX ;
		GD3D11.Device.DrawInfo.VertexBufferNextAddr = GD3D11.Device.DrawInfo.VertexBufferTemp ;
	}
	else
	{
		// JgeNX`ꍇ̓eNX`Xe[Wuhe[ul擾

		// gpeNX`uhXe[WXe[^Xe[ũCfbNXZbg
		IgnoreTextureAlpha = 1 ;
		if( GD3D11.Device.DrawSetting.AlphaChannelValidFlag ||
			GD3D11.Device.DrawSetting.AlphaTestValidFlag    ||
			( GD3D11.Device.State.DepthStencilDesc.DepthEnable &&
			  GD3D11.Device.DrawSetting.BlendTexture == NULL ) )
		{
			IgnoreTextureAlpha = 0 ;
		}

		// uheNX`[gp邩ǂŕ
		if( GD3D11.Device.DrawSetting.BlendTexture != NULL )
		{
			int RenderBlendType ;

			// uheNX`[ꍇ AlphaTestValidFlag ͖

			// gpe[ũCfbNXo
			RenderBlendType = g_DefaultBlendDescArray[ NextBlendMode ].RenderBlendType ;

			// gpeNX`[AhXZbg
			ShaderResourceView[ 0 ] = GD3D11.Device.DrawSetting.RenderTextureSRV ;
			ShaderResourceView[ 1 ] = GD3D11.Device.DrawSetting.BlendTextureSRV ;
			ShaderResourceViewNum = 2 ;

			// _^CṽZbg
			GD3D11.Device.DrawInfo.VertexType = VERTEXTYPE_BLENDTEX ;
			GD3D11.Device.DrawInfo.VertexBufferNextAddr = GD3D11.Device.DrawInfo.VertexBufferTemp ;

			// uh^Cvɂď𕪊
			switch( GD3D11.Device.DrawSetting.BlendGraphType )
			{
			case DX_BLENDGRAPHTYPE_NORMAL :
				// Ƃ肠`揈s
				GD3D11.Device.DrawInfo.BlendMaxNotDrawFlag = FALSE ;

				// At@eXgp[^Lȏꍇ͂D悷
				if( GD3D11.Device.DrawSetting.AlphaTestMode != -1 )
				{
					GD3D11.Device.State.AlphaTestEnable = TRUE ;
					AlphaTestCmpMode = GD3D11.Device.DrawSetting.AlphaTestMode ;
					AlphaTestRef     = GD3D11.Device.DrawSetting.AlphaTestParam ;
				}
				else
				{
					// Lȏꍇ̓lȌꍇ̂ݕ\Ȃ悤ɂ
					if( GD3D11.Device.DrawSetting.AlphaTestValidFlag == TRUE ||
						g_DefaultBlendDescArray[ NextBlendMode ].RenderTargetBlendDesc.BlendEnable == TRUE ||
						GD3D11.Device.DrawSetting.AlphaChannelValidFlag == TRUE )
					{
						GD3D11.Device.State.AlphaTestEnable = TRUE ;
						AlphaTestRef     = 0 ;
						AlphaTestCmpMode = DX_CMP_GREATER ;
					}
					else
					{
						GD3D11.Device.State.AlphaTestEnable = FALSE ;
					}
				}

				// NXtF[hݒ肷
				UseFloatFactorColor = TRUE ;
				FloatFactorColor[ 0 ] = 1.0f ;
				FloatFactorColor[ 1 ] = 1.0f ;
				FloatFactorColor[ 2 ] = 1.0f ;
				FloatFactorColor[ 3 ] = GD3D11.Device.DrawSetting.BlendGraphFadeRatio / 255.0f ;

				// gpVF[_[Zbg
				GD3D11.Device.State.AlphaTestModeShaderIndex = Graphics_D3D11_Shader_GetAlphaTestModeIndex( GD3D11.Device.State.AlphaTestEnable, AlphaTestCmpMode ) ;
				UsePixelShader = GD3D11.Device.Shader.Base.BaseUseTex_PS[ 1 ][ RenderBlendType ][ GD3D11.Device.DrawSetting.IgnoreGraphColorFlag ? 1 : 0 ][ IgnoreTextureAlpha ][ GD3D11.Device.State.AlphaTestModeShaderIndex ] ;
				break ;

			case DX_BLENDGRAPHTYPE_WIPE :
				// uhElő̏ꍇ͉`悵Ȃ
				GD3D11.Device.DrawInfo.BlendMaxNotDrawFlag = GD3D11.Device.DrawSetting.BlendGraphBorderParam == 255 ? TRUE : FALSE ;

				// float^ FactorColor gp
				UseFloatFactorColor = TRUE ;
				FloatFactorColor[ 0 ] = 0.0f ;
				FloatFactorColor[ 1 ] = 0.0f ;
				FloatFactorColor[ 2 ] = 0.0f ;
				FloatFactorColor[ 3 ] = 0.0f ;

				// E͈͂Pȉǂŏ𕪊
				if( GD3D11.Device.DrawSetting.BlendGraphBorderRange <= 1 )
				{
					// ͂wǗO -------------------------------------------

					// eXggp
					GD3D11.Device.State.AlphaTestEnable = TRUE ;
					AlphaTestRef     = GD3D11.Device.DrawSetting.BlendGraphBorderParam ;
					AlphaTestCmpMode = DX_CMP_GREATEREQUAL ;

					// uh@\nee
					NextBlendMode = DX_BLENDMODE_NOBLEND ;

					// 郿l͖
					FloatFactorColor[ 3 ] = 0.0f ;
					FloatFactorColor[ 2 ] = 1.0f ;

					// 摜`lgpĂāA BlendGraphBorderParam  0  AlphaRef OɂȂ
					if( ( GD3D11.Device.DrawSetting.AlphaChannelValidFlag ||
						  GD3D11.Device.DrawSetting.AlphaTestValidFlag ) &&
						GD3D11.Device.DrawSetting.BlendGraphBorderParam == 0 )
					{
						AlphaTestRef = 1 ;
					}
				}
				else
				{
					int p ;
				
					// uhɂeNX`uh

					// eXg͍sȂ
					GD3D11.Device.State.AlphaTestEnable = FALSE ;

					// E͈͂ɂĂSiK
					if( GD3D11.Device.DrawSetting.BlendGraphBorderRange <= 64 )
					{
						// ~S

						p = 1280 - GD3D11.Device.DrawSetting.BlendGraphBorderParam * 1280 / 255 ; 

						// uheNX`̃uhlɂčp[^ύX
						if( p < 1024 )
						{
							FloatFactorColor[ 3 ] = - ( float )( 255 - p * 255 / 1024 ) / 255.0f ;
						}
						else
						{
							FloatFactorColor[ 3 ] =   ( float )( 64 * ( p - 1024 ) / 256 ) / 255.0f ;
						}

						FloatFactorColor[ 2 ] = 4.0f ;
					}
					else
					if( GD3D11.Device.DrawSetting.BlendGraphBorderRange <= 128 )
					{
						// ~Q

						p = 768 - GD3D11.Device.DrawSetting.BlendGraphBorderParam * 768 / 255 ; 

						// uheNX`̃uhlɂčp[^ύX
						if( p < 512 )
						{
							FloatFactorColor[ 3 ] = - ( float )( 255 - p * 255 / 512 ) / 255.0f ;
						}
						else
						{
							FloatFactorColor[ 3 ] =   ( float )( 128 * ( p - 512 ) / 256 ) / 255.0f ;
						}

						FloatFactorColor[ 2 ] = 2.0f ;
					}
					else
					{
						// ~P

						p = 512 - GD3D11.Device.DrawSetting.BlendGraphBorderParam * 512 / 255 ; 

						// uheNX`̃uhlɂčp[^ύX
						if( p < 256 )
						{
							FloatFactorColor[ 3 ] = - ( float )( 255 - p * 255 / 256 ) / 255.0f ;
						}
						else
						{
							FloatFactorColor[ 3 ] =   ( float )( 255 * ( p - 256 ) / 256 ) / 255.0f ;
						}

						FloatFactorColor[ 2 ] = 1.0f ;
					}

					// gpVF[_[Zbg
					GD3D11.Device.State.AlphaTestModeShaderIndex = Graphics_D3D11_Shader_GetAlphaTestModeIndex( GD3D11.Device.State.AlphaTestEnable, AlphaTestCmpMode ) ;
					UsePixelShader = GD3D11.Device.Shader.Base.BaseUseTex_PS[ 2 ][ RenderBlendType ][ GD3D11.Device.DrawSetting.IgnoreGraphColorFlag ? 1 : 0 ][ IgnoreTextureAlpha ][ GD3D11.Device.State.AlphaTestModeShaderIndex ] ;
				}
				break ;

			case DX_BLENDGRAPHTYPE_ALPHA :
				// Ƃ肠`揈s
				GD3D11.Device.DrawInfo.BlendMaxNotDrawFlag = FALSE ;

				// At@eXgp[^Lȏꍇ͂D悷
				if( GD3D11.Device.DrawSetting.AlphaTestMode != -1 )
				{
					GD3D11.Device.State.AlphaTestEnable = TRUE ;
					AlphaTestCmpMode = GD3D11.Device.DrawSetting.AlphaTestMode ;
					AlphaTestRef     = GD3D11.Device.DrawSetting.AlphaTestParam ;
				}
				else
				{
					// Lȏꍇ̓lȌꍇ̂ݕ\Ȃ悤ɂ
					if( g_DefaultBlendDescArray[ NextBlendMode ].RenderTargetBlendDesc.BlendEnable == TRUE )
					{
						GD3D11.Device.State.AlphaTestEnable = TRUE ;
						AlphaTestRef     = 0 ;
						AlphaTestCmpMode = DX_CMP_GREATER ;
					}
					else
					{
						GD3D11.Device.State.AlphaTestEnable = FALSE ;
					}
				}

				// gpVF[_[Zbg
				GD3D11.Device.State.AlphaTestModeShaderIndex = Graphics_D3D11_Shader_GetAlphaTestModeIndex( GD3D11.Device.State.AlphaTestEnable, AlphaTestCmpMode ) ;
				UsePixelShader = GD3D11.Device.Shader.Base.BaseUseTex_PS[ 3 ][ RenderBlendType ][ GD3D11.Device.DrawSetting.IgnoreGraphColorFlag ? 1 : 0 ][ IgnoreTextureAlpha ][ GD3D11.Device.State.AlphaTestModeShaderIndex ] ;
				break ;
			}
		}
		else
		{
			// uheNX`[ꍇ

			// Ƃ肠`揈s
			GD3D11.Device.DrawInfo.BlendMaxNotDrawFlag = FALSE ;

			// _^CṽZbg
			GD3D11.Device.DrawInfo.VertexType = VERTEXTYPE_TEX ;
			GD3D11.Device.DrawInfo.VertexBufferNextAddr = GD3D11.Device.DrawInfo.VertexBufferTemp ;

			// At@eXgp[^Lȏꍇ͂D悷
			if( GD3D11.Device.DrawSetting.AlphaTestMode != -1 )
			{
				GD3D11.Device.State.AlphaTestEnable = TRUE ;
				AlphaTestCmpMode = GD3D11.Device.DrawSetting.AlphaTestMode ;
				AlphaTestRef     = GD3D11.Device.DrawSetting.AlphaTestParam ;
			}
			else
			{
				// eXggp邩ǂŏ𕪊
				if( GD3D11.Device.DrawSetting.AlphaTestValidFlag == TRUE )
				{
					// eXgs(ߐFȊOɃeXg̓uheNX`łgpĂ)
					GD3D11.Device.State.AlphaTestEnable = TRUE ;
					AlphaTestRef     = 16 ;
					AlphaTestCmpMode = DX_CMP_GREATER ;
				}
				else
				{
					// Lȏꍇ̓lȌꍇ̂ݕ\Ȃ悤ɂ
					if( g_DefaultBlendDescArray[ NextBlendMode ].RenderTargetBlendDesc.BlendEnable == TRUE )
					{
						GD3D11.Device.State.AlphaTestEnable = TRUE ;
						AlphaTestRef     = 0 ;
						AlphaTestCmpMode = DX_CMP_GREATER ;
					}
					else
					{
						GD3D11.Device.State.AlphaTestEnable = FALSE ;
					}
				}
			}

			// gpsNZVF[_[Zbg
			GD3D11.Device.State.AlphaTestModeShaderIndex = Graphics_D3D11_Shader_GetAlphaTestModeIndex( GD3D11.Device.State.AlphaTestEnable, AlphaTestCmpMode ) ;
			UsePixelShader = GD3D11.Device.Shader.Base.BaseUseTex_PS[ 0 ][ g_DefaultBlendDescArray[ NextBlendMode ].RenderBlendType ][ GD3D11.Device.DrawSetting.IgnoreGraphColorFlag ? 1 : 0 ][ IgnoreTextureAlpha ][ GD3D11.Device.State.AlphaTestModeShaderIndex ] ;

			// gpeNX`[AhXZbg
			ShaderResourceView[ 0 ] = GD3D11.Device.DrawSetting.RenderTextureSRV ;

			// gpeNX`͈̐
			ShaderResourceViewNum = 1 ;
		}
	}

	if( ShaderResourceViewNum > 0 )
	{
		Graphics_D3D11_DeviceState_SetPSShaderResouceView( 0, ShaderResourceViewNum, ShaderResourceView ) ;
	}

	if( GD3D11.Device.State.AlphaTestEnable )
	{
		Graphics_D3D11_DeviceState_SetAlphaTestRef( AlphaTestRef ) ;
		Graphics_D3D11_DeviceState_SetAlphaTestCmpMode( AlphaTestCmpMode ) ;
	}
	else
	{
		Graphics_D3D11_DeviceState_SetAlphaTestRef( -1 ) ;
		Graphics_D3D11_DeviceState_SetAlphaTestCmpMode( DX_CMP_GREATER ) ;
	}

	if( UseFloatFactorColor )
	{
		Graphics_D3D11_DeviceState_SetFactorColor( &FloatFactorColor ) ;
	}

	Graphics_D3D11_DeviceState_SetBlendMode( NextBlendMode ) ;

	Graphics_D3D11_DeviceState_SetPixelShader( UsePixelShader, TRUE ) ;
	
	// I
	return 0 ;
}























// `ݒ֌W֐

// `uh[h̐ݒ
extern int Graphics_D3D11_DrawSetting_SetDrawBlendMode( int BlendMode, int AlphaTestValidFlag, int AlphaChannelValidFlag )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
		GD3D11.Device.DrawSetting.BlendMode               == BlendMode &&
		GD3D11.Device.DrawSetting.AlphaTestValidFlag      == AlphaTestValidFlag &&
		GD3D11.Device.DrawSetting.AlphaChannelValidFlag   == AlphaChannelValidFlag )
	{
		return 0 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GD3D11.Device.DrawSetting.BlendMode             = BlendMode ;
	GD3D11.Device.DrawSetting.AlphaChannelValidFlag = AlphaChannelValidFlag ;
	GD3D11.Device.DrawSetting.AlphaTestValidFlag    = AlphaTestValidFlag ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag    = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GD3D11.Device.DrawSetting.ChangeBlendParamFlag = TRUE ;

	return 0 ;
}

// `掞̉摜̐F𖳎邩ǂݒ肷
extern int Graphics_D3D11_DrawSetting_SetIgnoreDrawGraphColor( int EnableFlag )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.IgnoreGraphColorFlag == EnableFlag &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GD3D11.Device.DrawSetting.IgnoreGraphColorFlag = EnableFlag ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GD3D11.Device.DrawSetting.ChangeBlendParamFlag = TRUE ;

	return 0 ;
}

// At@eXg̐ݒ
extern int Graphics_D3D11_DrawSetting_SetDrawAlphaTest( int TestMode, int TestParam )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
		GD3D11.Device.DrawSetting.AlphaTestMode  == TestMode &&
		GD3D11.Device.DrawSetting.AlphaTestParam == TestParam )
	{
		return 0 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	GD3D11.Device.DrawSetting.AlphaTestMode      = TestMode ;
	GD3D11.Device.DrawSetting.AlphaTestParam     = TestParam ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GD3D11.Device.DrawSetting.ChangeBlendParamFlag = TRUE ;

	return 0 ;
}

// uheNX`̃p[^Zbg
extern int Graphics_D3D11_DrawSetting_SetBlendTextureParam( int BlendType, int *Param )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// p[^ۑ
	switch( BlendType )
	{
	case DX_BLENDGRAPHTYPE_NORMAL :
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
			BlendType == GD3D11.Device.DrawSetting.BlendGraphType &&
			GD3D11.Device.DrawSetting.BlendGraphFadeRatio == Param[ 0 ] )
		{
			return 0 ;
		}

		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			// `ҋ@Ă`敨`
			DRAWSTOCKINFO
		}

		GD3D11.Device.DrawSetting.BlendGraphFadeRatio = Param[ 0 ] ;
		break;

	case DX_BLENDGRAPHTYPE_WIPE:
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
			BlendType == GD3D11.Device.DrawSetting.BlendGraphType &&
			GD3D11.Device.DrawSetting.BlendGraphBorderParam == Param[ 0 ] &&
			GD3D11.Device.DrawSetting.BlendGraphBorderRange == Param[ 1 ] )
		{
			return 0 ;
		}

		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			// `ҋ@Ă`敨`
			DRAWSTOCKINFO
		}

		GD3D11.Device.DrawSetting.BlendGraphBorderParam = Param[ 0 ] ;
		GD3D11.Device.DrawSetting.BlendGraphBorderRange = Param[ 1 ] ;
		break;

	case DX_BLENDGRAPHTYPE_ALPHA :
		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
			BlendType == GD3D11.Device.DrawSetting.BlendGraphType )
		{
			return 0 ;
		}

		if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
		{
			// `ҋ@Ă`敨`
			DRAWSTOCKINFO
		}
		break;
	}

	// uh^Cvۑ
	GD3D11.Device.DrawSetting.BlendGraphType = BlendType ;

	// p[^ύXꂽAtO𗧂Ă
	GD3D11.Device.DrawSetting.ChangeBlendParamFlag = TRUE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// eNX`Zbg 
extern int Graphics_D3D11_DrawSetting_SetTexture( D_ID3D11Texture2D *RenderTexture, D_ID3D11ShaderResourceView *RenderTextureSRV )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( RenderTexture == GD3D11.Device.DrawSetting.RenderTexture &&
		GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		return 0 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		// `ҋ@Ă`敨`
		DRAWSTOCKINFO
	}

	// eNX`ύXꂽAtO𗧂Ă
	GD3D11.Device.DrawSetting.ChangeTextureFlag = TRUE ;

	// eNX`̗L薳ύXꂽꍇ̓uhp[^̕ύXstOZbg
	if( ( GD3D11.Device.DrawSetting.RenderTexture == NULL && RenderTexture != NULL ) ||
		( GD3D11.Device.DrawSetting.RenderTexture != NULL && RenderTexture == NULL ) )
	{
		GD3D11.Device.DrawSetting.ChangeBlendParamFlag = TRUE ;
	}

	// eNX`Zbg
	GD3D11.Device.DrawSetting.RenderTexture      = RenderTexture ;
	GD3D11.Device.DrawSetting.RenderTextureSRV   = RenderTextureSRV ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// uheNX`Zbg 
extern int Graphics_D3D11_DrawSetting_SetBlendTexture( D_ID3D11Texture2D *BlendTexture,  D_ID3D11ShaderResourceView *BlendTextureSRV, int TexWidth, int TexHeight )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE &&
		BlendTexture == GD3D11.Device.DrawSetting.BlendTexture )
	{
		return 0 ;
	}

	if( GD3D11.Device.DrawSetting.CancelSettingEqualCheck == FALSE )
	{
		// `ҋ@Ă`敨`
		DRAWSTOCKINFO
	}

	// eNX`ύXꂽAtO𗧂Ă
	GD3D11.Device.DrawSetting.ChangeTextureFlag = TRUE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;

	// uheNX`̗L薳ύXꂽꍇ̓uhp[^̕ύXstOZbg
	if( ( GD3D11.Device.DrawSetting.BlendTexture == NULL && BlendTexture != NULL ) ||
		( GD3D11.Device.DrawSetting.BlendTexture != NULL && BlendTexture == NULL ) )
	{
		GD3D11.Device.DrawSetting.ChangeBlendParamFlag = TRUE ;
	}

	// eNX`Zbg
	GD3D11.Device.DrawSetting.BlendTexture    = BlendTexture ;
	GD3D11.Device.DrawSetting.BlendTextureSRV = BlendTextureSRV ;

	// eNX`̕ƍۑ
	if( BlendTexture != NULL )
	{
		GD3D11.Device.DrawSetting.BlendTextureWidth  = ( float )TexWidth  ;
		GD3D11.Device.DrawSetting.BlendTextureHeight = ( float )TexHeight ;
		GD3D11.Device.DrawSetting.InvBlendTextureWidth  = 1.0F / GD3D11.Device.DrawSetting.BlendTextureWidth ;
		GD3D11.Device.DrawSetting.InvBlendTextureHeight = 1.0F / GD3D11.Device.DrawSetting.BlendTextureHeight ;
	}

	// I
	return 0 ;
}






























// 萔֌W֐

// Direct3D11 ̒萔̏s
extern int Graphics_D3D11_Constant_Initialize( void )
{
	// e萔obt@쐬
	GD3D11.Device.Shader.Constant.ConstBuffer_Common = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_CONST_BUFFER_COMMON ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_Common == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_VS_CONST_BUFFER_BASE ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_VS_CONST_BUFFER_LOCALWORLDMATRIX ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_PS_CONST_BUFFER_BASE ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap = Graphics_D3D11_ConstantBuffer_Create( sizeof( DX_D3D11_PS_CONST_BUFFER_SHADOWMAP ) ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap == NULL )
	{
		goto ERR ;
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter = Graphics_D3D11_ConstantBuffer_Create( DX_D3D11_PS_CONST_FILTER_SIZE ) ;
	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter == NULL )
	{
		goto ERR ;
	}

	// I
	return 0 ;

ERR :
	if( GD3D11.Device.Shader.Constant.ConstBuffer_Common != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_Common = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter = NULL ;
	}

	DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@̍쐬Ɏs܂\n" ) ) ) ;

	// G[I
	return -1 ;
}

// Direct3D11 ̒萔̌ns
extern int Graphics_D3D11_Constant_Terminate( void )
{
	if( GD3D11.Device.Shader.Constant.ConstBuffer_Common != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_Common ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_Common = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_VS_LocalWorldMatrix = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_Base = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap = NULL ;
	}

	if( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter != NULL )
	{
		Graphics_D3D11_ConstantBuffer_Delete( GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter ) ;
		GD3D11.Device.Shader.Constant.ConstBuffer_PS_Filter = NULL ;
	}

	// I
	return 0 ;
}

































// 萔obt@֌W֐

// 萔obt@쐬
extern	CONSTANTBUFFER_DIRECT3D11 *Graphics_D3D11_ConstantBuffer_Create( DWORD Size )
{
	CONSTANTBUFFER_DIRECT3D11	*NewBuffer = NULL ;
	DWORD						AllocSize ;
	D_D3D11_BUFFER_DESC			BufferDesc ;

	// TCY`FbN
	if( Size % 16 != 0 )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@̃TCY͂PU̔{łKv܂\n" ) ) ) ;
		goto ERR ;
	}

	// ̊m
	AllocSize = Size + sizeof( CONSTANTBUFFER_DIRECT3D11 ) ;
	NewBuffer = ( CONSTANTBUFFER_DIRECT3D11 * )DXALLOC( AllocSize ) ;
	if( NewBuffer == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@i[郁̈̊mۂɎs܂\n" ) ) ) ;
		goto ERR ;
	}

	// 돉
	_MEMSET( NewBuffer, 0, AllocSize ) ;

	// ID3D11Buffer ̍쐬
	_MEMSET( &BufferDesc, 0, sizeof( BufferDesc ) ) ;
	BufferDesc.ByteWidth      = Size ;
	BufferDesc.Usage          = D_D3D11_USAGE_DEFAULT ;
	BufferDesc.BindFlags      = D_D3D11_BIND_CONSTANT_BUFFER ;
	BufferDesc.CPUAccessFlags = 0 ;
	if( D3D11Device_CreateBuffer( &BufferDesc, NULL, &NewBuffer->ConstantBuffer ) != S_OK )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "萔obt@p ID3D11Buffer ̍쐬Ɏs܂\n" ) ) ) ;
		goto ERR ;
	}

	// Zbg
	NewBuffer->Size         = Size ;
	NewBuffer->SysmemBuffer = NewBuffer + 1 ;
	NewBuffer->ChangeFlag   = FALSE ;

	// Xgɒǉ
	if( GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer != NULL )
	{
		NewBuffer->NextData = GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer ;
		GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer->PrevData = NewBuffer ;
	}
	GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer = NewBuffer ;

	// obt@̐𑝂₷
	GD3D11.Device.Shader.Constant.ConstantBufferManage.BufferNum ++ ;

	// I
	return NewBuffer ;


	// G[
ERR :
	if( NewBuffer != NULL )
	{
		if( NewBuffer->ConstantBuffer != NULL )
		{
			Direct3D11_ObjectRelease( NewBuffer->ConstantBuffer ) ;
			NewBuffer->ConstantBuffer = NULL ;
		}

		DXFREE( NewBuffer ) ;
	}

	// G[I
	return NULL ;
}

// 萔obt@폜
extern int Graphics_D3D11_ConstantBuffer_Delete( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer )
{
	int i ;

	// foCXŎgpĂO
	for( i = 0 ; i < D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ; i ++ )
	{
		if( GD3D11.Device.State.SetPixelShaderConstantBuffer[ i ] == ConstantBuffer->ConstantBuffer )
		{
			GD3D11.Device.State.SetPixelShaderConstantBuffer[ i ] = NULL ;
		}

		if( GD3D11.Device.State.SetVertexShaderConstantBuffer[ i ] == ConstantBuffer->ConstantBuffer )
		{
			GD3D11.Device.State.SetVertexShaderConstantBuffer[ i ] = NULL ;
		}
	}

	// ID3D11Buffer 
	if( ConstantBuffer->ConstantBuffer != NULL )
	{
		Direct3D11_ObjectRelease( ConstantBuffer->ConstantBuffer ) ;
		ConstantBuffer->ConstantBuffer = NULL ;
	}

	// XgO
	if( GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer == ConstantBuffer )
	{
		GD3D11.Device.Shader.Constant.ConstantBufferManage.FirstBuffer = ConstantBuffer->NextData ;
		if( ConstantBuffer->NextData != NULL )
		{
			ConstantBuffer->NextData->PrevData = NULL ;
		}
	}
	else
	{
		ConstantBuffer->PrevData->NextData = ConstantBuffer->NextData ;
		if( ConstantBuffer->NextData != NULL )
		{
			ConstantBuffer->NextData->PrevData = ConstantBuffer->PrevData ;
		}
	}

	// ̉
	DXFREE( ConstantBuffer ) ;

	// obt@̐炷
	GD3D11.Device.Shader.Constant.ConstantBufferManage.BufferNum -- ;

	// I
	return 0 ;
}

// VXẽobt@ɍsύXKp
extern int Graphics_D3D11_ConstantBuffer_Update( CONSTANTBUFFER_DIRECT3D11 *ConstantBuffer )
{
	// ύXꍇ͉ɏI
	if( ConstantBuffer->ChangeFlag == FALSE )
	{
		return 0 ;
	}

	// XV
	D3D11DeviceContext_UpdateSubresource( ConstantBuffer->ConstantBuffer, 0, NULL, ConstantBuffer->SysmemBuffer, 0, 0 ) ;

	// ύXtO|
	ConstantBuffer->ChangeFlag = FALSE ;

	// I
	return 0 ;
}

// w̒萔obt@𒸓_VF[_[ɐݒ肷
extern int Graphics_D3D11_ConstantBuffer_VSSet( UINT StartSlot, UINT NumBuffers, CONSTANTBUFFER_DIRECT3D11 * const *pConstantBuffers )
{
	D_ID3D11Buffer *D3D11ConstantBuffer[ D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ] ;
	UINT                 i ;

	if( StartSlot < 0 || StartSlot + NumBuffers > D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT )
	{
		return -1 ;
	}

	if( NumBuffers == 1 )
	{
		return Graphics_D3D11_DeviceState_SetVertexShaderConstantBuffers( StartSlot, NumBuffers, &pConstantBuffers[ 0 ]->ConstantBuffer ) ;
	}
	
	for( i = 0 ; i < NumBuffers ; i ++ )
	{
		D3D11ConstantBuffer[ i ] = pConstantBuffers[ i ]->ConstantBuffer ;
	}

	return Graphics_D3D11_DeviceState_SetVertexShaderConstantBuffers( StartSlot, NumBuffers, D3D11ConstantBuffer ) ;
}

// w̒萔obt@sNZVF[_[ɐݒ肷
extern int Graphics_D3D11_ConstantBuffer_PSSet( UINT StartSlot, UINT NumBuffers, CONSTANTBUFFER_DIRECT3D11 * const *pConstantBuffers )
{
	D_ID3D11Buffer *D3D11ConstantBuffer[ D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT ] ;
	UINT                 i ;

	if( StartSlot < 0 || StartSlot + NumBuffers > D_D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT )
	{
		return -1 ;
	}

	if( NumBuffers == 1 )
	{
		return Graphics_D3D11_DeviceState_SetPixelShaderConstantBuffers( StartSlot, NumBuffers, &pConstantBuffers[ 0 ]->ConstantBuffer ) ;
	}
	
	for( i = 0 ; i < NumBuffers ; i ++ )
	{
		D3D11ConstantBuffer[ i ] = pConstantBuffers[ i ]->ConstantBuffer ;
	}

	return Graphics_D3D11_DeviceState_SetPixelShaderConstantBuffers( StartSlot, NumBuffers, D3D11ConstantBuffer ) ;
}
































// ̓CAEg֌W֐

static D_D3D11_INPUT_ELEMENT_DESC MakeD3D11InputElement( LPCSTR SemanticName, UINT SemanticIndex, D_DXGI_FORMAT Format, UINT InputSlot, UINT AlignedByteOffset )
{
	D_D3D11_INPUT_ELEMENT_DESC Result = 
	{
		SemanticName,
		SemanticIndex,
		Format,
		InputSlot,
		AlignedByteOffset,
		D_D3D11_INPUT_PER_VERTEX_DATA,
		0
	} ;
	return Result ;
}

// W`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Base_Create( void )
{
	int							i ;
	int							ElementNum ;
	HRESULT						hr ;
	GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO *BSVI ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO                *Code ;

	// ɍ쐬ĂƂ̂߂ɍ폜s
	Graphics_D3D11_InputLayout_Base_Terminate() ;

	// W`p̃VF[_[Ŏgp钸_f[^`쐬
	BSVI = g_BaseSimpleVertexShaderInfo ;
	Code = GraphicsHardDataDirect3D11.ShaderCode.Base.BaseSimple_VS_Code ;
	for( i = 0 ; i < D3D11_VERTEX_INPUTLAYOUT_NUM ; i++, BSVI++, Code++ )
	{
		// _Ɋ܂܂̐𐔂
		for( ElementNum = 0 ; BSVI->InputElementDesc[ ElementNum ].SemanticName != NULL ; ElementNum ++ ){}

		// _f[^tH[}bg쐬
		hr = D3D11Device_CreateInputLayout( BSVI->InputElementDesc, ElementNum, Code->Binary, ( SIZE_T )Code->Size, &GD3D11.Device.InputLayout.BaseInputLayout[ i ] ) ;
		if( hr != S_OK )
		{
			return -1 ;
		}
	}

	// P]p̒_f[^tH[}bg쐬
	{
		static D_D3D11_INPUT_ELEMENT_DESC StretchRectInputElementDesc[] =
		{
			{ "POSITION",     0, D_DXGI_FORMAT_R32G32_FLOAT, 0,  0, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32_FLOAT, 0,  8, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
			{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32_FLOAT, 0, 16, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
		} ;
		
		hr = D3D11Device_CreateInputLayout(
			StretchRectInputElementDesc,
			sizeof( StretchRectInputElementDesc ) / sizeof( D_D3D11_INPUT_ELEMENT_DESC ),
			GD3D11.ShaderCode.Base.StretchRect_VS_Code.Binary,
			( SIZE_T )GD3D11.ShaderCode.Base.StretchRect_VS_Code.Size,
			&GD3D11.Device.InputLayout.BaseStretchRectInputLayout ) ;
		if( hr != S_OK )
		{
			return -1 ;
		}
	}

	// I
	return 0 ;
}

// W`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Base_Terminate( void )
{
	int							i ;
	GRAPHICS_HARDWEARE_DIRECT3D11_BASE_SIMPLE_VERTEXSHADER_INFO *BSVI ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// W`p̃VF[_[Ŏgp钸_f[^`
	BSVI = g_BaseSimpleVertexShaderInfo ;
	for( i = 0 ; i < D3D11_VERTEX_INPUTLAYOUT_NUM ; i++, BSVI++ )
	{
		if( GD3D11.Device.InputLayout.BaseInputLayout[ i ] != NULL )
		{
			Direct3D11_ObjectRelease( GD3D11.Device.InputLayout.BaseInputLayout[ i ] ) ;
			GD3D11.Device.InputLayout.BaseInputLayout[ i ] = NULL ;
		}
	}

	// I
	return 0 ;
}

#ifndef DX_NON_MODEL

// f`p ID3D11InputLayout IuWFNg̍쐬( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Model_Create( int BumpMap, int MeshType )
{
	int offset, index ;
	HRESULT hr ;
	D_ID3D11VertexShader **VS = NULL ;
	GRAPHICS_HARDWARE_DIRECT3D11_SHADERCODE_INFO *VSAddress = NULL ;
	D_D3D11_INPUT_ELEMENT_DESC InputElement[ 64 ] = 
	{
		{ "POSITION",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0,  0, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "NORMAL",       0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, 12, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "COLOR",        0, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 24, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "COLOR",        1, D_DXGI_FORMAT_B8G8R8A8_UNORM,     0, 28, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "TEXCOORD",     0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 32, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "TEXCOORD",     1, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, 48, D_D3D11_INPUT_PER_VERTEX_DATA, 0 },
	} ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// ɂ牽I
	if( GD3D11.Device.InputLayout.MV1_VertexInputLayout[ BumpMap ][ MeshType ] != NULL )
	{
		return 0 ;
	}

	index  = 6 ;
	offset = 64 ;
	if( BumpMap )
	{
		InputElement[ index ] = MakeD3D11InputElement( "TANGENT",      0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, offset ) ;
		index++ ;
		offset += sizeof( VECTOR ) ;

		InputElement[ index ] = MakeD3D11InputElement( "BINORMAL",     0, D_DXGI_FORMAT_R32G32B32_FLOAT,    0, offset ) ;
		index++ ;
		offset += sizeof( VECTOR ) ;
	}

	switch( MeshType )
	{
	case 0 :	// ̃bV
		break ;

	case 1 :	// S{[ȓXLjObV
	case 2 :	// W{[ȓXLjObV
		InputElement[ index ] = MakeD3D11InputElement( "BLENDINDICES", 0, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, offset ) ;
		index++ ;
		offset += sizeof( BYTE ) * 4 ;

		InputElement[ index ] = MakeD3D11InputElement( "BLENDWEIGHT",  0, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, offset ) ;
		index++ ;
		offset += sizeof( FLOAT4 ) ;

		if( MeshType == 2 )
		{
			InputElement[ index ] = MakeD3D11InputElement( "BLENDINDICES", 1, D_DXGI_FORMAT_R8G8B8A8_UINT,      0, offset ) ;
			index++ ;
			offset += sizeof( BYTE ) * 4 ;

			InputElement[ index ] = MakeD3D11InputElement( "BLENDWEIGHT",  1, D_DXGI_FORMAT_R32G32B32A32_FLOAT, 0, offset ) ;
			index++ ;
			offset += sizeof( FLOAT4 ) ;
		}
		break ;
	}

	VS        = &GD3D11.Device.Shader.Model.MV1_VertexLighting_VS     [ 0 ][ MeshType ][ BumpMap ][ 0 ][ 0 ] ;
	VSAddress =    &GD3D11.ShaderCode.Model.MV1_VertexLighting_VS_Code[ 0 ][ MeshType ][ BumpMap ][ 0 ][ 0 ] ;

	// VF[_[邩𒲂ׂ
	if( *VS == NULL )
	{
		// VF[_[̍쐬݂
		if( Graphics_D3D11_VertexShader_Create( VSAddress, VS, 1 ) != 0 )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "Graphics_D3D11_InputLayout_Model_Create Œ_VF[_[̍쐬Ɏs܂\n" ) ) ) ;
			return -1 ;
		}
	}

	hr = D3D11Device_CreateInputLayout( InputElement, index, VSAddress->Binary, ( SIZE_T )VSAddress->Size, &GD3D11.Device.InputLayout.MV1_VertexInputLayout[ BumpMap ][ MeshType ] ) ;
	if( hr != S_OK )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// f`p ID3D11InputLayout IuWFNg̍폜( 0:  -1:s )
extern int Graphics_D3D11_InputLayout_Model_Terminate( void )
{
	int i ;
	int j ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	for( i = 0; i < 2; i ++ )
	{
		for( j = 0; j < 3; j ++ )
		{
			if( GD3D11.Device.InputLayout.MV1_VertexInputLayout[ i ][ j ] != NULL )
			{
				Direct3D11_ObjectRelease( GD3D11.Device.InputLayout.MV1_VertexInputLayout[ i ][ j ] ) ;
				GD3D11.Device.InputLayout.MV1_VertexInputLayout[ i ][ j ] = NULL ;
			}
		}
	}

	return 0 ;
}

#endif // DX_NON_MODEL














// W`֌W

// W`p̒_obt@̍쐬( 0:  -1:s )
extern	int		Graphics_D3D11_NormalDrawVertexBuffer_Create( void )
{
	D_D3D11_BUFFER_DESC BufferDesc ;
	HRESULT             hr ;

	_MEMSET( &BufferDesc, 0, sizeof( BufferDesc ) ) ;
	BufferDesc.ByteWidth      = D3D11_VERTEXBUFFER_SIZE ;
//	BufferDesc.Usage          = D_D3D11_USAGE_DYNAMIC ;
	BufferDesc.Usage          = D_D3D11_USAGE_DEFAULT ;
	BufferDesc.BindFlags      = D_D3D11_BIND_VERTEX_BUFFER ;
//	BufferDesc.CPUAccessFlags = D_D3D11_CPU_ACCESS_WRITE ;
	BufferDesc.CPUAccessFlags = 0 ;
	hr = D3D11Device_CreateBuffer( &BufferDesc, NULL, &GD3D11.Device.DrawInfo.VertexBuffer ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "W`p̒_obt@̍쐬Ɏs܂\n" ) ) ) ;
		return -1 ;
	}

	// I
	return 0 ;
}

// W`p̒_obt@̍폜( 0:  -1:s )
extern	int		Graphics_D3D11_NormalDrawVertexBuffer_Terminate( void )
{
	if( GD3D11.Device.DrawInfo.VertexBuffer )
	{
		Direct3D11_ObjectRelease( GD3D11.Device.DrawInfo.VertexBuffer ) ;
		GD3D11.Device.DrawInfo.VertexBuffer = NULL ;
	}

	// I
	return 0 ;
}

// ėp`p_obt@gpăVXe̒_f[^̕`s
extern int Graphics_D3D11_CommonBuffer_DrawPrimitive(
	int                        InputLayout,
	D_D3D11_PRIMITIVE_TOPOLOGY PrimitiveType,
	const void *               VertexData,
	int                        VertexNum
)
{
	int         VertexSize ;
	D_D3D11_BOX DestBox ;

	VertexSize = D3D11_VertexSize[ InputLayout ] ;

	Graphics_D3D11_CommonVertexBuffer_Setup( VertexSize * VertexNum ) ;

	DestBox.left   = 0 ;
	DestBox.top    = 0 ;
	DestBox.front  = 0 ;
	DestBox.bottom = 1 ;
	DestBox.back   = 1 ;

	DestBox.right  = VertexSize * VertexNum ;
	D3D11DeviceContext_UpdateSubresource_ASync( GD3D11.Device.DrawInfo.CommonVertexBuffer, 0, &DestBox, VertexData, 0, 0 ) ;

	// v~eBu^CvZbg
	Graphics_D3D11_DeviceState_SetPrimitiveTopology( PrimitiveType ) ;

	// ̓CAEgZbg
	Graphics_D3D11_DeviceState_SetInputLayout( GD3D11.Device.InputLayout.BaseInputLayout[ InputLayout ] ) ;

	// _VF[_[Zbg
	if( InputLayout == D3D11_VERTEX_INPUTLAYOUT_3D_LIGHT )
	{
		if( Graphics_D3D11_Shader_Normal3DDraw_Setup() == FALSE )
		{
			return -1 ;
		}
	}
	else
	{
		Graphics_D3D11_DeviceState_SetVertexShader( GD3D11.Device.Shader.Base.BaseSimple_VS[ InputLayout ], TRUE ) ;
	}

	// _obt@Zbg
	Graphics_D3D11_DeviceState_SetVertexBuffer( GD3D11.Device.DrawInfo.CommonVertexBuffer, D3D11_VertexSize[ InputLayout ] ) ;

	// `
	D3D11DeviceContext_Draw( VertexNum, 0 ) ;

	// I
	return 0 ;
}

// ėp`p_obt@ECfbNXobt@gpăVXe̒_f[^ECfbNXf[^̕`s
extern int Graphics_D3D11_CommonBuffer_DrawIndexedPrimitive(
	int							InputLayout,
	D_D3D11_PRIMITIVE_TOPOLOGY	PrimitiveType,
	const void *				VertexData,
	int							VertexNum,
	const void *				IndexData,
	int							IndexNum,
	D_DXGI_FORMAT				IndexFormat
)
{
	int         VertexSize ;
	int         IndexSize ;
	D_D3D11_BOX DestBox ;

	VertexSize = D3D11_VertexSize[ InputLayout ] ;
	switch( IndexFormat )
	{
	case D_DXGI_FORMAT_R16_UINT :
		IndexSize = 2 ;
		break ;

	case D_DXGI_FORMAT_R32_UINT :
		IndexSize = 4 ;
		break ;
	}

	Graphics_D3D11_CommonVertexBuffer_Setup( VertexSize * VertexNum ) ;
	Graphics_D3D11_CommonIndexBuffer_Setup( IndexSize * IndexNum ) ;

	DestBox.left   = 0 ;
	DestBox.top    = 0 ;
	DestBox.front  = 0 ;
	DestBox.bottom = 1 ;
	DestBox.back   = 1 ;

	DestBox.right  = VertexSize * VertexNum ;
	D3D11DeviceContext_UpdateSubresource_ASync( GD3D11.Device.DrawInfo.CommonVertexBuffer, 0, &DestBox, VertexData, 0, 0 ) ;

	DestBox.right  = IndexSize * IndexNum ;
	D3D11DeviceContext_UpdateSubresource_ASync( GD3D11.Device.DrawInfo.CommonIndexBuffer,  0, &DestBox, IndexData,  0, 0 ) ;

	// v~eBu^CvZbg
	Graphics_D3D11_DeviceState_SetPrimitiveTopology( PrimitiveType ) ;

	// ̓CAEgZbg
	Graphics_D3D11_DeviceState_SetInputLayout( GD3D11.Device.InputLayout.BaseInputLayout[ InputLayout ] ) ;

	// _VF[_[Zbg
	if( InputLayout == D3D11_VERTEX_INPUTLAYOUT_3D_LIGHT )
	{
		if( Graphics_D3D11_Shader_Normal3DDraw_Setup() == FALSE )
		{
			return -1 ;
		}
	}
	else
	{
		Graphics_D3D11_DeviceState_SetVertexShader( GD3D11.Device.Shader.Base.BaseSimple_VS[ InputLayout ], TRUE ) ;
	}

	// _obt@Zbg
	Graphics_D3D11_DeviceState_SetVertexBuffer( GD3D11.Device.DrawInfo.CommonVertexBuffer, D3D11_VertexSize[ InputLayout ] ) ;

	// CfbNXobt@Zbg
	Graphics_D3D11_DeviceState_SetIndexBuffer( GD3D11.Device.DrawInfo.CommonIndexBuffer, IndexFormat ) ;

	// `
	D3D11DeviceContext_DrawIndexed( IndexNum, 0, 0 ) ;

	// I
	return 0 ;
}

// wTCY̔ėp`p_obt@̏s
extern int Graphics_D3D11_CommonVertexBuffer_Setup( int Size )
{
	D_D3D11_BUFFER_DESC BufferDesc ;
	HRESULT             hr ;

	if( Size <= GD3D11.Device.DrawInfo.CommonVertexBufferSize )
	{
		return 0 ;
	}

	Graphics_D3D11_CommonVertexBuffer_Terminate() ;

	Size += D3D11_COMMONBUFFER_ADDSIZE ;
	Size = ( Size + 15 ) / 16 * 16 ;

	_MEMSET( &BufferDesc, 0, sizeof( BufferDesc ) ) ;
	BufferDesc.ByteWidth      = Size ;
	BufferDesc.Usage          = D_D3D11_USAGE_DEFAULT ;
	BufferDesc.BindFlags      = D_D3D11_BIND_VERTEX_BUFFER ;
	BufferDesc.CPUAccessFlags = 0 ;
	hr = D3D11Device_CreateBuffer( &BufferDesc, NULL, &GD3D11.Device.DrawInfo.CommonVertexBuffer ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "ėp`p̒_obt@̍쐬Ɏs܂( TCY %d byte )\n" ), Size ) ) ;
		return -1 ;
	}

	GD3D11.Device.DrawInfo.CommonVertexBufferSize = Size ;

	// I
	return 0 ;
}

// wTCY̔ėp`pCfbNXobt@̏s
extern int Graphics_D3D11_CommonIndexBuffer_Setup( int Size )
{
	D_D3D11_BUFFER_DESC BufferDesc ;
	HRESULT             hr ;

	if( Size <= GD3D11.Device.DrawInfo.CommonIndexBufferSize )
	{
		return 0 ;
	}

	Graphics_D3D11_CommonIndexBuffer_Terminate() ;

	Size += D3D11_COMMONBUFFER_ADDSIZE ;
	Size = ( Size + 15 ) / 16 * 16 ;

	_MEMSET( &BufferDesc, 0, sizeof( BufferDesc ) ) ;
	BufferDesc.ByteWidth      = Size ;
	BufferDesc.Usage          = D_D3D11_USAGE_DEFAULT ;
	BufferDesc.BindFlags      = D_D3D11_BIND_INDEX_BUFFER ;
	BufferDesc.CPUAccessFlags = 0 ;
	hr = D3D11Device_CreateBuffer( &BufferDesc, NULL, &GD3D11.Device.DrawInfo.CommonIndexBuffer ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "ėp`p̃CfbNXobt@̍쐬Ɏs܂( TCY %d byte )\n" ), Size ) ) ;
		return -1 ;
	}

	GD3D11.Device.DrawInfo.CommonIndexBufferSize = Size ;

	// I
	return 0 ;
}

// ėp`p_obt@̌ns
extern int Graphics_D3D11_CommonVertexBuffer_Terminate( void )
{
	if( GD3D11.Device.DrawInfo.CommonVertexBuffer == NULL )
	{
		return 0 ;
	}

	if( GD3D11.Device.State.SetVertexBuffer == GD3D11.Device.DrawInfo.CommonVertexBuffer )
	{
		Graphics_D3D11_DeviceState_SetVertexBuffer( NULL, 0 ) ;
	}

	Direct3D11_ObjectRelease( GD3D11.Device.DrawInfo.CommonVertexBuffer ) ;
	GD3D11.Device.DrawInfo.CommonVertexBuffer = NULL ;

	GD3D11.Device.DrawInfo.CommonVertexBufferSize = 0 ;

	return 0 ;
}

// ėp`pCfbNXobt@̌ns
extern int Graphics_D3D11_CommonIndexBuffer_Terminate( void )
{
	if( GD3D11.Device.DrawInfo.CommonIndexBuffer == NULL )
	{
		return 0 ;
	}

	if( GD3D11.Device.State.SetIndexBuffer == GD3D11.Device.DrawInfo.CommonIndexBuffer )
	{
		Graphics_D3D11_DeviceState_SetIndexBuffer( NULL, D_DXGI_FORMAT_R16_UINT ) ;
	}

	Direct3D11_ObjectRelease( GD3D11.Device.DrawInfo.CommonIndexBuffer ) ;
	GD3D11.Device.DrawInfo.CommonIndexBuffer = NULL ;

	GD3D11.Device.DrawInfo.CommonIndexBufferSize = 0 ;

	return 0 ;
}






















// Direct3D11 ̕`揈֌W

#ifndef DX_NON_ASYNCLOAD
static int Graphics_D3D11_RenderVertexASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO * Info )
{
	return Graphics_D3D11_RenderVertex(
		( int )Info->Data[ 0 ],
		FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

// _obt@ɗ܂_f[^_O
extern	int		Graphics_D3D11_RenderVertex( int NextUse3DVertex, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Graphics_D3D11_RenderVertexASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )NextUse3DVertex ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// _`͍sȂ
	if( GD3D11.Device.DrawInfo.VertexNum != 0 && DxLib_GetEndRequest() == FALSE )
	{
		// Graphics_D3D11_BeginScene ĂȂ炷
//		if( GD3D11.Device.DrawInfo.BeginSceneFlag == FALSE ) Graphics_D3D11_BeginScene() ;

		// `tOĂȂ΃_O
		if( GD3D11.Device.DrawInfo.BlendMaxNotDrawFlag == FALSE )
		{
//			D_D3D11_MAPPED_SUBRESOURCE MappedSubResource ;
//			HRESULT                    hr ;
			DWORD                      InputLayout ;
			D_D3D11_BOX                DestBox ;

			InputLayout = D3D11_VertexTypeToInputLayout[ GD3D11.Device.DrawInfo.Use3DVertex ][ GD3D11.Device.DrawInfo.VertexType ] ;

			// _f[^𒸓_obt@ɔf
/*			hr = D3D11DeviceContext_Map(
				GD3D11.Device.DrawInfo.VertexBuffer,
				0, 
				D_D3D11_MAP_WRITE_DISCARD,
				0,
				&MappedSubResource
			);*/
			DestBox.left   = 0 ;
			DestBox.top    = 0 ;
			DestBox.front  = 0 ;
			DestBox.right  = D3D11_VertexSize[ InputLayout ] * GD3D11.Device.DrawInfo.VertexNum ;
			DestBox.bottom = 1 ;
			DestBox.back   = 1 ;
			D3D11DeviceContext_UpdateSubresource_ASync(
				GD3D11.Device.DrawInfo.VertexBuffer,
				0,
				&DestBox,
				GD3D11.Device.DrawInfo.VertexBufferTemp,
				0,
				0,
				ASyncThread
			) ;

//			if( !FAILED( hr ) )
			{
/*				_MEMCPY(
					MappedSubResource.pData,
					GD3D11.Device.DrawInfo.VertexBufferTemp[ InputLayout ], 
					D3D11_VertexSize[ InputLayout ] * GD3D11.Device.DrawInfo.VertexNum
				) ;
				D3D11DeviceContext_Unmap( GD3D11.Device.DrawInfo.VertexBuffer, 0 ) ;*/

				// v~eBu^CvZbg
				Graphics_D3D11_DeviceState_SetPrimitiveTopology( GD3D11.Device.DrawInfo.PrimitiveType ) ;

				// ̓CAEgZbg
				Graphics_D3D11_DeviceState_SetInputLayout( GD3D11.Device.InputLayout.BaseInputLayout[ InputLayout ] ) ;

				// _VF[_[Zbg
				if( InputLayout == D3D11_VERTEX_INPUTLAYOUT_3D_LIGHT )
				{
					if( Graphics_D3D11_Shader_Normal3DDraw_Setup() == FALSE )
					{
						return -1 ;
					}
				}
				else
				{
					Graphics_D3D11_DeviceState_SetVertexShader( GD3D11.Device.Shader.Base.BaseSimple_VS[ InputLayout ], TRUE ) ;
				}

				// _obt@Zbg
				Graphics_D3D11_DeviceState_SetVertexBuffer( GD3D11.Device.DrawInfo.VertexBuffer, D3D11_VertexSize[ InputLayout ] ) ;

				// `
				D3D11DeviceContext_Draw( GD3D11.Device.DrawInfo.VertexNum, 0 ) ;

//				if( GD3D11.Device.DrawInfo.Use3DVertex )
//				{
//					Graphics_D3D11_DeviceState_SetWorldMatrix( &GSYS.DrawSetting.WorldMatrixF ) ;
//				}
			}
		}
	}

	if( NextUse3DVertex >= 0 )
	{
		GD3D11.Device.DrawInfo.Use3DVertex = NextUse3DVertex ;
	}

	GD3D11.Device.DrawInfo.VertexNum = 0 ;
	GD3D11.Device.DrawInfo.VertexBufferNextAddr = GD3D11.Device.DrawInfo.VertexBufferTemp ;

	// I
	return 0 ;
}

// `揀s
extern	void	FASTCALL Graphics_D3D11_DrawPreparation( int ParamFlag )
{
	int AlphaTest ;
	int AlphaChannel ;
	int Specular ;
	int i ;

	// K Graphics_D3D11_DrawPreparation sׂƂtO|
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = FALSE ;

	// ݒ肪ύXꂽǂ̃tO|
	GSYS.ChangeSettingFlag = FALSE ;

	// Cggǂŏ𕪊
	if( ( ParamFlag & DX_D3D11_DRAWPREP_LIGHTING ) != 0 && GSYS.Light.ProcessDisable == FALSE )
	{
		// Cg̐ݒ肪ύXĂύXK
		if( GSYS.Light.HardwareChange )
		{
			Graphics_Light_RefreshState() ;
		}
		else
		{
			// CgLȂ̂ɈꎞIɖɂȂĂLɂ
			if( GD3D11.Device.State.Lighting == 0 )
			{
				Graphics_D3D11_DeviceState_SetLighting( TRUE ) ;
			}
		}

		// }eA̐ݒ肪OύXĂ猳ɖ߂
		if( GSYS.Light.ChangeMaterial )
		{
			GSYS.Light.ChangeMaterial = 0 ;
			Graphics_D3D11_DeviceState_SetMaterial( &GSYS.Light.Material ) ;
		}

		// _J[}eÃJ[ƂĎgp邩ǂZbg
		if( ( GSYS.Light.MaterialNotUseVertexDiffuseColor ? FALSE : TRUE ) != GD3D11.Device.State.MaterialUseVertexDiffuseColor )
		{
			Graphics_D3D11_DeviceState_SetUseVertexDiffuseColor( GSYS.Light.MaterialNotUseVertexDiffuseColor ? FALSE : TRUE ) ;
		}

		if( ( GSYS.Light.MaterialNotUseVertexSpecularColor ? FALSE : TRUE ) != GD3D11.Device.State.MaterialUseVertexSpecularColor )
		{
			Graphics_D3D11_DeviceState_SetUseVertexSpecularColor( GSYS.Light.MaterialNotUseVertexSpecularColor ? FALSE : TRUE ) ;
		}
	}
	else
	{
		// CgLɂȂĂ疳ɂ
		if( GD3D11.Device.State.Lighting == 1 )
		{
			Graphics_D3D11_DeviceState_SetLighting( FALSE ) ;
		}
	}

	// XyLgp邩ǂ̐ݒs
	Specular = ( GSYS.DrawSetting.NotUseSpecular == FALSE && ( ParamFlag & DX_D3D11_DRAWPREP_SPECULAR ) != 0 ) ? TRUE : FALSE ;
	if( Specular != GD3D11.Device.State.UseSpecular )
	{
		Graphics_D3D11_DeviceState_SetSpecularEnable( Specular ) ;
	}

	// ˉes̐ݒs
//	Graphics_DrawSetting_SetUse2DProjectionMatrix( ( ParamFlag & DX_D3D11_DRAWPREP_3D ) == 0 ? TRUE : FALSE ) ;

	// yobt@̐ݒs
	{
		BOOL                    DepthEnable ;
		int                     WriteDepthBuffer ;
		D_D3D11_COMPARISON_FUNC DepthFunc ;
		int						DepthBias ;

		if( ParamFlag & DX_D3D11_DRAWPREP_3D )
		{
			DepthEnable      = GSYS.DrawSetting.EnableZBufferFlag3D ;
			WriteDepthBuffer = GSYS.DrawSetting.WriteZBufferFlag3D ;
			DepthFunc        = ( D_D3D11_COMPARISON_FUNC )GSYS.DrawSetting.ZBufferCmpType3D ;
			DepthBias        = GSYS.DrawSetting.ZBias3D ;
		}
		else
		{
			DepthEnable      = GSYS.DrawSetting.EnableZBufferFlag2D ;
			WriteDepthBuffer = GSYS.DrawSetting.WriteZBufferFlag2D ;
			DepthFunc        = ( D_D3D11_COMPARISON_FUNC )GSYS.DrawSetting.ZBufferCmpType2D ;
			DepthBias        = GSYS.DrawSetting.ZBias2D ;
		}

		if( DepthEnable )
		{
			if( GD3D11.Device.State.DepthStencilDesc.DepthEnable != DepthEnable )
			{
				Graphics_D3D11_DeviceState_SetDepthEnable( DepthEnable ) ;
			}

			if( ( GD3D11.Device.State.DepthStencilDesc.DepthWriteMask == D_D3D11_DEPTH_WRITE_MASK_ALL ? TRUE : FALSE ) != WriteDepthBuffer  )
			{
				Graphics_D3D11_DeviceState_SetDepthWriteEnable( WriteDepthBuffer  ) ;
			}

			if( GD3D11.Device.State.DepthStencilDesc.DepthFunc != DepthFunc )
			{
				Graphics_D3D11_DeviceState_SetDepthFunc( DepthFunc ) ;
			}

			if( GD3D11.Device.State.RasterizerDesc.DepthBias != DepthBias )
			{
				Graphics_D3D11_DeviceState_SetDepthBias( DepthBias ) ;
			}
		}
		else
		{
			if( GD3D11.Device.State.DepthStencilDesc.DepthEnable )
			{
				Graphics_D3D11_DeviceState_SetDepthEnable( FALSE ) ;
			}

			if( GD3D11.Device.State.DepthStencilDesc.DepthWriteMask != D_D3D11_DEPTH_WRITE_MASK_ZERO  )
			{
				Graphics_D3D11_DeviceState_SetDepthWriteEnable( FALSE ) ;
			}
		}
	}

	// tB[h̃Zbg
	if( GD3D11.Device.State.RasterizerDesc.FillMode != ( D_D3D11_FILL_MODE )GSYS.DrawSetting.FillMode )
	{
		Graphics_D3D11_DeviceState_SetFillMode( ( D_D3D11_FILL_MODE )GSYS.DrawSetting.FillMode ) ;
	}

	// tHO̐ݒs
	if( ParamFlag & DX_D3D11_DRAWPREP_FOG )
	{
		if( GD3D11.Device.State.FogEnable != GSYS.DrawSetting.FogEnable )
		{
			Graphics_D3D11_DeviceState_SetFogEnable( GSYS.DrawSetting.FogEnable ) ;
		}
	}
	else
	{
		if( GD3D11.Device.State.FogEnable )
		{
			Graphics_D3D11_DeviceState_SetFogEnable( FALSE ) ;
		}
	}

	// ufBO֌W̃ZbeBOsꍇ̂ݎs
	if( ( ParamFlag & DX_D3D11_DRAWPREP_NOBLENDSETTING ) == 0 )
	{
		// tȌ
		AlphaTest    = FALSE ;
		AlphaChannel = FALSE ;

		// eNX`[gp邩ǂŏ𕪊
		// gpȂꍇ͏l̂܂
		if( ParamFlag & DX_D3D11_DRAWPREP_TEXTURE )
		{
			// ߐFsȂꍇ̓J[L[eXg`lgpȂ̂ŏl̂܂
			// ߐFsꍇ̂ݏ
			if( ParamFlag & DX_D3D11_DRAWPREP_TRANS )
			{
				int TexAlphaTestFlag = ( ParamFlag & DX_D3D11_DRAWPREP_TEXALPHATEST ) != 0 ? 1 : 0 ;
				int TexAlphaChFlag   = ( ParamFlag & DX_D3D11_DRAWPREP_TEXALPHACH   ) != 0 ? 1 : 0 ;

				// eNX`Ƀrbg邩ǂŏ𕪊
				if( TexAlphaTestFlag || TexAlphaChFlag )
				{
					// eXgł_W̃f[^^_^ŁAeNX`tB^O[h
					// `Ԃł邩Auh[h DX_BLENDMODE_NOBLEND ȊO烿`lƂĈ
					if( ( GSYS.DrawSetting.BlendMode != DX_BLENDMODE_NOBLEND && GSYS.DrawSetting.BlendMode != DX_BLENDMODE_DESTCOLOR ) ||
						( ( ParamFlag & DX_D3D11_DRAWPREP_VECTORINT ) == 0   && GSYS.DrawSetting.DrawMode  == DX_DRAWMODE_BILINEAR   ) )
					{
						AlphaChannel = TRUE ;
					}
					else
					{
						// ȊȌꍇ̓eNX`[̃tOɈς˂
						AlphaTest    = TexAlphaTestFlag ;
						AlphaChannel = TexAlphaChFlag ;
					}
				}
			}
		}

		// ꂽp[^Zbg
		if( GD3D11.Device.DrawSetting.IgnoreGraphColorFlag  != GSYS.DrawSetting.IgnoreGraphColorFlag )
		{
			Graphics_D3D11_DrawSetting_SetIgnoreDrawGraphColor( GSYS.DrawSetting.IgnoreGraphColorFlag ) ;
		}

		if( GD3D11.Device.DrawSetting.BlendMode             != GSYS.DrawSetting.BlendMode ||
			GD3D11.Device.DrawSetting.AlphaTestValidFlag    != AlphaTest ||
			GD3D11.Device.DrawSetting.AlphaChannelValidFlag != AlphaChannel               )
		{
			Graphics_D3D11_DrawSetting_SetDrawBlendMode( GSYS.DrawSetting.BlendMode, AlphaTest, AlphaChannel ) ;
		}

		if( GD3D11.Device.DrawSetting.AlphaTestMode         != GSYS.DrawSetting.AlphaTestMode ||
			GD3D11.Device.DrawSetting.AlphaTestParam        != GSYS.DrawSetting.AlphaTestParam )
		{
			Graphics_D3D11_DrawSetting_SetDrawAlphaTest( GSYS.DrawSetting.AlphaTestMode, GSYS.DrawSetting.AlphaTestParam ) ;
		}

		if( GD3D11.Device.DrawSetting.ChangeBlendParamFlag ||
			GD3D11.Device.DrawSetting.ChangeTextureFlag ||
			( GSYS.HardInfo.UseShader &&
			  GD3D11.Device.State.SetNormalPixelShader == FALSE ) )
		{
			Graphics_D3D11_DeviceState_NormalDrawSetup() ;
		}
	}

	if( GD3D11.Device.State.DrawMode != GSYS.DrawSetting.DrawMode )
	{
		Graphics_D3D11_DeviceState_SetDrawMode( GSYS.DrawSetting.DrawMode ) ;
	}

	if( GD3D11.Device.State.MaxAnisotropy != GSYS.DrawSetting.MaxAnisotropy )
	{
		Graphics_D3D11_DeviceState_SetMaxAnisotropy( GSYS.DrawSetting.MaxAnisotropy ) ;
	}

	if( ParamFlag & DX_D3D11_DRAWPREP_CULLING )
	{
		int SetCullMode ;

		switch( GD3D11.Device.State.RasterizerDesc.CullMode )
		{
		case D_D3D11_CULL_NONE :
		default :
			SetCullMode = 0 ;
			break ;

		case D_D3D11_CULL_BACK :
			SetCullMode = 1 ;
			break ;

		case D_D3D11_CULL_FRONT :
			SetCullMode = 2 ;
			break ;
		}

		if( SetCullMode != GSYS.DrawSetting.CullMode )
		{
			Graphics_D3D11_DeviceState_SetCullMode( GSYS.DrawSetting.CullMode ) ;
		}
	}
	else
	{
		if( GD3D11.Device.State.RasterizerDesc.CullMode != D_D3D11_CULL_NONE )
		{
			Graphics_D3D11_DeviceState_SetCullMode( DX_CULLING_NONE ) ;
		}
	}

	if( GSYS.DrawSetting.MatchHardwareTextureAddressTransformMatrix == FALSE )
	{
		Graphics_D3D11_DeviceState_SetTextureAddressTransformMatrix( GSYS.DrawSetting.TextureAddressTransformUse, &GSYS.DrawSetting.TextureAddressTransformMatrix ) ;
		GSYS.DrawSetting.MatchHardwareTextureAddressTransformMatrix = TRUE ;
		GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;
	}

	if( ParamFlag & DX_D3D11_DRAWPREP_TEXADDRESS )
	{
		for( i = 0; i < USE_TEXTURESTAGE_NUM; i++ )
		{
			if( GSYS.DrawSetting.TexAddressModeU[ i ] == GSYS.DrawSetting.TexAddressModeV[ i ] )
			{
				if( GD3D11.Device.State.SamplerDesc[ i ].AddressU != ( D_D3D11_TEXTURE_ADDRESS_MODE )GSYS.DrawSetting.TexAddressModeU[ i ] ||
					GD3D11.Device.State.SamplerDesc[ i ].AddressV != ( D_D3D11_TEXTURE_ADDRESS_MODE )GSYS.DrawSetting.TexAddressModeV[ i ] )
				{
					Graphics_D3D11_DeviceState_SetTextureAddress( GSYS.DrawSetting.TexAddressModeU[ i ], i ) ;
				}
			}
			else
			{
				if( GD3D11.Device.State.SamplerDesc[ i ].AddressU != ( D_D3D11_TEXTURE_ADDRESS_MODE )GSYS.DrawSetting.TexAddressModeU[ i ] )
				{
					Graphics_D3D11_DeviceState_SetTextureAddressU( GSYS.DrawSetting.TexAddressModeU[ i ], i ) ;
				}

				if( GD3D11.Device.State.SamplerDesc[ i ].AddressV != ( D_D3D11_TEXTURE_ADDRESS_MODE )GSYS.DrawSetting.TexAddressModeV[ i ] )
				{
					Graphics_D3D11_DeviceState_SetTextureAddressV( GSYS.DrawSetting.TexAddressModeV[ i ], i ) ;
				}
			}
		}
	}
	else
	{
		for( i = 0; i < 4; i++ )
		{
			if( GD3D11.Device.State.SamplerDesc[ i ].AddressU != D_D3D11_TEXTURE_ADDRESS_CLAMP ||
				GD3D11.Device.State.SamplerDesc[ i ].AddressV != D_D3D11_TEXTURE_ADDRESS_CLAMP )
			{
				Graphics_D3D11_DeviceState_SetTextureAddress( D_D3D11_TEXTURE_ADDRESS_CLAMP, i ) ;
			}
		}
	}

	// p[^ۑ
	GD3D11.Device.DrawSetting.DrawPrepParamFlag = ParamFlag ;
}


// `R}hJn
extern	void	Graphics_D3D11_RenderBegin( void )
{
	if( D3D11Device_IsValid() == 0 || GD3D11.Device.DrawInfo.BeginSceneFlag == TRUE ) return ;

//	D3D11DeviceContext_Begin() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = TRUE ;
	GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag = TRUE ;
}

// `R}hI
extern	void	Graphics_D3D11_RenderEnd( void )
{
	if( D3D11Device_IsValid() == 0 || GD3D11.Device.DrawInfo.BeginSceneFlag == FALSE ) return ;

//	D3D11DeviceContext_End() ;
	GD3D11.Device.DrawInfo.BeginSceneFlag = FALSE ;
}




























// Direct3D11 g`֌W

// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_D3D11_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag, RECT *DrawArea )
{
	VERTEX_2D *DrawVect ;
	VERTEX_2D TempVect[ 6 ] ;
	VERTEX_3D *DrawVect3D ;
	VERTEX_BLENDTEX_2D *DrawVectB ;
	VERTEX_BLENDTEX_2D TempVectB[ 6 ] ;
	IMAGEDATA_HARD_DRAW *DrawTex ;
	IMAGEDATA_HARD_DRAW *BlendDrawTex ;
	IMAGEDATA_ORIG *Orig ;
	IMAGEDATA_HARD_VERT *TexVect ;
	IMAGEDATA_HARD_VERT *BlendTexVect = NULL ;
	DWORD DiffuseColor ;
	int DrawTexNum ;
	int i ;
	int Flag ;
	int BlendGraphNoIncFlag ;
	float SizeX ;
	float SizeY ;
	float f ;
	VECTOR SrcVec[ 4 ] ;
	VECTOR SrcVec2[ 4 ] ;
	float Sin = 0.0f ;
	float Cos = 1.0f ;
	float ScaleX ;
	float ScaleY ;
	float dleft = 0.0f ;
	float dright = 0.0f ;
	float dtop = 0.0f ;
	float dbottom = 0.0f ;

	Orig = Image->Orig ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `揀
	if( DrawFlag )
	{
		Flag = TransFlag | DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG | DX_D3D11_DRAWPREP_TEXADDRESS ;
		DX_D3D11_DRAWPREP_TEX( Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )
	}
	else
	{
		dleft   = -100000000.0f ;
		dright  =  100000000.0f ;
		dtop    = -100000000.0f ;
		dbottom =  100000000.0f ;
	}

	// _f[^擾
	DiffuseColor = GD3D11.Device.DrawInfo.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage != NULL && BlendImage->Hard.DrawNum != Image->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image->Hard.Draw ;
	BlendDrawTex = NULL ;
	if( BlendImage != NULL )
	{
		BlendDrawTex = BlendImage->Hard.Draw ;
	}

	// TCYƍW֌W̎OvZ
	SizeX = Size ;
	SizeY = Size * ( float )Image->Height / ( float )Image->Width ;

	ScaleX = SizeX / Image->Width ;
	ScaleY = SizeY / Image->Height ;
	cx *= Image->Width ;
	cy *= Image->Height ;

	// ]ꍇ͉]l߂Ă
	if( Angle != 0.0 )
	{
		_SINCOS( (float)Angle, &Sin, &Cos ) ;
	}

	// eNX`[̐JԂ
	for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
	{
		// `悷eNX`[̃Zbg
		if( DrawFlag )
		{
			Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;

			if( BlendDrawTex != NULL )
			{
				Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
			}

			if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
			{
				Graphics_D3D11_DeviceState_NormalDrawSetup() ;
			}
		}

		TexVect = DrawTex->Vertex ;
		if( BlendDrawTex != NULL )
		{
			BlendTexVect = BlendDrawTex->Vertex ;
		}

		// uhOtBbNgpĂȂāA`悷ꍇ͍ȏgp
		if( GD3D11.Device.DrawInfo.VertexType != VERTEXTYPE_BLENDTEX && DrawFlag == TRUE )
		{
			GETVERTEX_BILLBOARD( DrawVect3D ) ;

			// ]ꍇƂȂꍇŏ𕪊
			if( Angle != 0.0 )
			{
				// [JW
				SrcVec[2].x = SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
				SrcVec[3].x = SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

				SrcVec[1].y = SrcVec[0].y = ( -cy + Image->Height - TexVect[0].y ) * ScaleY ;
				SrcVec[3].y = SrcVec[2].y = ( -cy + Image->Height - TexVect[2].y ) * ScaleY ;

				// ]vZ
				f             = SrcVec[ 0 ].x * Cos - SrcVec[ 0 ].y * Sin ;	
				SrcVec[ 0 ].y = SrcVec[ 0 ].x * Sin + SrcVec[ 0 ].y * Cos ;
				SrcVec[ 0 ].x = f ;

				f             = SrcVec[ 1 ].x * Cos - SrcVec[ 1 ].y * Sin ;	
				SrcVec[ 1 ].y = SrcVec[ 1 ].x * Sin + SrcVec[ 1 ].y * Cos ;
				SrcVec[ 1 ].x = f ;

				f             = SrcVec[ 2 ].x * Cos - SrcVec[ 2 ].y * Sin ;	
				SrcVec[ 2 ].y = SrcVec[ 2 ].x * Sin + SrcVec[ 2 ].y * Cos ;
				SrcVec[ 2 ].x = f ;

				f             = SrcVec[ 3 ].x * Cos - SrcVec[ 3 ].y * Sin ;	
				SrcVec[ 3 ].y = SrcVec[ 3 ].x * Sin + SrcVec[ 3 ].y * Cos ;
				SrcVec[ 3 ].x = f ;

				// r{[hW[hW֕ϊ
				DrawVect3D[ 0 ].pos.x = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				DrawVect3D[ 0 ].pos.y = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				DrawVect3D[ 0 ].pos.z = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

				DrawVect3D[ 1 ].pos.x = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				DrawVect3D[ 1 ].pos.y = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				DrawVect3D[ 1 ].pos.z = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

				DrawVect3D[ 2 ].pos.x = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				DrawVect3D[ 2 ].pos.y = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				DrawVect3D[ 2 ].pos.z = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

				DrawVect3D[ 3 ].pos.x = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				DrawVect3D[ 3 ].pos.y = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				DrawVect3D[ 3 ].pos.z = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;
			}
			else
			{
				VECTOR TempVecX[ 2 ], TempVecY[ 2 ] ;

				// [JW
				SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
				SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

				SrcVec[0].y = ( -cy + Image->Height - TexVect[0].y ) * ScaleY ;
				SrcVec[2].y = ( -cy + Image->Height - TexVect[2].y ) * ScaleY ;

				// r{[hW[hW֕ϊ
				TempVecX[ 0 ].x = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + Pos.x ;
				TempVecX[ 0 ].y = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + Pos.y ;
				TempVecX[ 0 ].z = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + Pos.z ;

				TempVecX[ 1 ].x = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + Pos.x ;
				TempVecX[ 1 ].y = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + Pos.y ;
				TempVecX[ 1 ].z = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + Pos.z ;

				TempVecY[ 0 ].x = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] ;
				TempVecY[ 0 ].y = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] ;
				TempVecY[ 0 ].z = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] ;

				TempVecY[ 1 ].x = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] ;
				TempVecY[ 1 ].y = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] ;
				TempVecY[ 1 ].z = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] ;

				DrawVect3D[ 0 ].pos.x = TempVecX[ 0 ].x + TempVecY[ 0 ].x ;
				DrawVect3D[ 0 ].pos.y = TempVecX[ 0 ].y + TempVecY[ 0 ].y ;
				DrawVect3D[ 0 ].pos.z = TempVecX[ 0 ].z + TempVecY[ 0 ].z ;

				DrawVect3D[ 1 ].pos.x = TempVecX[ 1 ].x + TempVecY[ 0 ].x ;
				DrawVect3D[ 1 ].pos.y = TempVecX[ 1 ].y + TempVecY[ 0 ].y ;
				DrawVect3D[ 1 ].pos.z = TempVecX[ 1 ].z + TempVecY[ 0 ].z ;

				DrawVect3D[ 2 ].pos.x = TempVecX[ 0 ].x + TempVecY[ 1 ].x ;
				DrawVect3D[ 2 ].pos.y = TempVecX[ 0 ].y + TempVecY[ 1 ].y ;
				DrawVect3D[ 2 ].pos.z = TempVecX[ 0 ].z + TempVecY[ 1 ].z ;

				DrawVect3D[ 3 ].pos.x = TempVecX[ 1 ].x + TempVecY[ 1 ].x ;
				DrawVect3D[ 3 ].pos.y = TempVecX[ 1 ].y + TempVecY[ 1 ].y ;
				DrawVect3D[ 3 ].pos.z = TempVecX[ 1 ].z + TempVecY[ 1 ].z ;
			}

			DrawVect3D[4].pos = DrawVect3D[2].pos ;
			DrawVect3D[5].pos = DrawVect3D[1].pos ;

			*( ( DWORD * )&DrawVect3D[0].b ) = 
			*( ( DWORD * )&DrawVect3D[1].b ) = 
			*( ( DWORD * )&DrawVect3D[2].b ) = 
			*( ( DWORD * )&DrawVect3D[3].b ) = 
			*( ( DWORD * )&DrawVect3D[4].b ) = 
			*( ( DWORD * )&DrawVect3D[5].b ) = DiffuseColor ;

			if( TurnFlag )
			{
				DrawVect3D[5].u = DrawVect3D[3].u = DrawVect3D[1].u = TexVect[0].u ;
				DrawVect3D[4].u = DrawVect3D[2].u = DrawVect3D[0].u = TexVect[1].u ;
			}
			else
			{
				DrawVect3D[4].u = DrawVect3D[2].u = DrawVect3D[0].u = TexVect[0].u ;
				DrawVect3D[5].u = DrawVect3D[3].u = DrawVect3D[1].u = TexVect[1].u ;
			}
			DrawVect3D[5].v = DrawVect3D[1].v = DrawVect3D[0].v = TexVect[0].v ;
			DrawVect3D[4].v = DrawVect3D[3].v = DrawVect3D[2].v = TexVect[2].v ;

			// eNX`[`悷
			ADD4VERTEX_BILLBOARD
		}
		else
		{
			// r{[ĥS_𓾂
			{
				// ]ꍇƂȂꍇŏ𕪊
				if( Angle != 0.0 )
				{
					// [JW
					SrcVec[2].x = SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
					SrcVec[3].x = SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

					SrcVec[1].y = SrcVec[0].y = ( -cy + Image->Height - TexVect[0].y ) * ScaleY ;
					SrcVec[3].y = SrcVec[2].y = ( -cy + Image->Height - TexVect[2].y ) * ScaleY ;

					// ]vZ
					f             = SrcVec[ 0 ].x * Cos - SrcVec[ 0 ].y * Sin ;	
					SrcVec[ 0 ].y = SrcVec[ 0 ].x * Sin + SrcVec[ 0 ].y * Cos ;
					SrcVec[ 0 ].x = f ;

					f             = SrcVec[ 1 ].x * Cos - SrcVec[ 1 ].y * Sin ;	
					SrcVec[ 1 ].y = SrcVec[ 1 ].x * Sin + SrcVec[ 1 ].y * Cos ;
					SrcVec[ 1 ].x = f ;

					f             = SrcVec[ 2 ].x * Cos - SrcVec[ 2 ].y * Sin ;	
					SrcVec[ 2 ].y = SrcVec[ 2 ].x * Sin + SrcVec[ 2 ].y * Cos ;
					SrcVec[ 2 ].x = f ;

					f             = SrcVec[ 3 ].x * Cos - SrcVec[ 3 ].y * Sin ;	
					SrcVec[ 3 ].y = SrcVec[ 3 ].x * Sin + SrcVec[ 3 ].y * Cos ;
					SrcVec[ 3 ].x = f ;

					// r{[hW[hW֕ϊ
					SrcVec2[ 0 ].x = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
					SrcVec2[ 0 ].y = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
					SrcVec2[ 0 ].z = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

					SrcVec2[ 1 ].x = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
					SrcVec2[ 1 ].y = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
					SrcVec2[ 1 ].z = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 1 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

					SrcVec2[ 2 ].x = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
					SrcVec2[ 2 ].y = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
					SrcVec2[ 2 ].z = SrcVec[ 2 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

					SrcVec2[ 3 ].x = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
					SrcVec2[ 3 ].y = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
					SrcVec2[ 3 ].z = SrcVec[ 3 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + SrcVec[ 3 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;
				}
				else
				{
					VECTOR TempVecX[ 2 ], TempVecY[ 2 ] ;

					// [JW
					SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
					SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

					SrcVec[0].y = ( -cy + Image->Height - TexVect[0].y ) * ScaleY ;
					SrcVec[2].y = ( -cy + Image->Height - TexVect[2].y ) * ScaleY ;

					// r{[hW[hW֕ϊ
					TempVecX[ 0 ].x = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + Pos.x ;
					TempVecX[ 0 ].y = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + Pos.y ;
					TempVecX[ 0 ].z = SrcVec[ 0 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + Pos.z ;

					TempVecX[ 1 ].x = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + Pos.x ;
					TempVecX[ 1 ].y = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + Pos.y ;
					TempVecX[ 1 ].z = SrcVec[ 1 ].x * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + Pos.z ;

					TempVecY[ 0 ].x = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] ;
					TempVecY[ 0 ].y = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] ;
					TempVecY[ 0 ].z = SrcVec[ 0 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] ;

					TempVecY[ 1 ].x = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][0] ;
					TempVecY[ 1 ].y = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][1] ;
					TempVecY[ 1 ].z = SrcVec[ 2 ].y * GSYS.DrawSetting.BillboardMatrixF.m[1][2] ;

					SrcVec2[ 0 ].x = TempVecX[ 0 ].x + TempVecY[ 0 ].x ;
					SrcVec2[ 0 ].y = TempVecX[ 0 ].y + TempVecY[ 0 ].y ;
					SrcVec2[ 0 ].z = TempVecX[ 0 ].z + TempVecY[ 0 ].z ;

					SrcVec2[ 1 ].x = TempVecX[ 1 ].x + TempVecY[ 0 ].x ;
					SrcVec2[ 1 ].y = TempVecX[ 1 ].y + TempVecY[ 0 ].y ;
					SrcVec2[ 1 ].z = TempVecX[ 1 ].z + TempVecY[ 0 ].z ;

					SrcVec2[ 2 ].x = TempVecX[ 0 ].x + TempVecY[ 1 ].x ;
					SrcVec2[ 2 ].y = TempVecX[ 0 ].y + TempVecY[ 1 ].y ;
					SrcVec2[ 2 ].z = TempVecX[ 0 ].z + TempVecY[ 1 ].z ;

					SrcVec2[ 3 ].x = TempVecX[ 1 ].x + TempVecY[ 1 ].x ;
					SrcVec2[ 3 ].y = TempVecX[ 1 ].y + TempVecY[ 1 ].y ;
					SrcVec2[ 3 ].z = TempVecX[ 1 ].z + TempVecY[ 1 ].z ;
				}
			}

			// _^Cvɂď𕪊
			switch( GD3D11.Device.DrawInfo.VertexType )
			{
			case VERTEXTYPE_BLENDTEX :
				// uheNX`gp

				// _obt@̎擾
				if( DrawFlag )
				{
					GETVERTEX_QUAD( DrawVectB )
				}
				else
				{
					DrawVectB = TempVectB ;
				}

				// XN[Wɕϊ
				DrawVectB[0].pos.x = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
				DrawVectB[0].pos.y = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
				DrawVectB[0].pos.z = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
				DrawVectB[0].rhw   = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

				DrawVectB[3].rhw = 
				DrawVectB[2].rhw = 
				DrawVectB[1].rhw = 
				DrawVectB[0].rhw = 1.0F / DrawVectB[0].rhw ;
				DrawVectB[0].pos.x *= DrawVectB[0].rhw ;
				DrawVectB[0].pos.y *= DrawVectB[0].rhw ;
				DrawVectB[3].pos.z =
				DrawVectB[2].pos.z =
				DrawVectB[1].pos.z =
				DrawVectB[0].pos.z *= DrawVectB[0].rhw ;

				DrawVectB[1].pos.x = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[1].pos.y = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.x = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.y = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.x = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.y = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVectB[0].rhw ;

				DrawVectB[4].pos = DrawVectB[2].pos ;
				DrawVectB[5].pos = DrawVectB[1].pos ;
				DrawVectB[4].rhw = DrawVectB[2].rhw ;
				DrawVectB[5].rhw = DrawVectB[1].rhw ;

				DrawVectB[0].color	= 
				DrawVectB[1].color	= 
				DrawVectB[2].color	= 
				DrawVectB[3].color	= 
				DrawVectB[4].color	= 
				DrawVectB[5].color	= DiffuseColor ;

				if( TurnFlag )
				{
					DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
					DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				}
				else
				{
					DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
					DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				}
				DrawVectB[4].u2 = DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[5].u2 = DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;

				DrawVectB[5].v1 = DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				DrawVectB[4].v1 = DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				DrawVectB[5].v2 = DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[4].v2 = DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_BLENDTEX
				}
				else
				{
					if( dright  > DrawVectB[ 0 ].pos.x ) dright  = DrawVectB[ 0 ].pos.x ;
					if( dright  > DrawVectB[ 1 ].pos.x ) dright  = DrawVectB[ 1 ].pos.x ;
					if( dright  > DrawVectB[ 2 ].pos.x ) dright  = DrawVectB[ 2 ].pos.x ;
					if( dright  > DrawVectB[ 3 ].pos.x ) dright  = DrawVectB[ 3 ].pos.x ;

					if( dleft   < DrawVectB[ 0 ].pos.x ) dleft   = DrawVectB[ 0 ].pos.x ;
					if( dleft   < DrawVectB[ 1 ].pos.x ) dleft   = DrawVectB[ 1 ].pos.x ;
					if( dleft   < DrawVectB[ 2 ].pos.x ) dleft   = DrawVectB[ 2 ].pos.x ;
					if( dleft   < DrawVectB[ 3 ].pos.x ) dleft   = DrawVectB[ 3 ].pos.x ;

					if( dbottom > DrawVectB[ 0 ].pos.y ) dbottom = DrawVectB[ 0 ].pos.y ;
					if( dbottom > DrawVectB[ 1 ].pos.y ) dbottom = DrawVectB[ 1 ].pos.y ;
					if( dbottom > DrawVectB[ 2 ].pos.y ) dbottom = DrawVectB[ 2 ].pos.y ;
					if( dbottom > DrawVectB[ 3 ].pos.y ) dbottom = DrawVectB[ 3 ].pos.y ;

					if( dtop    < DrawVectB[ 0 ].pos.y ) dtop    = DrawVectB[ 0 ].pos.y ;
					if( dtop    < DrawVectB[ 1 ].pos.y ) dtop    = DrawVectB[ 1 ].pos.y ;
					if( dtop    < DrawVectB[ 2 ].pos.y ) dtop    = DrawVectB[ 2 ].pos.y ;
					if( dtop    < DrawVectB[ 3 ].pos.y ) dtop    = DrawVectB[ 3 ].pos.y ;
				}

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
				break ;

			case VERTEXTYPE_TEX :
				// uheNX`gpȂ

				// _obt@̎擾
				if( DrawFlag )
				{
					GETVERTEX_QUAD( DrawVect )
				}
				else
				{
					DrawVect = TempVect;
				}

				// XN[Wɕϊ
				DrawVect[0].pos.x = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
				DrawVect[0].pos.y = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
				DrawVect[0].pos.z = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
				DrawVect[0].rhw   = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

				DrawVect[3].rhw = 
				DrawVect[2].rhw = 
				DrawVect[1].rhw = 
				DrawVect[0].rhw = 1.0F / DrawVect[0].rhw ;
				DrawVect[0].pos.x *= DrawVect[0].rhw ;
				DrawVect[0].pos.y *= DrawVect[0].rhw ;
				DrawVect[3].pos.z =
				DrawVect[2].pos.z =
				DrawVect[1].pos.z =
				DrawVect[0].pos.z *= DrawVect[0].rhw ;

				DrawVect[1].pos.x = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[1].pos.y = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.x = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.y = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.x = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.y = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVect[0].rhw ;

				DrawVect[4].pos = DrawVect[2].pos ;
				DrawVect[5].pos = DrawVect[1].pos ;
				DrawVect[4].rhw = DrawVect[2].rhw ;
				DrawVect[5].rhw = DrawVect[1].rhw ;

				DrawVect[0].color	= 
				DrawVect[1].color	= 
				DrawVect[2].color	= 
				DrawVect[3].color	= 
				DrawVect[4].color	= 
				DrawVect[5].color	= DiffuseColor ;

				if( TurnFlag )
				{
					DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[0].u ;
					DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[1].u ;
				}
				else
				{
					DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
					DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				}
				DrawVect[5].v       = DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[4].v       = DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_TEX
				}
				else
				{
					if( dright  > DrawVect[ 0 ].pos.x ) dright  = DrawVect[ 0 ].pos.x ;
					if( dright  > DrawVect[ 1 ].pos.x ) dright  = DrawVect[ 1 ].pos.x ;
					if( dright  > DrawVect[ 2 ].pos.x ) dright  = DrawVect[ 2 ].pos.x ;
					if( dright  > DrawVect[ 3 ].pos.x ) dright  = DrawVect[ 3 ].pos.x ;

					if( dleft   < DrawVect[ 0 ].pos.x ) dleft   = DrawVect[ 0 ].pos.x ;
					if( dleft   < DrawVect[ 1 ].pos.x ) dleft   = DrawVect[ 1 ].pos.x ;
					if( dleft   < DrawVect[ 2 ].pos.x ) dleft   = DrawVect[ 2 ].pos.x ;
					if( dleft   < DrawVect[ 3 ].pos.x ) dleft   = DrawVect[ 3 ].pos.x ;

					if( dbottom > DrawVect[ 0 ].pos.y ) dbottom = DrawVect[ 0 ].pos.y ;
					if( dbottom > DrawVect[ 1 ].pos.y ) dbottom = DrawVect[ 1 ].pos.y ;
					if( dbottom > DrawVect[ 2 ].pos.y ) dbottom = DrawVect[ 2 ].pos.y ;
					if( dbottom > DrawVect[ 3 ].pos.y ) dbottom = DrawVect[ 3 ].pos.y ;

					if( dtop    < DrawVect[ 0 ].pos.y ) dtop    = DrawVect[ 0 ].pos.y ;
					if( dtop    < DrawVect[ 1 ].pos.y ) dtop    = DrawVect[ 1 ].pos.y ;
					if( dtop    < DrawVect[ 2 ].pos.y ) dtop    = DrawVect[ 2 ].pos.y ;
					if( dtop    < DrawVect[ 3 ].pos.y ) dtop    = DrawVect[ 3 ].pos.y ;
				}
				break ;
			}
		}
	}

	if( DrawFlag == FALSE )
	{
		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_D3D11_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int DrawFlag, RECT *DrawArea )
{
	VERTEX_2D *DrawVect ;
	VERTEX_3D *DrawVect3D ;
	VERTEX_BLENDTEX_2D *DrawVectB ;
	IMAGEDATA_HARD_DRAW *DrawTex ;
	IMAGEDATA_HARD_DRAW *BlendDrawTex ;
	IMAGEDATA_ORIG *Orig ;
	IMAGEDATA_HARD_VERT *TexVect ;
	IMAGEDATA_HARD_VERT *BlendTexVect = NULL ;
	DWORD DiffuseColor ;
	int DrawTexNum ;
	int i, Flag ;
	int BlendGraphNoIncFlag ;
	VECTOR SrcVec2[ 4 ] ;
	float dleft = 0.0f, dright = 0.0f, dtop = 0.0f, dbottom = 0.0f;

	Orig = Image->Orig ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	// `揀
	if( DrawFlag )
	{
		Flag = TransFlag | DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG | DX_D3D11_DRAWPREP_TEXADDRESS ;
		DX_D3D11_DRAWPREP_TEX( Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )
	}
	else
	{
		dleft   = -100000000.0f ;
		dright  =  100000000.0f ;
		dtop    = -100000000.0f ;
		dbottom =  100000000.0f ;
	}

	// _f[^擾
	DiffuseColor = GD3D11.Device.DrawInfo.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage != NULL && BlendImage->Hard.DrawNum != Image->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image->Hard.Draw ;
	BlendDrawTex = NULL ;
	if( BlendImage != NULL )
	{
		BlendDrawTex = BlendImage->Hard.Draw ;
	}

	// eNX`[̐JԂ
	for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
	{
		// `悷eNX`[̃Zbg
		if( DrawFlag )
		{
			Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;

			if( BlendDrawTex != NULL )
			{
				Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
			}

			if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
			{
				Graphics_D3D11_DeviceState_NormalDrawSetup() ;
			}
		}

		TexVect = DrawTex->Vertex ;
		if( BlendDrawTex != NULL )
		{
			BlendTexVect = BlendDrawTex->Vertex ;
		}

		// uhOtBbNgpĂȂāA`悷ꍇ͍ȏgp
		if( GD3D11.Device.DrawInfo.VertexType != VERTEXTYPE_BLENDTEX && DrawFlag == TRUE )
		{
			GETVERTEX_BILLBOARD( DrawVect3D ) ;

			// r{[hW[hW֕ϊ
			DrawVect3D[ 0 ].pos.x = x1 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y1 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
			DrawVect3D[ 0 ].pos.y = x1 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y1 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
			DrawVect3D[ 0 ].pos.z = x1 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y1 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

			DrawVect3D[ 1 ].pos.x = x2 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y2 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
			DrawVect3D[ 1 ].pos.y = x2 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y2 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
			DrawVect3D[ 1 ].pos.z = x2 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y2 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

			DrawVect3D[ 2 ].pos.x = x4 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y4 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
			DrawVect3D[ 2 ].pos.y = x4 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y4 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
			DrawVect3D[ 2 ].pos.z = x4 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y4 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

			DrawVect3D[ 3 ].pos.x = x3 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y3 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
			DrawVect3D[ 3 ].pos.y = x3 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y3 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
			DrawVect3D[ 3 ].pos.z = x3 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y3 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

			DrawVect3D[4].pos = DrawVect3D[2].pos ;
			DrawVect3D[5].pos = DrawVect3D[1].pos ;

			*( ( DWORD * )&DrawVect3D[0].b ) = 
			*( ( DWORD * )&DrawVect3D[1].b ) = 
			*( ( DWORD * )&DrawVect3D[2].b ) = 
			*( ( DWORD * )&DrawVect3D[3].b ) = 
			*( ( DWORD * )&DrawVect3D[4].b ) = 
			*( ( DWORD * )&DrawVect3D[5].b ) = DiffuseColor ;

			DrawVect3D[4].u       = DrawVect3D[2].u       = DrawVect3D[0].u       = TexVect[0].u ;
			DrawVect3D[5].u       = DrawVect3D[3].u       = DrawVect3D[1].u       = TexVect[1].u ;
			DrawVect3D[5].v       = DrawVect3D[1].v       = DrawVect3D[0].v       = TexVect[0].v ;
			DrawVect3D[4].v       = DrawVect3D[3].v       = DrawVect3D[2].v       = TexVect[2].v ;

			// eNX`[`悷
			ADD4VERTEX_BILLBOARD
		}
		else
		{
			// r{[ĥS_𓾂
			{
				// r{[hW[hW֕ϊ
				SrcVec2[ 0 ].x = x1 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y1 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				SrcVec2[ 0 ].y = x1 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y1 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				SrcVec2[ 0 ].z = x1 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y1 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

				SrcVec2[ 1 ].x = x2 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y2 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				SrcVec2[ 1 ].y = x2 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y2 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				SrcVec2[ 1 ].z = x2 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y2 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

				SrcVec2[ 2 ].x = x4 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y4 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				SrcVec2[ 2 ].y = x4 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y4 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				SrcVec2[ 2 ].z = x4 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y4 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;

				SrcVec2[ 3 ].x = x3 * GSYS.DrawSetting.BillboardMatrixF.m[0][0] + y3 * GSYS.DrawSetting.BillboardMatrixF.m[1][0] + Pos.x ;
				SrcVec2[ 3 ].y = x3 * GSYS.DrawSetting.BillboardMatrixF.m[0][1] + y3 * GSYS.DrawSetting.BillboardMatrixF.m[1][1] + Pos.y ;
				SrcVec2[ 3 ].z = x3 * GSYS.DrawSetting.BillboardMatrixF.m[0][2] + y3 * GSYS.DrawSetting.BillboardMatrixF.m[1][2] + Pos.z ;
			}

			// _^Cvɂď𕪊
			switch( GD3D11.Device.DrawInfo.VertexType )
			{
			case VERTEXTYPE_BLENDTEX :
				// uheNX`gp

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVectB )

				// XN[Wɕϊ
				DrawVectB[0].pos.x = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
				DrawVectB[0].pos.y = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
				DrawVectB[0].pos.z = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
				DrawVectB[0].rhw   = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

				DrawVectB[3].rhw = 
				DrawVectB[2].rhw = 
				DrawVectB[1].rhw = 
				DrawVectB[0].rhw = 1.0F / DrawVectB[0].rhw ;
				DrawVectB[0].pos.x *= DrawVectB[0].rhw ;
				DrawVectB[0].pos.y *= DrawVectB[0].rhw ;
				DrawVectB[3].pos.z =
				DrawVectB[2].pos.z =
				DrawVectB[1].pos.z =
				DrawVectB[0].pos.z *= DrawVectB[0].rhw ;

				DrawVectB[1].pos.x = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[1].pos.y = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.x = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.y = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.x = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.y = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVectB[0].rhw ;

				DrawVectB[4].pos = DrawVectB[2].pos ;
				DrawVectB[5].pos = DrawVectB[1].pos ;
				DrawVectB[4].rhw = DrawVectB[2].rhw ;
				DrawVectB[5].rhw = DrawVectB[1].rhw ;

				DrawVectB[0].color	= 
				DrawVectB[1].color	= 
				DrawVectB[2].color	= 
				DrawVectB[3].color	= 
				DrawVectB[4].color	= 
				DrawVectB[5].color	= DiffuseColor ;

				DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				DrawVectB[5].v1 = DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				DrawVectB[4].v1 = DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				DrawVectB[4].u2 = DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[5].u2 = DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;
				DrawVectB[5].v2 = DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[4].v2 = DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_BLENDTEX
				}
				else
				{
					if( dright  > DrawVectB[ 0 ].pos.x ) dright  = DrawVectB[ 0 ].pos.x ;
					if( dright  > DrawVectB[ 1 ].pos.x ) dright  = DrawVectB[ 1 ].pos.x ;
					if( dright  > DrawVectB[ 2 ].pos.x ) dright  = DrawVectB[ 2 ].pos.x ;
					if( dright  > DrawVectB[ 3 ].pos.x ) dright  = DrawVectB[ 3 ].pos.x ;

					if( dleft   < DrawVectB[ 0 ].pos.x ) dleft   = DrawVectB[ 0 ].pos.x ;
					if( dleft   < DrawVectB[ 1 ].pos.x ) dleft   = DrawVectB[ 1 ].pos.x ;
					if( dleft   < DrawVectB[ 2 ].pos.x ) dleft   = DrawVectB[ 2 ].pos.x ;
					if( dleft   < DrawVectB[ 3 ].pos.x ) dleft   = DrawVectB[ 3 ].pos.x ;

					if( dbottom > DrawVectB[ 0 ].pos.y ) dbottom = DrawVectB[ 0 ].pos.y ;
					if( dbottom > DrawVectB[ 1 ].pos.y ) dbottom = DrawVectB[ 1 ].pos.y ;
					if( dbottom > DrawVectB[ 2 ].pos.y ) dbottom = DrawVectB[ 2 ].pos.y ;
					if( dbottom > DrawVectB[ 3 ].pos.y ) dbottom = DrawVectB[ 3 ].pos.y ;

					if( dtop    < DrawVectB[ 0 ].pos.y ) dtop    = DrawVectB[ 0 ].pos.y ;
					if( dtop    < DrawVectB[ 1 ].pos.y ) dtop    = DrawVectB[ 1 ].pos.y ;
					if( dtop    < DrawVectB[ 2 ].pos.y ) dtop    = DrawVectB[ 2 ].pos.y ;
					if( dtop    < DrawVectB[ 3 ].pos.y ) dtop    = DrawVectB[ 3 ].pos.y ;
				}

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
				break ;

			case VERTEXTYPE_TEX :
				// uheNX`gpȂ

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVect )

				// XN[Wɕϊ
				DrawVect[0].pos.x = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
				DrawVect[0].pos.y = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
				DrawVect[0].pos.z = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
				DrawVect[0].rhw   = SrcVec2[0].x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + SrcVec2[0].y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + SrcVec2[0].z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

				DrawVect[3].rhw = 
				DrawVect[2].rhw = 
				DrawVect[1].rhw = 
				DrawVect[0].rhw = 1.0F / DrawVect[0].rhw ;
				DrawVect[0].pos.x *= DrawVect[0].rhw ;
				DrawVect[0].pos.y *= DrawVect[0].rhw ;
				DrawVect[3].pos.z =
				DrawVect[2].pos.z =
				DrawVect[1].pos.z =
				DrawVect[0].pos.z *= DrawVect[0].rhw ;

				DrawVect[1].pos.x = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[1].pos.y = ( SrcVec2[1].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[1].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[1].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.x = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.y = ( SrcVec2[2].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[2].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[2].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.x = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.y = ( SrcVec2[3].x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + SrcVec2[3].y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + SrcVec2[3].z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1] ) * DrawVect[0].rhw ;

				DrawVect[4].pos = DrawVect[2].pos ;
				DrawVect[5].pos = DrawVect[1].pos ;
				DrawVect[4].rhw = DrawVect[2].rhw ;
				DrawVect[5].rhw = DrawVect[1].rhw ;

				DrawVect[0].color	= 
				DrawVect[1].color	= 
				DrawVect[2].color	= 
				DrawVect[3].color	= 
				DrawVect[4].color	= 
				DrawVect[5].color	= DiffuseColor ;

				DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
				DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				DrawVect[5].v       = DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[4].v       = DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_TEX
				}
				else
				{
					if( dright  > DrawVect[ 0 ].pos.x ) dright  = DrawVect[ 0 ].pos.x ;
					if( dright  > DrawVect[ 1 ].pos.x ) dright  = DrawVect[ 1 ].pos.x ;
					if( dright  > DrawVect[ 2 ].pos.x ) dright  = DrawVect[ 2 ].pos.x ;
					if( dright  > DrawVect[ 3 ].pos.x ) dright  = DrawVect[ 3 ].pos.x ;

					if( dleft   < DrawVect[ 0 ].pos.x ) dleft   = DrawVect[ 0 ].pos.x ;
					if( dleft   < DrawVect[ 1 ].pos.x ) dleft   = DrawVect[ 1 ].pos.x ;
					if( dleft   < DrawVect[ 2 ].pos.x ) dleft   = DrawVect[ 2 ].pos.x ;
					if( dleft   < DrawVect[ 3 ].pos.x ) dleft   = DrawVect[ 3 ].pos.x ;

					if( dbottom > DrawVect[ 0 ].pos.y ) dbottom = DrawVect[ 0 ].pos.y ;
					if( dbottom > DrawVect[ 1 ].pos.y ) dbottom = DrawVect[ 1 ].pos.y ;
					if( dbottom > DrawVect[ 2 ].pos.y ) dbottom = DrawVect[ 2 ].pos.y ;
					if( dbottom > DrawVect[ 3 ].pos.y ) dbottom = DrawVect[ 3 ].pos.y ;

					if( dtop    < DrawVect[ 0 ].pos.y ) dtop    = DrawVect[ 0 ].pos.y ;
					if( dtop    < DrawVect[ 1 ].pos.y ) dtop    = DrawVect[ 1 ].pos.y ;
					if( dtop    < DrawVect[ 2 ].pos.y ) dtop    = DrawVect[ 2 ].pos.y ;
					if( dtop    < DrawVect[ 3 ].pos.y ) dtop    = DrawVect[ 3 ].pos.y ;
				}
				break ;
			}
		}
	}

	if( DrawFlag == FALSE )
	{
		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_D3D11_DrawGraph( int x, int y, float xf, float yf, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	VERTEX_2D			*DrawVect ;
	VERTEX_2D			*Vect ;
	VERTEX_BLENDTEX_2D	*DrawVectB ;
	VERTEX_BLENDTEX_2D	*VectB ;
	IMAGEDATA_HARD_DRAW	*DrawTex ;
	IMAGEDATA_HARD_DRAW	*BlendDrawTex = NULL ;
	IMAGEDATA_ORIG		*Orig ;
	IMAGEDATA_HARD_VERT	*TexVect ;
	IMAGEDATA_HARD_VERT	*BlendTexVect ;
	DWORD				DiffuseColor ;
	int					DrawTexNum ;
	int					i ;
	int					j ;
	int					Flag ;
	int					BlendGraphNoIncFlag ;
	float				left ;
	float				right ;
	float				top ;
	float				bottom ;
	float				Vx ;
	float				Vy ;
	float				VBx ;
	float				VBy ;
	DWORD				drawz;

	Orig = Image->Orig ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// floatW␳
//	xf -= 0.5F ;
//	yf -= 0.5F ;

	// `揀
	Flag = TransFlag | ( IntFlag << 1 ) ;
	DX_D3D11_DRAWPREP_TEX( Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )

	// _f[^擾
	DiffuseColor = GD3D11.Device.DrawInfo.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage != NULL && BlendImage->Hard.DrawNum != Image->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image->Hard.Draw ;
	if( BlendImage != NULL )
	{
		BlendDrawTex = BlendImage->Hard.Draw ;
	}

	// yobt@ɏނylZbg
	drawz = *( ( DWORD * )&GSYS.DrawSetting.DrawZ ) ;

	// `͈͂͂ݏoĂ邩ǂŏ𕪊
	if( IN_DRAWAREA_CHECK( x, y, x + Image->Width, y + Image->Height ) )
//	if( x + Image->Width  < GSYS.DrawSetting.DrawArea.right  && x > GSYS.DrawSetting.DrawArea.left &&
//		y + Image->Height < GSYS.DrawSetting.DrawArea.bottom && y > GSYS.DrawSetting.DrawArea.right )
	{
		// ͂ݏoĂȂꍇ

		// _^Cvɂď𕪊
		if( GD3D11.Device.DrawInfo.VertexType == VERTEXTYPE_BLENDTEX )
		{
			// uheNX`gp

			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );

				if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
				{
					Graphics_D3D11_DeviceState_NormalDrawSetup() ;
				}

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVectB )
				
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				DrawVectB[0].color = 
				DrawVectB[1].color = 
				DrawVectB[2].color = 
				DrawVectB[3].color = 
				DrawVectB[4].color = 
				DrawVectB[5].color = ( DWORD )DiffuseColor ;

				DrawVectB[4].pos.x = DrawVectB[2].pos.x = DrawVectB[0].pos.x = xf + TexVect[0].x ;
				DrawVectB[5].pos.x = DrawVectB[3].pos.x = DrawVectB[1].pos.x = xf + TexVect[1].x ;
				DrawVectB[5].pos.y = DrawVectB[1].pos.y = DrawVectB[0].pos.y = yf + TexVect[0].y ;
				DrawVectB[4].pos.y = DrawVectB[3].pos.y = DrawVectB[2].pos.y = yf + TexVect[2].y ;

				DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				DrawVectB[5].v1 = DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				DrawVectB[4].v1 = DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				DrawVectB[4].u2 = DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[5].u2 = DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;
				DrawVectB[5].v2 = DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[4].v2 = DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				*((DWORD *)&DrawVectB[0].pos.z) =
				*((DWORD *)&DrawVectB[1].pos.z) =
				*((DWORD *)&DrawVectB[2].pos.z) =
				*((DWORD *)&DrawVectB[3].pos.z) =
				*((DWORD *)&DrawVectB[4].pos.z) =
				*((DWORD *)&DrawVectB[5].pos.z) = drawz ;

				DrawVectB[0].rhw =
				DrawVectB[1].rhw =
				DrawVectB[2].rhw =
				DrawVectB[3].rhw =
				DrawVectB[4].rhw =
				DrawVectB[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
		}
		else
		{
			// uheNX`gpȂ

			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _obt@̎擾
				GETVERTEX_QUAD( DrawVect )

				// _f[^
				TexVect = DrawTex->Vertex ;
				DrawVect[0].color	= 
				DrawVect[1].color	= 
				DrawVect[2].color	= 
				DrawVect[3].color	= 
				DrawVect[4].color	= 
				DrawVect[5].color	= DiffuseColor ;

				DrawVect[4].pos.x   = DrawVect[2].pos.x   = DrawVect[0].pos.x   = TexVect[0].x + xf ;
				DrawVect[5].pos.x   = DrawVect[3].pos.x   = DrawVect[1].pos.x   = TexVect[1].x + xf ;
				DrawVect[5].pos.y   = DrawVect[1].pos.y   = DrawVect[0].pos.y   = TexVect[0].y + yf ;
				DrawVect[4].pos.y   = DrawVect[3].pos.y   = DrawVect[2].pos.y   = TexVect[2].y + yf ;

				DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
				DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				DrawVect[5].v       = DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[4].v       = DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;

				*((DWORD *)&DrawVect[0].pos.z) =
				*((DWORD *)&DrawVect[1].pos.z) =
				*((DWORD *)&DrawVect[2].pos.z) =
				*((DWORD *)&DrawVect[3].pos.z) =
				*((DWORD *)&DrawVect[4].pos.z) =
				*((DWORD *)&DrawVect[5].pos.z) = drawz;

				DrawVect[0].rhw =
				DrawVect[1].rhw =
				DrawVect[2].rhw =
				DrawVect[3].rhw =
				DrawVect[4].rhw =
				DrawVect[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DeviceState_NormalDrawSetup() ;
			}
		}
	}
	else
	{
		// ͂ݏoĂꍇ

		// Sɂ͂ݏoĂ牽I
		if( OUT_DRAWAREA_CHECK( x, y, x + Image->Width, y + Image->Height ) ) return 0 ;
//		if( x > GSYS.DrawSetting.DrawArea.right || x + Image->Width < GSYS.DrawSetting.DrawArea.left ||
//			y > GSYS.DrawSetting.DrawArea.bottom || y + Image->Height < GSYS.DrawSetting.DrawArea.top ) return 0 ;

		// ``̕ۑ
		left	= GSYS.DrawSetting.DrawAreaF.left   ;
		top		= GSYS.DrawSetting.DrawAreaF.top    ;
		right	= GSYS.DrawSetting.DrawAreaF.right  ;
		bottom	= GSYS.DrawSetting.DrawAreaF.bottom ;

		// _^Cvɂď𕪊
		switch( GD3D11.Device.DrawInfo.VertexType )
		{
		case VERTEXTYPE_BLENDTEX :
			// uheNX`gp

			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );

				if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
				{
					Graphics_D3D11_DeviceState_NormalDrawSetup() ;
				}

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVectB )
				
				// _f[^
				VectB = DrawVectB ;
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				Vx  = 1.0F / ( float )DrawTex->Tex->TexWidth  ;
				Vy  = 1.0F / ( float )DrawTex->Tex->TexHeight ;
				VBx = GD3D11.Device.DrawSetting.InvBlendTextureWidth  ;
				VBy = GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				DrawVectB[0].color = 
				DrawVectB[1].color = 
				DrawVectB[2].color = 
				DrawVectB[3].color = 
				DrawVectB[4].color = 
				DrawVectB[5].color = ( DWORD )DiffuseColor ;

				DrawVectB[2].pos.x = DrawVectB[0].pos.x = xf + TexVect[0].x ;
				DrawVectB[3].pos.x = DrawVectB[1].pos.x = xf + TexVect[1].x ;
				DrawVectB[1].pos.y = DrawVectB[0].pos.y = yf + TexVect[0].y ;
				DrawVectB[3].pos.y = DrawVectB[2].pos.y = yf + TexVect[2].y ;

				DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;
				DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				for( j = 0 ; j < 4 ; j ++, VectB ++ )
				{
					// ``oĂꍇ̕␳
					if( VectB->pos.x < left )
					{
						VectB->u2 += ( left - VectB->pos.x ) * Vx ;
						VectB->u1 += ( left - VectB->pos.x ) * VBx ;
						VectB->pos.x = left ;
					}
					else
					if( VectB->pos.x > right )
					{
						VectB->u2 -= ( VectB->pos.x - right ) * Vx ;
						VectB->u1 -= ( VectB->pos.x - right ) * VBx ;
						VectB->pos.x = right ;
					}	

					if( VectB->pos.y < top )
					{
						VectB->v2 += ( top - VectB->pos.y ) * Vy ;
						VectB->v1 += ( top - VectB->pos.y ) * VBy ;
						VectB->pos.y = top ;
					}
					else
					if( VectB->pos.y > bottom )
					{
						VectB->v2 -= ( VectB->pos.y - bottom ) * Vy ;
						VectB->v1 -= ( VectB->pos.y - bottom ) * VBy ;
						VectB->pos.y = bottom ;
					}
				}

				DrawVectB[4] = DrawVectB[2] ;
				DrawVectB[5] = DrawVectB[1] ;

				*((DWORD *)&DrawVectB[0].pos.z) =
				*((DWORD *)&DrawVectB[1].pos.z) =
				*((DWORD *)&DrawVectB[2].pos.z) =
				*((DWORD *)&DrawVectB[3].pos.z) =
				*((DWORD *)&DrawVectB[4].pos.z) =
				*((DWORD *)&DrawVectB[5].pos.z) = drawz;

				DrawVectB[0].rhw =
				DrawVectB[1].rhw =
				DrawVectB[2].rhw =
				DrawVectB[3].rhw =
				DrawVectB[4].rhw =
				DrawVectB[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
			break ;
		
		case VERTEXTYPE_TEX :
			// uheNX`gpȂ

			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _obt@̎擾
				GETVERTEX_QUAD( DrawVect )
				
				// _f[^
				TexVect = DrawTex->Vertex ;
				DrawVect[0].color	= 
				DrawVect[1].color	= 
				DrawVect[2].color	= 
				DrawVect[3].color	= 
				DrawVect[4].color	= 
				DrawVect[5].color	= DiffuseColor ;

				DrawVect[2].pos.x   = DrawVect[0].pos.x   = TexVect[0].x + xf ;
				DrawVect[3].pos.x   = DrawVect[1].pos.x   = TexVect[1].x + xf ;
				DrawVect[1].pos.y   = DrawVect[0].pos.y   = TexVect[0].y + yf ;
				DrawVect[3].pos.y   = DrawVect[2].pos.y   = TexVect[2].y + yf ;

				DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
				DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;
				
				// _f[^
				Vect = DrawVect ;
				Vx	= 1.0F / ( float )DrawTex->Tex->TexWidth ;
				Vy	= 1.0F / ( float )DrawTex->Tex->TexHeight ;
				for( j = 0 ; j < 4 ; j ++, Vect ++ )
				{
					// ``oĂꍇ̕␳
					if( Vect->pos.x < left )
					{
						Vect->u += ( left - Vect->pos.x ) * Vx ;
						Vect->pos.x = left ;
					}
					else
					if( Vect->pos.x > right )
					{
						Vect->u -= ( Vect->pos.x - right ) * Vx ;
						Vect->pos.x = right ;
					}	

					if( Vect->pos.y < top )
					{
						Vect->v += ( top - Vect->pos.y ) * Vy ;
						Vect->pos.y = top ;
					}
					else
					if( Vect->pos.y > bottom )
					{
						Vect->v -= ( Vect->pos.y - bottom ) * Vy ;
						Vect->pos.y = bottom ;
					}
				}

				DrawVect[4] = DrawVect[2] ;
				DrawVect[5] = DrawVect[1] ;

				*((DWORD *)&DrawVect[0].pos.z) =
				*((DWORD *)&DrawVect[1].pos.z) =
				*((DWORD *)&DrawVect[2].pos.z) =
				*((DWORD *)&DrawVect[3].pos.z) =
				*((DWORD *)&DrawVect[4].pos.z) =
				*((DWORD *)&DrawVect[5].pos.z) = drawz;

				DrawVect[0].rhw =
				DrawVect[1].rhw =
				DrawVect[2].rhw =
				DrawVect[3].rhw =
				DrawVect[4].rhw =
				DrawVect[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DeviceState_NormalDrawSetup() ;
			}
			break ;
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_D3D11_DrawExtendGraph( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	VERTEX_2D *Vect ;
	VERTEX_BLENDTEX_2D *VectDataB, *VectB ; 
	IMAGEDATA_HARD_DRAW *DrawTex ;
	IMAGEDATA_HARD_DRAW *BlendDrawTex = NULL ;
	IMAGEDATA_HARD_VERT *TexVect ;
	IMAGEDATA_HARD_VERT *BlendTexVect ;
	IMAGEDATA_ORIG *Orig ;
	int DrawTexNum ;
	int i, j ;
	int BlendGraphNoIncFlag ;
	float GraphExRateX, GraphExRateY ;
//	int ReverseX = FALSE, ReverseY = FALSE ;
	int Reverse ;
//	int AdjX = FALSE, AdjY = FALSE ;
	float left, right, top, bottom ;
	float Vx, Vy ;
	float VBx, VBy ;
	int DiffuseColor ;
	DWORD drawz;
	int Flag ;

	Orig = Image->Orig ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `攻
//	if( x2 - x1 == Image->Width && y2 - y1 == Image->Height ) return G_D3D_DrawGraph( x1, y1, GraphData, TransFlag ) ; 	

	// Ȃꍇ̓G[
	if( x1 == x2 || y1 == y2 ) return -1 ;

	// `̏
	Flag = TransFlag | ( IntFlag ? ( GSYS.DrawSetting.DrawMode == DX_DRAWMODE_BILINEAR ? 0 : DX_D3D11_DRAWPREP_VECTORINT ) : 0 ) ;
	DX_D3D11_DRAWPREP_TEX( Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )

	// fBt[YJ[̎擾
	DiffuseColor = GD3D11.Device.DrawInfo.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage != NULL && BlendImage->Hard.DrawNum != Image->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image->Hard.Draw ;
	if( BlendImage != NULL )
	{
		BlendDrawTex = BlendImage->Hard.Draw ;
	}

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// g嗦擾Ă
	GraphExRateX = ( x2f - x1f ) / Image->Width ;
	GraphExRateY = ( y2f - y1f ) / Image->Height ;
	Reverse = ( GraphExRateX < 0 ) != ( GraphExRateY < 0 ) ;

//	x1f -= 0.5F ;
//	y1f -= 0.5F ;

	if( x1 > x2 ){ i = x2; x2 = x1; x1 = i; }
	if( y1 > y2 ){ i = y2; y2 = y1; y1 = i; }

	// `͈͂͂ݏoĂ邩ǂŏ𕪊
	if( IN_DRAWAREA_CHECK( x1, y1, x2, y2 ) )
	{
		// _^Cvɂď𕪊
		switch( GD3D11.Device.DrawInfo.VertexType )
		{
		case VERTEXTYPE_BLENDTEX :	// uheNX`gp
			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );

				if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
				{
					Graphics_D3D11_DeviceState_NormalDrawSetup() ;
				}

				// _f[^
				GETVERTEX_QUAD( VectDataB )
				
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				VectDataB[0].color = 
				VectDataB[1].color = 
				VectDataB[2].color = 
				VectDataB[3].color = 
				VectDataB[4].color = 
				VectDataB[5].color = ( DWORD )DiffuseColor ;

				VectDataB[4].pos.x = VectDataB[2].pos.x = VectDataB[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				VectDataB[5].pos.x = VectDataB[3].pos.x = VectDataB[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				VectDataB[5].pos.y = VectDataB[1].pos.y = VectDataB[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				VectDataB[4].pos.y = VectDataB[3].pos.y = VectDataB[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				VectDataB[4].u1 = VectDataB[2].u1 = VectDataB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectDataB[5].u1 = VectDataB[3].u1 = VectDataB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectDataB[5].v1 = VectDataB[1].v1 = VectDataB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				VectDataB[4].v1 = VectDataB[3].v1 = VectDataB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				VectDataB[4].u2 = VectDataB[2].u2 = VectDataB[0].u2 = TexVect[0].u ;
				VectDataB[5].u2 = VectDataB[3].u2 = VectDataB[1].u2 = TexVect[1].u ;
				VectDataB[5].v2 = VectDataB[1].v2 = VectDataB[0].v2 = TexVect[0].v ;
				VectDataB[4].v2 = VectDataB[3].v2 = VectDataB[2].v2 = TexVect[2].v ;

				*((DWORD *)&VectDataB[0].pos.z) =
				*((DWORD *)&VectDataB[1].pos.z) =
				*((DWORD *)&VectDataB[2].pos.z) =
				*((DWORD *)&VectDataB[3].pos.z) =
				*((DWORD *)&VectDataB[4].pos.z) =
				*((DWORD *)&VectDataB[5].pos.z) = drawz;

				VectDataB[0].rhw =
				VectDataB[1].rhw =
				VectDataB[2].rhw =
				VectDataB[3].rhw =
				VectDataB[4].rhw =
				VectDataB[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
			break ;

		case VERTEXTYPE_TEX :	// uheNX`gpȂ
			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _f[^
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;
				
				Vect[0].color = 
				Vect[1].color = 
				Vect[2].color = 
				Vect[3].color = 
				Vect[4].color = 
				Vect[5].color = ( DWORD )DiffuseColor ;

				Vect[4].pos.x = Vect[2].pos.x = Vect[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				Vect[5].pos.x = Vect[3].pos.x = Vect[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				Vect[5].pos.y = Vect[1].pos.y = Vect[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				Vect[4].pos.y = Vect[3].pos.y = Vect[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				Vect[4].u       = Vect[2].u       = Vect[0].u       = TexVect[0].u ;
				Vect[5].u       = Vect[3].u       = Vect[1].u       = TexVect[1].u ;
				Vect[5].v       = Vect[1].v       = Vect[0].v       = TexVect[0].v ;
				Vect[4].v       = Vect[3].v       = Vect[2].v       = TexVect[2].v ;

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) =
				*((DWORD *)&Vect[4].pos.z) =
				*((DWORD *)&Vect[5].pos.z) = drawz;

				Vect[0].rhw =
				Vect[1].rhw =
				Vect[2].rhw =
				Vect[3].rhw =
				Vect[4].rhw =
				Vect[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DeviceState_NormalDrawSetup() ;
			}
			break ;
		}
	}
	else
	{
		// Sɂ͂ݏoĂ牽I
		if( OUT_DRAWAREA_CHECK( x1, y1, x2, y2 ) ) return 0 ;

		// ``̕ۑ
		left	= GSYS.DrawSetting.DrawAreaF.left   - 0.5f /* + GSYS.WindowDrawRect.left */ ;
		top		= GSYS.DrawSetting.DrawAreaF.top    - 0.5f /* + GSYS.WindowDrawRect.top  */ ;
		right	= GSYS.DrawSetting.DrawAreaF.right  - 0.5f /* + GSYS.WindowDrawRect.left */ ;
		bottom	= GSYS.DrawSetting.DrawAreaF.bottom - 0.5f /* + GSYS.WindowDrawRect.top  */ ;

		// _^Cvɂď𕪊
		switch( GD3D11.Device.DrawInfo.VertexType )
		{
		case VERTEXTYPE_BLENDTEX :	// uheNX`gp
			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );

				if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
				{
					Graphics_D3D11_DeviceState_NormalDrawSetup() ;
				}

				GETVERTEX_QUAD( VectDataB )
				
				VectB = VectDataB ;
				Vx = 1.0F / ( DrawTex->Tex->TexWidth * GraphExRateX ) ;
				Vy = 1.0F / ( DrawTex->Tex->TexHeight * GraphExRateY ) ;
				VBx = GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VBy = GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				// _f[^
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				VectDataB[0].color = 
				VectDataB[1].color = 
				VectDataB[2].color = 
				VectDataB[3].color = 
				VectDataB[4].color = 
				VectDataB[5].color = ( DWORD )DiffuseColor ;

				VectDataB[2].pos.x = VectDataB[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				VectDataB[3].pos.x = VectDataB[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				VectDataB[1].pos.y = VectDataB[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				VectDataB[3].pos.y = VectDataB[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				VectDataB[2].u1 = VectDataB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectDataB[3].u1 = VectDataB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectDataB[1].v1 = VectDataB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				VectDataB[3].v1 = VectDataB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				VectDataB[2].u2 = VectDataB[0].u2 = TexVect[0].u ;
				VectDataB[3].u2 = VectDataB[1].u2 = TexVect[1].u ;
				VectDataB[1].v2 = VectDataB[0].v2 = TexVect[0].v ;
				VectDataB[3].v2 = VectDataB[2].v2 = TexVect[2].v ;

				for( j = 0 ; j < 4 ; j ++, VectB ++ )
				{
					// ``oĂꍇ̕␳
					if( VectB->pos.x < left )
					{
						VectB->u2 += ( left - VectB->pos.x ) * Vx ;
						VectB->u1 += ( left - VectB->pos.x ) * VBx ;
						VectB->pos.x = left ;
					}
					else
					if( VectB->pos.x > right )
					{
						VectB->u2 -= ( VectB->pos.x - right ) * Vx ;
						VectB->u1 -= ( VectB->pos.x - right ) * VBx ;
						VectB->pos.x = right ;
					}	

					if( VectB->pos.y < top )
					{
						VectB->v2 += ( top - VectB->pos.y ) * Vy ;
						VectB->v1 += ( top - VectB->pos.y ) * VBy ;
						VectB->pos.y = top ;
					}
					else
					if( VectB->pos.y > bottom )
					{
						VectB->v2 -= ( VectB->pos.y - bottom ) * Vy ;
						VectB->v1 -= ( VectB->pos.y - bottom ) * VBy ;
						VectB->pos.y = bottom ;
					}
				}

				*((DWORD *)&VectDataB[0].pos.z) =
				*((DWORD *)&VectDataB[1].pos.z) =
				*((DWORD *)&VectDataB[2].pos.z) =
				*((DWORD *)&VectDataB[3].pos.z) = drawz;

				VectDataB[0].rhw =
				VectDataB[1].rhw =
				VectDataB[2].rhw =
				VectDataB[3].rhw = 1.0f ;

				VectDataB[4] = VectDataB[2] ;
				VectDataB[5] = VectDataB[1] ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
			break ;

		case VERTEXTYPE_TEX :	// uheNX`gpȂ
			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _f[^
				Vx = 1.0F / ( DrawTex->Tex->TexWidth * GraphExRateX ) ;
				Vy = 1.0F / ( DrawTex->Tex->TexHeight * GraphExRateY ) ;
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;

				Vect[0].color = 
				Vect[1].color = 
				Vect[2].color = 
				Vect[3].color = 
				Vect[4].color = 
				Vect[5].color = ( DWORD )DiffuseColor ;

				Vect[2].pos.x = Vect[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				Vect[3].pos.x = Vect[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				Vect[1].pos.y = Vect[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				Vect[3].pos.y = Vect[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				Vect[2].u       = Vect[0].u       = TexVect[0].u ;
				Vect[3].u       = Vect[1].u       = TexVect[1].u ;
				Vect[1].v       = Vect[0].v       = TexVect[0].v ;
				Vect[3].v       = Vect[2].v       = TexVect[2].v ;

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) = drawz;

				Vect[0].rhw =
				Vect[1].rhw =
				Vect[2].rhw =
				Vect[3].rhw = 1.0f ;

				for( j = 0 ; j < 4 ; j ++, Vect ++ )
				{
					// ``oĂꍇ̕␳
					if( Vect->pos.x < left )
					{
						Vect->u += ( left - Vect->pos.x ) * Vx ;
						Vect->pos.x = left ;
					}
					else
					if( Vect->pos.x > right )
					{
						Vect->u -= ( Vect->pos.x - right ) * Vx ;
						Vect->pos.x = right ;
					}	

					if( Vect->pos.y < top )
					{
						Vect->v += ( top - Vect->pos.y ) * Vy ;
						Vect->pos.y = top ;
					}
					else
					if( Vect->pos.y > bottom )
					{
						Vect->v -= ( Vect->pos.y - bottom ) * Vy ;
						Vect->pos.y = bottom ;
					}
				}

				Vect[0] = Vect[-2] ;
				Vect[1] = Vect[-3] ;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DeviceState_NormalDrawSetup() ;
			}
			break ;
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_D3D11_DrawRotaGraph( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag )
{
	VERTEX_2D *Vect ;
	VERTEX_BLENDTEX_2D *VectB ;
	int DiffuseColor ;
	IMAGEDATA_HARD_DRAW *DrawTex ;
	IMAGEDATA_HARD_DRAW *BlendDrawTex = NULL ;
	IMAGEDATA_HARD_VERT *TexVect ;
	IMAGEDATA_HARD_VERT *BlendTexVect ;
	int DrawTexNum ;
	int i ; 
	float Sin = 0.0f, Cos = 1.0f ;
	int BlendGraphNoIncFlag ;
	float XBuf[2], YBuf[2] ;
	float ExtendRate = ( float )ExRate ; 
	float ExtendRateX ;
	DWORD drawz;
//	BOOL Adj = FALSE ;
	float CenX, CenY ;
	float fx, fy ;
	int hx = 0, hy = 0 ;
	int FastCode, SinCosNone, AngleCheck, AlwaysCheck ;
	int Flag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// Ȃꍇ̓G[
	if( ExRate == 0.0 ) return -1 ;

	// `̏
	Flag = TransFlag ;
	DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )

	// ]vfׂ
	if( Angle == 0.0 )
	{
		SinCosNone = 1;
	}
	else
	{
		SinCosNone = 0;
		_SINCOS( (float)Angle, &Sin, &Cos ) ;
	}
//	if( _FABS( (float)Angle ) < 0.0001 && ExRate < 1.001 && ExRate > 0.999 ) Adj = TRUE ;

	// W̕␳
	if( IntFlag || GSYS.DrawSetting.DrawMode == DX_DRAWMODE_NEAREST )
	{
		AlwaysCheck = 0 ;
		FastCode    = 0 ;
		hx          = Image->Width % 2 ;
		hy          = Image->Height % 2 ;
		fx = xf - ( float )x ;
		fy = yf - ( float )y ;
		if( fx < 0.0f ) fx = -fx;
		if( fy < 0.0f ) fy = -fy;
		if( fx < 0.00001f && fy < 0.00001f )
		{
			if( ExRate == 1.0 )
			{
				if( hx == hy )
				{
					if( hx == 0 )
					{
						CenX = ( float )(Image->Width >> 1) ;
						CenY = ( float )(Image->Height >> 1) ;
						xf   = ( float )x ;
						yf   = ( float )y ;
					}
					else
					{
						CenX = ( float )Image->Width * 0.5F ;
						CenY = ( float )Image->Height * 0.5F ;
						xf   = ( float )x - 0.5F ;
						yf   = ( float )y - 0.5F ;
						FastCode = 1;
					}
				}
				else
				{
					CenX = ( float )Image->Width * 0.5F ;
					CenY = ( float )Image->Height * 0.5F ;
					xf   = ( float )x ;
					yf   = ( float )y ;
						
					if( hx != 0 ) CenX -= 0.5F ;
					if( hy != 0 ) CenY -= 0.5F ;
				}
			}
			else
			{
				CenX = ( float )Image->Width * 0.5F ;
				CenY = ( float )Image->Height * 0.5F ;
				xf   = ( float )x ;
				yf   = ( float )y ;
				FastCode = 1 ;
			}
		}
		else
		{
			CenX = ( float )Image->Width * 0.5F ;
			CenY = ( float )Image->Height * 0.5F ;
			xf   = ( float )x + 0.5f ;
			yf   = ( float )y + 0.5f ;
			AlwaysCheck = 1 ;
		}
	}
	else
	{
		CenX = ( float )Image->Width * 0.5F ;
		CenY = ( float )Image->Height * 0.5F ;
//		xf -= 0.5F ;
//		yf -= 0.5F ;
		AngleCheck = 0 ;
		AlwaysCheck = 0 ;
		FastCode = 1 ;
	}

	// ȉ]l̃`FbNsǂ𒲂ׂ
	if( IntFlag == TRUE && AlwaysCheck == 0 && SinCosNone == 0 && ( hx == 1 || hy == 1 ) &&
		( ( Angle < DX_PI / 180.0 *         - 4.0   ) ||
		  ( Angle > DX_PI / 180.0 * ( 360.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 *         - 4.0   && Angle < DX_PI / 180.0 *           4.0   ) ||
		  ( Angle > DX_PI / 180.0 * (  90.0 - 4.0 ) && Angle < DX_PI / 180.0 * (  90.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 * ( 180.0 - 4.0 ) && Angle < DX_PI / 180.0 * ( 180.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 * ( 270.0 - 4.0 ) && Angle < DX_PI / 180.0 * ( 270.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 * ( 360.0 - 4.0 ) && Angle < DX_PI / 180.0 * ( 360.0 + 4.0 ) ) ) )
	{
		AngleCheck = 1 ;
	}
	else
	{
		AngleCheck = 0 ;
	}

	// _f[^擾îƂF̃Zbĝ݁j
	DiffuseColor = GD3D11.Device.DrawInfo.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage != NULL && BlendImage->Hard.DrawNum != Image->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image->Hard.Draw ;
	if( BlendImage != NULL )
	{
		BlendDrawTex = BlendImage->Hard.Draw ;
	}

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// ]l̊g嗦Zbg
	ExtendRateX = ( ( TurnFlag == TRUE ) ? -1.0f : 1.0f ) * ExtendRate ;

	// _^Cvɂď𕪊
	switch( GD3D11.Device.DrawInfo.VertexType )
	{
	case VERTEXTYPE_BLENDTEX :	// uheNX`gp
		// eNX`[̐JԂ
		if( DrawTexNum == 1 && FastCode == 1 )
		{
			// `悷eNX`[̃Zbg
			Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
			Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );

			if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
			{
				Graphics_D3D11_DeviceState_NormalDrawSetup() ;
			}

			// _f[^
			GETVERTEX_QUAD( VectB )

			TexVect = DrawTex->Vertex ;
			BlendTexVect = BlendDrawTex->Vertex ;

			VectB[0].color = 
			VectB[1].color = 
			VectB[2].color = 
			VectB[3].color = 
			VectB[4].color = 
			VectB[5].color = ( DWORD )DiffuseColor ;

			XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
			YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
			XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
			YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
			VectB[0].pos.x =  XBuf[1] + xf ;
			VectB[0].pos.y =  YBuf[1] + yf ;
			VectB[3].pos.x = -XBuf[1] + xf ;
			VectB[3].pos.y = -YBuf[1] + yf ;
			
			XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
			YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
			XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
			YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
			VectB[5].pos.x = VectB[1].pos.x =  XBuf[1] + xf ;
			VectB[5].pos.y = VectB[1].pos.y =  YBuf[1] + yf ;
			VectB[4].pos.x = VectB[2].pos.x = -XBuf[1] + xf ;
			VectB[4].pos.y = VectB[2].pos.y = -YBuf[1] + yf ;

			VectB[4].u1 = VectB[2].u1 = VectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
			VectB[5].u1 = VectB[3].u1 = VectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
			VectB[5].v1 = VectB[1].v1 = VectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
			VectB[4].v1 = VectB[3].v1 = VectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

			VectB[4].u2 = VectB[2].u2 = VectB[0].u2 = TexVect[0].u ;
			VectB[5].u2 = VectB[3].u2 = VectB[1].u2 = TexVect[1].u ;
			VectB[5].v2 = VectB[1].v2 = VectB[0].v2 = TexVect[0].v ;
			VectB[4].v2 = VectB[3].v2 = VectB[2].v2 = TexVect[2].v ;

			*((DWORD *)&VectB[0].pos.z) =
			*((DWORD *)&VectB[1].pos.z) =
			*((DWORD *)&VectB[2].pos.z) =
			*((DWORD *)&VectB[3].pos.z) =
			*((DWORD *)&VectB[4].pos.z) =
			*((DWORD *)&VectB[5].pos.z) = drawz;

			VectB[0].rhw =
			VectB[1].rhw =
			VectB[2].rhw =
			VectB[3].rhw =
			VectB[4].rhw =
			VectB[5].rhw = 1.0f ;

			// eNX`[`悷
			ADD4VERTEX_BLENDTEX

			if( BlendGraphNoIncFlag == FALSE )
			{
				BlendDrawTex ++ ;
			}
		}
		else
		{
			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
				Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );

				if( GD3D11.Device.DrawSetting.ChangeTextureFlag )
				{
					Graphics_D3D11_DeviceState_NormalDrawSetup() ;
				}

				// _f[^
				GETVERTEX_QUAD( VectB )

				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				VectB[0].color = 
				VectB[1].color = 
				VectB[2].color = 
				VectB[3].color = 
				VectB[4].color = 
				VectB[5].color = ( DWORD )DiffuseColor ;

				XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[0].pos.x =  XBuf[1] + xf ;
				VectB[0].pos.y =  YBuf[1] + yf ;

				XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[5].pos.x = VectB[1].pos.x =  XBuf[1] + xf ;
				VectB[5].pos.y = VectB[1].pos.y =  YBuf[1] + yf ;

				XBuf[0] = ( TexVect[2].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[2].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[4].pos.x = VectB[2].pos.x =  XBuf[1] + xf ;
				VectB[4].pos.y = VectB[2].pos.y =  YBuf[1] + yf ;

				XBuf[0] = ( TexVect[3].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[3].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[3].pos.x =  XBuf[1] + xf ;
				VectB[3].pos.y =  YBuf[1] + yf ;

				VectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectB[2].u1 = ( TexVect[2].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectB[3].u1 = ( TexVect[3].x - BlendTexVect[0].x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectB[4].u1 = VectB[2].u1 ;
				VectB[5].u1 = VectB[1].u1 ;
				
				VectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				VectB[1].v1 = ( TexVect[1].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				VectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				VectB[3].v1 = ( TexVect[3].y - BlendTexVect[0].y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;
				VectB[4].v1 = VectB[2].v1 ;
				VectB[5].v1 = VectB[1].v1 ;

				VectB[4].u2 = VectB[2].u2 = VectB[0].u2 = TexVect[0].u ;
				VectB[5].u2 = VectB[3].u2 = VectB[1].u2 = TexVect[1].u ;
				VectB[5].v2 = VectB[1].v2 = VectB[0].v2 = TexVect[0].v ;
				VectB[4].v2 = VectB[3].v2 = VectB[2].v2 = TexVect[2].v ;

				*((DWORD *)&VectB[0].pos.z) =
				*((DWORD *)&VectB[1].pos.z) =
				*((DWORD *)&VectB[2].pos.z) =
				*((DWORD *)&VectB[3].pos.z) =
				*((DWORD *)&VectB[4].pos.z) =
				*((DWORD *)&VectB[5].pos.z) = drawz;

				VectB[0].rhw =
				VectB[1].rhw =
				VectB[2].rhw =
				VectB[3].rhw =
				VectB[4].rhw =
				VectB[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
		}
		break ;

	case VERTEXTYPE_TEX :	// uheNX`gpȂ
		// eNX`[̐JԂ
		if( DrawTexNum == 1 && FastCode == 1 )
		{
			if( SinCosNone == 0 )
			{
				// _f[^
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;

				Vect[0].color = 
				Vect[1].color = 
				Vect[2].color = 
				Vect[3].color = 
				Vect[4].color = 
				Vect[5].color = ( DWORD )DiffuseColor ;

				Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
				Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
				Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
				Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

				XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				Vect[0].pos.x =  XBuf[1] + xf ;
				Vect[0].pos.y =  YBuf[1] + yf ;
				Vect[3].pos.x = -XBuf[1] + xf ;
				Vect[3].pos.y = -YBuf[1] + yf ;
				
				XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				Vect[5].pos.x = Vect[1].pos.x =  XBuf[1] + xf ;
				Vect[5].pos.y = Vect[1].pos.y =  YBuf[1] + yf ;
				Vect[4].pos.x = Vect[2].pos.x = -XBuf[1] + xf ;
				Vect[4].pos.y = Vect[2].pos.y = -YBuf[1] + yf ;

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) =
				*((DWORD *)&Vect[4].pos.z) =
				*((DWORD *)&Vect[5].pos.z) = drawz;

				Vect[0].rhw =
				Vect[1].rhw =
				Vect[2].rhw =
				Vect[3].rhw =
				Vect[4].rhw =
				Vect[5].rhw = 1.0f ;

				if( AlwaysCheck )
				{
					if( ( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
							( ( Vect[0].pos.x > Vect[2].pos.x ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
							( ( Vect[2].pos.x > Vect[0].pos.x ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) ) < 0.0001f ) ||
						( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
							( ( Vect[0].pos.x > Vect[1].pos.x ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
							( ( Vect[1].pos.x > Vect[0].pos.x ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) ) < 0.0001f ) )
					{
						Vect[0].pos.x -= 0.5f;
						Vect[1].pos.x -= 0.5f;
						Vect[2].pos.x -= 0.5f;
						Vect[3].pos.x -= 0.5f;
						Vect[4].pos.x -= 0.5f;
						Vect[5].pos.x -= 0.5f;
					}

					if( ( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
							( ( Vect[0].pos.y > Vect[2].pos.y ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
							( ( Vect[2].pos.y > Vect[0].pos.y ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) ) < 0.0001f ) ||
						( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
							( ( Vect[0].pos.y > Vect[1].pos.y ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
							( ( Vect[1].pos.y > Vect[0].pos.y ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) ) < 0.0001f ) )
					{
						Vect[0].pos.y -= 0.5f;
						Vect[1].pos.y -= 0.5f;
						Vect[2].pos.y -= 0.5f;
						Vect[3].pos.y -= 0.5f;
						Vect[4].pos.y -= 0.5f;
						Vect[5].pos.y -= 0.5f;
					}
				}
				else
				if( AngleCheck )
				{
					if( hx &&
						( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
						( ( Vect[0].pos.x > Vect[2].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
						( ( Vect[2].pos.x > Vect[0].pos.x - 0.01f ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ||
						( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
						( ( Vect[0].pos.x > Vect[1].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
						( ( Vect[1].pos.x > Vect[0].pos.x - 0.01f ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) )
					{
						Vect[0].pos.x -= 0.5f;
						Vect[1].pos.x -= 0.5f;
						Vect[2].pos.x -= 0.5f;
						Vect[3].pos.x -= 0.5f;
						Vect[4].pos.x -= 0.5f;
						Vect[5].pos.x -= 0.5f;
					}

					if( hy &&
						( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
						( ( Vect[0].pos.y > Vect[1].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
						( ( Vect[1].pos.y > Vect[0].pos.y - 0.01f ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ||
						( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
						( ( Vect[0].pos.y > Vect[2].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
						( ( Vect[2].pos.y > Vect[0].pos.y - 0.01f ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) )
					{
						Vect[0].pos.y -= 0.5f;
						Vect[1].pos.y -= 0.5f;
						Vect[2].pos.y -= 0.5f;
						Vect[3].pos.y -= 0.5f;
						Vect[4].pos.y -= 0.5f;
						Vect[5].pos.y -= 0.5f;
					}
				}

				// eNX`[`悷
				ADD4VERTEX_TEX
			}
			else
			{
				// _f[^
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;

				Vect[0].color = 
				Vect[1].color = 
				Vect[2].color = 
				Vect[3].color = 
				Vect[4].color = 
				Vect[5].color = ( DWORD )DiffuseColor ;

				Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
				Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
				Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
				Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

				XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
				Vect[0].pos.x =  XBuf[0] + xf ;
				Vect[0].pos.y =  YBuf[0] + yf ;
				Vect[3].pos.x = -XBuf[0] + xf ;
				Vect[3].pos.y = -YBuf[0] + yf ;
				
				XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
				Vect[5].pos.x = Vect[1].pos.x =  XBuf[0] + xf ;
				Vect[5].pos.y = Vect[1].pos.y =  YBuf[0] + yf ;
				Vect[4].pos.x = Vect[2].pos.x = -XBuf[0] + xf ;
				Vect[4].pos.y = Vect[2].pos.y = -YBuf[0] + yf ;

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) =
				*((DWORD *)&Vect[4].pos.z) =
				*((DWORD *)&Vect[5].pos.z) = drawz;

				Vect[0].rhw =
				Vect[1].rhw =
				Vect[2].rhw =
				Vect[3].rhw =
				Vect[4].rhw =
				Vect[5].rhw = 1.0f ;

				// eNX`[`悷
				ADD4VERTEX_TEX
			}
		}
		else
		{
			if( SinCosNone == 0 )
			{
				// eNX`[̐JԂ
				i = 0 ;
				for(;;)
				{
					// _f[^
					GETVERTEX_QUAD( Vect )
					
					TexVect = DrawTex->Vertex ;

					Vect[0].color = 
					Vect[1].color = 
					Vect[2].color = 
					Vect[3].color = 
					Vect[4].color = 
					Vect[5].color = ( DWORD )DiffuseColor ;

					Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
					Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
					Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
					Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

					XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[0].pos.x =  XBuf[1] + xf ;
					Vect[0].pos.y =  YBuf[1] + yf ;

					XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[5].pos.x = Vect[1].pos.x =  XBuf[1] + xf ;
					Vect[5].pos.y = Vect[1].pos.y =  YBuf[1] + yf ;

					XBuf[0] = ( TexVect[2].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[2].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[4].pos.x = Vect[2].pos.x =  XBuf[1] + xf ;
					Vect[4].pos.y = Vect[2].pos.y =  YBuf[1] + yf ;

					XBuf[0] = ( TexVect[3].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[3].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[3].pos.x =  XBuf[1] + xf ;
					Vect[3].pos.y =  YBuf[1] + yf ;

					*((DWORD *)&Vect[0].pos.z) =
					*((DWORD *)&Vect[1].pos.z) =
					*((DWORD *)&Vect[2].pos.z) =
					*((DWORD *)&Vect[3].pos.z) =
					*((DWORD *)&Vect[4].pos.z) =
					*((DWORD *)&Vect[5].pos.z) = drawz;

					Vect[0].rhw =
					Vect[1].rhw =
					Vect[2].rhw =
					Vect[3].rhw =
					Vect[4].rhw =
					Vect[5].rhw = 1.0f ;

					if( AlwaysCheck )
					{
						float f;

						f = _FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) );
						if( ( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
							    ( ( Vect[0].pos.x >= Vect[2].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
							    ( ( Vect[2].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) ||
							( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
							    ( ( Vect[0].pos.x >= Vect[1].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
							    ( ( Vect[1].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) )
						{
							Vect[0].pos.x -= 0.5f;
							Vect[1].pos.x -= 0.5f;
							Vect[2].pos.x -= 0.5f;
							Vect[3].pos.x -= 0.5f;
							Vect[4].pos.x -= 0.5f;
							Vect[5].pos.x -= 0.5f;
						}

						f = _FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) );
						if( ( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
							    ( ( Vect[0].pos.y >= Vect[2].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
							    ( ( Vect[2].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) ||
							( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
							    ( ( Vect[0].pos.y >= Vect[1].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
							    ( ( Vect[1].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) )
						{
							Vect[0].pos.y -= 0.5f;
							Vect[1].pos.y -= 0.5f;
							Vect[2].pos.y -= 0.5f;
							Vect[3].pos.y -= 0.5f;
							Vect[4].pos.y -= 0.5f;
							Vect[5].pos.y -= 0.5f;
						}
					}
					else
					if( AngleCheck )
					{
						float f;

						if( hx )
						{
							f = _FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) );
							if( ( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
									( ( Vect[0].pos.x >= Vect[2].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
									( ( Vect[2].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) ||
								( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
									( ( Vect[0].pos.x >= Vect[1].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
									( ( Vect[1].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) )
							{
								Vect[0].pos.x -= 0.5f;
								Vect[1].pos.x -= 0.5f;
								Vect[2].pos.x -= 0.5f;
								Vect[3].pos.x -= 0.5f;
								Vect[4].pos.x -= 0.5f;
								Vect[5].pos.x -= 0.5f;
							}
						}

						if( hy )
						{
							f = _FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) );
							if( ( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
									( ( Vect[0].pos.y >= Vect[2].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
									( ( Vect[2].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) ||
								( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
									( ( Vect[0].pos.y >= Vect[1].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
									( ( Vect[1].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) )
							{
								Vect[0].pos.y -= 0.5f;
								Vect[1].pos.y -= 0.5f;
								Vect[2].pos.y -= 0.5f;
								Vect[3].pos.y -= 0.5f;
								Vect[4].pos.y -= 0.5f;
								Vect[5].pos.y -= 0.5f;
							}
						}
					}

					// eNX`[`悷
					ADD4VERTEX_TEX

					i ++ ;
					if( i >= DrawTexNum ) break ;

					// `悷eNX`[̃Zbg
					DrawTex ++ ;
					Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
					Graphics_D3D11_DeviceState_NormalDrawSetup() ;
				}
			}
			else
			{
				// eNX`[̐JԂ
				i = 0 ;
				for(;;)
				{
					// _f[^
					GETVERTEX_QUAD( Vect )
					
					TexVect = DrawTex->Vertex ;

					Vect[0].color = 
					Vect[1].color = 
					Vect[2].color = 
					Vect[3].color = 
					Vect[4].color = 
					Vect[5].color = ( DWORD )DiffuseColor ;

					Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
					Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
					Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
					Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

					Vect[0].pos.x =                 ( TexVect[0].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[0].pos.y =                 ( TexVect[0].y - CenY ) * ExtendRate  + yf;

					Vect[5].pos.x = Vect[1].pos.x = ( TexVect[1].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[5].pos.y = Vect[1].pos.y = ( TexVect[1].y - CenY ) * ExtendRate  + yf;

					Vect[4].pos.x = Vect[2].pos.x = ( TexVect[2].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[4].pos.y = Vect[2].pos.y = ( TexVect[2].y - CenY ) * ExtendRate  + yf;

					Vect[3].pos.x =                 ( TexVect[3].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[3].pos.y =                 ( TexVect[3].y - CenY ) * ExtendRate  + yf;

					*((DWORD *)&Vect[0].pos.z) =
					*((DWORD *)&Vect[1].pos.z) =
					*((DWORD *)&Vect[2].pos.z) =
					*((DWORD *)&Vect[3].pos.z) =
					*((DWORD *)&Vect[4].pos.z) =
					*((DWORD *)&Vect[5].pos.z) = drawz;

					Vect[0].rhw =
					Vect[1].rhw =
					Vect[2].rhw =
					Vect[3].rhw =
					Vect[4].rhw =
					Vect[5].rhw = 1.0f ;

					// eNX`[`悷
					ADD4VERTEX_TEX

					i ++ ;
					if( i >= DrawTexNum ) break ;

					// `悷eNX`[̃Zbg
					DrawTex ++ ;
					Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
					Graphics_D3D11_DeviceState_NormalDrawSetup() ;
				}
			}
		}
		break ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_D3D11_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	if( x1 == x3 && x2 == x4 && y1 == y2 && y3 == y4 ) return Graphics_D3D11_DrawExtendGraph( x1, y1, x4, y4, ( float )x1, ( float )y1, ( float )x4, ( float )y4, Image, BlendImage, TransFlag, TRUE ) ; 

	// uheNX`gpA^֐gptOĂȂ
	// s`֐gp
	if( GD3D11.Setting.UseOldDrawModiGraphCodeFlag == FALSE && GSYS.DrawSetting.BlendGraph <= 0 )
		return Graphics_D3D11_DrawModiGraphF( (float)x1, (float)y1, (float)x2, (float)y2, (float)x3, (float)y3, (float)x4, (float)y4, Image, BlendImage, TransFlag, SimpleDrawFlag ) ;

	VERTEX_2D           *DrawVect ;
	VERTEX_2D           VectBuf ;
	VERTEX_2D           *Vect ;
	VERTEX_BLENDTEX_2D	*DrawVectB ;
	VERTEX_BLENDTEX_2D  VectBufB ;
	VERTEX_BLENDTEX_2D  *VectB ;
	IMAGEDATA_HARD_DRAW *DrawTex ;
	IMAGEDATA_HARD_DRAW *BlendDrawTex = NULL ;
	IMAGEDATA_HARD_VERT *TexVect ;
	IMAGEDATA_HARD_VERT *BlendTexVect ;
	float GraphSizeX, GraphSizeY ;
	float XBuf, YBuf ;
	int DrawTexNum ;
	unsigned char *VectType ;
	int i, j ; 
	int BlendGraphNoIncFlag ;
	float Reverse0, Reverse1 ;
	float ExRate1X1, ExRate1Y1, ExRate2X1, ExRate2Y1 ;
	float ExRate1X2, ExRate1Y2, ExRate2X2, ExRate2Y2 ;
	int DiffuseColor ;
	float  xf1, yf1, xf4, yf4;
	DWORD drawz ;
	int Flag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	Flag = TransFlag | DX_D3D11_DRAWPREP_VECTORINT ;
	DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )

	GraphSizeX = ( float )Image->Width ;  GraphSizeY = ( float )Image->Height ;
	ExRate1X1 = ( x2 - x1 ) /  GraphSizeX ;  ExRate1X2 = ( x3 - x1 ) /  GraphSizeY ;
	ExRate1Y1 = ( y3 - y1 ) /  GraphSizeY ;  ExRate1Y2 = ( y2 - y1 ) /  GraphSizeX ;
	ExRate2X1 = ( x3 - x4 ) / -GraphSizeX ;  ExRate2X2 = ( x2 - x4 ) / -GraphSizeY ;
	ExRate2Y1 = ( y2 - y4 ) / -GraphSizeY ;  ExRate2Y2 = ( y3 - y4 ) / -GraphSizeX ;
//	xf1 = (float)x1 - 0.5F ; yf1 = (float)y1 - 0.5F ;
//	xf4 = (float)x4 - 0.5F ; yf4 = (float)y4 - 0.5F ; 
	xf1 = (float)x1 ; yf1 = (float)y1 ;
	xf4 = (float)x4 ; yf4 = (float)y4 ; 

	// _f[^擾îƂF̃Zbĝ݁j
	DiffuseColor = GD3D11.Device.DrawInfo.DiffuseColor ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// `̐Zbg
	DrawTexNum = Image->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage != NULL && BlendImage->Hard.DrawNum != Image->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image->Hard.Draw ;
	if( BlendImage != NULL )
	{
		BlendDrawTex = BlendImage->Hard.Draw ;
	}

	// _^Cvɂď𕪊
	switch( GD3D11.Device.DrawInfo.VertexType )
	{
	case VERTEXTYPE_BLENDTEX :	// uheNX`gp
		// eNX`[̐JԂ
		for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
		{
			// `悷eNX`[̃Zbg
			Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
			Graphics_D3D11_DrawSetting_SetBlendTexture( BlendDrawTex->Tex->PF->D3D11.Texture, BlendDrawTex->Tex->PF->D3D11.TextureSRV, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );

			Graphics_D3D11_DeviceState_NormalDrawSetup() ;

			// _obt@̎擾
			GETVERTEX_QUAD( DrawVectB )

			DrawVectB[0].color =
			DrawVectB[1].color =
			DrawVectB[2].color =
			DrawVectB[3].color = (DWORD)DiffuseColor ;

			*((DWORD *)&DrawVectB[0].pos.z) =
			*((DWORD *)&DrawVectB[1].pos.z) =
			*((DWORD *)&DrawVectB[2].pos.z) =
			*((DWORD *)&DrawVectB[3].pos.z) = drawz ;

			DrawVectB[0].rhw =
			DrawVectB[1].rhw =
			DrawVectB[2].rhw =
			DrawVectB[3].rhw = 1.0f ;

			VectType     = DrawTex->VertType ;
			VectB        = DrawVectB ;
			TexVect      = DrawTex->Vertex ;
			BlendTexVect = BlendDrawTex->Vertex ;

			for( j = 0 ; j < 4 ; j ++, VectB ++, TexVect ++ )
			{
				// _W̎Zo
				if( *VectType ++ )
				{
					// Op̏㑤
					VectB->pos.x = ( TexVect->x * ExRate1X1 ) + ( TexVect->y * ExRate1X2 ) + xf1 ;
					VectB->pos.y = ( TexVect->y * ExRate1Y1 ) + ( TexVect->x * ExRate1Y2 ) + yf1 ;
				} 
				else
				{
					// Op̉
					XBuf = TexVect->x - GraphSizeX ;  YBuf = TexVect->y - GraphSizeY ;
					VectB->pos.x = ( XBuf * ExRate2X1 ) + ( YBuf * ExRate2X2 ) + xf4 ;
					VectB->pos.y = ( YBuf * ExRate2Y1 ) + ( XBuf * ExRate2Y2 ) + yf4 ;
				}

				VectB->u1 = ( TexVect->x - BlendTexVect->x + GSYS.DrawSetting.BlendGraphX ) * GD3D11.Device.DrawSetting.InvBlendTextureWidth ;
				VectB->v1 = ( TexVect->y - BlendTexVect->y + GSYS.DrawSetting.BlendGraphY ) * GD3D11.Device.DrawSetting.InvBlendTextureHeight ;

				VectB->u2 = TexVect->u ;
				VectB->v2 = TexVect->v ;
			}

			// ]菈
			Reverse0 =  ( DrawVectB[ 1 ].pos.x - DrawVectB[ 0 ].pos.x ) * ( DrawVectB[ 2 ].pos.y - DrawVectB[ 0 ].pos.y ) -
						( DrawVectB[ 2 ].pos.x - DrawVectB[ 0 ].pos.x ) * ( DrawVectB[ 1 ].pos.y - DrawVectB[ 0 ].pos.y ) ;
			Reverse1 = -( DrawVectB[ 1 ].pos.x - DrawVectB[ 3 ].pos.x ) * ( DrawVectB[ 2 ].pos.y - DrawVectB[ 3 ].pos.y ) +
						( DrawVectB[ 1 ].pos.y - DrawVectB[ 3 ].pos.y ) * ( DrawVectB[ 2 ].pos.x - DrawVectB[ 3 ].pos.x ) ;
			if( Reverse0 <= 0 && Reverse1 <= 0 )
			{
				VectBufB = DrawVectB[ 1 ] ; DrawVectB[ 1 ] = DrawVectB[ 2 ] ; DrawVectB[ 2 ] = VectBufB ;
			}

			// `I
			if( Reverse0 * Reverse1 >= 0 )
			{
				DrawVectB[ 4 ] = DrawVectB[ 2 ] ;
				DrawVectB[ 5 ] = DrawVectB[ 1 ] ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX
			}
			else
			{
				// w]̕␳
				if( Reverse0 < 0 ) 
				{
					VectBufB = DrawVectB[ 1 ] ; DrawVectB[ 1 ] = DrawVectB[ 2 ] ; DrawVectB[ 2 ] = VectBufB ;
				}

				DrawVectB[ 4 ] = DrawVectB[ 2 ] ;
				DrawVectB[ 5 ] = DrawVectB[ 1 ] ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX
			}

			if( BlendGraphNoIncFlag == FALSE )
			{
				BlendDrawTex ++ ;
			}
		}
		break ;

	case VERTEXTYPE_TEX :	// uheNX`gpȂ
		// eNX`[̐JԂ
		for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
		{
			// `悷eNX`[̃Zbg
			Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
			Graphics_D3D11_DeviceState_NormalDrawSetup() ;

			TexVect = DrawTex->Vertex ;

			// _obt@̎擾
			GETVERTEX_QUAD( DrawVect )

			// _f[^Zbg
			DrawVect[ 0 ].pos.x = TexVect[ 0 ].x ;
			DrawVect[ 0 ].pos.y = TexVect[ 0 ].y ;
			DrawVect[ 1 ].pos.x = TexVect[ 1 ].x ;
			DrawVect[ 1 ].pos.y = TexVect[ 1 ].y ;
			DrawVect[ 2 ].pos.x = TexVect[ 2 ].x ;
			DrawVect[ 2 ].pos.y = TexVect[ 2 ].y ;
			DrawVect[ 3 ].pos.x = TexVect[ 3 ].x ;
			DrawVect[ 3 ].pos.y = TexVect[ 3 ].y ;

			DrawVect[ 0 ].u = TexVect[ 0 ].u ;
			DrawVect[ 0 ].v = TexVect[ 0 ].v ;
			DrawVect[ 1 ].u = TexVect[ 1 ].u ;
			DrawVect[ 1 ].v = TexVect[ 1 ].v ;
			DrawVect[ 2 ].u = TexVect[ 2 ].u ;
			DrawVect[ 2 ].v = TexVect[ 2 ].v ;
			DrawVect[ 3 ].u = TexVect[ 3 ].u ;
			DrawVect[ 3 ].v = TexVect[ 3 ].v ;

			DrawVect[0].color =
			DrawVect[1].color =
			DrawVect[2].color =
			DrawVect[3].color = DiffuseColor ;

			*((DWORD *)&DrawVect[0].pos.z) = 
			*((DWORD *)&DrawVect[1].pos.z) = 
			*((DWORD *)&DrawVect[2].pos.z) = 
			*((DWORD *)&DrawVect[3].pos.z) = drawz;

			DrawVect[0].rhw =
			DrawVect[1].rhw =
			DrawVect[2].rhw =
			DrawVect[3].rhw = 1.0f ;

			VectType = DrawTex->VertType ;
			Vect = DrawVect ;

			for( j = 0 ; j < 4 ; j ++, Vect ++ )
			{
				// _W̎Zo
				if( *VectType ++ )
				{
					// Op̏㑤
					XBuf = Vect->pos.x ;  YBuf = Vect->pos.y ;
					Vect->pos.x = ( XBuf * ExRate1X1 ) + ( YBuf * ExRate1X2 ) + xf1 ;
					Vect->pos.y = ( YBuf * ExRate1Y1 ) + ( XBuf * ExRate1Y2 ) + yf1 ;
				} 
				else
				{
					// Op̉
					XBuf = Vect->pos.x - GraphSizeX ;  YBuf = Vect->pos.y - GraphSizeY ;
					Vect->pos.x = ( XBuf * ExRate2X1 ) + ( YBuf * ExRate2X2 ) + xf4 ;
					Vect->pos.y = ( YBuf * ExRate2Y1 ) + ( XBuf * ExRate2Y2 ) + yf4 ;
				}
			}

			// ]菈
			Reverse0 =  ( DrawVect[ 1 ].pos.x - DrawVect[ 0 ].pos.x ) * ( DrawVect[ 2 ].pos.y - DrawVect[ 0 ].pos.y ) -
						( DrawVect[ 2 ].pos.x - DrawVect[ 0 ].pos.x ) * ( DrawVect[ 1 ].pos.y - DrawVect[ 0 ].pos.y ) ;
			Reverse1 = -( DrawVect[ 1 ].pos.x - DrawVect[ 3 ].pos.x ) * ( DrawVect[ 2 ].pos.y - DrawVect[ 3 ].pos.y ) +
						( DrawVect[ 1 ].pos.y - DrawVect[ 3 ].pos.y ) * ( DrawVect[ 2 ].pos.x - DrawVect[ 3 ].pos.x ) ;
			if( Reverse0 <= 0 && Reverse1 <= 0 )
			{
				VectBuf = DrawVect[ 1 ] ; DrawVect[ 1 ] = DrawVect[ 2 ] ; DrawVect[ 2 ] = VectBuf ;
			}

			// `I
			if( Reverse0 * Reverse1 >= 0 )
			{
				DrawVect[ 4 ] = DrawVect[ 2 ] ;
				DrawVect[ 5 ] = DrawVect[ 1 ] ;

				// eNX`[`悷
				ADD4VERTEX_TEX
			}
			else
			{
				// w]̕␳
				if( Reverse0 < 0 ) 
				{
					VectBuf = DrawVect[ 1 ] ; DrawVect[ 1 ] = DrawVect[ 2 ] ; DrawVect[ 2 ] = VectBuf ;
				}

				DrawVect[ 4 ] = DrawVect[ 2 ] ;
				DrawVect[ 5 ] = DrawVect[ 1 ] ;

				// eNX`[`悷
				ADD4VERTEX_TEX
			}
		}
		break ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraphF
extern	int		Graphics_D3D11_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	int Flag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// uheNX`t̏ꍇ͓sȂ`֐gp
	if( GSYS.DrawSetting.BlendGraph > 0 ) return Graphics_D3D11_DrawModiGraph( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), _FTOL( x4 ), _FTOL( y4 ), Image, BlendImage, TransFlag, SimpleDrawFlag ) ;

	// `̏
	Flag = TransFlag ;
	DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )

	// eNX`[P݂̂̏ꍇ͏𕪊
	if( Image->Hard.DrawNum == 1 )
	{
		// ̂܂ܕ`
		Graphics_D3D11_DrawModiTex( x1, y1, x2, y2, x3, y3, x4, y4, &Image->Hard.Draw[ 0 ], false ) ;
	}
	else
	{
		IMAGEDATA_HARD_DRAW *DrawTex ;
		IMAGEDATA_HARD_VERT *TexVect ;
		int DrawTexNum ;
		int i, j ;
		double xx1, yy1, xx2, yy2, xx3, yy3, xx4, yy4, xt1, yt1, xt2, yt2 ;
		double w, h, r ;
		float x[4], y[4], *xp, *yp ;

		xx1 = x2 - x1 ; xx2 = x4 - x3 ;
		yy1 = y2 - y1 ; yy2 = y4 - y3 ;

		xx3 = x3 - x1 ; xx4 = x4 - x2 ;
		yy3 = y3 - y1 ; yy4 = y4 - y2 ;
		
//		w = 1.0F / (float)Image->Width ;
//		h = 1.0F / (float)Image->Height ;
		w = 1.0F / (double)Image->Width ;
		h = 1.0F / (double)Image->Height ;

		// `̐Zbg
		DrawTexNum = Image->Hard.DrawNum ;

		// `z̃AhXZbgĂ
		DrawTex = Image->Hard.Draw ;

		// eNX`[̐JԂ
		for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
		{
			// eNX`[̃f[^AhX擾
			TexVect = DrawTex->Vertex ;

			// WZo
			xp = x ;
			yp = y ;
			for( j = 0 ; j < 4 ; j ++, TexVect ++ )
			{
				r = TexVect->y * h ;
				xt1 = x1 + xx3 * r ;	yt1 = y1 + yy3 * r ;
				xt2 = x2 + xx4 * r ;	yt2 = y2 + yy4 * r ;

				r = TexVect->x * w ;
				*xp++ = (float)( ( xt2 - xt1 ) * r + xt1 ) ;
				*yp++ = (float)( ( yt2 - yt1 ) * r + yt1 ) ;
			}

			// `
			Graphics_D3D11_DrawModiTex( x[0], y[0], x[1], y[1], x[2], y[2], x[3], y[3], DrawTex, false ) ;
		}
	}

	// I
	return 0 ;
}

// QzIɔzuꂽ_f[^𒸓_obt@ɒǉ
static int D3D11_Graphics_SetPlaneVertexHardware( VERTEX_2D *GraphVert, int xnum, int ynum )
{
	int i, j, k, l ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return 0 ;

	if( xnum < 2 || ynum < 2 ) return -1 ;

	// gCAOXg[h̏ꍇ̓obt@͎gpȂ
	DRAWSTOCKINFO

	// obt@gpȂݒɂȂĂ炱̏ŕ`
	{
#define MAX_POSNUM		1000
		WORD list[MAX_POSNUM] ;

		// _CfbNXXg쐬
		k = 0 ;
		l = 0 ;
		for( i = 0 ; i < ynum - 1 ; i ++ )
		{
			// _`
			if( k + xnum * 2 + 2 > MAX_POSNUM )
			{
				Graphics_D3D11_CommonBuffer_DrawIndexedPrimitive(
					D3D11_VERTEX_INPUTLAYOUT_2D,
					D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP,
					GraphVert,
					xnum * ynum,
					list,
					k,
					D_DXGI_FORMAT_R16_UINT
				) ;
					
				k = 0 ;
			}

			// O̍s̑ꍇ̓Xgbv̘Ap̒_o		
			if( k != 0 )
			{
				list[k] = ( WORD )( l + xnum ) ;
				k ++ ;
			}
			
			for( j = 0 ; j < xnum ; j ++, l ++ )
			{
				list[k] = ( WORD )( l + xnum ) ;
				list[k+1] = ( WORD )l ;
				k += 2 ;
			}
			if( i != ynum - 2 )
			{
				list[k] = list[k-1] ;
				k ++ ;
			}
		}
		if( k != 0 )
		{
			Graphics_D3D11_CommonBuffer_DrawIndexedPrimitive(
				D3D11_VERTEX_INPUTLAYOUT_2D,
				D_D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP,
				GraphVert,
				xnum * ynum,
				list,
				k,
				D_DXGI_FORMAT_R16_UINT
			) ;
		}
#undef	MAX_POSNUM
	}

	// I
	return 0 ;
}

// eNX`ό`ĕ`悷
extern	void	Graphics_D3D11_DrawModiTex( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA_HARD_DRAW *DrawTex, bool SimpleDrawFlag )
{
	IMAGEDATA_HARD_VERT *TexVect ;
	VERTEX_2D *vec ; 
	VERTEX_2D VectBuf[2] ;
	float xx1, yy1, xx2, yy2, xx3, yy3, xx4, yy4/*, r1, r2, r3, r4*/ ;
//	float xtmp1, ytmp1, xtmp2, ytmp2 ;
	int c, f1, f2, DiffuseColor ;
	float Reverse0, Reverse1;
	DWORD drawz ;

	// `悷eNX`[̃Zbg
	Graphics_D3D11_DrawSetting_SetTexture( DrawTex->Tex->PF->D3D11.Texture, DrawTex->Tex->PF->D3D11.TextureSRV ) ;
	Graphics_D3D11_DeviceState_NormalDrawSetup() ;

	// _f[^擾îƂF̃Zbĝ݁j
	DiffuseColor = GD3D11.Device.DrawInfo.DiffuseColor ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	TexVect = DrawTex->Vertex ;

	// ]p
	Reverse0 =  ( x2 - x1 ) * ( y3 - y1 ) - ( x3 - x1 ) * ( y2 - y1 ) ;
	Reverse1 = -( x2 - x4 ) * ( y3 - y4 ) + ( y2 - y4 ) * ( x3 - x4 ) ;

	if( SimpleDrawFlag ) goto R1 ;

	// slӌ`ȏ̕ό`NĂȂ畁ʂ̏s
	f1 = f2 = c = 0 ;
	xx1 = x2 - x1 ; xx2 = x4 - x3 ;
	yy1 = y2 - y1 ; yy2 = y4 - y3 ;

	xx3 = x3 - x1 ; xx4 = x4 - x2 ;
	yy3 = y3 - y1 ; yy4 = y4 - y2 ;

	if( _FABS( xx1 - xx2 ) < 1.0F && _FABS( yy1 - yy2 ) < 1.0F ) c ++, f1 = 1 ;
	if( _FABS( xx3 - xx4 ) < 1.0F && _FABS( yy3 - yy4 ) < 1.0F ) c ++, f2 = 1 ;
	if( c == 2 ) goto R1 ;

/*
	// `SȎRlp`𔻒
	f1 = f2 = c = 0 ;
	r1 = _SQRT( xx1 * xx1 + yy1 * yy1 ) ;	xtmp1 = xx1 / r1 ;	ytmp1 = yy1 / r1 ;
	r2 = _SQRT( xx2 * xx2 + yy2 * yy2 ) ;	xtmp2 = xx2 / r2 ;	ytmp2 = yy2 / r2 ;
	if( _FABS( xtmp1 - xtmp2 ) < 0.001F && _FABS( ytmp1 - ytmp2 ) < 0.001F ) c ++, f1 = 1 ;
	
	r3 = _SQRT( xx3 * xx3 + yy3 * yy3 ) ;	xtmp1 = xx3 / r3 ;	ytmp1 = yy3 / r3 ;
	r4 = _SQRT( xx4 * xx4 + yy4 * yy4 ) ;	xtmp2 = xx4 / r4 ;	ytmp2 = yy4 / r4 ;
	if( _FABS( xtmp1 - xtmp2 ) < 0.001F && _FABS( ytmp1 - ytmp2 ) < 0.001F ) c ++, f2 = 1 ;
*/

	{
#define TDIVNUM		5
#define TDN			(1 + ( 1 << TDIVNUM ))
#define ADJUSTUV	(0.001f)
		int DivNum, tdn ;
		static VERTEX_2D VectData2[TDN * TDN] ;
		VERTEX_2D *v ;
		float xxx1, yyy1, xxx2, yyy2, xxx3, yyy3 ;
		float adx1, ady1, adx2, ady2, adx3, ady3, adtu, adtv, tu, tv ; 
		int i, j ;
		float adjust_u_l, adjust_u_r, adjust_v_t, adjust_v_b ;

		// 摜̏ꍇׂ̉摜̃sNZȂ߂̕␳tul쐬
		{
			if( TexVect[ 0 ].u < 0.000001f )
			{
				adjust_u_l = 0.0f ;
			}
			else
			{
				adjust_u_l =  ( TexVect[ 3 ].u - TexVect[ 0 ].u ) / ( TexVect[ 3 ].x - TexVect[ 0 ].x ) * ADJUSTUV ;
			}

			if( TexVect[ 3 ].u > 0.99999f )
			{
				adjust_u_r = 0.0f ;
			}
			else
			{
				adjust_u_r = -( TexVect[ 3 ].u - TexVect[ 0 ].u ) / ( TexVect[ 3 ].x - TexVect[ 0 ].x ) * ADJUSTUV ;
			}

			if( TexVect[ 0 ].v < 0.000001f )
			{
				adjust_v_t = 0.0f ;
			}
			else
			{
				adjust_v_t =  ( TexVect[ 3 ].v - TexVect[ 0 ].v ) / ( TexVect[ 3 ].y - TexVect[ 0 ].y ) * ADJUSTUV ;
			}

			if( TexVect[ 3 ].v > 0.99999f )
			{
				adjust_v_b = 0.0f ;
			}
			else
			{
				adjust_v_b = -( TexVect[ 3 ].v - TexVect[ 0 ].v ) / ( TexVect[ 3 ].y - TexVect[ 0 ].y ) * ADJUSTUV ;
			}
		}

		// ̎Zo
		{
			float v1x, v1y, v2x, v2y ;
			float rate ;
			const float Table[] = { 2.0F, 1.0F, 0.6F, 0.1F, 0.05F } ;

			v1x = x4 - x1 ;		v1y = y4 - y1 ;
			v2x = x3 - x2 ;		v2y = y3 - y2 ;
			rate = (float)( 
				( _SQRT( v1x * v1x + v1y * v1y ) + _SQRT( v2x * v2x + v2y * v2y ) ) /
				( ( _SQRT( (float)( GSYS.DrawSetting.DrawSizeX * GSYS.DrawSetting.DrawSizeX + 
						GSYS.DrawSetting.DrawSizeY * GSYS.DrawSetting.DrawSizeY ) ) * 2 ) ) ) ;
			tdn = 8 ;
			if( tdn < 8 ) tdn = 8 ;
			else if( tdn > TDN ) tdn = TDN ;
			for( DivNum = TDIVNUM ; DivNum > 0 && rate < Table[TDIVNUM - DivNum] ; DivNum -- ){}
		}

		// Rlp`
		adx1 = xx3 / ( tdn - 1 ) ;	ady1 = yy3 / ( tdn - 1 ) ;
		adx2 = xx4 / ( tdn - 1 ) ;	ady2 = yy4 / ( tdn - 1 ) ;
		xxx1 = x1 ;		yyy1 = y1 ;
		xxx2 = x2 ;		yyy2 = y2 ;
		adtu = ( ( TexVect[3].u + adjust_u_r ) - ( TexVect[0].u + adjust_u_l ) ) / ( tdn - 1 ) ;
		adtv = ( ( TexVect[3].v + adjust_v_b ) - ( TexVect[0].v + adjust_v_t ) ) / ( tdn - 1 ) ;
		tv = TexVect[0].v + adjust_v_t ;
		v = VectData2 ;
		for( i = 0 ; i < tdn ; i ++, tv += adtv,
									 xxx1 += adx1, yyy1 += ady1,
									 xxx2 += adx2, yyy2 += ady2 )
		{
			adx3 = ( xxx2 - xxx1 ) / ( tdn - 1 ) ;
			ady3 = ( yyy2 - yyy1 ) / ( tdn - 1 ) ;

//			xxx3 = xxx1 - 0.5F ;	yyy3 = yyy1 - 0.5F ;
			xxx3 = xxx1 ;
			yyy3 = yyy1 ;
			tu = TexVect[0].u + adjust_u_l ;
			for( j = 0 ; j < tdn ; j ++, tu += adtu,
										 xxx3 += adx3, yyy3 += ady3, v ++ )
			{
				v->pos.x = (float)xxx3 ;
				v->pos.y = (float)yyy3 ;
				*((DWORD *)&v->pos.z) = drawz ;
				v->rhw   = 1.0F ;
				v->u     = (float)tu ;
				v->v     = (float)tv ;
				v->color = DiffuseColor ;
			}
		}

		// _ǉ
		D3D11_Graphics_SetPlaneVertexHardware( VectData2, tdn, tdn ) ;

#undef TDIVNUM
#undef TDN
	}

	return ;
		
R1 :
	// ʂɕ`
	GETVERTEX_QUAD( vec )

	vec[0].color =
	vec[1].color =
	vec[2].color =
	vec[3].color =
	vec[4].color =
	vec[5].color = DiffuseColor ;

	vec[0].pos.x = x1 ;	
	vec[5].pos.x = vec[1].pos.x = x2 ;	
	vec[4].pos.x = vec[2].pos.x = x3 ;
	vec[3].pos.x = x4 ;
	
	vec[0].pos.y = y1 ;
	vec[5].pos.y = vec[1].pos.y = y2 ;
	vec[4].pos.y = vec[2].pos.y = y3 ;
	vec[3].pos.y = y4 ;

	vec[4].u = vec[2].u = vec[0].u = TexVect[0].u + 0.0625f / DrawTex->Tex->TexWidth ;
	vec[5].u = vec[3].u = vec[1].u = TexVect[1].u - 0.0625f / DrawTex->Tex->TexWidth ;
	vec[5].v = vec[1].v = vec[0].v = TexVect[0].v + 0.0625f / DrawTex->Tex->TexHeight ;
	vec[4].v = vec[3].v = vec[2].v = TexVect[2].v - 0.0625f / DrawTex->Tex->TexHeight ;

	*((DWORD *)&vec[0].pos.z) =
	*((DWORD *)&vec[1].pos.z) =
	*((DWORD *)&vec[2].pos.z) =
	*((DWORD *)&vec[3].pos.z) =
	*((DWORD *)&vec[4].pos.z) =
	*((DWORD *)&vec[5].pos.z) = drawz;

	vec[0].rhw =
	vec[1].rhw =
	vec[2].rhw =
	vec[3].rhw =
	vec[4].rhw =
	vec[5].rhw = 1.0f ;

	if( Reverse0 <= 0  &&  Reverse1 <= 0 )
	{
		VectBuf[ 0 ] = vec[ 1 ] ;
		VectBuf[ 1 ] = vec[ 4 ] ;
		vec[ 1 ]     = vec[ 2 ] ;
		vec[ 4 ]     = vec[ 5 ] ;
		vec[ 2 ]     = VectBuf[ 0 ] ;
		vec[ 5 ]     = VectBuf[ 1 ] ;
	}

	ADD4VERTEX_TEX
}

// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_D3D11_DrawFillBox( int x1, int y1, int x2, int y2, int Color )
{
	VERTEX_NOTEX_2D *vec ;
	RECT drect ;
	int Red, Green, Blue, Flag ;
	DWORD drawz;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// ]
	{
		int b ;

		if( x1 > x2 ){ b = x1 ; x1 = x2 ; x2 = b ; }
		if( y1 > y2 ){ b = y1 ; y1 = y2 ; y2 = b ; }
	}
	
	// NbsO
	{
		drect.left   = x1 ;
		drect.right  = x2 ;
		drect.top    = y1 ;
		drect.bottom = y2 ;
		RectClipping( &drect, &GSYS.DrawSetting.DrawArea ) ;
		if( drect.left == drect.right || drect.top == drect.bottom ) return 0 ;
	}

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag ) ;

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// _f[^̃Zbg
	GETVERTEX_QUAD( vec )
	
	vec[0].color =
	vec[1].color =
	vec[2].color =
	vec[3].color =
	vec[4].color =
	vec[5].color = Color ;
	
	vec[4].pos.x = vec[2].pos.x = vec[0].pos.x = (float)drect.left   ;
	vec[5].pos.x = vec[3].pos.x = vec[1].pos.x = (float)drect.right  ;
	vec[5].pos.y = vec[1].pos.y = vec[0].pos.y = (float)drect.top    ;
	vec[4].pos.y = vec[3].pos.y = vec[2].pos.y = (float)drect.bottom ;

	*((DWORD *)&vec[0].pos.z) =
	*((DWORD *)&vec[1].pos.z) =
	*((DWORD *)&vec[2].pos.z) =
	*((DWORD *)&vec[3].pos.z) =
	*((DWORD *)&vec[4].pos.z) =
	*((DWORD *)&vec[5].pos.z) = drawz;

	vec[0].rhw =
	vec[1].rhw =
	vec[2].rhw =
	vec[3].rhw =
	vec[4].rhw =
	vec[5].rhw = 1.0f ;

	// _f[^̏o
	ADD4VERTEX_NOTEX

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLineBox
extern	int		Graphics_D3D11_DrawLineBox( int x1, int y1, int x2, int y2, int Color )
{
	VERTEX_NOTEX_2D *VectData ;
	int Red, Green, Blue ;
	float fx1, fx2, fy1, fy2 ;
	int Flag;
	DWORD drawz ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag ) ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// ]
	{
		int bx, by ;

		if( x1 > x2 || y1 > y2 )
		{
			bx = x1 ; by = y1 ;
			x1 = x2 ; y1 = y2 ;
			x2 = bx ; y2 = by ;
		}
	}

	fx1 = (float)x1 ;
	fy1 = (float)y1 ;
	fx2 = (float)x2 ;
	fy2 = (float)y2 ;

	GETVERTEX_LINEBOX( VectData ) ;
	VectData[ 0].color = VectData[ 1].color = VectData[ 2].color = VectData[ 3].color = VectData[ 4].color = VectData[ 5].color =
	VectData[ 6].color = VectData[ 7].color = VectData[ 8].color = VectData[ 9].color = VectData[10].color = VectData[11].color =
	VectData[12].color = VectData[13].color = VectData[14].color = VectData[15].color = VectData[16].color = VectData[17].color =
	VectData[18].color = VectData[19].color = VectData[20].color = VectData[21].color = VectData[22].color = VectData[23].color = Color ;

	*((DWORD *)&VectData[ 0].pos.z) = *((DWORD *)&VectData[ 1].pos.z) = *((DWORD *)&VectData[ 2].pos.z) = *((DWORD *)&VectData[ 3].pos.z) = *((DWORD *)&VectData[ 4].pos.z) = *((DWORD *)&VectData[ 5].pos.z) =
	*((DWORD *)&VectData[ 6].pos.z) = *((DWORD *)&VectData[ 7].pos.z) = *((DWORD *)&VectData[ 8].pos.z) = *((DWORD *)&VectData[ 9].pos.z) = *((DWORD *)&VectData[10].pos.z) = *((DWORD *)&VectData[11].pos.z) =
	*((DWORD *)&VectData[12].pos.z) = *((DWORD *)&VectData[13].pos.z) = *((DWORD *)&VectData[14].pos.z) = *((DWORD *)&VectData[15].pos.z) = *((DWORD *)&VectData[16].pos.z) = *((DWORD *)&VectData[17].pos.z) =
	*((DWORD *)&VectData[18].pos.z) = *((DWORD *)&VectData[19].pos.z) = *((DWORD *)&VectData[20].pos.z) = *((DWORD *)&VectData[21].pos.z) = *((DWORD *)&VectData[22].pos.z) = *((DWORD *)&VectData[23].pos.z) = drawz;

	VectData[ 0].rhw = VectData[ 1].rhw = VectData[ 2].rhw = VectData[ 3].rhw = VectData[ 4].rhw = VectData[ 5].rhw =
	VectData[ 6].rhw = VectData[ 7].rhw = VectData[ 8].rhw = VectData[ 9].rhw = VectData[10].rhw = VectData[11].rhw =
	VectData[12].rhw = VectData[13].rhw = VectData[14].rhw = VectData[15].rhw = VectData[16].rhw = VectData[17].rhw =
	VectData[18].rhw = VectData[19].rhw = VectData[20].rhw = VectData[21].rhw = VectData[22].rhw = VectData[23].rhw = 1.0f ;

	VectData[0].pos.x = fx1			; VectData[0].pos.y = fy1		 ;
	VectData[1].pos.x = fx2			; VectData[1].pos.y = fy1		 ;
	VectData[2].pos.x = fx1			; VectData[2].pos.y = fy1 + 1.0f ;

	VectData[3].pos.x = fx2			; VectData[3].pos.y = fy1 + 1.0f ;
	VectData[4].pos.x = fx1			; VectData[4].pos.y = fy1 + 1.0f ;
	VectData[5].pos.x = fx2			; VectData[5].pos.y = fy1		 ;

	VectData += 6 ;


	VectData[0].pos.x = fx2 - 1.0f	; VectData[0].pos.y = fy1 + 1.0f ;
	VectData[1].pos.x = fx2			; VectData[1].pos.y = fy1 + 1.0f ;
	VectData[2].pos.x = fx2	- 1.0f	; VectData[2].pos.y = fy2		 ;

	VectData[3].pos.x = fx2			; VectData[3].pos.y = fy2		 ;
	VectData[4].pos.x = fx2 - 1.0f	; VectData[4].pos.y = fy2		 ;
	VectData[5].pos.x = fx2			; VectData[5].pos.y = fy1 + 1.0f ;

	VectData += 6 ;


	VectData[0].pos.x = fx1			; VectData[0].pos.y = fy1 + 1.0f ;
	VectData[1].pos.x = fx1 + 1.0f	; VectData[1].pos.y = fy1 + 1.0f ;
	VectData[2].pos.x = fx1			; VectData[2].pos.y = fy2		 ;

	VectData[3].pos.x = fx1 + 1.0f	; VectData[3].pos.y = fy2		 ;
	VectData[4].pos.x = fx1			; VectData[4].pos.y = fy2		 ;
	VectData[5].pos.x = fx1 + 1.0f	; VectData[5].pos.y = fy1 + 1.0f ;

	VectData += 6 ;


	VectData[0].pos.x = fx1 + 1.0f	; VectData[0].pos.y = fy2 - 1.0f ;
	VectData[1].pos.x = fx2 - 1.0f	; VectData[1].pos.y = fy2 - 1.0f ;
	VectData[2].pos.x = fx1 + 1.0f	; VectData[2].pos.y = fy2		 ;

	VectData[3].pos.x = fx2 - 1.0f	; VectData[3].pos.y = fy2		 ;
	VectData[4].pos.x = fx1 + 1.0f	; VectData[4].pos.y = fy2		 ;
	VectData[5].pos.x = fx2 - 1.0f	; VectData[5].pos.y = fy2 - 1.0f ;

	VectData += 6 ;

	// _̒ǉ
	ADD4VERTEX_LINEBOX

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_D3D11_DrawLine( int x1, int y1, int x2, int y2, int Color )
{
	VERTEX_NOTEX_2D *VectData ;
	int Red, Green, Blue, Flag ;
	DWORD drawz ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	} 

	if( x2 - x1 == 0 && y2 - y1 == 0 ) return 0 ; 

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// FZbg
	GETVERTEX_LINE( VectData ) ;
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;
	VectData[ 0 ].color = Color ;
	VectData[ 1 ].color = Color ;
	*((DWORD *)&VectData[ 0 ].pos.z) =
	*((DWORD *)&VectData[ 1 ].pos.z) = drawz;
	VectData[ 0 ].rhw =
	VectData[ 1 ].rhw = 1.0f ;

	// WZbg
	VectData[ 0 ].pos.x = ( float )( x1 ) ;
	VectData[ 0 ].pos.y = ( float )( y1 ) ;

	VectData[ 1 ].pos.x = ( float )( x2 ) ;
	VectData[ 1 ].pos.y = ( float )( y2 ) ;

	// W̕␳
	if( x1 == x2 ) VectData[ 1 ].pos.y += y2 > y1 ? -0.1F : 0.1F ;
	if( y1 == y2 ) VectData[ 1 ].pos.x += x2 > x1 ? -0.1F : 0.1F ;

	// _̒ǉ
	ADD4VERTEX_LINE

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_D3D11_DrawLine3D( VECTOR Pos1, VECTOR Pos2, int Color, int DrawFlag, RECT *DrawArea )
{
	VERTEX_NOTEX_3D *VectData ;
	int Red, Green, Blue, Flag ;

	if( DrawFlag )
	{
		if( Graphics_Hardware_CheckValid_PF() == 0 )
		{
			return -1 ;
		}

		// `̏
		Flag = DX_D3D11_DRAWPREP_DIFFUSERGB | DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG ;
		DX_D3D11_DRAWPREP_NOTEX( Flag )

		GETVERTEX_LINE3D( VectData ) ;

		// FZbg
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
				( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
				( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
				( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;
		*( ( int * )&VectData[ 0 ].b ) = Color ;
		*( ( int * )&VectData[ 1 ].b ) = Color ;

		// WZbg
		VectData[ 0 ].pos = Pos1 ;
		VectData[ 1 ].pos = Pos2 ;

		// _̒ǉ
		ADD4VERTEX_LINE3D
	}
	else
	{
		VERTEX_2D TempVect[ 2 ] ;
		float dleft, dright, dtop, dbottom ;

		dleft   = -100000000.0f ;
		dright  =  100000000.0f ;
		dtop    = -100000000.0f ;
		dbottom =  100000000.0f ;

		// XN[Wɕϊ
		TempVect[0].pos.x = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
		TempVect[0].pos.y = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
		TempVect[0].pos.z = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
		TempVect[0].rhw   = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

		TempVect[1].pos.x = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
		TempVect[1].pos.y = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
		TempVect[1].pos.z = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
		TempVect[1].rhw   = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

		TempVect[0].rhw = 1.0F / TempVect[0].rhw ;
		TempVect[0].pos.x *= TempVect[0].rhw ;
		TempVect[0].pos.y *= TempVect[0].rhw ;
		TempVect[0].pos.z *= TempVect[0].rhw ;

		TempVect[1].rhw = 1.0F / TempVect[1].rhw ;
		TempVect[1].pos.x *= TempVect[1].rhw ;
		TempVect[1].pos.y *= TempVect[1].rhw ;
		TempVect[1].pos.z *= TempVect[1].rhw ;

		if( dright  > TempVect[ 0 ].pos.x ) dright  = TempVect[ 0 ].pos.x ;
		if( dright  > TempVect[ 1 ].pos.x ) dright  = TempVect[ 1 ].pos.x ;

		if( dleft   < TempVect[ 0 ].pos.x ) dleft   = TempVect[ 0 ].pos.x ;
		if( dleft   < TempVect[ 1 ].pos.x ) dleft   = TempVect[ 1 ].pos.x ;

		if( dbottom > TempVect[ 0 ].pos.y ) dbottom = TempVect[ 0 ].pos.y ;
		if( dbottom > TempVect[ 1 ].pos.y ) dbottom = TempVect[ 1 ].pos.y ;

		if( dtop    < TempVect[ 0 ].pos.y ) dtop    = TempVect[ 0 ].pos.y ;
		if( dtop    < TempVect[ 1 ].pos.y ) dtop    = TempVect[ 1 ].pos.y ;

		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}



#define D3D11_CIRCLE_VERTEX_NUM			(2000)

#define DX_D3D11_CIRCLE_THICKNESS											\
	if( x1 < DrawRect.left      ) x1 = DrawRect.left ;						\
	if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																			\
	VectBuf[ VectNum ].pos.x  = ( float )x1 + 0.1f ;						\
	VectBuf[ VectNum ].pos.y  = y1f + 0.1f ;								\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum ++ ;															\
																			\
	VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 ) + 0.1f ;				\
	VectBuf[ VectNum ].pos.y =  y1f + 0.1f ;								\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum  ++ ;															\
																			\
	if( VectNum >= D3D11_CIRCLE_VERTEX_NUM )								\
	{																		\
		Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST, VectBuf, VectNum ) ;\
		VectNum = 0 ;														\
	}																		

// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_D3D11_DrawCircle_Thickness( int x, int y, int r, int Color, int Thickness )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int VectNum ;
	short ( *CirclePos )[ 5 ] ;
	int Red, Green, Blue, Flag ;
	RECT DrawRect ;
	DWORD drawz ;
	int i ;
//	int j ;
	int x1, x2 ;
	float y1f ;

	// Qȉ牽I
	if( Thickness < 2 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `p̊m
	if( Graphics_Other_AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * D3D11_CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GSYS.Resource.CommonBuffer[ 0 ] ;

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// ␳
	DrawRect = GSYS.DrawSetting.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// ~̍Wobt@擾
	if( Graphics_Other_AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GSYS.Resource.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ~̍WXg쐬
	Graphics_Draw_GetCircle_ThicknessDrawPosition( x, y, r, Thickness, CirclePos ) ;

	// `揈
	VectNum = 0 ;
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1f = ( float )i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_D3D11_CIRCLE_THICKNESS
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DX_D3D11_CIRCLE_THICKNESS

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_D3D11_CIRCLE_THICKNESS
		}
	}
	if( VectNum )
	{
		Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST, VectBuf, VectNum ) ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_D3D11_DrawOval_Thickness( int x, int y, int rx, int ry, int Color, int Thickness )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int VectNum ;
	short ( *CirclePos )[ 5 ] ;
	int Red, Green, Blue, Flag ;
	RECT DrawRect ;
	DWORD drawz ;
	int i ;
//	int j ;
	int x1, x2 ;
	float y1f ;

	// Qȉ牽I
	if( Thickness < 2 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `p̊m
	if( Graphics_Other_AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * D3D11_CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GSYS.Resource.CommonBuffer[ 0 ] ;

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// ␳
	DrawRect = GSYS.DrawSetting.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// ~̍Wobt@擾
	if( Graphics_Other_AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GSYS.Resource.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ȉ~̍WXg쐬
	Graphics_Draw_GetOval_ThicknessDrawPosition( x, y, rx, ry, Thickness, CirclePos ) ;

	// `揈
	VectNum = 0 ;
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1f = ( float )i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_D3D11_CIRCLE_THICKNESS
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DX_D3D11_CIRCLE_THICKNESS

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_D3D11_CIRCLE_THICKNESS
		}
	}
	if( VectNum )
	{
		Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST, VectBuf, VectNum ) ;
	}

	// I
	return 0 ;
}




#define DX_D3D11_CIRCLE																	\
			if( !( ( x2 < DrawRect.left ) || ( x1 >= DrawRect.right  ) ||				\
			       ( y1 < DrawRect.top  ) || ( y1 >= DrawRect.bottom ) || LineDrawBuf[ y1 ] ) )		\
			{																			\
				if( x1 < DrawRect.left ) x1 = DrawRect.left ;							\
				if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																						\
				VectBuf[ VectNum ].pos.x  = ( float )x1 + 0.1f ;						\
				VectBuf[ VectNum ].pos.y  = ( float )y1 + 0.1f ;						\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
				LineDrawBuf[y1] = TRUE ;												\
																						\
				VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 ) + 0.1f ;				\
				VectBuf[ VectNum ].pos.y =  ( float )y1 + 0.1f ;						\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum  ++ ;															\
																						\
				if( VectNum >= D3D11_CIRCLE_VERTEX_NUM )								\
				{																		\
					Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST, VectBuf, VectNum ) ;\
					VectNum = 0 ;														\
				}																		\
			}

#define DX_D3D11_CIRCLE_PSET															\
			if( !( ( ( unsigned int )( x1 ) >= ( unsigned int )( DrawRect.right ) ) ||	\
				( y1 < DrawRect.top ) || ( y1 >= DrawRect.bottom ) ) )					\
			{																			\
				VectBuf[ VectNum ].pos.x  = ( float )x1 + 0.1f ;						\
				VectBuf[ VectNum ].pos.y  = ( float )y1 + 0.1f ;						\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
																						\
				if( VectNum >= D3D11_CIRCLE_VERTEX_NUM )								\
				{																		\
					Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_POINTLIST, VectBuf, VectNum ) ;\
					VectNum = 0 ;														\
				}																		\
			}

// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_D3D11_DrawCircle( int x, int y, int r, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int             VectNum ;
	BYTE            *LineDrawBuf ;
	int             Red ;
	int             Green ;
	int             Blue ;
	int             Flag ;
	RECT            DrawRect ;
	DWORD           drawz ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `p̊m
	if( Graphics_Other_AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * D3D11_CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GSYS.Resource.CommonBuffer[ 0 ] ;

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// ␳
	DrawRect = GSYS.DrawSetting.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// `揈
	{
		int Dx, Dy, F/*, i*/, j ;
		int x1, x2, y1 ;

		// lZbg
		Dx = r ; Dy = 0 ; F = -2 * r + 3 ;
		VectNum = 0 ;

		j = 0 ;
		// `Jn
		if( FillFlag )
		{
			if( Graphics_Other_AllocCommonBuffer( 1, DrawRect.bottom ) < 0 )
			{
				return DxLib_Error( DXSTRING( _T( "̊mۂɎs܂ in G_D3D_DrawCircle" ) ) ) ;
			}
			LineDrawBuf = ( BYTE * )GSYS.Resource.CommonBuffer[ 1 ] ;
			_MEMSET( LineDrawBuf, 0, DrawRect.bottom ) ;

			// ŏ̃C`
			{
				x2 = Dx + x ; x1 = -Dx + x ; y1 = Dy + y ;
				DX_D3D11_CIRCLE ;

				// Wf[^i߂
				if( F >= 0 )
				{
					x2 = Dy + x ; x1 = -Dy + x ; y1 = Dx + y ;
					DX_D3D11_CIRCLE ;
					x2 = Dy + x ; x1 = -Dy + x ; y1 = -Dx + y;
					DX_D3D11_CIRCLE ;

					Dx -- ;
					F -= 4 * Dx ;
				}	

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}

			while( Dx >= Dy )
			{
				x2 = Dx + x ; x1 = -Dx + x ; y1 = Dy + y ;
				DX_D3D11_CIRCLE ;
				x2 = Dx + x ; x1 = -Dx + x ; y1 = -Dy + y;
				DX_D3D11_CIRCLE ;

				// Wf[^i߂
				if( F >= 0 )
				{
					x2 = Dy + x ; x1 = -Dy + x ; y1 = Dx + y ;
					DX_D3D11_CIRCLE ;
					x2 = Dy + x ; x1 = -Dy + x ; y1 = -Dx + y;
					DX_D3D11_CIRCLE ;

					Dx -- ;
					F -= 4 * Dx ;
				}

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}
			if( VectNum )
			{
				Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST, VectBuf, VectNum ) ;
			}
		}
		else
		{
			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_D3D11_CIRCLE_PSET ;
				x1 = Dx + x ;  
				DX_D3D11_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = Dx + y ;
				DX_D3D11_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = -Dx + y;
				DX_D3D11_CIRCLE_PSET ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}	

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}

			while( Dx >= Dy )
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_D3D11_CIRCLE_PSET ;
				x1 = Dx + x ;  
				DX_D3D11_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = Dx + y ;
				DX_D3D11_CIRCLE_PSET ;
				x1 = -Dy + x ; 
				DX_D3D11_CIRCLE_PSET ;
			
				x1 = Dx + x ; y1 = -Dy + y;
				DX_D3D11_CIRCLE_PSET ;
				x1 = -Dx + x ; 
				DX_D3D11_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = -Dx + y;
				DX_D3D11_CIRCLE_PSET ;
				x1 = -Dy + x ; 
				DX_D3D11_CIRCLE_PSET ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}
			if( VectNum )
			{
				Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_POINTLIST, VectBuf, VectNum ) ;
			}
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_D3D11_DrawOval( int x, int y, int rx, int ry, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int VectNum ;
	BYTE *LineDrawBuf ;
//	VERTEX_NOTEX_2D *VectData ;
//	int i, j, r2 ;
//	float xd, x2, y2 ;
//	float d, yd ;
	int Red, Green, Blue, Flag ;
	RECT DrawRect ;
	DWORD drawz;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}
	if( !rx || !ry ) return -1 ;

	// `p̊m
	if( Graphics_Other_AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * D3D11_CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GSYS.Resource.CommonBuffer[ 0 ] ;

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// ␳
	if( rx < 0 ) rx *= -1 ;
	if( ry < 0 ) ry *= -1 ;
	DrawRect = GSYS.DrawSetting.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	VectNum = 0 ;

	// `揈
	{
		int Dx, Dy, F, H, j/*, i */ ;
		int x1, x2, y1, Df ;
		int yc, xc, rc, r ;

		j = 0 ;
		// `Jn
		if( FillFlag )
		{
			if( Graphics_Other_AllocCommonBuffer( 1, DrawRect.bottom ) < 0 )
			{
				return DxLib_Error( DXSTRING( _T( "̊mۂɎs܂ in G_D3D_DrawCircle" ) ) ) ;
			}
			LineDrawBuf = ( BYTE * )GSYS.Resource.CommonBuffer[ 1 ] ;
			_MEMSET( LineDrawBuf, 0, DrawRect.bottom ) ;

			if( rx >= ry )
			{
				// lZbg
				rc = ( rx * rx ) / ry ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 1 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̐`
				{
					x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
					DX_D3D11_CIRCLE ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						Df = 1 ;

						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
						DX_D3D11_CIRCLE ;

						y1 = -Dy + y ;
						DX_D3D11_CIRCLE ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̐`
				x1 = -Dx + x ; x2 = Dx + x ; y1 = -Dy + y;
				DX_D3D11_CIRCLE ;
			}
			else
			{
				// lZbg
				rc = ( ry * ry ) / rx ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 2 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̐`
				{
					x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
					DX_D3D11_CIRCLE ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
						DX_D3D11_CIRCLE ;

						y1 = -Dy + y ;
						DX_D3D11_CIRCLE ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̐`
				x1 = -Dx + x ; x2 = Dx + x ; y1 = -Dy + y;
				DX_D3D11_CIRCLE ;
			}
			if( VectNum )
			{
				Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_LINELIST, VectBuf, VectNum ) ;
			}
		}
		else
		{
			if( rx >= ry )
			{
				// lZbg
				rc = ( rx * rx ) / ry ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 2 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̓_`
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_D3D11_CIRCLE_PSET ;
					x1 = Dx + x ;  
					DX_D3D11_CIRCLE_PSET ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						Df = 1 ;

						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; y1 = Dy + y ;
						DX_D3D11_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_D3D11_CIRCLE_PSET ;

						x1 = -Dx + x ; y1 = -Dy + y ;
						DX_D3D11_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_D3D11_CIRCLE_PSET ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						Df = 1 ;

						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̓_`
				x1 = Dx + x ; y1 = -Dy + y;
				DX_D3D11_CIRCLE_PSET ;

				x1 = -Dx + x ; y1 = Dy + y ;
				DX_D3D11_CIRCLE_PSET ;
			}
			else
			{
				// lZbg
				rc = ( ry * ry ) / rx ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 2 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̓_`
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_D3D11_CIRCLE_PSET ;
					x1 = Dx + x ;  
					DX_D3D11_CIRCLE_PSET ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
								Df = 1 ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; y1 = Dy + y ;
						DX_D3D11_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_D3D11_CIRCLE_PSET ;

						x1 = -Dx + x ; y1 = -Dy + y ;
						DX_D3D11_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_D3D11_CIRCLE_PSET ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
								Df = 1 ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̓_`
				x1 = Dx + x ; y1 = -Dy + y;
				DX_D3D11_CIRCLE_PSET ;

				x1 = -Dx + x ; y1 = Dy + y ;
				DX_D3D11_CIRCLE_PSET ;
			}
			if( VectNum )
			{
				Graphics_D3D11_CommonBuffer_DrawPrimitive( D3D11_VERTEX_INPUTLAYOUT_NOTEX_2D, D_D3D11_PRIMITIVE_TOPOLOGY_POINTLIST, VectBuf, VectNum ) ;
			}
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_D3D11_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D *vec ; 
	int Red, Green, Blue ;
	int Flag ;
	int sx1, sx2, sy1, sy2 ;
	DWORD drawz;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// Cǂŏ𕪊
	if( FillFlag )
	{
		GETVERTEX_TRIANGLE( vec ) ;

		vec[ 0 ].color =
		vec[ 1 ].color =
		vec[ 2 ].color = Color ;

		vec[ 0 ].pos.x = ( float )x1 ; vec[ 0 ].pos.y = ( float )y1 ;

		// JOLɂȂĂꍇ̓JOȂ悤ɂ
		switch( GSYS.DrawSetting.CullMode )
		{
		case 0 :	// JOȂ
			vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
			vec[ 2 ].pos.x = ( float )x3 ; vec[ 2 ].pos.y = ( float )y3 ;
			break ;

		case 1 :	// JO
			sx1 = x2 - x1 ;		sy1 = y2 - y1 ;
			sx2 = x3 - x1 ;		sy2 = y3 - y1 ;
			if( sx1 * sy2 - sy1 * sx2 > 0 )
			{
				vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
				vec[ 2 ].pos.x = ( float )x3 ; vec[ 2 ].pos.y = ( float )y3 ;
			}
			else
			{
				vec[ 1 ].pos.x = ( float )x3 ; vec[ 1 ].pos.y = ( float )y3 ;
				vec[ 2 ].pos.x = ( float )x2 ; vec[ 2 ].pos.y = ( float )y2 ;
			}
			break ;

		case 2 :	// EJO
			sx1 = x2 - x1 ;		sy1 = y2 - y1 ;
			sx2 = x3 - x1 ;		sy2 = y3 - y1 ;
			if( sx1 * sy2 - sy1 * sx2 < 0 )
			{
				vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
				vec[ 2 ].pos.x = ( float )x3 ; vec[ 2 ].pos.y = ( float )y3 ;
			}
			else
			{
				vec[ 1 ].pos.x = ( float )x3 ; vec[ 1 ].pos.y = ( float )y3 ;
				vec[ 2 ].pos.x = ( float )x2 ; vec[ 2 ].pos.y = ( float )y2 ;
			}
			break ;
		}

		*( ( DWORD * )&vec[ 0 ].pos.z ) =
		*( ( DWORD * )&vec[ 1 ].pos.z ) =
		*( ( DWORD * )&vec[ 2 ].pos.z ) = drawz ;

		vec[ 0 ].rhw =
		vec[ 1 ].rhw =
		vec[ 2 ].rhw = 1.0f ;

		ADD3VERTEX_NOTEX
	}
	else
	{
		GETVERTEX_LINETRIANGLE( vec )

		vec[ 0 ].color =
		vec[ 1 ].color =
		vec[ 2 ].color =
		vec[ 3 ].color =
		vec[ 4 ].color =
		vec[ 5 ].color = Color ;

		vec[ 0 ].pos.x = ( float )x1 ; vec[ 0 ].pos.y = ( float )y1 ;
		vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
		vec[ 2 ].pos.x = ( float )x2 ; vec[ 2 ].pos.y = ( float )y2 ;
		vec[ 3 ].pos.x = ( float )x3 ; vec[ 3 ].pos.y = ( float )y3 ;
		vec[ 4 ].pos.x = ( float )x3 ; vec[ 4 ].pos.y = ( float )y3 ;
		vec[ 5 ].pos.x = ( float )x1 ; vec[ 5 ].pos.y = ( float )y1 ;
		*( ( DWORD * )&vec[ 0 ].pos.z ) =
		*( ( DWORD * )&vec[ 1 ].pos.z ) =
		*( ( DWORD * )&vec[ 2 ].pos.z ) =
		*( ( DWORD * )&vec[ 3 ].pos.z ) =
		*( ( DWORD * )&vec[ 4 ].pos.z ) =
		*( ( DWORD * )&vec[ 5 ].pos.z ) = drawz ;

		vec[ 0 ].rhw =
		vec[ 1 ].rhw =
		vec[ 2 ].rhw =
		vec[ 3 ].rhw =
		vec[ 4 ].rhw =
		vec[ 5 ].rhw = 1.0f ;

		ADD4VERTEX_LINETRIANGLE
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_D3D11_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag, int DrawFlag, RECT *DrawArea )
{
	VERTEX_NOTEX_3D *vec ; 
	int Red, Green, Blue ;
	int Flag ;

	if( DrawFlag )
	{
		if( Graphics_Hardware_CheckValid_PF() == 0 )
		{
			return -1 ;
		}

		// `̏
		Flag = DX_D3D11_DRAWPREP_DIFFUSERGB | DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG | DX_D3D11_DRAWPREP_CULLING ;
		DX_D3D11_DRAWPREP_NOTEX( Flag )

		// F̑Xe[^X̃Zbg
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
				( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
				( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
				( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

		// Cǂŏ𕪊
		if( FillFlag )
		{
			GETVERTEX_TRIANGLE3D( vec ) ;

			*( ( DWORD * )&vec[ 0 ].b ) =
			*( ( DWORD * )&vec[ 1 ].b ) =
			*( ( DWORD * )&vec[ 2 ].b ) = ( DWORD )Color ;
			vec[ 0 ].pos = Pos1 ;
			vec[ 1 ].pos = Pos2 ;
			vec[ 2 ].pos = Pos3 ;

			ADD3VERTEX_NOTEX3D
		}
		else
		{
			GETVERTEX_LINETRIANGLE3D( vec )

			*( ( DWORD * )&vec[ 0 ].b ) =
			*( ( DWORD * )&vec[ 1 ].b ) =
			*( ( DWORD * )&vec[ 2 ].b ) =
			*( ( DWORD * )&vec[ 3 ].b ) =
			*( ( DWORD * )&vec[ 4 ].b ) =
			*( ( DWORD * )&vec[ 5 ].b ) = ( DWORD )Color ;

			vec[ 0 ].pos = Pos1 ;
			vec[ 1 ].pos = Pos2 ;
			vec[ 2 ].pos = Pos2 ;
			vec[ 3 ].pos = Pos3 ;
			vec[ 4 ].pos = Pos3 ;
			vec[ 5 ].pos = Pos1 ;

			ADD4VERTEX_LINETRIANGLE3D
		}
	}
	else
	{
		VERTEX_2D TempVect[ 3 ] ;
		float dleft, dright, dtop, dbottom ;

		dleft   =  100000000.0f ;
		dright  = -100000000.0f ;
		dtop    =  100000000.0f ;
		dbottom = -100000000.0f ;

		// XN[Wɕϊ
		TempVect[0].pos.x = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
		TempVect[0].pos.y = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
		TempVect[0].pos.z = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
		TempVect[0].rhw   = Pos1.x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + Pos1.y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + Pos1.z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

		TempVect[1].pos.x = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
		TempVect[1].pos.y = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
		TempVect[1].pos.z = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
		TempVect[1].rhw   = Pos2.x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + Pos2.y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + Pos2.z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

		TempVect[2].pos.x = Pos3.x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + Pos3.y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + Pos3.z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
		TempVect[2].pos.y = Pos3.x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + Pos3.y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + Pos3.z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
		TempVect[2].pos.z = Pos3.x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + Pos3.y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + Pos3.z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
		TempVect[2].rhw   = Pos3.x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + Pos3.y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + Pos3.z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

		TempVect[0].rhw = 1.0F / TempVect[0].rhw ;
		TempVect[0].pos.x *= TempVect[0].rhw ;
		TempVect[0].pos.y *= TempVect[0].rhw ;
		TempVect[0].pos.z *= TempVect[0].rhw ;

		TempVect[1].rhw = 1.0F / TempVect[1].rhw ;
		TempVect[1].pos.x *= TempVect[1].rhw ;
		TempVect[1].pos.y *= TempVect[1].rhw ;
		TempVect[1].pos.z *= TempVect[1].rhw ;

		TempVect[2].rhw = 1.0F / TempVect[2].rhw ;
		TempVect[2].pos.x *= TempVect[2].rhw ;
		TempVect[2].pos.y *= TempVect[2].rhw ;
		TempVect[2].pos.z *= TempVect[2].rhw ;

		if( dright  < TempVect[ 0 ].pos.x ) dright  = TempVect[ 0 ].pos.x ;
		if( dright  < TempVect[ 1 ].pos.x ) dright  = TempVect[ 1 ].pos.x ;
		if( dright  < TempVect[ 2 ].pos.x ) dright  = TempVect[ 2 ].pos.x ;

		if( dleft   > TempVect[ 0 ].pos.x ) dleft   = TempVect[ 0 ].pos.x ;
		if( dleft   > TempVect[ 1 ].pos.x ) dleft   = TempVect[ 1 ].pos.x ;
		if( dleft   > TempVect[ 2 ].pos.x ) dleft   = TempVect[ 2 ].pos.x ;

		if( dbottom < TempVect[ 0 ].pos.y ) dbottom = TempVect[ 0 ].pos.y ;
		if( dbottom < TempVect[ 1 ].pos.y ) dbottom = TempVect[ 1 ].pos.y ;
		if( dbottom < TempVect[ 2 ].pos.y ) dbottom = TempVect[ 2 ].pos.y ;

		if( dtop    > TempVect[ 0 ].pos.y ) dtop    = TempVect[ 0 ].pos.y ;
		if( dtop    > TempVect[ 1 ].pos.y ) dtop    = TempVect[ 1 ].pos.y ;
		if( dtop    > TempVect[ 2 ].pos.y ) dtop    = TempVect[ 2 ].pos.y ;

		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_D3D11_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D *vec ;
	int Red, Green, Blue ;
	int Flag ;
	DWORD drawz;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
			( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
			( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
			( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;

	// hԂǂŏ𕪊
	if( FillFlag )
	{
		// hԂ̏ꍇ

		// _f[^̃Zbg
		GETVERTEX_QUAD( vec )

		vec[0].color =
		vec[1].color =
		vec[2].color =
		vec[3].color = Color ;
		
		vec[ 0 ].pos.x = ( float )x1 ; vec[ 0 ].pos.y = ( float )y1 ;
		vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
		vec[ 2 ].pos.x = ( float )x4 ; vec[ 2 ].pos.y = ( float )y4 ;
		vec[ 3 ].pos.x = ( float )x3 ; vec[ 3 ].pos.y = ( float )y3 ;

		*((DWORD *)&vec[0].pos.z) =
		*((DWORD *)&vec[1].pos.z) =
		*((DWORD *)&vec[2].pos.z) =
		*((DWORD *)&vec[3].pos.z) = drawz;

		vec[0].rhw =
		vec[1].rhw =
		vec[2].rhw =
		vec[3].rhw = 1.0f ;

		vec[ 4 ] = vec[ 2 ] ;
		vec[ 5 ] = vec[ 1 ] ;

		// _f[^̏o
		ADD4VERTEX_NOTEX
	}
	else
	{
		// hԂł͖ꍇ

		GETVERTEX_LINE( vec ) ;

		vec[ 0 ].color = Color ;
		vec[ 1 ].color = Color ;

		*((DWORD *)&vec[ 0 ].pos.z) = drawz;
		*((DWORD *)&vec[ 1 ].pos.z) = drawz;

		vec[ 0 ].rhw =
		vec[ 1 ].rhw = 1.0f ;

		vec[ 0 ].pos.x = ( float )( x1 ) ;
		vec[ 0 ].pos.y = ( float )( y1 ) ;

		vec[ 1 ].pos.x = ( float )( x2 ) ;
		vec[ 1 ].pos.y = ( float )( y2 ) ;

		// _̒ǉ
		ADD4VERTEX_LINE


		GETVERTEX_LINE( vec ) ;

		vec[ 0 ].color = Color ;
		vec[ 1 ].color = Color ;

		*((DWORD *)&vec[ 0 ].pos.z) = drawz;
		*((DWORD *)&vec[ 1 ].pos.z) = drawz;

		vec[ 0 ].rhw =
		vec[ 1 ].rhw = 1.0f ;

		vec[ 0 ].pos.x = ( float )( x2 ) ;
		vec[ 0 ].pos.y = ( float )( y2 ) ;

		vec[ 1 ].pos.x = ( float )( x3 ) ;
		vec[ 1 ].pos.y = ( float )( y3 ) ;

		// _̒ǉ
		ADD4VERTEX_LINE


		GETVERTEX_LINE( vec ) ;

		vec[ 0 ].color = Color ;
		vec[ 1 ].color = Color ;

		*((DWORD *)&vec[ 0 ].pos.z) = drawz;
		*((DWORD *)&vec[ 1 ].pos.z) = drawz;

		vec[ 0 ].rhw =
		vec[ 1 ].rhw = 1.0f ;

		vec[ 0 ].pos.x = ( float )( x3 ) ;
		vec[ 0 ].pos.y = ( float )( y3 ) ;

		vec[ 1 ].pos.x = ( float )( x4 ) ;
		vec[ 1 ].pos.y = ( float )( y4 ) ;

		// _̒ǉ
		ADD4VERTEX_LINE


		GETVERTEX_LINE( vec ) ;

		vec[ 0 ].color = Color ;
		vec[ 1 ].color = Color ;

		*((DWORD *)&vec[ 0 ].pos.z) = drawz;
		*((DWORD *)&vec[ 1 ].pos.z) = drawz;

		vec[ 0 ].rhw =
		vec[ 1 ].rhw = 1.0f ;

		vec[ 0 ].pos.x = ( float )( x4 ) ;
		vec[ 0 ].pos.y = ( float )( y4 ) ;

		vec[ 1 ].pos.x = ( float )( x1 ) ;
		vec[ 1 ].pos.y = ( float )( y1 ) ;

		// _̒ǉ
		ADD4VERTEX_LINE
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_D3D11_DrawPixel( int x, int y, int Color )
{
	VERTEX_NOTEX_2D *VectData ;
	int Red, Green, Blue, Flag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ; 
	}

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// F̑Xe[^X̃Zbg
	GETVERTEX_POINT( VectData ) ;

	if( GD3D11.Device.DrawInfo.DiffuseColor == 0xffffffff )
	{
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		VectData->color = 0xff000000 | ( Red << 16 ) | ( Green << 8 ) | ( Blue ) ;
	}
	else
	{
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		VectData->color =
				( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
				( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
				( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
				( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;
	}

	// W̃Zbg
	VectData->pos.x = ( float )x + 0.1f ;
	VectData->pos.y = ( float )y + 0.1f ;
	VectData->pos.z = GSYS.DrawSetting.DrawZ ;
	VectData->rhw   = 1.0f ;

	// _̒ǉ
	ADD4VERTEX_POINT

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_D3D11_DrawPixel3D( VECTOR Pos, int Color, int DrawFlag, RECT *DrawArea )
{
	VERTEX_NOTEX_3D *VectData ; 
	int Red, Green, Blue ;
	int Flag ;

	if( DrawFlag )
	{
		if( Graphics_Hardware_CheckValid_PF() == 0 )
		{
			return -1 ;
		}

		// `̏
		Flag = DX_D3D11_DRAWPREP_DIFFUSERGB | DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG ;
		DX_D3D11_DRAWPREP_NOTEX( Flag )

		// F̑Xe[^X̃Zbg
		GETVERTEX_POINT3D( VectData ) ;

		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		if( GD3D11.Device.DrawInfo.DiffuseColor == 0xffffffff )
		{
			NS_GetColor2( Color, &Red, &Green, &Blue ) ;
			*( ( DWORD * )&VectData->b ) = 0xff000000 | ( Red << 16 ) | ( Green << 8 ) | ( Blue ) ;
		}
		else
		{
			NS_GetColor2( Color, &Red, &Green, &Blue ) ;
			*( ( DWORD * )&VectData->b ) =
				( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   ) / 255 ) << 16 ) |
				( ( ( ( ( 	GD3D11.Device.DrawInfo.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8  ) |
				( ( ( ( (	GD3D11.Device.DrawInfo.DiffuseColor & 0x000000ff )       ) * Blue  ) / 255 )       ) | 
				( 			GD3D11.Device.DrawInfo.DiffuseColor & 0xff000000 ) ;
		}

		// W̃Zbg
		VectData->pos = Pos ;

		// _̒ǉ
		ADD4VERTEX_POINT3D
	}
	else
	{
		VERTEX_2D TempVect ;

		// XN[Wɕϊ
		TempVect.pos.x = Pos.x * GSYS.DrawSetting.BlendMatrixF.m[0][0] + Pos.y * GSYS.DrawSetting.BlendMatrixF.m[1][0] + Pos.z * GSYS.DrawSetting.BlendMatrixF.m[2][0] + GSYS.DrawSetting.BlendMatrixF.m[3][0]  ;
		TempVect.pos.y = Pos.x * GSYS.DrawSetting.BlendMatrixF.m[0][1] + Pos.y * GSYS.DrawSetting.BlendMatrixF.m[1][1] + Pos.z * GSYS.DrawSetting.BlendMatrixF.m[2][1] + GSYS.DrawSetting.BlendMatrixF.m[3][1]  ;
		TempVect.pos.z = Pos.x * GSYS.DrawSetting.BlendMatrixF.m[0][2] + Pos.y * GSYS.DrawSetting.BlendMatrixF.m[1][2] + Pos.z * GSYS.DrawSetting.BlendMatrixF.m[2][2] + GSYS.DrawSetting.BlendMatrixF.m[3][2]  ;
		TempVect.rhw   = Pos.x * GSYS.DrawSetting.BlendMatrixF.m[0][3] + Pos.y * GSYS.DrawSetting.BlendMatrixF.m[1][3] + Pos.z * GSYS.DrawSetting.BlendMatrixF.m[2][3] + GSYS.DrawSetting.BlendMatrixF.m[3][3]  ;

		TempVect.rhw = 1.0F / TempVect.rhw ;
		TempVect.pos.x *= TempVect.rhw ;
		TempVect.pos.y *= TempVect.rhw ;
		TempVect.pos.z *= TempVect.rhw ;

		DrawArea->left   = _FTOL( TempVect.pos.x ) - 1 ;
		DrawArea->right  = _FTOL( TempVect.pos.x ) + 1 ;
		DrawArea->top    = _FTOL( TempVect.pos.y ) - 1 ;
		DrawArea->bottom = _FTOL( TempVect.pos.y ) + 1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_D3D11_DrawPixelSet( const POINTDATA *PointData, int Num )
{
	VERTEX_NOTEX_2D *VectData ;
	int i ;
	COLORDATA ColorData ;
	int MaxRed, MaxGreen, MaxBlue ; 
	int Color, Flag ;
	DWORD drawz;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// xNg{Xe[^X擾
	ColorData = *( ( COLORDATA * )NS_GetDispColorData() ) ;
	
	MaxRed		= ( 1 << ColorData.RedWidth	  ) - 1 ; 
	MaxGreen	= ( 1 << ColorData.GreenWidth ) - 1 ;
	MaxBlue		= ( 1 << ColorData.BlueWidth  ) - 1 ; 

	for( i = 0 ; i < Num ; i ++, PointData ++ )
	{
		GETVERTEX_POINT( VectData ) ;

		Color = PointData->color ;
		VectData->color = ( PointData->pal << 24 ) |
						( ( ( ( ( ( Color & ColorData.RedMask	) >> ColorData.RedLoc	) << 8 ) - 1 ) / MaxRed		)       ) |
						( ( ( ( ( ( Color & ColorData.GreenMask	) >> ColorData.GreenLoc	) << 8 ) - 1 ) / MaxGreen	) << 8  ) |
						( ( ( ( ( ( Color & ColorData.BlueMask	) >> ColorData.BlueLoc	) << 8 ) - 1 ) / MaxBlue	) << 16 ) ; 

		VectData->pos.x = ( float )PointData->x + 0.1f ;
		VectData->pos.y = ( float )PointData->y + 0.1f ;
		*((DWORD *)&VectData->pos.z) = drawz ;
		VectData->rhw    = 1.0f ;

		// _̒ǉ
		ADD4VERTEX_POINT
	}

	// I
	return 0;
}

// n[hEGAANZ[^gp DrawLineSet
extern	int		Graphics_D3D11_DrawLineSet( const LINEDATA *LineData, int Num )
{
	int i ;
	VERTEX_NOTEX_2D *VectData ;
	COLORDATA ColorData ;
	int MaxRed, MaxGreen, MaxBlue ; 
	int Color, Flag ;
	DWORD drawz;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	Flag = DX_D3D11_DRAWPREP_DIFFUSERGB ;
	DX_D3D11_DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GSYS.DrawSetting.DrawZ);

	// xNg{Xe[^X擾
	ColorData = *( ( COLORDATA * )NS_GetDispColorData() ) ;
	
	MaxRed		= ( 1 << ColorData.RedWidth	) - 1 ; 
	MaxGreen	= ( 1 << ColorData.GreenWidth ) - 1 ;
	MaxBlue		= ( 1 << ColorData.BlueWidth ) - 1 ; 

	for( i = 0 ; i < Num ; i ++, LineData ++ )
	{
		GETVERTEX_LINE( VectData ) ;

		Color = LineData->color ;
		VectData->color = ( LineData->pal << 24 ) |
						( ( ( ( ( ( Color & ColorData.RedMask	) >> ColorData.RedLoc	) << 8 ) - 1 ) / MaxRed		)       ) |
						( ( ( ( ( ( Color & ColorData.GreenMask	) >> ColorData.GreenLoc	) << 8 ) - 1 ) / MaxGreen	) << 8  ) |
						( ( ( ( ( ( Color & ColorData.BlueMask	) >> ColorData.BlueLoc	) << 8 ) - 1 ) / MaxBlue	) << 16 ) ; 
		VectData[1].color = VectData[0].color ;
		*((DWORD *)&VectData[0].pos.z) =
		*((DWORD *)&VectData[1].pos.z) = drawz;
		VectData[0].rhw   =
		VectData[1].rhw   = 1.0f ;
 
		// W̃ZbgEChEڕ`掞␳
		VectData[0].pos.x = ( float )LineData->x1 ;
		VectData[0].pos.y = ( float )LineData->y1 ;
		VectData[1].pos.x = ( float )LineData->x2 ;
		VectData[1].pos.y = ( float )LineData->y2 ;

		// W̕␳
		if( LineData->x1 == LineData->x2 ) VectData[ 1 ].pos.y += LineData->y2 > LineData->y1 ? -0.1F : 0.1F ;
		if( LineData->y1 == LineData->y2 ) VectData[ 1 ].pos.x += LineData->x2 > LineData->x1 ? -0.1F : 0.1F ;

		// _̒ǉ
		ADD4VERTEX_LINE
	}

	// I
	return 0 ;
}














// DrawPrimitive3D n̋ʂ̏s֐
__inline int Graphics_D3D11_DrawPrimitive3DPreparation( int AddFlag, IMAGEDATA *Image, int TransFlag, int TextureNo = 0 )
{
	int Flag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	Flag = TransFlag | DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG | DX_D3D11_DRAWPREP_TEXADDRESS | DX_D3D11_DRAWPREP_CULLING | AddFlag ;
	if( Image )
	{
		DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ TextureNo ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ TextureNo ].Tex->PF->D3D11.TextureSRV, Flag )
	}
	else
	{
		int WhiteHandle ;

		WhiteHandle = Graphics_Image_GetWhiteTexHandle() ;
		if( GRAPHCHK( WhiteHandle, Image ) )
		{
			return -1 ;
		}
//		DX_D3D11_DRAWPREP_NOTEX( Flag )
		DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )
	}

	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive( const VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	if( Graphics_D3D11_DrawPrimitive3DPreparation( 0, Image, TransFlag ) < 0 )
	{
		return -1 ;
	}

	// `
	Graphics_D3D11_CommonBuffer_DrawPrimitive(
		D3D11_VERTEX_INPUTLAYOUT_3D,
		( D_D3D11_PRIMITIVE_TOPOLOGY )PrimitiveType,
		Vertex,
		VertexNum
	) ;

	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive( const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	if( Graphics_D3D11_DrawPrimitive3DPreparation( 0, Image, TransFlag ) < 0 )
	{
		return -1 ;
	}

	// `
	Graphics_D3D11_CommonBuffer_DrawIndexedPrimitive(
		D3D11_VERTEX_INPUTLAYOUT_3D,
		( D_D3D11_PRIMITIVE_TOPOLOGY )PrimitiveType,
		Vertex,
		VertexNum,
		Indices,
		IndexNum,
		D_DXGI_FORMAT_R16_UINT
	) ;

	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitiveLight( const VERTEX3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	if( Graphics_D3D11_DrawPrimitive3DPreparation( DX_D3D11_DRAWPREP_LIGHTING | DX_D3D11_DRAWPREP_SPECULAR, Image, TransFlag ) < 0 )
	{
		return -1 ;
	}

	// `
	Graphics_D3D11_CommonBuffer_DrawPrimitive(
		D3D11_VERTEX_INPUTLAYOUT_3D_LIGHT,
		( D_D3D11_PRIMITIVE_TOPOLOGY )PrimitiveType,
		Vertex,
		VertexNum
	) ;

	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight( const VERTEX3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	if( Graphics_D3D11_DrawPrimitive3DPreparation( DX_D3D11_DRAWPREP_LIGHTING | DX_D3D11_DRAWPREP_SPECULAR, Image, TransFlag ) < 0 )
	{
		return -1 ;
	}

	// `
	Graphics_D3D11_CommonBuffer_DrawIndexedPrimitive(
		D3D11_VERTEX_INPUTLAYOUT_3D_LIGHT,
		( D_D3D11_PRIMITIVE_TOPOLOGY )PrimitiveType,
		Vertex,
		VertexNum,
		Indices,
		IndexNum,
		D_DXGI_FORMAT_R16_UINT
	) ;

	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitiveLight_UseVertexBuffer( 
	VERTEXBUFFERHANDLEDATA *VertexBuffer,
	int						PrimitiveType,
	int						StartVertex,
	int						UseVertexNum,
	IMAGEDATA *			Image,
	int						TransFlag 
)
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight_UseVertexBuffer(
	VERTEXBUFFERHANDLEDATA *	VertexBuffer,
	INDEXBUFFERHANDLEDATA *		IndexBuffer,
	int							PrimitiveType,
	int							BaseVertex,
	int							StartVertex,
	int							UseVertexNum,
	int							StartIndex,
	int							UseIndexNum,
	IMAGEDATA *				Image,
	int							TransFlag
)
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2D( VERTEX_2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo )
{
	int Flag ;
	int i ;
	VERTEX_2D *Vert ;
	int SmHandle ;
	SHADOWMAPDATA *ShadowMap ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return -1 ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	if( BillboardFlag == TRUE )
	{
		Flag = TransFlag | ( Is3D ? DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG : 0 ) | DX_D3D11_DRAWPREP_TEXADDRESS ;
	}
	else
	{
		Flag = TransFlag | ( Is3D ? DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG : 0 ) | DX_D3D11_DRAWPREP_TEXADDRESS | DX_D3D11_DRAWPREP_CULLING ;
	}
	if( Image && ( DWORD_PTR )Image <= 0xffffffff )
	{
		SmHandle = ( int )( DWORD_PTR )Image ;
		if( !SHADOWMAPCHKFULL( SmHandle, ShadowMap ) )
		{
			Flag |= DX_D3D11_DRAWPREP_TEXTURE ;
			Graphics_D3D11_DrawSetting_SetTexture( ShadowMap->PF->D3D11.DepthTexture, ShadowMap->PF->D3D11.DepthTextureSRV ) ;

			if( GSYS.ChangeSettingFlag ||
				GD3D11.Device.DrawSetting.DrawPrepAlwaysFlag != FALSE ||
				GD3D11.Device.DrawSetting.DrawPrepParamFlag != Flag )
			{
				Graphics_D3D11_DrawPreparation( Flag ) ;
			}
		}
		else
		{
			DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ TextureNo ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ TextureNo ].Tex->PF->D3D11.TextureSRV, Flag )
		}
	}
	else
	{
		DX_D3D11_DRAWPREP_NOTEX( Flag )
	}

	// r{[h̏ꍇ͂tulT[tFXf[^擾
	if( BillboardFlag == TRUE )
	{
		float tu1, tv1, tu2, tv2 ;
		int Num ;
		
		Vert = Vertex ;
		Num = VertexNum / 6 ;
		tu1 = Image->Hard.Draw[ 0 ].Vertex[ 0 ].u ;
		tv1 = Image->Hard.Draw[ 0 ].Vertex[ 0 ].v ;
		tu2 = Image->Hard.Draw[ 0 ].Vertex[ 3 ].u ;
		tv2 = Image->Hard.Draw[ 0 ].Vertex[ 3 ].v ;
		for( i = 0 ; i < Num ; i ++, Vert += 6 )
		{
			if( TurnFlag )
			{
				Vert[ 0 ].u = tu2 ;
				Vert[ 1 ].u = tu1 ;
				Vert[ 2 ].u = tu2 ;
				Vert[ 3 ].u = tu1 ;
			}
			else
			{
				Vert[ 0 ].u = tu1 ;
				Vert[ 1 ].u = tu2 ;
				Vert[ 2 ].u = tu1 ;
				Vert[ 3 ].u = tu2 ;
			}
			Vert[ 0 ].v = tv1 ;
			Vert[ 1 ].v = tv1 ;
			Vert[ 2 ].v = tv2 ;
			Vert[ 3 ].v = tv2 ;

			Vert[ 4 ].u = Vert[ 2 ].u ;
			Vert[ 4 ].v = Vert[ 2 ].v ;
			Vert[ 5 ].u = Vert[ 1 ].u ;
			Vert[ 5 ].v = Vert[ 1 ].v ;
		}
	}

	// `
	Graphics_D3D11_CommonBuffer_DrawPrimitive(
		D3D11_VERTEX_INPUTLAYOUT_2D,
		( D_D3D11_PRIMITIVE_TOPOLOGY )PrimitiveType,
		Vertex,
		VertexNum
	) ;

	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2DUser( const VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	int Flag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	Flag = TransFlag | ( Is3D ? DX_D3D11_DRAWPREP_3D | DX_D3D11_DRAWPREP_FOG : 0 ) | DX_D3D11_DRAWPREP_TEXADDRESS | DX_D3D11_DRAWPREP_CULLING ;
	if( Image )
	{
		DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ TextureNo ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ TextureNo ].Tex->PF->D3D11.TextureSRV, Flag )
	}
	else
	{
		DX_D3D11_DRAWPREP_NOTEX( Flag )
	}

	// `
	Graphics_D3D11_CommonBuffer_DrawPrimitive(
		D3D11_VERTEX_INPUTLAYOUT_2D,
		( D_D3D11_PRIMITIVE_TOPOLOGY )PrimitiveType,
		Vertex,
		VertexNum
	) ;

	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive2DUser( const VERTEX2D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	int Flag ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏
	Flag = TransFlag | DX_D3D11_DRAWPREP_TEXADDRESS | DX_D3D11_DRAWPREP_CULLING ;
	if( Image )
	{
		DX_D3D11_DRAWPREP_TEX( Image->Orig, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, Image->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureSRV, Flag )
	}
	else
	{
		DX_D3D11_DRAWPREP_NOTEX( Flag )
	}

	// `
	Graphics_D3D11_CommonBuffer_DrawIndexedPrimitive(
		D3D11_VERTEX_INPUTLAYOUT_2D,
		( D_D3D11_PRIMITIVE_TOPOLOGY )PrimitiveType,
		Vertex,
		VertexNum,
		Indices,
		IndexNum, 
		D_DXGI_FORMAT_R16_UINT
	) ;

	// I
	return 0 ;
}












// VF[_[`p`OZbgAbv֐
extern void Graphics_D3D11_DrawPreparationToShader( int ParamFlag, int UseVertexShaderNo, int Is2D, int UseLibSubShaderConst )
{
}


// VF[_[gĂQc|S`悷
extern	int		Graphics_D3D11_DrawPolygon2DToShader(          const VERTEX2DSHADER *Vertex, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷
extern	int		Graphics_D3D11_DrawPolygon3DToShader(          const VERTEX3DSHADER *Vertex, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂQc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPolygonIndexed2DToShader(   const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPolygonIndexed3DToShader(   const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive2DToShader(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive3DToShader(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer(         int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	return NS_DrawPrimitive3DToShader_UseVertexBuffer2( VertexBufHandle, PrimitiveType, 0, VertexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer(  int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	return NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( VertexBufHandle, IndexBufHandle, PrimitiveType, 0, 0, VertexBuffer->Num, 0, IndexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer2(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum )
{
	// I
	return 0 ;
}
















// Direct3D ̃A_v^񋓂
static int EnumDirect3DAdapter()
{
	// I
	return 0 ;
}





















// ˑ֌W

// `揈̊ˑ̏s֐( sӏʂO )
extern	int		Graphics_D3D11_Initialize_Timing0_PF( void )
{
	// Direct3D11 gpOtBbNX̏
	if( Graphics_D3D11_Initialize() == -1 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// `揈̊ˑ̏s֐( sӏʂQ )
extern	int		Graphics_D3D11_Initialize_Timing1_PF( void )
{
	// foCX̐ݒtbV
	Graphics_D3D11_DeviceState_RefreshRenderState() ;

	// I
	return 0 ;
}

// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_D3D11_Hardware_Initialize_PF( void )
{
	return Graphics_D3D11_Device_Initialize() ;
}

// `揈̊ˑ̌ns֐
extern	int		Graphics_D3D11_Terminate_PF( void )
{
	// Direct3D11 ̕`揈̌n
	Graphics_D3D11_Terminate() ;

	// VF[_[R[ȟn
	Graphics_D3D11_ShaderCode_Base_Terminate() ;
	Graphics_D3D11_ShaderCode_Base3D_Terminate() ;

#ifndef DX_NON_MODEL
	Graphics_D3D11_ShaderCode_Model_Terminate() ;
#endif // DX_NON_MODEL

	// I
	return 0 ;
}

// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern	int		Graphics_D3D11_RestoreOrChangeSetupGraphSystem_PF( int Change, int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int RefreshRate )
{
	// I
	return 0 ;
}

// `pfoCXLǂ擾( ߂l  TRUE:L  FALSE: )
extern	int		Graphics_D3D11_Hardware_CheckValid_PF( void )
{
	return D3D11Device_IsValid() ;
}

// DirectX ̃IuWFNg
extern	void	Graphics_D3D11_ReleaseDirectXObject_PF( void )
{
}























// ˑ`ݒ֌W

// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_D3D11_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex )
{
	// I
	return 0 ;
}

// SetDrawBright ̈
extern	int		Graphics_Hardware_D3D11_SetDrawBrightToOneParam_PF( DWORD Bright )
{
	// fBt[YJ[̍XV
	GD3D11.Device.DrawInfo.DiffuseColor = GetDiffuseColor() ;

	// I
	return 0 ;
}

// `uh[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBlendMode_PF( int BlendMode, int BlendParam )
{
	// fBt[YJ[̍XV
	GD3D11.Device.DrawInfo.DiffuseColor = GetDiffuseColor() ;

	// I
	return 0 ;
}

// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_D3D11_SetDrawAlphaTest_PF( int TestMode, int TestParam )
{
	// fBt[YJ[̍XV
	GD3D11.Device.DrawInfo.DiffuseColor = GetDiffuseColor() ;

	// I
	return 0 ;
}

// `惂[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawMode_PF( int DrawMode )
{
	Graphics_D3D11_DeviceState_SetDrawMode( DrawMode ) ;

	// I
	return 0 ;
}

// `PxZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright )
{
	// fBt[YJ[̍XV
	GD3D11.Device.DrawInfo.DiffuseColor = GetDiffuseColor() ;

	// I
	return 0 ;
}

// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_D3D11_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param )
{
	// I
	return 0 ;
}

// őٕ̒lZbg
extern	int		Graphics_Hardware_D3D11_SetMaxAnisotropy_PF( int MaxAnisotropy )
{
	// I
	return 0 ;
}

// [hϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToWorld_PF( const MATRIX *Matrix )
{
	Graphics_D3D11_DeviceState_SetWorldMatrix( Matrix ) ;

	// I
	return 0 ;
}

// r[ϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToView_PF( const MATRIX *Matrix )
{
	Graphics_D3D11_DeviceState_SetViewMatrix( Matrix ) ;

	// I
	return 0 ;
}

// Direct3D11 ɐݒ肷ˉesXV
static void Graphics_Hardware_D3D11_RefreshProjectionMatrix( /* int Update3DProjection, int Update2DProjection, int AlwaysUpdate */ )
{
	MATRIX *UseProjectionMatrix ;
	MATRIX *UseViewportMatrix ;
	MATRIX TempMatrix ;

//	if( GSYS.DrawSetting.UseProjectionMatrix2D )
//	{
//		if( AlwaysUpdate == FALSE && Update2DProjection == FALSE )
//		{
//			return ;
//		}
//
//		UseProjectionMatrix = &GSYS.DrawSetting.ProjectionMatrix2D ;
//		UseViewportMatrix   = &GSYS.DrawSetting.ViewportMatrix2D ;
//	}
//	else
//	{
//		if( AlwaysUpdate == FALSE && Update3DProjection == FALSE )
//		{
//			return ;
//		}

		UseProjectionMatrix = &GSYS.DrawSetting.ProjectionMatrixF ;
		UseViewportMatrix   = &GSYS.DrawSetting.ViewportMatrixF ;
//	}
	CreateMultiplyMatrix( &TempMatrix, UseProjectionMatrix, UseViewportMatrix                             ) ;
	CreateMultiplyMatrix( &TempMatrix, &TempMatrix,         &GSYS.DrawSetting.Direct3DViewportMatrixAntiF ) ;

	Graphics_D3D11_DeviceState_SetProjectionMatrix( &TempMatrix ) ;
}

// eϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToProjection_PF( const MATRIX *Matrix )
{
	Graphics_Hardware_D3D11_RefreshProjectionMatrix() ;

	// I
	return 0 ;
}

// r[|[gsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToViewport_PF( const MATRIX * /* Matrix */ )
{
	Graphics_Hardware_D3D11_RefreshProjectionMatrix() ;

	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage )
{
	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage )
{
	// I
	return 0 ;
}

// eNX`WϊsZbg
extern	int		Graphics_Hardware_D3D11_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler )
{
	// I
	return 0 ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_D3D11_SetFogEnable_PF( int Flag )
{
	// I
	return 0 ;
}

// tHO[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ )
{
	// I
	return 0 ;
}

// tHOJ[ύX
extern	int		Graphics_Hardware_D3D11_SetFogColor_PF( DWORD FogColor )
{
	// I
	return 0 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogStartEnd_PF( float start, float end )
{
	// I
	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogDensity_PF( float density )
{
	// I
	return 0 ;
}

// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_D3D11_ApplyLigFogToHardware_PF( void )
{
	// I
	return 0 ;
}

// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_D3D11_SetUseOldDrawModiGraphCodeFlag_PF( int Flag )
{
	// I
	return 0 ;
}

// `ɐlނǂ̃tOXV
extern	int		Graphics_Hardware_D3D11_RefreshAlphaChDrawMode_PF( void )
{
	// I
	return 0 ;
}

// gpˉesRcpɂ邩Qcpɂ邩ݒ肷
//extern	void	Graphics_Hardware_D3D11_SetUse2DProjectionMatrix_PF( int Use2DProjectionMatrix )
//{
//	// ˉesXV
//	Graphics_Hardware_D3D11_RefreshProjectionMatrix( FALSE, FALSE, TRUE ) ;
//}
























// ˑݒ֌W

// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int		Graphics_Hardware_D3D11_SetUseHardwareVertexProcessing_PF( int Flag )
{
	// I
	return 0 ;
}

// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_D3D11_SetUsePixelLighting_PF( int Flag )
{
	GD3D11.UsePixelLightingShader = Flag ;

	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	// I
	return 0 ;
}

// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_Hardware_D3D11_SetUseNormalDrawShader_PF( int Flag )
{
	// I
	return 0 ;
}

// DirectDraw  Direct3D ̋x}`XbhΉɂ邩ǂZbg
extern	int		Graphics_Hardware_D3D11_SetMultiThreadFlag_PF( int Flag )
{
	// I
	return 0 ;
}

// rfI̗eʂ𓾂
extern	int		Graphics_Hardware_D3D11_GetVideoMemorySize_PF( int *AllSize, int *FreeSize )
{
	return 0 ;
}

// gp̂cRccXIuWFNg𓾂
extern	const D_IDirect3DDevice9 * Graphics_Hardware_D3D11_GetUseDirect3DDevice9_PF( void )
{
	return 0 ;
}

// gp̃obNobt@Direct3DSurface9IuWFNg擾
extern	const D_IDirect3DSurface9* Graphics_Hardware_D3D11_GetUseDirect3D11BackBufferSurface_PF( void )
{
	return 0 ;
}

// cwCûcRcݒȂ
extern	int		Graphics_Hardware_D3D11_RefreshDxLibDirect3DSetting_PF( void )
{
	// I
	return 0 ;
}

// ccgpftchݒ肷
extern	int		Graphics_D3D11_SetDDrawUseGuid_PF( const GUID FAR *Guid )
{
	// I
	return 0 ;
}

// L DirectDraw foCX GUID 擾
extern	const GUID *Graphics_D3D11_GetDirectDrawDeviceGUID_PF( int Number )
{
	return 0 ;
}

// L DirectDraw foCX̖O𓾂
extern	int		Graphics_D3D11_GetDirectDrawDeviceDescription_PF( int Number, char *StringBuffer )
{
	// I
	return 0 ;
}

// L DirectDraw foCX̐擾
extern	int		Graphics_D3D11_GetDirectDrawDeviceNum_PF( void )
{
	return 0 ;
}

// gp DirectDraw foCX̃CfbNXݒ肷
extern	int		Graphics_D3D11_SetUseDirectDrawDeviceIndex_PF( int Index )
{
	// I
	return 0 ;
}

// Vistaȍ~̊ Direct3D11Ex gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_D3D11_SetUseDirect3D11Ex_PF( int Flag )
{
	// I
	return 0 ;
}
































// ˑʊ֌W

// ݒɊÂĎgpyobt@Zbg
extern	int		Graphics_Hardware_D3D11_SetupUseZBuffer_PF( void )
{
	IMAGEDATA *TargetScreenImage = NULL ;
	IMAGEDATA *TargetZBufferImage = NULL ;
	SHADOWMAPDATA *TargetShadowMap = NULL ;

	// VhE}bvǂ`FbN
	if( !SHADOWMAPCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], TargetShadowMap ) )
	{
		// VhE}bv̏ꍇ͐p̂yobt@gp
		Graphics_D3D11_DeviceState_SetDepthStencil( TargetShadowMap->PF->D3D11.DepthBuffer, TargetShadowMap->PF->D3D11.DepthBufferDSV ) ;
	}
	else
	{
		// `̉摜̎擾
		GRAPHCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], TargetScreenImage ) ;

		// gpyobt@̉摜̎擾
		GRAPHCHKFULL( GSYS.DrawSetting.TargetZBuffer, TargetZBufferImage ) ;

		// }XNT[tFX݂ĂĊLȏꍇ̓}XNT[tFX̂yobt@gp
//#ifndef DX_NON_MASK
//		if( MASKD.MaskValidFlag && MASKD3D9.MaskScreenSurface )
//		{
//			Direct3DDevice9_SetDepthStencilSurface( GD3D9.Device.Screen.ZBufferSurface ) ;
//		}
//		else
//#endif
		// `\摜`悩ǂŏ𕪊
		if( TargetScreenImage )
		{
			// `yobt@āA`ȏ̃TCYꍇ͕`yobt@gp
			if( TargetZBufferImage != NULL &&
				TargetZBufferImage->Width >= TargetScreenImage->Width &&
				TargetZBufferImage->Height >= TargetScreenImage->Height )
			{
				Graphics_D3D11_DeviceState_SetDepthStencil( TargetZBufferImage->Hard.Draw[ 0 ].Tex->PF->D3D11.DepthBuffer, TargetZBufferImage->Hard.Draw[ 0 ].Tex->PF->D3D11.DepthBufferDSV ) ;
			}
			else
			// `\摜̂yobt@ꍇ͂̂yobt@gp
			if( TargetScreenImage->Hard.Draw[ 0 ].Tex->PF->D3D9.ZBuffer )
			{
				Graphics_D3D11_DeviceState_SetDepthStencil( TargetScreenImage->Hard.Draw[ 0 ].Tex->PF->D3D11.DepthBuffer, TargetScreenImage->Hard.Draw[ 0 ].Tex->PF->D3D11.DepthBufferDSV ) ;
			}
			else
			// `悪ftHĝyobt@傫yobt@O
			if( TargetScreenImage->Width  > GD3D9.Device.Screen.ZBufferSizeX || 
				TargetScreenImage->Height > GD3D9.Device.Screen.ZBufferSizeY )
			{
				Graphics_D3D11_DeviceState_SetDepthStencil( NULL, NULL ) ;
			}
			else
			{
				// ftHĝyobt@gp
				Graphics_D3D11_DeviceState_SetDepthStencil( GD3D11.Device.Screen.DepthBufferTexture2D, GD3D11.Device.Screen.DepthBufferDSV ) ;
			}
		}
		else
		{
			// `yobt@āA`ȏ̃TCYꍇ͕`yobt@gp
			if( TargetZBufferImage != NULL &&
				TargetZBufferImage->Width  >= GSYS.DrawSetting.DrawSizeX &&
				TargetZBufferImage->Height >= GSYS.DrawSetting.DrawSizeY )
			{
				Graphics_D3D11_DeviceState_SetDepthStencil( TargetZBufferImage->Hard.Draw[ 0 ].Tex->PF->D3D11.DepthBuffer, TargetZBufferImage->Hard.Draw[ 0 ].Tex->PF->D3D11.DepthBufferDSV ) ;
			}
			else
			{
				// ftHĝyobt@gp
				Graphics_D3D11_DeviceState_SetDepthStencil( GD3D11.Device.Screen.DepthBufferTexture2D, GD3D11.Device.Screen.DepthBufferDSV ) ;
			}
		}
	}

	// I
	return 0 ;
}

// ʂ̂yobt@̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreenZBuffer_PF( const RECT *ClearRect )
{
	// I
	return 0 ;
}

// ʂ̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreen_PF( const RECT *ClearRect )
{
	D_ID3D11Texture2D        *TargetTexture2D ;
	D_ID3D11RenderTargetView *TargetRTV ;
	FLOAT                    ClearColor[ 4 ] ;
	IMAGEDATA                *Image = NULL ;
	SHADOWMAPDATA            *ShadowMap = NULL ;
//	HRESULT hr ;

	if( Graphics_Hardware_CheckValid_PF() == 0 ) return 0 ;

	// `摜̉摜擾
	GRAPHCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], Image ) ;
	SHADOWMAPCHKFULL( GSYS.DrawSetting.TargetScreen[ 0 ], ShadowMap ) ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// `̏I
//	Graphics_D3D9_EndScene() ;

	// VhE}bvgpĂꍇ̓VhE}bv
	if( ShadowMap )
	{
		TargetTexture2D = ShadowMap->PF->D3D11.DepthTexture ;
		TargetRTV       = ShadowMap->PF->D3D11.DepthTextureRTV ;
	}
	else
	// `\摜gpĂꍇ͕`\摜
	if( Image )
	{
		TargetTexture2D = Image->Orig->Hard.Tex[ 0 ].PF->D3D11.Texture ;
		TargetRTV       = Image->Orig->Hard.Tex[ 0 ].PF->D3D11.TextureRTV ;
	}
	else
	// TuobNobt@LɂȂĂꍇ̓TuobNobt@
	if( GD3D11.Device.Screen.SubBackBufferTexture2D != NULL )
	{
		TargetTexture2D = GD3D11.Device.Screen.SubBackBufferTexture2D ;
		TargetRTV       = GD3D11.Device.Screen.SubBackBufferRTV ;
	}
	else
	{
		TargetTexture2D = GD3D11.Device.Screen.BackBufferTexture2D ;
		TargetRTV       = GD3D11.Device.Screen.BackBufferRTV ;
	}

	// `Ώۂ̃J[obt@
	ClearColor[ 0 ] = GSYS.Screen.BackgroundRed   / 255.0f ;
	ClearColor[ 1 ] = GSYS.Screen.BackgroundGreen / 255.0f ;
	ClearColor[ 2 ] = GSYS.Screen.BackgroundBlue  / 255.0f ;
	ClearColor[ 3 ] = 0.0f ;
	D3D11DeviceContext_ClearRenderTargetView_ASync( TargetRTV, ClearColor ) ;

	// `Ώۂ̐[xobt@
	D3D11DeviceContext_ClearDepthStencilView_ASync( GD3D11.Device.State.TargetDepthDSV, D_D3D11_CLEAR_DEPTH, 1.0f, 0 ) ;

	// I
	return 0 ;
}

// `ʂ̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap )
{
	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// ZbgĂeNX`[O
	Graphics_D3D11_DrawSetting_SetTexture( NULL, NULL ) ;

	// ܂ł̕`悪_O^[QbgT[tFXꍇ̓_O^[QbgeNX`ɓ]
//	if( OldTargetImage != NULL && OldTargetImage->Hard.Draw[ 0 ].Tex->PF->D3D9.RenderTargetSurface )
//	{
//		Graphics_D3D9_UpdateDrawTexture( OldTargetImage->Hard.Draw[ 0 ].Tex, OldScreenSurface ) ;
//	}

	// `̕ύX

	// }XNT[tFX݂ĂĊLȏꍇ̓}XNT[tFX`Ώ̂ɂ
#ifndef DX_NON_MASK
	if( MASKD.MaskValidFlag && MASKD3D11.MaskScreenTexture )
	{
		Graphics_D3D11_DeviceState_SetRenderTarget( MASKD3D11.MaskScreenTexture, MASKD3D11.MaskScreenTextureRTV ) ;
	}
	else
#endif
	// VhE}bvLȏꍇ̓VhE}bv`Ώۂɂ
	if( NewTargetShadowMap )
	{
		Graphics_D3D11_DeviceState_SetRenderTarget( NewTargetShadowMap->PF->D3D11.DepthTexture, NewTargetShadowMap->PF->D3D11.DepthTextureRTV, 0 ) ;
	}
	else
	// `\摜Lȏꍇ͕`\摜`Ώۂɂ
	if( NewTargetImage )
	{
		Graphics_D3D11_DeviceState_SetRenderTarget( NewTargetImage->Hard.Draw[ 0 ].Tex->PF->D3D11.Texture, NewTargetImage->Hard.Draw[ 0 ].Tex->PF->D3D11.TextureRTV, 0 ) ;
	}
	else
	// TuobNobt@Lȏꍇ̓TuobNobt@`Ώۂɂ
	if( GD3D11.Device.Screen.SubBackBufferTexture2D != NULL )
	{
		Graphics_D3D11_DeviceState_SetRenderTarget( GD3D11.Device.Screen.SubBackBufferTexture2D, GD3D11.Device.Screen.SubBackBufferRTV ) ;
	}
	else
	// ȊȌꍇ̓obNobt@`Ώۂɂ
	{
		Graphics_D3D11_DeviceState_SetRenderTarget( GD3D11.Device.Screen.BackBufferTexture2D, GD3D11.Device.Screen.BackBufferRTV ) ;
	}

	// gpyobt@̃ZbgAbv
	Graphics_Screen_SetupUseZBuffer() ;

	// I
	return 0 ;
}

// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_Post_PF( int DrawScreen )
{
	// `悪\ʂIɉʃRs[s
	DXGISwapChain_SetupTimerPresent( DrawScreen == DX_SCREEN_FRONT ) ;

	// I
	return 0 ;
}

// `\̈̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawArea_PF( int x1, int y1, int x2, int y2 )
{
	D_D3D11_VIEWPORT Viewport ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	if( GSYS.DrawSetting.DrawArea.right  - GSYS.DrawSetting.DrawArea.left == 0 ||
		GSYS.DrawSetting.DrawArea.bottom - GSYS.DrawSetting.DrawArea.top  == 0 )
	{
		return -1 ;
	}

	// r[|[g̃Zbg
	Viewport.TopLeftX	= ( float )GSYS.DrawSetting.DrawArea.left ;
	Viewport.TopLeftY	= ( float )GSYS.DrawSetting.DrawArea.top ;
	Viewport.Width		= ( float )( GSYS.DrawSetting.DrawArea.right  - GSYS.DrawSetting.DrawArea.left ) ;
	Viewport.Height		= ( float )( GSYS.DrawSetting.DrawArea.bottom - GSYS.DrawSetting.DrawArea.top  ) ;
	Viewport.MinDepth	= 0.0f ;
	Viewport.MaxDepth	= 1.0f ;
	Graphics_D3D11_DeviceState_SetViewport( &Viewport ) ;

	// ˉesƃr[|[gs̋tsẐZbg
	Graphics_Hardware_D3D11_RefreshProjectionMatrix() ;
	GSYS.DrawSetting.MatchHardwareProjectionMatrix = TRUE ;

	// A`r[|[gsXV
	Graphics_D3D11_DeviceState_SetAntiViewportMatrix( &GSYS.DrawSetting.Direct3DViewportMatrixAntiF ) ;

	// I
	return 0 ;
}

// `obt@bN
extern	int		Graphics_Hardware_D3D11_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo )
{
	D_ID3D11Texture2D          *TargetTexture ;
	D_D3D11_TEXTURE2D_DESC     TargetTexture2DDesc ;
	D_D3D11_MAPPED_SUBRESOURCE MappedSubresource ;
	COLORDATA                  *TargetColorData ;
	int                        Width ;
	int                        Height ;
	HRESULT                    hr ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	Width  = LockRect->right  - LockRect->left ;
	Height = LockRect->bottom - LockRect->top ;

	// 荞݌ƂȂT[tFX̌

	// `\摜Ώۂ̏ꍇ
	if( TargetImage )
	{
		TargetTexture	= TargetImage->Orig->Hard.Tex[ TargetScreenTextureNo ].PF->D3D11.Texture ;
	}
	else
	// TuobNobt@LɂȂĂꍇ̓TuobNobt@
	if( GD3D11.Device.Screen.SubBackBufferTexture2D != NULL )
	{
		TargetTexture    = GD3D11.Device.Screen.SubBackBufferTexture2D ;
	}
	else
	{
		TargetTexture    = GD3D11.Device.Screen.BackBufferTexture2D ;
	}

	// 擾
	TargetTexture->GetDesc( &TargetTexture2DDesc ) ;
	TargetColorData = Graphics_D3D11_GetD3DFormatColorData( TargetTexture2DDesc.Format ) ;

	// ]peNX`ɕ`Ώۉ摜]
	{
		D_ID3D11Texture2D          *SMTexture ;
		D_D3D11_TEXTURE2D_DESC     Texture2DDesc ;

		_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) ) ;
		Texture2DDesc.Usage              = D_D3D11_USAGE_STAGING ;
		Texture2DDesc.Format             = TargetTexture2DDesc.Format ;
		Texture2DDesc.BindFlags          = 0 ;
		Texture2DDesc.Width              = TargetTexture2DDesc.Width ;
		Texture2DDesc.Height             = TargetTexture2DDesc.Height ;
		Texture2DDesc.CPUAccessFlags     = D_D3D11_CPU_ACCESS_READ ;
		Texture2DDesc.MipLevels          = 1 ;
		Texture2DDesc.ArraySize          = 1 ;
		Texture2DDesc.SampleDesc.Count   = 1 ;
		Texture2DDesc.SampleDesc.Quality = 0 ;
		hr = D3D11Device_CreateTexture2D_ASync( &Texture2DDesc, NULL, &SMTexture ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "`Ώۃobt@ǂݎp̃eNX`̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}

		D3D11DeviceContext_CopyResource( SMTexture, TargetTexture ) ;

		// }bv
		hr = D3D11DeviceContext_Map( SMTexture, D_D3D11CalcSubresource( 0, 0, 1 ), D_D3D11_MAP_READ, 0, &MappedSubresource ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "`Ώۃobt@ǂݎp̃eNX`̃}bsOɎs܂\n" ) ) ;
			return -1 ;
		}

		// ꎞIɍ쐬eNX`̃AhXۑ
		GD3D11.Device.Screen.DrawScreenBufferLockSMTexture = SMTexture ;
	}

	// {C[W\̂̃f[^ɃZbg
	BaseImage->ColorData     = *TargetColorData ;
	BaseImage->Width          = Width ;
	BaseImage->Height         = Height ;
	BaseImage->Pitch          = MappedSubresource.RowPitch ;
	BaseImage->GraphData      = ( BYTE * )MappedSubresource.pData + LockRect->left * TargetColorData->PixelByte + LockRect->top * MappedSubresource.RowPitch ;
	BaseImage->MipMapCount    = 0 ;
	BaseImage->GraphDataCount = 0 ;

	// I
	return 0 ;
}

// `obt@AbN
extern	int		Graphics_Hardware_D3D11_UnlockDrawScreenBuffer_PF( void )
{
	// ꎞIɎgpĂT[tFXbNǂŏ𕪊
	if( GD3D11.Device.Screen.DrawScreenBufferLockSMTexture != NULL )
	{
		// }bv̉
		D3D11DeviceContext_Unmap( GD3D11.Device.Screen.DrawScreenBufferLockSMTexture, D_D3D11CalcSubresource( 0, 0, 1 ) ) ;

		// ꎞIɍ쐬eNX`̉
		Direct3D11_ObjectRelease( GD3D11.Device.Screen.DrawScreenBufferLockSMTexture ) ;
		GD3D11.Device.Screen.DrawScreenBufferLockSMTexture = NULL ;
	}

	// I
	return 0 ;
}

// ʂ̓e\ʂɕ`悷
extern	int		Graphics_Hardware_D3D11_ScreenCopy_PF( void )
{
	// TuobNobt@̃ZbgAbv
	if( NS_GetWindowModeFlag() == FALSE )
	{
		Graphics_D3D11_SetupSubBackBuffer() ;
	}

	// I
	return 0 ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Begin_PF( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage )
{
	// I
	return 0 ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Post_PF( void )
{
	// I
	return 0 ;
}

// M҂
extern	int		Graphics_Hardware_D3D11_WaitVSync_PF( int SyncNum )
{
	return 0 ;
}

// ʂƕ\ʂ
extern	int		Graphics_Hardware_D3D11_ScreenFlipBase_PF( void )
{
	// ȏł̓tbvLZ
	if( WinData.ActiveFlag == FALSE && 
		WinData.DrawBackGraphFlag == FALSE && 
		WinData.PauseGraph.GraphData != NULL )
	{
		return 0 ;
	}

	// tXN[[h
	// tXN[𑜓x[h DX_FSRESOLUTIONMODE_NATIVE ł͂Ȃꍇ
	// GSYS.Screen/ValidGraphDisplayArea  TRUE ̏ꍇ̓TuobNobt@̃ZbgAbv
	if( NS_GetWindowModeFlag() == FALSE &&
		( GSYS.Screen.FullScreenResolutionModeAct != DX_FSRESOLUTIONMODE_NATIVE ||
		  GSYS.Screen.ValidGraphDisplayArea != FALSE ) )
	{
		Graphics_D3D11_SetupSubBackBuffer() ;
	}

	// ʂ̓e\ʂɔf
	return DXGISwapChain_Present() ;
}

// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_Hardware_D3D11_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect )
{
	return 0 ;
}

// ScreenFlip ŉ摜]̃EChEݒ肷( NULL w肷Ɛݒ )
extern	int		Graphics_Hardware_D3D11_SetScreenFlipTargetWindow_PF( HWND TargetWindow )
{
	return 0 ;
}

// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_D3D11_SetZBufferMode_PF( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth )
{
	// I
	return 0 ;
}

// `yobt@̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawZBuffer_PF( int DrawScreen, IMAGEDATA *Image )
{
	// I
	return 0 ;
}
























// ˑ擾֌W

// GetColor  GetColor2 ŎgpJ[f[^擾
extern const COLORDATA *Graphics_Hardware_D3D11_GetMainColorData_PF( void )
{
	return Graphics_D3D11_GetD3DFormatColorData( DIRECT3D11_BACKBUFFER_FORMAT ) ;
}

// fBXv[̃J[f[^|C^𓾂
extern	const COLORDATA *Graphics_Hardware_D3D11_GetDispColorData_PF( void )
{
	return Graphics_D3D11_GetD3DFormatColorData( GD3D11.Device.Caps.ScreenFormat ) ;
}

// wW̐F擾
extern	int Graphics_Hardware_D3D11_GetPixel_PF( int x, int y )
{
	return 0 ;
}


























// ˑ摜֌W

// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_D3D11_UpdateGraphMovie_TheoraYUV_PF( MOVIEGRAPH *Movie, IMAGEDATA *Image )
{
	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP )
{
	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphUnlock_PF( IMAGEDATA *Image )
{
	// I
	return 0 ;
}

// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_D3D11_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage )
{
	// I
	return 0 ;
}

// 摜f[^̏
extern	int		Graphics_Hardware_D3D11_InitGraph_PF( void )
{
	// I
	return 0 ;
}

// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_D3D11_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread )
{
	// I
	return 0 ;
}

// `\摜obNobt@ẅ̃OtBbN擾
extern	int		Graphics_Hardware_D3D11_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY )
{
	RECT SrcRect ;
	RECT DestRect ;
	RECT Rect ;
	int Width, Height ;

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO

	// ƍvZ
	Width  = x2 - x1 ;
	Height = y2 - y1 ;

	// ]ƂȂT[tFX`\eNX`ꍇ͒Pɓ]
	if( Image->Orig->FormatDesc.DrawValidFlag )
	{
		D_ID3D11Texture2D          *TargetTexture ;
		D_ID3D11ShaderResourceView *TargetTextureSRV ;

		// 荞݌ƂȂeNX`̌

		// `\摜Ώۂ̏ꍇ
		if( TargetImage )
		{
			TargetTexture    = TargetImage->Orig->Hard.Tex[ 0 ].PF->D3D11.Texture ;
			TargetTextureSRV = TargetImage->Orig->Hard.Tex[ 0 ].PF->D3D11.TextureSRV ;
		}
		else
		// TuobNobt@LɂȂĂꍇ̓TuobNobt@
		if( GD3D11.Device.Screen.SubBackBufferTexture2D != NULL )
		{
			TargetTexture    = GD3D11.Device.Screen.SubBackBufferTexture2D ;
			TargetTextureSRV = GD3D11.Device.Screen.SubBackBufferSRV ;
		}
		else
		{
			TargetTexture    = GD3D11.Device.Screen.BackBufferTexture2D ;
			TargetTextureSRV = GD3D11.Device.Screen.BackBufferSRV ;
		}

		SrcRect.left    = x1 ;
		SrcRect.top     = y1 ;
		SrcRect.right   = x2 ;
		SrcRect.bottom  = y2 ;

		DestRect.left   = destX ;
		DestRect.top    = destY ;
		DestRect.right  = destX + Width ;
		DestRect.bottom = destY + Height ;

		Graphics_D3D11_StretchRect(
			TargetTexture,                                TargetTextureSRV,                                &SrcRect,
			Image->Orig->Hard.Tex[ 0 ].PF->D3D11.Texture, Image->Orig->Hard.Tex[ 0 ].PF->D3D11.TextureRTV, &DestRect
		) ; 
	}
	else
	// ʏ̃eNX`ꍇ͍ŏɃbNAʖڂxɎ荞ł]
	{
		// `obt@bN
		BASEIMAGE LockImage ;
		SrcRect.left   = x1 ;
		SrcRect.top    = y1 ;
		SrcRect.right  = x2 ;
		SrcRect.bottom = y2 ;
		if( Graphics_Screen_LockDrawScreen( &SrcRect, &LockImage, TargetScreen, TargetScreenSurface, TRUE, 0 ) < 0 )
		{
			return -1 ;
		}

		// eNX`ɓ]
		Rect.left   = 0 ;
		Rect.top    = 0 ;
		Rect.right  = LockImage.Width ;
		Rect.bottom = LockImage.Height ;
		Graphics_Image_BltBmpOrBaseImageToGraph3(
			&Rect,
			destX, destY,
			Image->HandleInfo.Handle,
			&LockImage, NULL,
			FALSE,
			FALSE,
			FALSE
		) ;

		// `obt@̃AbN
		Graphics_Screen_UnlockDrawScreen() ;
	}

	// I
	return 0 ;
}

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_MipMapBlt(
	      IMAGEDATA_ORIG	*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	      int				UseSysMemSurface,
	      D_ID3D11Texture2D	*UseTex,
	      int				TexWidth,
	      int				TexHeight,
	const BASEIMAGE			*RgbBaseImage,
	const BASEIMAGE			*AlphaBaseImage,
	const COLORDATA			*DestColor,
	      int				RedIsAlphaFlag,
	      int				UseTransColorConvAlpha,
	      int				ASyncThread
)
{
	int					AlphaImageSize ;
	int					ImageSize ;
	int					ImageW ;
	int					ImageH ;
	int					ImagePitch ;
	void				*Image1 ;
	void				*Image2 ;
	void				*ImageD ;
	void				*ImageS ;
	void				*ImageBuffer ;
	int					ImageDW ;
	int					ImageDH ;
	int					ImageSW ;
	int					ImageSH ;
	int					ImageNum ;
//	RECT				DestRectT ;
//	RECT				SrcRectT ;
//	D_D3DLOCKED_RECT	LockRect ;
	POINT				DestPoint ;
	int					UseSysMemSurfaceIndex = -1 ;
//	D_IDirect3DSurface9	*DestSurface ;
//	D_IDirect3DSurface9	*UseSurface = NULL ;
	int					TempTexWidth ;
	int					TempTexHeight ;
	int					i ;
	int					j ;
	int					ts ;
//	HRESULT				hr ;
	D_D3D11_BOX			DestBox ;

	DestPoint.x = 0 ;
	DestPoint.y = 0 ;

	ImageNum = Orig->FormatDesc.CubeMapTextureFlag ? CUBEMAP_SURFACE_NUM : 1 ;

	// ]悪eNX`ŜŁADXTtH[}bgœ]DXTtH[}bg̏ꍇ͒Pȃ]s
/*	if( DestRect->left == 0 && DestRect->right  == TexWidth  &&
		DestRect->top  == 0 && DestRect->bottom == TexHeight &&
		RgbBaseImage->MipMapCount >= Orig->Hard.MipMapCount &&
		( ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT1 ) ||
		  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT2 ) ||
		  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT3 ) ||
		  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT4 ) ||
		  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT5 ) ) )
	{
		if( Orig->FormatDesc.CubeMapTextureFlag )
		{
			ImageBuffer = RgbBaseImage->GraphData ;
			for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
			{
				TempTexWidth  = TexWidth ;
				TempTexHeight = TexHeight ;
				ImageSize     = RgbBaseImage->Width * RgbBaseImage->Height * RgbBaseImage->ColorData.ColorBitDepth / 8 ;
				for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
				{
					// eNX`bN
					if( UseSysMemSurface == FALSE )
					{
						hr = Direct3DCubeTexture9_LockRect_ASync(
							( D_IDirect3DCubeTexture9 * )UseTex,
							( D_D3DCUBEMAP_FACES )i,
							j,
							&LockRect,
							NULL,
							0,
							ASyncThread
						) ;
					}
					else
					{
						for(;;)
						{
							UseSysMemSurfaceIndex = Graphics_D3D9_GetSysMemSurface(
								TempTexWidth,
								TempTexHeight,
								GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ],
								ASyncThread
							) ;

							if( UseSysMemSurfaceIndex != -1 )
							{
								break ;
							}

							if( NS_ProcessMessage() != 0 )
							{
								break ;
							}

							Thread_Sleep( 1 ) ;
						}

						if( UseSysMemSurfaceIndex == -1 )
						{
							return -1 ;
						}

						UseSurface = GD3D9.SysMemTexSurf.Surface[ UseSysMemSurfaceIndex ].MemSurface ;

						hr = Direct3DSurface9_LockRect_ASync(
							UseSurface,
							&LockRect,
							NULL,
							D_D3DLOCK_DISCARD,
							ASyncThread
						) ;
					}
					if( hr != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "L[u}bv~bv}bveNX`̃bNɎs܂\n" ) ) ;
						return -1 ;
					}

					// eNX`ɓ]
					_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

					// bN
					if( UseSysMemSurface == FALSE )
					{
						Direct3DCubeTexture9_UnlockRect_ASync(
							( D_IDirect3DCubeTexture9 * )UseTex,
							( D_D3DCUBEMAP_FACES )i,
							j,
							ASyncThread
						) ;
					}
					else
					{
						Direct3DSurface9_UnlockRect_ASync( UseSurface, ASyncThread ) ;

						Direct3DCubeTexture9_GetCubeMapSurface_ASync(
							( D_IDirect3DCubeTexture9 * )UseTex,
							( D_D3DCUBEMAP_FACES )i,
							j,
							&DestSurface,
							ASyncThread
						) ;

						Direct3DDevice9_UpdateSurface_ASync(
							UseSurface,
							NULL,
							DestSurface,
							NULL,
							ASyncThread
						) ; 

						Direct3D9_ObjectRelease_ASync( DestSurface, ASyncThread ) ;

						Graphics_D3D9_ReleaseSysMemSurface( UseSysMemSurfaceIndex, ASyncThread ) ;
						UseSysMemSurfaceIndex = -1 ;
					}

					// ]AhXi߂
					ImageBuffer  = ( BYTE * )ImageBuffer + ImageSize ;
					ImageSize   /= 4 ;
					if( ImageSize < 8 )
					{
						ImageSize = 8 ;
					}

					TempTexWidth  >>= 1 ;
					TempTexHeight >>= 1 ;
					if( TempTexWidth < 1 )
					{
						TempTexWidth = 1 ;
					}
					if( TempTexHeight < 1 )
					{
						TempTexHeight = 1 ;
					}
				}
			}
		}
		else
		{
			TempTexWidth  = TexWidth ;
			TempTexHeight = TexHeight ;
			ImageSize     = RgbBaseImage->Width * RgbBaseImage->Height * RgbBaseImage->ColorData.ColorBitDepth / 8 ;
			ImageBuffer   = RgbBaseImage->GraphData ;
			for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
			{
				// eNX`bN
				if( UseSysMemSurface == FALSE )
				{
					hr = Direct3DTexture9_LockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, j, &LockRect, NULL, 0, ASyncThread ) ;
				}
				else
				{
					for(;;)
					{
						UseSysMemSurfaceIndex = Graphics_D3D9_GetSysMemSurface(
							TempTexWidth,
							TempTexHeight,
							GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ],
							ASyncThread
						) ;

						if( UseSysMemSurfaceIndex != -1 )
						{
							break ;
						}

						if( NS_ProcessMessage() != 0 )
						{
							break ;
						}

						Thread_Sleep( 1 ) ;
					}

					if( UseSysMemSurfaceIndex == -1 )
					{
						return -1 ;
					}

					UseSurface = GD3D9.SysMemTexSurf.Surface[ UseSysMemSurfaceIndex ].MemSurface ;

					hr = Direct3DSurface9_LockRect_ASync(
						UseSurface,
						&LockRect,
						NULL,
						D_D3DLOCK_DISCARD,
						ASyncThread
					) ;
				}
				if( hr != D_D3D_OK )
				{
					DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
					return -1 ;
				}

				// eNX`ɓ]
				_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

				// bN
				if( UseSysMemSurface == FALSE )
				{
					Direct3DTexture9_UnlockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, j, ASyncThread ) ;
				}
				else
				{
					Direct3DSurface9_UnlockRect_ASync( UseSurface, ASyncThread ) ;

					Direct3DTexture9_GetSurfaceLevel_ASync(
						( D_IDirect3DTexture9 * )UseTex,
						j,
						&DestSurface,
						ASyncThread
					) ;

					Direct3DDevice9_UpdateSurface_ASync(
						UseSurface,
						NULL,
						DestSurface,
						NULL,
						ASyncThread
					) ; 

					Direct3D9_ObjectRelease_ASync( DestSurface, ASyncThread ) ;

					Graphics_D3D9_ReleaseSysMemSurface( UseSysMemSurfaceIndex, ASyncThread ) ;
					UseSysMemSurfaceIndex = -1 ;
				}

				// ]AhXi߂
				ImageBuffer  = ( BYTE * )ImageBuffer + ImageSize ;
				ImageSize   /= 4 ;
				if( ImageSize < 8 )
				{
					ImageSize = 8 ;
				}

				TempTexWidth  >>= 1 ;
				TempTexHeight >>= 1 ;
				if( TempTexWidth < 1 )
				{
					TempTexWidth = 1 ;
				}
				if( TempTexHeight < 1 )
				{
					TempTexHeight = 1 ;
				}
			}
		}
	}
	else*/
	{
		// ]悪WtH[}bgł͂Ȃꍇ͓]łȂ
		if( GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT1 &&
			GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT2 &&
			GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT3 &&
			GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT4 &&
			GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT5 )
		{
			// ]Ƀ~bv}bv񂪂ꍇƖꍇŏ𕪊
/*			if( RgbBaseImage->MipMapCount >= Orig->Hard.MipMapCount )
			{
				// ꍇ

				ImageBuffer = RgbBaseImage->GraphData ;
				if( Orig->FormatDesc.CubeMapTextureFlag )
				{
					for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
					{
						TempTexWidth = TexWidth ;
						TempTexHeight = TexHeight ;
						ImageSize = RgbBaseImage->Width * RgbBaseImage->Height * RgbBaseImage->ColorData.PixelByte ;
						for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
						{
							// eNX`bN
							if( UseSysMemSurface == FALSE )
							{
								hr = Direct3DCubeTexture9_LockRect_ASync(
									( D_IDirect3DCubeTexture9 * )UseTex,
									( D_D3DCUBEMAP_FACES )i,
									j,
									&LockRect,
									NULL,
									0,
									ASyncThread
								) ;
							}
							else
							{
								for(;;)
								{
									UseSysMemSurfaceIndex = Graphics_D3D9_GetSysMemSurface(
										TempTexWidth,
										TempTexHeight,
										GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ],
										ASyncThread
									) ;

									if( UseSysMemSurfaceIndex != -1 )
									{
										break ;
									}

									if( NS_ProcessMessage() != 0 )
									{
										break ;
									}

									Thread_Sleep( 1 ) ;
								}
								if( UseSysMemSurfaceIndex == -1 )
								{
									return -1 ;
								}
								UseSurface = GD3D9.SysMemTexSurf.Surface[ UseSysMemSurfaceIndex ].MemSurface ;

								hr = Direct3DSurface9_LockRect_ASync( UseSurface, &LockRect, NULL, D_D3DLOCK_DISCARD, ASyncThread ) ;
							}
							if( hr != D_D3D_OK )
							{
								DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
								return -1 ;
							}

							// eNX`ɓ]
							_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

							// bN
							if( UseSysMemSurface == FALSE )
							{
								Direct3DCubeTexture9_UnlockRect_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, ASyncThread ) ;
							}
							else
							{
								Direct3DSurface9_UnlockRect_ASync( UseSurface, ASyncThread ) ;

								Direct3DCubeTexture9_GetCubeMapSurface_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, &DestSurface, ASyncThread ) ;

								Direct3DDevice9_UpdateSurface_ASync( UseSurface, NULL, DestSurface, NULL, ASyncThread ) ; 

								Direct3D9_ObjectRelease_ASync( DestSurface, ASyncThread ) ;

								Graphics_D3D9_ReleaseSysMemSurface( UseSysMemSurfaceIndex, ASyncThread ) ;
								UseSysMemSurfaceIndex = -1 ;
							}

							// ]AhXi߂
							ImageBuffer = ( BYTE * )ImageBuffer + ImageSize ;
							ImageSize /= 4 ;

							TempTexWidth >>= 1 ;
							TempTexHeight >>= 1 ;
							if( TempTexWidth < 1 )
							{
								TempTexWidth = 1 ;
							}
							if( TempTexHeight < 1 )
							{
								TempTexHeight = 1 ;
							}
						}
					}
				}
				else
				{
					TempTexWidth = TexWidth ;
					TempTexHeight = TexHeight ;
					ImageSize = RgbBaseImage->Width * RgbBaseImage->Height * RgbBaseImage->ColorData.PixelByte ;
					for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
					{
						// eNX`bN
						if( UseSysMemSurface == FALSE )
						{
							hr = Direct3DTexture9_LockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, j, &LockRect, NULL, 0, ASyncThread ) ;
						}
						else
						{
							for(;;)
							{
								UseSysMemSurfaceIndex = Graphics_D3D9_GetSysMemSurface( TempTexWidth, TempTexHeight, GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ], ASyncThread ) ;
								if( UseSysMemSurfaceIndex != -1 ) break ;
								if( NS_ProcessMessage() != 0 ) break ;
								Thread_Sleep( 1 ) ;
							}
							if( UseSysMemSurfaceIndex == -1 )
							{
								return -1 ;
							}
							UseSurface = GD3D9.SysMemTexSurf.Surface[ UseSysMemSurfaceIndex ].MemSurface ;

							hr = Direct3DSurface9_LockRect_ASync( UseSurface, &LockRect, NULL, D_D3DLOCK_DISCARD, ASyncThread ) ;
						}
						if( hr != D_D3D_OK )
						{
							DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
							return -1 ;
						}

						// eNX`ɓ]
						_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

						// bN
						if( UseSysMemSurface == FALSE )
						{
							Direct3DTexture9_UnlockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, j, ASyncThread ) ;
						}
						else
						{
							Direct3DSurface9_UnlockRect_ASync( UseSurface, ASyncThread ) ;

							Direct3DTexture9_GetSurfaceLevel_ASync( ( D_IDirect3DTexture9 * )UseTex, j, &DestSurface, ASyncThread ) ;

							Direct3DDevice9_UpdateSurface_ASync( UseSurface, NULL, DestSurface, NULL, ASyncThread ) ; 

							Direct3D9_ObjectRelease_ASync( DestSurface, ASyncThread ) ;

							Graphics_D3D9_ReleaseSysMemSurface( UseSysMemSurfaceIndex, ASyncThread ) ;
							UseSysMemSurfaceIndex = -1 ;
						}

						// ]AhXi߂
						ImageBuffer = ( BYTE * )ImageBuffer + ImageSize ;
						ImageSize /= 4 ;

						TempTexWidth >>= 1 ;
						TempTexHeight >>= 1 ;
						if( TempTexWidth < 1 )
						{
							TempTexWidth = 1 ;
						}
						if( TempTexHeight < 1 )
						{
							TempTexHeight = 1 ;
						}
					}
				}
			}
			else*/
			{
				// ꍇ

				// ꎞobt@Ɋi[
				ts = DestRect->right  - DestRect->left ;
				for( ImageW = 1 ; ImageW < ts ; ImageW <<= 1 ){}
				ts = DestRect->bottom - DestRect->top  ;
				for( ImageH = 1 ; ImageH < ts ; ImageH <<= 1 ){}
				ImagePitch  = DestColor->PixelByte * ImageW ;
				ImageSize   = ImagePitch * ImageH ;
				ImageBuffer = DXALLOC( ImageSize * 2 ) ;
				Image1      = ImageBuffer ;
				Image2      = ( BYTE * )Image1 + ImageSize ;
				if( ImageBuffer == NULL )
				{
					DXST_ERRORLOG_ADD( _T( "eNX`֓]摜ꎞIɊi[郁̈̊mۂɎs܂\n" ) ) ;
					return -1 ;
				}

				ImageSize      = RgbBaseImage->Pitch   * RgbBaseImage->Height ;
				AlphaImageSize = AlphaBaseImage->Pitch * AlphaBaseImage->Height ;
				for( i = 0 ; i < ImageNum ; i ++ )
				{
					// ~bv}bv̐[JԂ
					ImageSW       = ImageW ;
					ImageSH       = ImageH ;
					ImageDW       = ImageW ;
					ImageDH       = ImageH ;
					TempTexWidth  = TexWidth ;
					TempTexHeight = TexHeight ;
					for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
					{
						// k摜̍쐬
						if( j == 0 )
						{
							// level0 ͓̎{̏o̓tH[}bg摜쐬
							NS_GraphColorMatchBltVer2(
								Image1,                                                   ImagePitch,            DestColor,
								( BYTE * )RgbBaseImage->GraphData   + ImageSize * i,      RgbBaseImage->Pitch,   &RgbBaseImage->ColorData,
								( BYTE * )AlphaBaseImage->GraphData + AlphaImageSize * i, AlphaBaseImage->Pitch, &AlphaBaseImage->ColorData,
								DestPoint, SrcRect, FALSE,
								UseTransColorConvAlpha && ( DestColor->AlphaWidth != 0 && AlphaBaseImage->GraphData == NULL ), Orig->TransCode,
								BASEIM.ImageShavedMode, FALSE,
								RedIsAlphaFlag, FALSE,
								FALSE ) ;
							ImageD = Image1 ;
						}
						else
						{
							if( j & 1 )
							{
								ImageS = Image1 ;
								ImageD = Image2 ;
							}
							else
							{
								ImageS = Image2 ;
								ImageD = Image1 ;
							}

							GraphHalfScaleBlt( DestColor, ImageD, ImagePitch, ImageS, ImagePitch, 0, 0, 0, 0, ImageSW, ImageSH ) ;
						}

						// ]̃bN
/*						DestRectT.left   = DestRect->left   >> j ;
						DestRectT.right  = DestRect->right  >> j ;
						DestRectT.top    = DestRect->top    >> j ;
						DestRectT.bottom = DestRect->bottom >> j ;
						if( DestRectT.right  == DestRectT.left ) DestRectT.right  = DestRectT.left + 1 ;
						if( DestRectT.bottom == DestRectT.top  ) DestRectT.bottom = DestRectT.top  + 1 ;
						if( UseSysMemSurface == FALSE )
						{
							if( Orig->FormatDesc.CubeMapTextureFlag )
							{
								if( Direct3DCubeTexture9_LockRect_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, &LockRect, &DestRectT, 0, ASyncThread ) != D_D3D_OK )
								{
									DXFREE( ImageBuffer ) ;
									ImageBuffer = NULL ;
									DXST_ERRORLOG_ADD( _T( "L[u}bv~bv}bveNX`̃bNɎs܂\n" ) ) ;
									return -1 ;
								}
							}
							else
							{
								if( Direct3DTexture9_LockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, j, &LockRect, &DestRectT, 0, ASyncThread ) != D_D3D_OK )
								{
									DXFREE( ImageBuffer ) ;
									ImageBuffer = NULL ;
									DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
									return -1 ;
								}
							}
						}
						else
						{
							for(;;)
							{
								UseSysMemSurfaceIndex = Graphics_D3D9_GetSysMemSurface( TempTexWidth, TempTexHeight, GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ], ASyncThread ) ;
								if( UseSysMemSurfaceIndex != -1 ) break ;
								if( NS_ProcessMessage() != 0 ) break ;
								Thread_Sleep( 1 ) ;
							}
							if( UseSysMemSurfaceIndex == -1 )
							{
								DXFREE( ImageBuffer ) ;
								ImageBuffer = NULL ;
								DXST_ERRORLOG_ADD( _T( "~bv}bveNX`p̃T[tFX̎擾Ɏs܂\n" ) ) ;
								return -1 ;
							}
							UseSurface = GD3D9.SysMemTexSurf.Surface[ UseSysMemSurfaceIndex ].MemSurface ;

							if( Direct3DSurface9_LockRect_ASync( UseSurface, &LockRect, &DestRectT, D_D3DLOCK_DISCARD, ASyncThread ) != D_D3D_OK )
							{
								DXFREE( ImageBuffer ) ;
								ImageBuffer = NULL ;
								DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
								return -1 ;
							}
						}
*/
						// eNX`ɓ]
						DestBox.left   = DestRect->left   >> j ;
						DestBox.top    = DestRect->top    >> j ;
						DestBox.front  = 0 ;
						DestBox.right  = DestRect->right  >> j ;
						DestBox.bottom = DestRect->bottom >> j ;
						DestBox.back   = 1 ;

						D3D11DeviceContext_UpdateSubresource_ASync( UseTex, D_D3D11CalcSubresource( j, i, 1 ), &DestBox, ImageD, ImagePitch, 0 ) ;

/*						// eNX`ɓ]
						SrcRectT.left   = 0 ;
						SrcRectT.top    = 0 ;
						SrcRectT.right  = ImageDW ;
						SrcRectT.bottom = ImageDH ;
						NS_GraphColorMatchBltVer2(
							LockRect.pBits, LockRect.Pitch,  DestColor,
									ImageD,     ImagePitch,  DestColor,
									  NULL,              0,       NULL,
							DestPoint, &SrcRectT, FALSE,
							FALSE, 0, 0, FALSE, FALSE, FALSE, FALSE ) ;

						// bN
						if( UseSysMemSurface == FALSE )
						{
							if( Orig->FormatDesc.CubeMapTextureFlag )
							{
								Direct3DCubeTexture9_UnlockRect_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, ASyncThread ) ;
							}
							else
							{
								Direct3DTexture9_UnlockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, j, ASyncThread ) ;
							}
						}
						else
						{
							D_IDirect3DSurface9 *DestSurface ;
							POINT DestSurfacePoint ;

							Direct3DSurface9_UnlockRect_ASync( UseSurface, ASyncThread ) ;

							if( Orig->FormatDesc.CubeMapTextureFlag )
							{
								Direct3DCubeTexture9_GetCubeMapSurface_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, &DestSurface, ASyncThread ) ;
							}
							else
							{
								Direct3DTexture9_GetSurfaceLevel_ASync( ( D_IDirect3DTexture9 * )UseTex, j, &DestSurface, ASyncThread ) ;
							}

							DestSurfacePoint.x = DestRectT.left ;
							DestSurfacePoint.y = DestRectT.top ;
							Direct3DDevice9_UpdateSurface_ASync( UseSurface, &DestRectT, DestSurface, &DestSurfacePoint, ASyncThread ) ; 

							Direct3D9_ObjectRelease_ASync( DestSurface, ASyncThread ) ;

							Graphics_D3D9_ReleaseSysMemSurface( UseSysMemSurfaceIndex, ASyncThread ) ;
							UseSysMemSurfaceIndex = -1 ;
						}

						// ̃C[W̃TCYZbg
						ImageSW = ImageDW ;
						ImageSH = ImageDH ;
						ImageDW >>= 1 ;
						ImageDH >>= 1 ;
						if( ImageDW == 0 ) ImageDW = 1 ;
						if( ImageDH == 0 ) ImageDH = 1 ;

						TempTexWidth >>= 1 ;
						TempTexHeight >>= 1 ;
						if( TempTexWidth < 1 )
						{
							TempTexWidth = 1 ;
						}
						if( TempTexHeight < 1 )
						{
							TempTexHeight = 1 ;
						}
*/					}
				}

				// ̉
				DXFREE( ImageBuffer ) ;
			}
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "DXTtH[}bg̃eNX`ɕW`̃C[W]邱Ƃ͂ł܂\n" ) ) ;
		}
	}

	// I
	return 0 ;
}

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
	      IMAGEDATA_ORIG	*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	      int				UseSysMemSurface,
	      D_ID3D11Texture2D	*UseTex,
	      int				TexWidth,
	      int				TexHeight,
	      int				TexUseWidth,
	      int				TexUseHeight,
	const BASEIMAGE			*RgbBaseImage,
	const BASEIMAGE			*AlphaBaseImage,
	const COLORDATA			*DestColor,
	      int				RedIsAlphaFlag,
	      int				UseTransColorConvAlpha,
	      int				ASyncThread
)
{
	int					i ;
//	int					k ;
//	int					hr ;
	POINT				DestPoint ;
//	RECT				DestRectT ;
//	int					H ;
//	BYTE				*DestAddr ;
	BYTE				*SrcRgbAddr ;
	BYTE				*SrcAlphaAddr ;
//	D_D3DLOCKED_RECT	LockRect ;
//	int					RightLineFillFlag ;
//	int					BottomLineFillFlag ;
	int					ImageNum ;
	DWORD				ImageSize ;
	DWORD				AlphaImageSize ;
//	int					UseSysMemSurfaceIndex ;
//	D_IDirect3DSurface9	*UseSurface = NULL ;
	void				*TempBuffer ;
	int					TempBufferPitch ;
	D_D3D11_BOX			DestBox ;

	TempBufferPitch = TexUseWidth * DestColor->PixelByte ;
	TempBuffer      = DXALLOC( TempBufferPitch * TexUseHeight ) ;

	DestPoint.x = 0 ;
	DestPoint.y = 0 ;

/*	RightLineFillFlag  = FALSE ;
	BottomLineFillFlag = FALSE ;
	DestRectT          = *DestRect ;
	if( TexUseWidth  < TexWidth  && TexUseWidth  == DestRectT.right )
	{
		RightLineFillFlag = TRUE ;
		DestRectT.right ++ ;
	}
	if( TexUseHeight < TexHeight && TexUseHeight == DestRectT.bottom )
	{
		BottomLineFillFlag = TRUE ;
		DestRectT.bottom ++ ;
	}*/

	ImageNum = Orig->FormatDesc.CubeMapTextureFlag ? CUBEMAP_SURFACE_NUM : 1 ;

//	DXST_ERRORLOGFMT_ADD(( _T( "SrcRect l:%d t:%d r:%d b:%d  DestRect l:%d t:%d r:%d b:%d" ),
//	SrcRect->left, SrcRect->top, SrcRect->right, SrcRect->bottom,
//	DestRectT.left, DestRectT.top, DestRectT.right, DestRectT.bottom )) ;

	for( i = 0 ; i < ImageNum ; i ++ )
	{
		// ]̃bN
		/*if( UseSysMemSurface == FALSE )
		{
			if( Orig->FormatDesc.CubeMapTextureFlag )
			{
				hr = Direct3DCubeTexture9_LockRect_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, 0, &LockRect, &DestRectT, 0, ASyncThread ) ;
			}
			else
			{
				hr = Direct3DTexture9_LockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, 0, &LockRect, &DestRectT, 0, ASyncThread ) ;
			}
			UseSysMemSurfaceIndex = -1 ;
		}
		else
		{
			for(;;)
			{
				UseSysMemSurfaceIndex = Graphics_D3D9_GetSysMemSurface( TexWidth, TexHeight, GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ], ASyncThread ) ;
				if( UseSysMemSurfaceIndex != -1 ) break ;
				if( NS_ProcessMessage() != 0 ) break ;
				Thread_Sleep( 1 ) ;
			}
			if( UseSysMemSurfaceIndex == -1 )
			{
				return -1 ;
			}
			UseSurface = GD3D9.SysMemTexSurf.Surface[ UseSysMemSurfaceIndex ].MemSurface ;

			hr = Direct3DSurface9_LockRect_ASync( UseSurface, &LockRect, &DestRectT, D_D3DLOCK_DISCARD, ASyncThread ) ;
		}
		if( hr != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "eNX`̃bNɎs܂\n" ) ) ;
			return -1  ;
		}*/

		// ]

		// ]悪eNX`ŜŁADXTtH[}bgœ]DXTtH[}bg̏ꍇ͒Pȃ]s
		/*if( DestRect->left == 0 && DestRect->right  == TexWidth  &&
			DestRect->top  == 0 && DestRect->bottom == TexHeight &&
			( ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT1 ) ||
			  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT2 ) ||
			  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT3 ) ||
			  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT4 ) ||
			  ( RgbBaseImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 && GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT5 ) ) )
		{
			ImageSize = RgbBaseImage->Width * RgbBaseImage->Height * RgbBaseImage->ColorData.ColorBitDepth / 8 ;
			_MEMCPY( LockRect.pBits, ( BYTE * )RgbBaseImage->GraphData + ImageSize * i, ImageSize ) ;
		}
		else*/
		{
			// ]悪WtH[}bgł͂Ȃꍇ͓]łȂ
			if( GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT1 &&
				GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT2 &&
				GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT3 &&
				GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT4 &&
				GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT5 )
			{
				ImageSize      = RgbBaseImage->Pitch   * RgbBaseImage->Height ;
				AlphaImageSize = AlphaBaseImage->Pitch * AlphaBaseImage->Height ;

				SrcRgbAddr   = ( BYTE * )RgbBaseImage->GraphData   + i * ImageSize ;
				SrcAlphaAddr = ( BYTE * )AlphaBaseImage->GraphData + i * AlphaImageSize ;
				NS_GraphColorMatchBltVer2(
					TempBuffer,     TempBufferPitch,       DestColor,
					SrcRgbAddr,     RgbBaseImage->Pitch,   &RgbBaseImage->ColorData,
					SrcAlphaAddr,   AlphaBaseImage->Pitch, &AlphaBaseImage->ColorData,
					DestPoint, SrcRect, FALSE,
					UseTransColorConvAlpha && ( DestColor->AlphaWidth != 0 && AlphaBaseImage->GraphData == NULL ), Orig->TransCode,
					BASEIM.ImageShavedMode, FALSE,
					RedIsAlphaFlag, FALSE,
					FALSE ) ;

/*				if( BottomLineFillFlag )
				{
					_MEMCPY( ( BYTE * )TempBuffer + ( TexUseHeight - DestRect->top     ) * TempBufferPitch,
							 ( BYTE * )TempBuffer + ( TexUseHeight - DestRect->top - 1 ) * TempBufferPitch,
							 DestColor->PixelByte * ( SrcRect->right - SrcRect->left ) ) ;
				}
				if( RightLineFillFlag )
				{
					H = SrcRect->bottom - SrcRect->top ;
					DestAddr = ( BYTE * )TempBuffer + ( TexUseWidth - DestRect->left ) * DestColor->PixelByte ;
					switch( DestColor->PixelByte )
					{
					case 2 :
						for( k = 0 ; k < H ; k ++, DestAddr += TempBufferPitch )
						{
							*( ( WORD * )DestAddr ) = *( ( WORD * )DestAddr - 1 ) ;
						}
						break ;

					case 4 :
						for( k = 0 ; k < H ; k ++, DestAddr += TempBufferPitch )
						{
							*( ( DWORD * )DestAddr ) = *( ( DWORD * )DestAddr - 1 ) ;
						}
						break ;
					}
				}
				if( BottomLineFillFlag && RightLineFillFlag )
				{
					DestAddr = ( BYTE * )TempBuffer + ( TexUseHeight - DestRect->top ) * TempBufferPitch + ( TexUseWidth - DestRect->left ) * DestColor->PixelByte ;
					switch( DestColor->PixelByte )
					{
					case 2 : *( ( WORD  * )DestAddr ) = *( ( WORD  * )( DestAddr - TempBufferPitch ) - 1 ) ; break ;
					case 4 : *( ( DWORD * )DestAddr ) = *( ( DWORD * )( DestAddr - TempBufferPitch ) - 1 ) ;	break ;
					}
				}*/
			}
			else
			{
				DXST_ERRORLOG_ADD( _T( "DXTtH[}bg̃eNX`ɕW`̃C[W]邱Ƃ͂ł܂\n" ) ) ;
			}
		}

		DestBox.left   = DestRect->left ;
		DestBox.top    = DestRect->top ;
		DestBox.front  = 0 ;
		DestBox.right  = DestRect->right ;
		DestBox.bottom = DestRect->bottom ;
		DestBox.back   = 1 ;

		D3D11DeviceContext_UpdateSubresource_ASync( UseTex, D_D3D11CalcSubresource( 0, i, 1 ), &DestBox, TempBuffer, TempBufferPitch, 0 ) ;
//		D3D11DeviceContext_UpdateSubresource_ASync( UseTex, D_D3D11CalcSubresource( 0, i, 1 ), NULL,     TempBuffer, TempBufferPitch, 0 ) ;

		
/*		D_D3D11_MAPPED_SUBRESOURCE mapped ;
		_MEMSET( &mapped, 0, sizeof( mapped ) ) ;
		D3D11DeviceContext_Map(
			UseTex,
			D_D3D11CalcSubresource( 0, 0, 1 ),
			D_D3D11_MAP_WRITE_DISCARD,
			0,
			&mapped );

		for( int i = 0 ; i < TexUseHeight ; i ++ )
		{
			_MEMCPY( ( BYTE * )mapped.pData + mapped.RowPitch * i, ( BYTE * )TempBuffer + TempBufferPitch * i, TempBufferPitch ) ;
		}

		D3D11DeviceContext_Unmap( UseTex, D_D3D11CalcSubresource( 0, 0, 1 ) ) ;
*/		

		// bN
		/*if( UseSysMemSurface == FALSE )
		{
			if( Orig->FormatDesc.CubeMapTextureFlag )
			{
				Direct3DCubeTexture9_UnlockRect_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, 0, ASyncThread ) ;
			}
			else
			{
				Direct3DTexture9_UnlockRect_ASync( ( D_IDirect3DTexture9 * )UseTex, 0, ASyncThread ) ;
			}
		}
		else
		{
			D_IDirect3DSurface9 *DestSurface ;
			POINT                DestSurfacePoint ;

			Direct3DSurface9_UnlockRect_ASync( UseSurface, ASyncThread ) ;

			if( Orig->FormatDesc.CubeMapTextureFlag )
			{
				Direct3DCubeTexture9_GetCubeMapSurface_ASync( ( D_IDirect3DCubeTexture9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, 0, &DestSurface, ASyncThread ) ;
			}
			else
			{
				Direct3DTexture9_GetSurfaceLevel_ASync( ( D_IDirect3DTexture9 * )UseTex, 0, &DestSurface, ASyncThread ) ;
			}

			DestSurfacePoint.x = DestRectT.left ;
			DestSurfacePoint.y = DestRectT.top ;
			Direct3DDevice9_UpdateSurface_ASync( UseSurface, &DestRectT, DestSurface, &DestSurfacePoint, ASyncThread ) ; 

			Direct3D9_ObjectRelease_ASync( DestSurface, ASyncThread ) ;

			Graphics_D3D9_ReleaseSysMemSurface( UseSysMemSurfaceIndex, ASyncThread ) ;
			UseSysMemSurfaceIndex = -1 ;
		}*/
	}

	if( TempBuffer != NULL )
	{
		DXFREE( TempBuffer ) ;
		TempBuffer = NULL ;
	}

	// I
	return 0 ;
}

// Direct3D11 ̃OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Hardware_D3D11_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
)
{
	IMAGEDATA					*Image ;
	IMAGEDATA_ORIG				*Orig ;
	IMAGEDATA_ORIG_HARD_TEX		*OrigTex ;
	IMAGEDATA_HARD_DRAW			*DrawTex ;
	int							ImageNum ;
//	int							UseSysMemTex = -1 ;
	int							i ;
//	int							j ;
	POINT						DestPoint ;
	RECT						DestRect ;
	RECT						MoveRect ;
	COLORDATA					*DestColor ;
//	D_D3DLOCKED_RECT			LockRect ;
	D_ID3D11Texture2D			*UseTex ;
//	D_IDirect3DSurface9			*SMSurface[ CUBEMAP_SURFACE_NUM ] = { 0 } ;
	int							SrcWidth ;
	int							SrcHeight ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// `ҋ@Ă`敨`
	DRAWSTOCKINFO_ASYNC( ASyncThread ) ;

	// ]vZĂ
	SrcWidth  = SrcRect->right  - SrcRect->left ;
	SrcHeight = SrcRect->bottom - SrcRect->top ;
	if( SrcWidth <= 0 || SrcHeight <= 0 )
	{
		return 0 ;
	}

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image ) )
		{
			return -1 ;
		}
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image ) )
		{
			return -1 ;
		}
	}
	Orig = Image->Orig ;

	// C[W̐Zbg
	ImageNum = RgbBaseImage->GraphDataCount == 0 ? 1 : RgbBaseImage->GraphDataCount ;

	// eNX`̃J[擾
	DestColor = Graphics_D3D11_GetD3DFormatColorData( GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] ) ;

	// ]ʒũZbg
	DestPoint.x = 0 ;
	DestPoint.y = 0 ;

	// `\摜̏ꍇ͓]摜Ɠ傫̃VXeT[tFXɓe]
/*	if( Orig->FormatDesc.DrawValidFlag )
	{
		for( i = 0 ; i < ImageNum ; i ++ )
		{
			if( Direct3DDevice9_CreateOffscreenPlainSurface_ASync(
					SrcWidth,
					SrcHeight,
					GD3D9.Device.Caps.TextureFormat[ Orig->ColorFormat ],
					D_D3DPOOL_SYSTEMMEM,
					&SMSurface[ i ],
					NULL,
					ASyncThread
				) != D_D3D_OK )
			{
				DXST_ERRORLOG_ADD( _T( "摜]p̃VXeeNX`̍쐬Ɏs܂\n" ) ) ;
				goto ERR ;
			}

			// VXeT[tFXbN
			Direct3DSurface9_LockRect_ASync( SMSurface[ i ], &LockRect, NULL, D_D3DLOCK_DISCARD, ASyncThread ) ;

			// e]
			MoveRect.left   = 0 ;
			MoveRect.top    = 0 ;
			MoveRect.right  = SrcWidth ;
			MoveRect.bottom = SrcHeight ;
			NS_GraphColorMatchBltVer2(
				LockRect.pBits,                                                               LockRect.Pitch,    DestColor,
				( BYTE * )RgbBaseImage->GraphData   + RgbBaseImage->Pitch   * RgbBaseImage->Height   * i, RgbBaseImage->Pitch,   &RgbBaseImage->ColorData,
				( BYTE * )AlphaBaseImage->GraphData + AlphaBaseImage->Pitch * AlphaBaseImage->Height * i, AlphaBaseImage->Pitch, &AlphaBaseImage->ColorData,
				DestPoint, &MoveRect, FALSE,
				UseTransColorConvAlpha && ( DestColor->AlphaWidth != 0 && AlphaBaseImage->GraphData == NULL ), Orig->TransCode,
				BASEIM.ImageShavedMode, FALSE,
				RedIsAlphaFlag, FALSE,
				FALSE ) ;

			// VXeT[tFX̃bN
			Direct3DSurface9_UnlockRect_ASync( SMSurface[ i ], ASyncThread ) ;
		}
	}*/

	// ]ΏۂIWi摜ɑ΂Ăǂŏ𕪊
	if( TargetOrig == TRUE )
	{
		// IWi摜ɑ΂Ă̏ꍇ

		// eNX`̐JԂ
		OrigTex = Orig->Hard.Tex ;
		for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
		{
			// ]`̍쐬
			if( Graphics_Image_BltBmpOrBaseImageToGraph3_Make_OrigTex_MoveRect(
					OrigTex,
					SrcRect,
					SrcWidth,
					SrcHeight,
					DestX,
					DestY,
					&DestRect,
					&MoveRect ) < 0 )
			{
				continue ;
			}

			// `\摜ǂŏ𕪊
			/*if( Orig->FormatDesc.DrawValidFlag == TRUE )
			{
				// `\摜̏ꍇ

				// e]
				DestPoint.x = DestRect.left ;
				DestPoint.y = DestRect.top ;
				for( j = 0 ; j < ImageNum ; j ++ )
				{
					Direct3DDevice9_UpdateSurface_ASync(
						SMSurface[ j ],				&MoveRect,
						OrigTex->PF->D3D9.Surface[ j ],	&DestPoint, ASyncThread ) ;
				}
				if( OrigTex->PF->D3D9.RenderTargetSurface )
				{
					Direct3DDevice9_UpdateSurface_ASync(
						SMSurface[ 0 ],						&MoveRect,
						OrigTex->PF->D3D9.RenderTargetSurface,	&DestPoint, ASyncThread ) ;
				}
			}
			else*/
			{
				int FullUpdate ;

				// `s\摜̏ꍇ

				// S̓]ǂ𒲂ׂ
				if( DestRect.right  - DestRect.left == OrigTex->TexWidth &&
					DestRect.bottom - DestRect.top  == OrigTex->TexHeight )
				{
					FullUpdate = TRUE ;
				}
				else
				{
					FullUpdate = FALSE ;
				}

				// gpeNX`̃Zbg
				//UseTex = Orig->FormatDesc.UseManagedTextureFlag == FALSE ? OrigTex->MemTexture : OrigTex->PF->D3D9.Texture ;
				/*if( FullUpdate && Orig->FormatDesc.UseManagedTextureFlag == FALSE )
				{
					for(;;)
					{
						UseSysMemTex = Graphics_D3D9_GetSysMemTextureFromOrig( Orig, OrigTex, ASyncThread ) ;
						if( UseSysMemTex != -1 ) break ;
						if( NS_ProcessMessage() != 0 ) break ;
						Thread_Sleep( 1 ) ;
					}
					if( UseSysMemTex == -1 )
					{
						goto ERR ;
					}
					UseTex = GD3D9.SysMemTexSurf.Texture[ UseSysMemTex ].MemTexture ;
				}
				else*/
				{
//					UseSysMemTex = -1 ;
					UseTex = OrigTex->PF->D3D11.Texture ;
				}

				// ~bv}bvǂŏ𕪊
				if( Orig->Hard.MipMapCount > 1 )
				{
					if( Graphics_D3D11_BltBmpOrBaseImageToGraph3_MipMapBlt(
							Orig,
							&MoveRect,
							&DestRect,
							FullUpdate == FALSE && Orig->FormatDesc.UseManagedTextureFlag == FALSE,
							UseTex,
							OrigTex->TexWidth,
							OrigTex->TexHeight,
							RgbBaseImage,
							AlphaBaseImage,
							DestColor,
							RedIsAlphaFlag,
							UseTransColorConvAlpha,
							ASyncThread ) < 0 )
						goto ERR ;
				}
				else
				{
					if( Graphics_D3D11_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
							Orig,
							&MoveRect,
							&DestRect,
							FullUpdate == FALSE && Orig->FormatDesc.UseManagedTextureFlag == FALSE,
							UseTex,
							OrigTex->TexWidth,
							OrigTex->TexHeight,
							OrigTex->UseWidth,
							OrigTex->UseHeight,
							RgbBaseImage,
							AlphaBaseImage,
							DestColor,
							RedIsAlphaFlag,
							UseTransColorConvAlpha,
							ASyncThread ) < 0 )
						goto ERR ;
				}

				// ǗeNX`ł͂Ȃꍇ͂œ]p̃VXeeNX`
				/*if( FullUpdate && Orig->FormatDesc.UseManagedTextureFlag == FALSE )
				{
					if( Orig->FormatDesc.CubeMapTextureFlag )
					{
						Direct3DDevice9_UpdateTexture_ASync( UseTex, OrigTex->PF->D3D9.CubeTexture, ASyncThread ) ;
					}
					else
					{
						Direct3DDevice9_UpdateTexture_ASync( UseTex, OrigTex->PF->D3D9.Texture, ASyncThread ) ;
					}
					Graphics_D3D9_ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
					UseSysMemTex = -1 ;
				}*/
			}
		}
	}
	else
	{
		// IWi摜ɑ΂Ăł͂Ȃꍇ

		// `̐JԂ
		DrawTex = Image->Hard.Draw ;
		DestPoint.x = 0 ;
		DestPoint.y = 0 ;
		for( i = 0 ; i < Image->Hard.DrawNum ; i ++, DrawTex ++ )
		{
			// ]`̍쐬
			if( Graphics_Image_BltBmpOrBaseImageToGraph3_Make_DrawTex_MoveRect(
					DrawTex,
					SrcRect,
					SrcWidth,
					SrcHeight,
					DestX,
					DestY,
					&DestRect,
					&MoveRect ) < 0 )
			{
				continue ;
			}

			// `\摜ǂŏ𕪊
			/*if( Orig->FormatDesc.DrawValidFlag == TRUE )
			{
				// `\摜̏ꍇ

				// e]
				DestPoint.x = DestRect.left ;
				DestPoint.y = DestRect.top ;
				for( j = 0 ; j < ImageNum ; j ++ )
				{
					if( Direct3DDevice9_UpdateSurface_ASync(
							SMSurface[ j ],             &MoveRect,
							DrawTex->Tex->PF->D3D9.Surface[ j ], &DestPoint, ASyncThread ) != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "`\eNX`ւ̉摜̓]Ɏs܂\n" ) ) ;
						goto ERR ;
					}
				}
			}
			else*/
			{
				int FullUpdate ;

				// `s\摜̏ꍇ

				// S̓]ǂ𒲂ׂ
				if( DestRect.right  - DestRect.left == DrawTex->Tex->TexWidth &&
					DestRect.bottom - DestRect.top  == DrawTex->Tex->TexHeight )
				{
					FullUpdate = TRUE ;
				}
				else
				{
					FullUpdate = FALSE ;
				}

				// gpeNX`̃Zbg
				//UseTex = Orig->FormatDesc.UseManagedTextureFlag == FALSE ? DrawTex->Tex->MemTexture : DrawTex->Tex->PF->D3D9.Texture ;
				/*if( FullUpdate && Orig->FormatDesc.UseManagedTextureFlag == FALSE )
				{
					for(;;)
					{
						UseSysMemTex = Graphics_D3D9_GetSysMemTextureFromOrig( Orig, DrawTex->Tex, ASyncThread ) ;
						if( UseSysMemTex       != -1 ) break ;
						if( NS_ProcessMessage() != 0 ) break ;
						Thread_Sleep( 1 ) ;
					}
					if( UseSysMemTex == -1 )
					{
						goto ERR ;
					}
					UseTex       = GD3D9.SysMemTexSurf.Texture[ UseSysMemTex ].MemTexture ;
				}
				else*/
				{
					UseTex       = DrawTex->Tex->PF->D3D11.Texture ;
//					UseSysMemTex = -1 ;
				}

				// ~bv}bvǂŏ𕪊
				if( Orig->Hard.MipMapCount > 1 )
				{
					if( Graphics_D3D11_BltBmpOrBaseImageToGraph3_MipMapBlt(
							Orig,
							&MoveRect,
							&DestRect,
							FullUpdate == FALSE && Orig->FormatDesc.UseManagedTextureFlag == FALSE,
							UseTex,
							DrawTex->Tex->TexWidth,
							DrawTex->Tex->TexHeight,
							RgbBaseImage,
							AlphaBaseImage,
							DestColor,
							RedIsAlphaFlag,
							UseTransColorConvAlpha,
							ASyncThread ) < 0 )
						goto ERR ;
				}
				else
				{
					if( Graphics_D3D11_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
							Orig,
							&MoveRect,
							&DestRect,
							FullUpdate == FALSE && Orig->FormatDesc.UseManagedTextureFlag == FALSE,
							UseTex,
							DrawTex->Tex->TexWidth,
							DrawTex->Tex->TexHeight,
							DrawTex->Tex->UseWidth,
							DrawTex->Tex->UseHeight,
							RgbBaseImage,
							AlphaBaseImage,
							DestColor,
							RedIsAlphaFlag,
							UseTransColorConvAlpha,
							ASyncThread ) < 0 )
						goto ERR ;
				}

				// ǗeNX`ł͂Ȃꍇ͂œ]p̃VXeeNX`
				/*if( FullUpdate && Orig->FormatDesc.UseManagedTextureFlag == FALSE )
				{
					if( Orig->FormatDesc.CubeMapTextureFlag )
					{
						Direct3DDevice9_UpdateTexture_ASync( UseTex, DrawTex->Tex->PF->D3D9.CubeTexture, ASyncThread ) ;
					}
					else
					{
						Direct3DDevice9_UpdateTexture_ASync( UseTex, DrawTex->Tex->PF->D3D9.Texture, ASyncThread ) ;
					}
					Graphics_D3D9_ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
					UseSysMemTex = -1 ;
				}*/
			}
		}
	}

	/*for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
	{
		if( SMSurface[ i ] != NULL )
		{
			Direct3D9_ObjectRelease_ASync( SMSurface[ i ], ASyncThread ) ;
			SMSurface[ i ] = NULL ;
		}
	}

	if( UseSysMemTex != -1 )
	{
		Graphics_D3D9_ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
		UseSysMemTex = -1 ;
	}*/

	// I
	return 0 ;


	// G[I
ERR :
/*
	for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
	{
		if( SMSurface[ i ] != NULL )
		{
			Direct3D9_ObjectRelease_ASync( SMSurface[ i ], ASyncThread ) ;
			SMSurface[ i ] = NULL ;
		}
	}

	if( UseSysMemTex != -1 )
	{
		Graphics_D3D9_ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
		UseSysMemTex = -1 ;
	}
*/
	return -1 ;
}

// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern	int		Graphics_Hardware_D3D11_CreateOrigTexture_PF(  IMAGEDATA_ORIG *Orig, int ASyncThread )
{
	int									i ;
	IMAGEDATA_ORIG_HARD_TEX				*OrigTex ;
	D_D3D11_TEXTURE2D_DESC				Texture2DDesc ;
	D_D3D11_RENDER_TARGET_VIEW_DESC		RTVDesc ;
	D_D3D11_SHADER_RESOURCE_VIEW_DESC	SRVDesc ;
	D_D3D11_DEPTH_STENCIL_VIEW_DESC		DepthStencilViewDesc ;
	HRESULT								hr ;
	UINT								Samples = 0 ;
	UINT								Quality = 0 ;

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// n[hEGAgp摜ł͂Ȃꍇ͉ɏI
	if( Orig->FormatDesc.TextureFlag == FALSE )
	{
		return 0 ;
	}

	// w̃tH[}bg쐬łȂꍇ͎s
	if( GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] == D_DXGI_FORMAT_UNKNOWN )
	{
		DXST_ERRORLOG_ADD( _T( "w̃tH[}bgō쐬łeNX`tH[}bg܂ł\n" ) ) ;
		return -1 ;
	}

	// }`TvtH[}bg̏ꍇ͎gpłTvƃNIeB擾Ă
	if( Orig->FormatDesc.MSSamples != 0 )
	{
		Samples = ( UINT )Orig->FormatDesc.MSSamples ;
		Quality = ( UINT )Orig->FormatDesc.MSQuality ;
		D3D11Device_CheckMultiSampleParam_ASync( GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ], &Samples, &Quality, FALSE, ASyncThread ) ;
	}

	// eNX`̏ꍇ̓eNX`̐eNX`쐬
	OrigTex = Orig->Hard.Tex ;
	for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
	{

		// Direct3D11 ɊǗ͖
		Orig->FormatDesc.UseManagedTextureFlag = FALSE ;

		// eNX`̍쐬
		if( OrigTex->PF->D3D11.Texture == NULL )
		{
			_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) ) ;
			Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
//			Texture2DDesc.Usage              = D_D3D11_USAGE_DYNAMIC ;
			Texture2DDesc.Format             = GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] ;
			Texture2DDesc.BindFlags          = D_D3D11_BIND_SHADER_RESOURCE | ( Orig->FormatDesc.DrawValidFlag ? D_D3D11_BIND_RENDER_TARGET : 0 ) ;
			Texture2DDesc.Width              = OrigTex->TexWidth ;
			Texture2DDesc.Height             = OrigTex->TexHeight ;
			Texture2DDesc.CPUAccessFlags     = 0 ;
//			Texture2DDesc.CPUAccessFlags     = D_D3D11_CPU_ACCESS_WRITE ;
			Texture2DDesc.MipLevels          = Orig->Hard.MipMapCount ;
			Texture2DDesc.ArraySize          = Orig->FormatDesc.CubeMapTextureFlag ? CUBEMAP_SURFACE_NUM : 1 ;
			Texture2DDesc.SampleDesc.Count   = Samples == 0 ? 1 : Samples ;
			Texture2DDesc.SampleDesc.Quality = Quality ;
			hr = D3D11Device_CreateTexture2D_ASync( &Texture2DDesc, NULL, &OrigTex->PF->D3D11.Texture, ASyncThread ) ;
			if( FAILED( hr ) )
			{
				DXST_ERRORLOG_ADD( _T( "eNX`̍쐬Ɏs܂\n" ) ) ;
				return -1 ;
			}
		}

		// `Ώۂɂ邱Ƃłꍇ͏𕪊
		if( Orig->FormatDesc.DrawValidFlag )
		{
			// _[^[Qbgr[쐬
			if( OrigTex->PF->D3D11.TextureRTV == NULL )
			{
				_MEMSET( &RTVDesc, 0, sizeof( RTVDesc ) );
				RTVDesc.Format        = GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] ;
				if( Orig->FormatDesc.CubeMapTextureFlag )
				{
					RTVDesc.ViewDimension            = D_D3D11_RTV_DIMENSION_TEXTURE2DARRAY ;
					RTVDesc.Texture2DArray.ArraySize = CUBEMAP_SURFACE_NUM ;
				}
				else
				{
					RTVDesc.ViewDimension = D_D3D11_RTV_DIMENSION_TEXTURE2D ;
				}
				hr = D3D11Device_CreateRenderTargetView_ASync( OrigTex->PF->D3D11.Texture, &RTVDesc, &OrigTex->PF->D3D11.TextureRTV, ASyncThread ) ;
				if( FAILED( hr ) )
				{
					DXST_ERRORLOGFMT_ADD(( _T( "eNX`p_[^[Qbgr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
						GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ], OrigTex->TexWidth, OrigTex->TexHeight )) ;
					return -1 ;
				}
			}

			// }`TvA[xobt@쐬w肪ꍇ͐[xobt@쐬
			if( ( ( D_D3DMULTISAMPLE_TYPE )GRAWIN.Setting.FSAAMultiSampleCount == D_D3DMULTISAMPLE_NONE && Orig->FormatDesc.MSSamples != 0 ) ||
				( ( D_D3DMULTISAMPLE_TYPE )GRAWIN.Setting.FSAAMultiSampleCount != D_D3DMULTISAMPLE_NONE && Orig->FormatDesc.MSSamples == 0 ) ||
				Orig->ZBufferFlag  )
			{
				if( OrigTex->PF->D3D11.DepthBuffer != NULL )
				{
					Direct3D11_ObjectRelease( OrigTex->PF->D3D11.DepthBuffer ) ;
					OrigTex->PF->D3D11.DepthBuffer = NULL ;
				}

				if( OrigTex->PF->D3D11.DepthBufferDSV != NULL )
				{
					Direct3D11_ObjectRelease( OrigTex->PF->D3D11.DepthBufferDSV ) ;
					OrigTex->PF->D3D11.DepthBufferDSV = NULL ;
				}

				// eNX`̍쐬
				_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) ) ;
				Texture2DDesc.Width              = OrigTex->TexWidth ;
				Texture2DDesc.Height             = OrigTex->TexHeight ;
				Texture2DDesc.MipLevels          = 1 ;
				Texture2DDesc.ArraySize          = 1 ;
				Texture2DDesc.Format             = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ Orig->ZBufferBitDepthIndex ] ;
				Texture2DDesc.SampleDesc.Count   = Samples == 0 ? 1 : Samples ;
				Texture2DDesc.SampleDesc.Quality = Quality ;
				Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
				Texture2DDesc.BindFlags          = D_D3D11_BIND_DEPTH_STENCIL ;
				Texture2DDesc.CPUAccessFlags     = 0 ;
				Texture2DDesc.MiscFlags          = 0 ;
				hr = D3D11Device_CreateTexture2D_ASync( &Texture2DDesc, NULL, &OrigTex->PF->D3D11.DepthBuffer, ASyncThread ) ;
				if( FAILED( hr ) )
				{
					DXST_ERRORLOG_ADD( _T( "ݐp}`Tv[xeNX`̍쐬Ɏs܂\n" ) ) ;
					return -1 ;
				}

				// [xXeVr[̍쐬
				_MEMSET( &DepthStencilViewDesc, 0, sizeof( DepthStencilViewDesc ) ) ;
				DepthStencilViewDesc.Format = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ Orig->ZBufferBitDepthIndex ] ;
				if( Orig->FormatDesc.MSSamples <= 1 )
				{
					DepthStencilViewDesc.ViewDimension      = D_D3D11_DSV_DIMENSION_TEXTURE2D;
					DepthStencilViewDesc.Texture2D.MipSlice = 0;
				}
				else
				{
					DepthStencilViewDesc.ViewDimension		= D_D3D11_DSV_DIMENSION_TEXTURE2DMS;
				}

				hr = D3D11Device_CreateDepthStencilView_ASync( OrigTex->PF->D3D11.DepthBuffer, &DepthStencilViewDesc, &OrigTex->PF->D3D11.DepthBufferDSV, ASyncThread ) ;
				if( FAILED( hr ) )
				{
					DXST_ERRORLOG_ADD( _T( "[xobt@p[xXeVr[̍쐬Ɏs܂\n" ) ) ;
					return -1 ;
				}
			}
			else
			{
				if( OrigTex->PF->D3D11.DepthBuffer != NULL )
				{
					Direct3D11_ObjectRelease( OrigTex->PF->D3D11.DepthBuffer ) ;
					OrigTex->PF->D3D11.DepthBuffer = NULL ;
				}

				if( OrigTex->PF->D3D11.DepthBufferDSV != NULL )
				{
					Direct3D11_ObjectRelease( OrigTex->PF->D3D11.DepthBufferDSV ) ;
					OrigTex->PF->D3D11.DepthBufferDSV = NULL ;
				}
			}
		}

		// VF[_[\[Xr[쐬
		if( OrigTex->PF->D3D11.TextureSRV == NULL )
		{
			_MEMSET( &SRVDesc, 0, sizeof( SRVDesc ) );
			SRVDesc.Format              = GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ] ;
			if( Orig->FormatDesc.CubeMapTextureFlag )
			{
				SRVDesc.ViewDimension            = D_D3D11_SRV_DIMENSION_TEXTURE2DARRAY ;
				SRVDesc.Texture2DArray.MipLevels = Orig->Hard.MipMapCount ;
				SRVDesc.Texture2DArray.ArraySize = CUBEMAP_SURFACE_NUM ;
			}
			else
			{
				SRVDesc.ViewDimension       = D_D3D11_SRV_DIMENSION_TEXTURE2D ;
				SRVDesc.Texture2D.MipLevels = Orig->Hard.MipMapCount ;
			}
			hr = D3D11Device_CreateShaderResourceView_ASync( OrigTex->PF->D3D11.Texture, &SRVDesc, &OrigTex->PF->D3D11.TextureSRV, ASyncThread ) ;
			if( FAILED( hr ) )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "eNX`pVF[_[\[Xr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
					GD3D11.Device.Caps.TextureFormat[ Orig->ColorFormat ], OrigTex->TexWidth, OrigTex->TexHeight )) ;
				return -1 ;
			}
		}

		// `Ώۂɏo摜̏ꍇ͐^ɓhԂ
		if( Orig->FormatDesc.DrawValidFlag )
		{
			if( OrigTex->PF->D3D11.TextureRTV != NULL )
			{
				FLOAT ClearColor[ 4 ] = { 0.0f } ;

				D3D11DeviceContext_ClearRenderTargetView_ASync( OrigTex->PF->D3D11.TextureRTV, ClearColor, ASyncThread ) ;
			}

			if( OrigTex->PF->D3D11.DepthBufferDSV != NULL )
			{
				D3D11DeviceContext_ClearDepthStencilView_ASync( OrigTex->PF->D3D11.DepthBufferDSV, D_D3D11_CLEAR_DEPTH, 1.0f, 0, ASyncThread ) ;
			}
		}
	}

	// I
	return 0 ;
}

// IWi摜񒆂̃eNX`
extern	int		Graphics_Hardware_D3D11_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig )
{
	int i ;
	IMAGEDATA_ORIG_HARD_TEX *OrigTex ;

	// n[hEGAgp摜ł͂Ȃꍇ͉ɏI
	if( Orig->FormatDesc.TextureFlag == FALSE )
	{
		return 0 ;
	}

	// eNX`̏ꍇ̓eNX`̐eNX`쐬
	OrigTex = Orig->Hard.Tex ;
	for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
	{
		if( OrigTex->PF->D3D11.TextureRTV )
		{
			Direct3D11_ObjectRelease( OrigTex->PF->D3D11.TextureRTV ) ;
			OrigTex->PF->D3D11.TextureRTV = NULL ;
		}
		if( OrigTex->PF->D3D11.TextureSRV )
		{
			Direct3D11_ObjectRelease( OrigTex->PF->D3D11.TextureSRV ) ;
			OrigTex->PF->D3D11.TextureSRV = NULL ;
		}
		if( OrigTex->PF->D3D11.Texture )
		{
			Direct3D11_ObjectRelease( OrigTex->PF->D3D11.Texture ) ;
			OrigTex->PF->D3D11.Texture = NULL ;
		}

		if( OrigTex->PF->D3D11.DepthBufferDSV )
		{
			Direct3D11_ObjectRelease( OrigTex->PF->D3D11.DepthBufferDSV ) ;
			OrigTex->PF->D3D11.DepthBufferDSV = NULL ;
		}
		if( OrigTex->PF->D3D11.DepthBuffer )
		{
			Direct3D11_ObjectRelease( OrigTex->PF->D3D11.DepthBuffer ) ;
			OrigTex->PF->D3D11.DepthBuffer = NULL ;
		}
	}

	// I
	return 0 ;
}

// w̃}`TvŎgpłőNIeBl擾
extern	int		Graphics_Hardware_D3D11_GetMultiSampleQuality_PF( int Samples )
{
	IMAGEFORMATDESC				Format ;
	SETUP_GRAPHHANDLE_GPARAM	GParam ;
	int							FormatIndex ;
	D_DXGI_FORMAT				D3DFormat ;
	UINT						Quality ;

	if( Samples > 16 )
	{
		Samples = 16 ;
	}

	if( Graphics_Hardware_CheckValid_PF() == 0 )
	{
		return -1 ;
	}

	// ݂̐ݒ̃tH[}bgZbgAbv
	Graphics_Image_InitSetupGraphHandleGParam( &GParam ) ; 
	GParam.DrawValidImageCreateFlag = TRUE ;
	GParam.CubeMapTextureCreateFlag = FALSE ;
	Graphics_Image_SetupFormatDesc( &Format, &GParam, 256, 256, GParam.AlphaChannelImageCreateFlag, FALSE, DX_BASEIMAGE_FORMAT_NORMAL, -1 ) ;

	// tH[}bgCfbNX𓾂
	FormatIndex = NS_GetTexFormatIndex( &Format ) ;

	// Direct3D ł̃tH[}bg擾
	D3DFormat = GD3D11.Device.Caps.TextureFormat[ FormatIndex ] ;
	if( D3DFormat == D_DXGI_FORMAT_UNKNOWN )
	{
		return -1 ;
	}

	// ݒłNIeB擾
	Quality = 10000 ;
	if( D3D11Device_CheckMultiSampleParam_ASync( D3DFormat, ( UINT * )&Samples, &Quality, TRUE ) < 0 )
	{
		return -1 ;
	}

	// NIeBԂ
	return ( int )Quality ;
}




























// ˑ_obt@ECfbNXobt@֌W

// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Create_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int VertexSize, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	// I
	return 0 ;
}

// _obt@nȟn
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer )
{
	// I
	return 0 ;
}

// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_D3D11_VertexBuffer_SetData_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum )
{
	// I
	return 0 ;
}

// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Create_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int IndexSize, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ )
{
	// I
	return 0 ;
}

// CfbNXobt@nȟn
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Terminate_PF( INDEXBUFFERHANDLEDATA *IndexBuffer )
{
	// I
	return 0 ;
}

// CfbNXobt@ɃCfbNXf[^]
extern	int		Graphics_Hardware_D3D11_IndexBuffer_SetData_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum )
{
	// I
	return 0 ;
}























// ˑCg֌W

// CeBOsǂݒ肷
extern	int		Graphics_Hardware_D3D11_Light_SetUse_PF( int Flag )
{
	return Graphics_D3D11_DeviceState_SetLighting( Flag ) ;
}

// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_D3D11_Light_GlobalAmbient_PF( COLOR_F *Color )
{
	return Graphics_D3D11_DeviceState_SetAmbient( Color ) ;
}

// Cgp[^Zbg
extern	int		Graphics_Hardware_D3D11_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam )
{
	return Graphics_D3D11_DeviceState_SetLightState( LightNumber, LightParam ) ;
}

// Cg̗LAύX
extern	int		Graphics_Hardware_D3D11_Light_SetEnable_PF( int LightNumber, int EnableState )
{
	return Graphics_D3D11_DeviceState_SetLightEnable( LightNumber, EnableState ) ;
}




























// ˑVhE}bv֌W

// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_D3D11_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread )
{
	D_D3D11_TEXTURE2D_DESC				Texture2DDesc ;
	D_D3D11_RENDER_TARGET_VIEW_DESC		RTVDesc ;
	D_D3D11_SHADER_RESOURCE_VIEW_DESC	SRVDesc ;
	D_D3D11_DEPTH_STENCIL_VIEW_DESC		DepthStencilViewDesc ;
	HRESULT								hr ;

	// tH[}bǧ
	if( ShadowMap->TexFormat_Float )
	{
		if( ShadowMap->TexFormat_BitDepth == 16 )
		{
			ShadowMap->ColorFormat = /*DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16*/DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ;
			ShadowMap->ZBufferFormat = ZBUFFER_FORMAT_16BIT ;
		}
		else
		{
			ShadowMap->ColorFormat = /*DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32*/DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ;
			ShadowMap->ZBufferFormat = ZBUFFER_FORMAT_32BIT ;
		}
	}
	else
	{
		if( ShadowMap->TexFormat_BitDepth == 16 )
		{
			ShadowMap->ColorFormat = /*DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16*/ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ;
			ShadowMap->ZBufferFormat = ZBUFFER_FORMAT_16BIT ;
		}
		else
		{
			ShadowMap->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ;
			ShadowMap->ZBufferFormat = ZBUFFER_FORMAT_32BIT ;
		}
	}

	// 肵tH[}bg쐬łȂꍇ͎s
	if( GD3D11.Device.Caps.TextureFormat[ ShadowMap->ColorFormat ] == D_DXGI_FORMAT_UNKNOWN )
	{
		DXST_ERRORLOG_ADD( _T( "VhE}bvf[^p̃tH[}bgō쐬łeNX`tH[}bg܂ł\n" ) ) ;
		return -1 ;
	}

	// _O^[Qbg[xobt@̍쐬
	if( ShadowMap->PF->D3D11.DepthBuffer == NULL )
	{
		// eNX`̍쐬
		_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) ) ;
		Texture2DDesc.Width              = ShadowMap->BaseSizeX ;
		Texture2DDesc.Height             = ShadowMap->BaseSizeY ;
		Texture2DDesc.MipLevels          = 1 ;
		Texture2DDesc.ArraySize          = 1 ;
		Texture2DDesc.Format             = GD3D11.Device.Caps.DepthBufferTexture2DFormat[ ShadowMap->ZBufferFormat ] ;
		Texture2DDesc.SampleDesc.Count   = 1 ;
		Texture2DDesc.SampleDesc.Quality = 0 ;
		Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
		Texture2DDesc.BindFlags          = D_D3D11_BIND_DEPTH_STENCIL ;
		Texture2DDesc.CPUAccessFlags     = 0 ;
		Texture2DDesc.MiscFlags          = 0 ;
		hr = D3D11Device_CreateTexture2D_ASync( &Texture2DDesc, NULL, &ShadowMap->PF->D3D11.DepthBuffer, ASyncThread ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "VhE}bvp[xobt@eNX`̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}

		// [xXeVr[̍쐬
		_MEMSET( &DepthStencilViewDesc, 0, sizeof( DepthStencilViewDesc ) ) ;
		DepthStencilViewDesc.Format             = GD3D11.Device.Caps.DepthBufferDepthStencilFormat[ ShadowMap->ZBufferFormat ] ;
		DepthStencilViewDesc.ViewDimension      = D_D3D11_DSV_DIMENSION_TEXTURE2D;
		DepthStencilViewDesc.Texture2D.MipSlice = 0;

		hr = D3D11Device_CreateDepthStencilView_ASync( ShadowMap->PF->D3D11.DepthBuffer, &DepthStencilViewDesc, &ShadowMap->PF->D3D11.DepthBufferDSV, ASyncThread ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "VhE}bvp[xXeVr[̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// _[^[QbgɂłeNX`̍쐬
	if( ShadowMap->PF->D3D11.DepthTexture == NULL )
	{
		_MEMSET( &Texture2DDesc, 0, sizeof( Texture2DDesc ) ) ;
		Texture2DDesc.Usage              = D_D3D11_USAGE_DEFAULT ;
		Texture2DDesc.Format             = GD3D11.Device.Caps.TextureFormat[ ShadowMap->ColorFormat ] ;
		Texture2DDesc.BindFlags          = D_D3D11_BIND_SHADER_RESOURCE | D_D3D11_BIND_RENDER_TARGET ;
		Texture2DDesc.Width              = ShadowMap->BaseSizeX ;
		Texture2DDesc.Height             = ShadowMap->BaseSizeY ;
		Texture2DDesc.CPUAccessFlags     = 0 ;
		Texture2DDesc.MipLevels          = 1 ;
		Texture2DDesc.ArraySize          = 1 ;
		Texture2DDesc.SampleDesc.Count   = 1 ;
		Texture2DDesc.SampleDesc.Quality = 0 ;
		hr = D3D11Device_CreateTexture2D_ASync( &Texture2DDesc, NULL, &ShadowMap->PF->D3D11.DepthTexture, ASyncThread ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOG_ADD( _T( "VhE}bvpeNX`̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}

		_MEMSET( &RTVDesc, 0, sizeof( RTVDesc ) );
		RTVDesc.Format        = GD3D11.Device.Caps.TextureFormat[ ShadowMap->ColorFormat ] ;
		RTVDesc.ViewDimension = D_D3D11_RTV_DIMENSION_TEXTURE2D ;
		hr = D3D11Device_CreateRenderTargetView_ASync( ShadowMap->PF->D3D11.DepthTexture, &RTVDesc, &ShadowMap->PF->D3D11.DepthTextureRTV, ASyncThread ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "VhE}bvp_[^[Qbgr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
				GD3D11.Device.Caps.TextureFormat[ ShadowMap->ColorFormat ], ShadowMap->BaseSizeX, ShadowMap->BaseSizeY )) ;
			return -1 ;
		}

		_MEMSET( &SRVDesc, 0, sizeof( SRVDesc ) );
		SRVDesc.Format              = GD3D11.Device.Caps.TextureFormat[ ShadowMap->ColorFormat ] ;
		SRVDesc.ViewDimension       = D_D3D11_SRV_DIMENSION_TEXTURE2D ;
		SRVDesc.Texture2D.MipLevels = 1 ;
		hr = D3D11Device_CreateShaderResourceView_ASync( ShadowMap->PF->D3D11.DepthTexture, &SRVDesc, &ShadowMap->PF->D3D11.DepthTextureSRV, ASyncThread ) ;
		if( FAILED( hr ) )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "VhE}bvpVF[_[\[Xr[̍쐬Ɏs܂  Format:%d  SizeX:%d  SizeY:%d \n" ),
				GD3D11.Device.Caps.TextureFormat[ ShadowMap->ColorFormat ], ShadowMap->BaseSizeX, ShadowMap->BaseSizeY )) ;
			return -1 ;
		}
	}

	// I
	return 0 ;
}

// VhE}bvf[^ɕKvȃeNX`
extern	int		Graphics_Hardware_D3D11_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap )
{
	if( ShadowMap->PF->D3D11.DepthTexture != NULL )
	{
		Direct3D11_ObjectRelease( ShadowMap->PF->D3D11.DepthTexture ) ;
		ShadowMap->PF->D3D11.DepthTexture = NULL ;
	}

	if( ShadowMap->PF->D3D11.DepthTextureSRV != NULL )
	{
		Direct3D11_ObjectRelease( ShadowMap->PF->D3D11.DepthTextureSRV ) ;
		ShadowMap->PF->D3D11.DepthTextureSRV = NULL ;
	}

	if( ShadowMap->PF->D3D11.DepthTextureRTV != NULL )
	{
		Direct3D11_ObjectRelease( ShadowMap->PF->D3D11.DepthTextureRTV ) ;
		ShadowMap->PF->D3D11.DepthTextureRTV = NULL ;
	}

	if( ShadowMap->PF->D3D11.DepthBuffer != NULL )
	{
		Direct3D11_ObjectRelease( ShadowMap->PF->D3D11.DepthBuffer ) ;
		ShadowMap->PF->D3D11.DepthBuffer = NULL ;
	}

	if( ShadowMap->PF->D3D11.DepthBufferDSV != NULL )
	{
		Direct3D11_ObjectRelease( ShadowMap->PF->D3D11.DepthBufferDSV ) ;
		ShadowMap->PF->D3D11.DepthBufferDSV = NULL ;
	}

	// I
	return 0 ;
}

// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshVSParam_PF( void )
{
	DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX *ConstOtherMatrix = ( DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX * )GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix->SysmemBuffer ;
	SHADOWMAPDATA *ShadowMap ;
	static float TranspMatDef[ 4 ][ 4 ] =
	{
		{ 0.0f, 0.0f, 0.0f, -1.0f },
		{ 0.0f, 0.0f, 0.0f, -1.0f },
		{ 0.0f, 0.0f, 0.0f, -1.0f },
		{ 0.0f, 0.0f, 0.0f, -1.0f },
	} ;
	int i ;

	for( i = 0 ; i < MAX_USE_SHADOWMAP_NUM ; i ++ )
	{
		// AhX̎擾
		if( SHADOWMAPCHKFULL( GSYS.DrawSetting.ShadowMap[ i ], ShadowMap ) )
		{
			_MEMCPY( ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ], TranspMatDef, sizeof( TranspMatDef ) ) ;
		}
		else
		{
			// s̃Zbg
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 0 ][ 0 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 0 ][ 0 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 0 ][ 1 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 1 ][ 0 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 0 ][ 2 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 2 ][ 0 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 0 ][ 3 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 3 ][ 0 ] ;

			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 1 ][ 0 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 0 ][ 1 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 1 ][ 1 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 1 ][ 1 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 1 ][ 2 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 2 ][ 1 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 1 ][ 3 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 3 ][ 1 ] ;

			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 2 ][ 0 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 0 ][ 2 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 2 ][ 1 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 1 ][ 2 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 2 ][ 2 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 2 ][ 2 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 2 ][ 3 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 3 ][ 2 ] ;

			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 3 ][ 0 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 0 ][ 3 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 3 ][ 1 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 1 ][ 3 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 3 ][ 2 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 2 ][ 3 ] ;
			ConstOtherMatrix->ShadowMapLightViewProjectionMatrix[ i ][ 3 ][ 3 ] = ShadowMap->ShadowMapViewProjectionMatrix.m[ 3 ][ 3 ] ;
		}
	}

	GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_VS_OtherMatrix ) ;
}

// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshPSParam_PF( void )
{
	DX_D3D11_PS_CONST_BUFFER_SHADOWMAP *ConstantPSShadowMap = ( DX_D3D11_PS_CONST_BUFFER_SHADOWMAP * )GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap->SysmemBuffer ;
	SHADOWMAPDATA *ShadowMap ;
	LIGHT_HANDLE  *pLH ;
	int           CheckNum ;
	int           i ;
	int           j ;

	CheckNum = GSYS.Light.EnableNum > 3 ? 3 : GSYS.Light.EnableNum ;

	for( i = 0 ; i < MAX_USE_SHADOWMAP_NUM ; i ++ )
	{
		ConstantPSShadowMap->Data[ i ].Enable_Light0 = 1.0f ;
		ConstantPSShadowMap->Data[ i ].Enable_Light1 = 1.0f ;
		ConstantPSShadowMap->Data[ i ].Enable_Light2 = 1.0f ;

		// AhX̎擾
		if( SHADOWMAPCHKFULL( GSYS.DrawSetting.ShadowMap[ i ], ShadowMap ) )
		{
			ConstantPSShadowMap->Data[ i ].AdjustDepth    = 1.0f ;
			ConstantPSShadowMap->Data[ i ].GradationParam = 0.0f ;
		}
		else
		{
			ConstantPSShadowMap->Data[ i ].AdjustDepth    = ShadowMap->AdjustDepth ;
			ConstantPSShadowMap->Data[ i ].GradationParam = ShadowMap->GradationParam ;

			for( j = 0 ; j < CheckNum ; j ++ )
			{
				pLH = GSYS.Light.Data[ GSYS.Light.EnableHardwareIndex[ j ] ] ;
				if( pLH->ShadowMapSlotDisableFlag[ i ] == FALSE )
				{
					switch( j )
					{
					case 0 :
						ConstantPSShadowMap->Data[ i ].Enable_Light0 = 0.0f ;
						break ;

					case 1 :
						ConstantPSShadowMap->Data[ i ].Enable_Light1 = 0.0f ;
						break ;

					case 2 :
						ConstantPSShadowMap->Data[ i ].Enable_Light2 = 0.0f ;
						break ;
					}
				}
			}
		}
	}
	GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap->ChangeFlag = TRUE ;

	// 萔obt@XV
	Graphics_D3D11_ConstantBuffer_Update( GD3D11.Device.Shader.Constant.ConstBuffer_PS_ShadowMap ) ;
}

// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// VhE}bvւ̕`I
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// `ŎgpVhE}bvw肷( Xbg͂OPw\ )
extern	int		Graphics_Hardware_D3D11_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}































// ˑVF[_[֌W

// VF[_[nh
extern	int		Graphics_Hardware_D3D11_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread )
{
	SHADERHANDLEDATA     *pShader ;
	D_ID3D11PixelShader  *PixelShader  = NULL ;
	D_ID3D11VertexShader *VertexShader = NULL ;

	// G[
	if( ASyncThread )
	{
		if( SHADERCHK_ASYNC( ShaderHandle, pShader ) )
			return -1 ;
	}
	else
	{
		if( SHADERCHK( ShaderHandle, pShader ) )
			return -1 ;
	}

	// VF[_[쐬
	if( IsVertexShader )
	{
		if( D3D11Device_CreateVertexShader_ASync( Image, ( SIZE_T )ImageSize, NULL, &VertexShader, ASyncThread ) != S_OK )
		{
			DXST_ERRORLOG_ADD( _T( "_VF[_[̍쐬Ɏs܂\n" ) ) ;
			goto ERR ;
		}
	}
	else
	{
		if( D3D11Device_CreatePixelShader_ASync( Image, ( SIZE_T )ImageSize, NULL, &PixelShader, ASyncThread ) != S_OK )
		{
			DXST_ERRORLOG_ADD( _T( "sNZVF[_[̍쐬Ɏs܂\n" ) ) ;
			goto ERR ;
		}
	}

	// oCiC[Wۑ郁̈̊m
	pShader->FunctionCode = DXCALLOC( ImageSize ) ;
	if( pShader->FunctionCode == NULL )
	{
		DXST_ERRORLOG_ADD( _T( "̊mۂɎs܂" ) ) ;
		goto ERR ;
	}

	// oCiC[Wۑ
	_MEMCPY( pShader->FunctionCode, Image, ImageSize ) ;

	// _VF[_[ǂۑ
	pShader->IsVertexShader = IsVertexShader ? TRUE : FALSE ;

	// VF[_[̃AhXۑ
	if( IsVertexShader )
	{
		pShader->PF->D3D11.VertexShader = VertexShader ;
	}
	else
	{
		pShader->PF->D3D11.PixelShader = PixelShader ;
	}

	// ɉׂ̃tOĂ
	if( ImageAfterFree )
	{
		DXFREE( Image ) ;
	}

	// I
	return 0 ;

ERR :
	if( VertexShader )
	{
		Direct3D11_ObjectRelease_ASync( VertexShader, ASyncThread ) ;
	}

	if( PixelShader )
	{
		Direct3D11_ObjectRelease_ASync( PixelShader, ASyncThread ) ;
	}

	// ɉׂ̃tOĂ
	if( ImageAfterFree )
	{
		DXFREE( Image ) ;
	}

	return -1 ;
}

// VF[_[nȟn
extern	int		Graphics_Hardware_D3D11_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader )
{
	// VF[_[̉
	if( Shader->IsVertexShader )
	{
		if( Shader->PF->D3D11.VertexShader )
		{
			Direct3D9_ObjectRelease( Shader->PF->D3D11.VertexShader ) ;
			Shader->PF->D3D11.VertexShader = NULL ;
		}
	}
	else
	{
		if( Shader->PF->D3D11.PixelShader )
		{
			Direct3D9_ObjectRelease( Shader->PF->D3D11.PixelShader ) ;
			Shader->PF->D3D11.PixelShader = NULL ;
		}
	}

	// I
	return 0 ;
}

// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_D3D11_Shader_GetValidShaderVersion_PF( void )
{
	return 500 ;
}

// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstIndex_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// w̖O萔gpVF[_[萔̐擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstCount_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	const FLOAT4 *Graphics_Hardware_D3D11_Shader_GetConstDefaultParamF_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_D3D11_Shader_SetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea )
{
	// I
	return 0 ;
}

// ẅ̃VF[_[萔Zbg
extern	int		Graphics_Hardware_D3D11_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum )
{
	// I
	return 0 ;
}

#ifndef DX_NON_MODEL
// Rcfp̃VF[_[R[h̏s
extern	int		Graphics_Hardware_D3D11_Shader_ModelCode_Init_PF( void )
{
	if( Graphics_D3D11_ShaderCode_Model_Initialize() == FALSE )
	{
		return -1 ;
	}

	// I
	return 0 ;
}
#endif // DX_NON_MODEL




































// ˑ`֌W

// w_狫EFƂ܂œhԂ
extern	int		Graphics_Hardware_D3D11_Paint_PF( int x, int y, int FillColor, int BoundaryColor )
{
	// I
	return 0 ;
}


























#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_DIRECT3D11



